/* Include files */

#include "blascompat32.h"
#include "PAC_sfun.h"
#include "c1_PAC.h"
#include "mwmathutil.h"
#define CHARTINSTANCE_CHARTNUMBER      (chartInstance->chartNumber)
#define CHARTINSTANCE_INSTANCENUMBER   (chartInstance->instanceNumber)
#include "PAC_sfun_debug_macros.h"

/* Type Definitions */

/* Named Constants */
#define CALL_EVENT                     (-1)

/* Variable Declarations */

/* Variable Definitions */
static const char * c1_debug_family_names[27] = { "Tc", "R", "e1", "e2", "e3",
  "e4", "f1", "f2", "f4", "g1", "g2", "g4", "b", "k", "Tr", "Zmax", "Zmin", "z",
  "Zmoy", "zer", "fzmoy", "fzmin", "nargin", "nargout", "T", "P", "v" };

/* Function Declarations */
static void initialize_c1_PAC(SFc1_PACInstanceStruct *chartInstance);
static void initialize_params_c1_PAC(SFc1_PACInstanceStruct *chartInstance);
static void enable_c1_PAC(SFc1_PACInstanceStruct *chartInstance);
static void disable_c1_PAC(SFc1_PACInstanceStruct *chartInstance);
static void c1_update_debugger_state_c1_PAC(SFc1_PACInstanceStruct
  *chartInstance);
static const mxArray *get_sim_state_c1_PAC(SFc1_PACInstanceStruct *chartInstance);
static void set_sim_state_c1_PAC(SFc1_PACInstanceStruct *chartInstance, const
  mxArray *c1_st);
static void finalize_c1_PAC(SFc1_PACInstanceStruct *chartInstance);
static void sf_c1_PAC(SFc1_PACInstanceStruct *chartInstance);
static void c1_chartstep_c1_PAC(SFc1_PACInstanceStruct *chartInstance);
static void initSimStructsc1_PAC(SFc1_PACInstanceStruct *chartInstance);
static void init_script_number_translation(uint32_T c1_machineNumber, uint32_T
  c1_chartNumber);
static const mxArray *c1_sf_marshallOut(void *chartInstanceVoid, void *c1_inData);
static real_T c1_emlrt_marshallIn(SFc1_PACInstanceStruct *chartInstance, const
  mxArray *c1_v, const char_T *c1_identifier);
static real_T c1_b_emlrt_marshallIn(SFc1_PACInstanceStruct *chartInstance, const
  mxArray *c1_u, const emlrtMsgIdentifier *c1_parentId);
static void c1_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c1_mxArrayInData, const char_T *c1_varName, void *c1_outData);
static const mxArray *c1_b_sf_marshallOut(void *chartInstanceVoid, void
  *c1_inData);
static int32_T c1_c_emlrt_marshallIn(SFc1_PACInstanceStruct *chartInstance,
  const mxArray *c1_u, const emlrtMsgIdentifier *c1_parentId);
static void c1_b_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c1_mxArrayInData, const char_T *c1_varName, void *c1_outData);
static uint8_T c1_d_emlrt_marshallIn(SFc1_PACInstanceStruct *chartInstance,
  const mxArray *c1_b_is_active_c1_PAC, const char_T *c1_identifier);
static uint8_T c1_e_emlrt_marshallIn(SFc1_PACInstanceStruct *chartInstance,
  const mxArray *c1_u, const emlrtMsgIdentifier *c1_parentId);
static void init_dsm_address_info(SFc1_PACInstanceStruct *chartInstance);

/* Function Definitions */
static void initialize_c1_PAC(SFc1_PACInstanceStruct *chartInstance)
{
  chartInstance->c1_sfEvent = CALL_EVENT;
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
  chartInstance->c1_is_active_c1_PAC = 0U;
}

static void initialize_params_c1_PAC(SFc1_PACInstanceStruct *chartInstance)
{
}

static void enable_c1_PAC(SFc1_PACInstanceStruct *chartInstance)
{
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
}

static void disable_c1_PAC(SFc1_PACInstanceStruct *chartInstance)
{
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
}

static void c1_update_debugger_state_c1_PAC(SFc1_PACInstanceStruct
  *chartInstance)
{
}

static const mxArray *get_sim_state_c1_PAC(SFc1_PACInstanceStruct *chartInstance)
{
  const mxArray *c1_st;
  const mxArray *c1_y = NULL;
  real_T c1_hoistedGlobal;
  real_T c1_u;
  const mxArray *c1_b_y = NULL;
  uint8_T c1_b_hoistedGlobal;
  uint8_T c1_b_u;
  const mxArray *c1_c_y = NULL;
  real_T *c1_v;
  c1_v = (real_T *)ssGetOutputPortSignal(chartInstance->S, 1);
  c1_st = NULL;
  c1_st = NULL;
  c1_y = NULL;
  sf_mex_assign(&c1_y, sf_mex_createcellarray(2), FALSE);
  c1_hoistedGlobal = *c1_v;
  c1_u = c1_hoistedGlobal;
  c1_b_y = NULL;
  sf_mex_assign(&c1_b_y, sf_mex_create("y", &c1_u, 0, 0U, 0U, 0U, 0), FALSE);
  sf_mex_setcell(c1_y, 0, c1_b_y);
  c1_b_hoistedGlobal = chartInstance->c1_is_active_c1_PAC;
  c1_b_u = c1_b_hoistedGlobal;
  c1_c_y = NULL;
  sf_mex_assign(&c1_c_y, sf_mex_create("y", &c1_b_u, 3, 0U, 0U, 0U, 0), FALSE);
  sf_mex_setcell(c1_y, 1, c1_c_y);
  sf_mex_assign(&c1_st, c1_y, FALSE);
  return c1_st;
}

static void set_sim_state_c1_PAC(SFc1_PACInstanceStruct *chartInstance, const
  mxArray *c1_st)
{
  const mxArray *c1_u;
  real_T *c1_v;
  c1_v = (real_T *)ssGetOutputPortSignal(chartInstance->S, 1);
  chartInstance->c1_doneDoubleBufferReInit = TRUE;
  c1_u = sf_mex_dup(c1_st);
  *c1_v = c1_emlrt_marshallIn(chartInstance, sf_mex_dup(sf_mex_getcell(c1_u, 0)),
    "v");
  chartInstance->c1_is_active_c1_PAC = c1_d_emlrt_marshallIn(chartInstance,
    sf_mex_dup(sf_mex_getcell(c1_u, 1)), "is_active_c1_PAC");
  sf_mex_destroy(&c1_u);
  c1_update_debugger_state_c1_PAC(chartInstance);
  sf_mex_destroy(&c1_st);
}

static void finalize_c1_PAC(SFc1_PACInstanceStruct *chartInstance)
{
}

static void sf_c1_PAC(SFc1_PACInstanceStruct *chartInstance)
{
  real_T *c1_T;
  real_T *c1_v;
  real_T *c1_P;
  c1_P = (real_T *)ssGetInputPortSignal(chartInstance->S, 1);
  c1_v = (real_T *)ssGetOutputPortSignal(chartInstance->S, 1);
  c1_T = (real_T *)ssGetInputPortSignal(chartInstance->S, 0);
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
  _SFD_CC_CALL(CHART_ENTER_SFUNCTION_TAG, 0U, chartInstance->c1_sfEvent);
  _SFD_DATA_RANGE_CHECK(*c1_T, 0U);
  _SFD_DATA_RANGE_CHECK(*c1_v, 1U);
  _SFD_DATA_RANGE_CHECK(*c1_P, 2U);
  chartInstance->c1_sfEvent = CALL_EVENT;
  c1_chartstep_c1_PAC(chartInstance);
  sf_debug_check_for_state_inconsistency(_PACMachineNumber_,
    chartInstance->chartNumber, chartInstance->instanceNumber);
}

static void c1_chartstep_c1_PAC(SFc1_PACInstanceStruct *chartInstance)
{
  real_T c1_hoistedGlobal;
  real_T c1_b_hoistedGlobal;
  real_T c1_T;
  real_T c1_P;
  uint32_T c1_debug_family_var_map[27];
  real_T c1_Tc;
  real_T c1_R;
  real_T c1_e1;
  real_T c1_e2;
  real_T c1_e3;
  real_T c1_e4;
  real_T c1_f1;
  real_T c1_f2;
  real_T c1_f4;
  real_T c1_g1;
  real_T c1_g2;
  real_T c1_g4;
  real_T c1_b;
  real_T c1_k;
  real_T c1_Tr;
  real_T c1_Zmax;
  real_T c1_Zmin;
  real_T c1_z;
  real_T c1_Zmoy;
  real_T c1_zer;
  real_T c1_fzmoy;
  real_T c1_fzmin;
  real_T c1_nargin = 2.0;
  real_T c1_nargout = 1.0;
  real_T c1_v;
  real_T c1_A;
  real_T c1_x;
  real_T c1_b_x;
  real_T c1_b_A;
  real_T c1_c_x;
  real_T c1_d_x;
  real_T c1_b_b;
  real_T c1_y;
  real_T c1_c_A;
  real_T c1_B;
  real_T c1_e_x;
  real_T c1_b_y;
  real_T c1_f_x;
  real_T c1_c_y;
  real_T c1_d_y;
  real_T c1_c_b;
  real_T c1_e_y;
  real_T c1_d_b;
  real_T c1_f_y;
  real_T c1_g_x;
  real_T c1_h_x;
  real_T c1_e_b;
  real_T c1_g_y;
  real_T c1_a;
  real_T c1_f_b;
  real_T c1_h_y;
  real_T c1_d_A;
  real_T c1_b_B;
  real_T c1_i_x;
  real_T c1_i_y;
  real_T c1_j_x;
  real_T c1_j_y;
  real_T c1_k_y;
  real_T c1_g_b;
  real_T c1_l_y;
  real_T c1_h_b;
  real_T c1_m_y;
  real_T c1_k_x;
  real_T c1_l_x;
  real_T c1_i_b;
  real_T c1_n_y;
  real_T c1_b_a;
  real_T c1_j_b;
  real_T c1_o_y;
  real_T c1_c_a;
  real_T c1_k_b;
  real_T c1_p_y;
  real_T c1_e_A;
  real_T c1_c_B;
  real_T c1_m_x;
  real_T c1_q_y;
  real_T c1_n_x;
  real_T c1_r_y;
  real_T c1_s_y;
  real_T c1_d_a;
  real_T c1_l_b;
  real_T c1_t_y;
  real_T c1_e_a;
  real_T c1_m_b;
  real_T c1_u_y;
  real_T c1_f_a;
  real_T c1_n_b;
  real_T c1_v_y;
  real_T c1_d_B;
  real_T c1_w_y;
  real_T c1_x_y;
  real_T c1_y_y;
  real_T c1_o_b;
  real_T c1_ab_y;
  real_T c1_p_b;
  real_T c1_bb_y;
  real_T c1_o_x;
  real_T c1_p_x;
  real_T c1_q_b;
  real_T c1_cb_y;
  real_T c1_g_a;
  real_T c1_r_b;
  real_T c1_db_y;
  real_T c1_h_a;
  real_T c1_s_b;
  real_T c1_eb_y;
  real_T c1_i_a;
  real_T c1_t_b;
  real_T c1_fb_y;
  real_T c1_j_a;
  real_T c1_u_b;
  real_T c1_gb_y;
  real_T c1_f_A;
  real_T c1_e_B;
  real_T c1_q_x;
  real_T c1_hb_y;
  real_T c1_r_x;
  real_T c1_ib_y;
  real_T c1_jb_y;
  real_T c1_v_b;
  real_T c1_kb_y;
  real_T c1_g_A;
  real_T c1_f_B;
  real_T c1_s_x;
  real_T c1_lb_y;
  real_T c1_t_x;
  real_T c1_mb_y;
  real_T c1_nb_y;
  real_T c1_w_b;
  real_T c1_ob_y;
  real_T c1_x_b;
  real_T c1_pb_y;
  real_T c1_u_x;
  real_T c1_v_x;
  real_T c1_y_b;
  real_T c1_qb_y;
  real_T c1_k_a;
  real_T c1_ab_b;
  real_T c1_rb_y;
  real_T c1_h_A;
  real_T c1_g_B;
  real_T c1_w_x;
  real_T c1_sb_y;
  real_T c1_x_x;
  real_T c1_tb_y;
  real_T c1_ub_y;
  real_T c1_bb_b;
  real_T c1_vb_y;
  real_T c1_cb_b;
  real_T c1_wb_y;
  real_T c1_y_x;
  real_T c1_ab_x;
  real_T c1_db_b;
  real_T c1_xb_y;
  real_T c1_l_a;
  real_T c1_eb_b;
  real_T c1_yb_y;
  real_T c1_m_a;
  real_T c1_fb_b;
  real_T c1_ac_y;
  real_T c1_i_A;
  real_T c1_h_B;
  real_T c1_bb_x;
  real_T c1_bc_y;
  real_T c1_cb_x;
  real_T c1_cc_y;
  real_T c1_dc_y;
  real_T c1_n_a;
  real_T c1_gb_b;
  real_T c1_ec_y;
  real_T c1_o_a;
  real_T c1_hb_b;
  real_T c1_fc_y;
  real_T c1_p_a;
  real_T c1_ib_b;
  real_T c1_gc_y;
  real_T c1_i_B;
  real_T c1_hc_y;
  real_T c1_ic_y;
  real_T c1_jc_y;
  real_T c1_jb_b;
  real_T c1_kc_y;
  real_T c1_kb_b;
  real_T c1_lc_y;
  real_T c1_db_x;
  real_T c1_eb_x;
  real_T c1_lb_b;
  real_T c1_mc_y;
  real_T c1_q_a;
  real_T c1_mb_b;
  real_T c1_nc_y;
  real_T c1_r_a;
  real_T c1_nb_b;
  real_T c1_oc_y;
  real_T c1_s_a;
  real_T c1_ob_b;
  real_T c1_pc_y;
  real_T c1_t_a;
  real_T c1_pb_b;
  real_T c1_qc_y;
  real_T c1_j_A;
  real_T c1_j_B;
  real_T c1_fb_x;
  real_T c1_rc_y;
  real_T c1_gb_x;
  real_T c1_sc_y;
  real_T c1_tc_y;
  real_T c1_u_a;
  real_T c1_qb_b;
  real_T c1_uc_y;
  real_T c1_v_a;
  real_T c1_rb_b;
  real_T c1_vc_y;
  real_T *c1_b_P;
  real_T *c1_b_T;
  real_T *c1_b_v;
  c1_b_P = (real_T *)ssGetInputPortSignal(chartInstance->S, 1);
  c1_b_v = (real_T *)ssGetOutputPortSignal(chartInstance->S, 1);
  c1_b_T = (real_T *)ssGetInputPortSignal(chartInstance->S, 0);
  _SFD_CC_CALL(CHART_ENTER_DURING_FUNCTION_TAG, 0U, chartInstance->c1_sfEvent);
  c1_hoistedGlobal = *c1_b_T;
  c1_b_hoistedGlobal = *c1_b_P;
  c1_T = c1_hoistedGlobal;
  c1_P = c1_b_hoistedGlobal;
  sf_debug_symbol_scope_push_eml(0U, 27U, 27U, c1_debug_family_names,
    c1_debug_family_var_map);
  sf_debug_symbol_scope_add_eml(&c1_Tc, 0U, c1_sf_marshallOut);
  sf_debug_symbol_scope_add_eml(&c1_R, 1U, c1_sf_marshallOut);
  sf_debug_symbol_scope_add_eml_importable(&c1_e1, 2U, c1_sf_marshallOut,
    c1_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c1_e2, 3U, c1_sf_marshallOut,
    c1_sf_marshallIn);
  sf_debug_symbol_scope_add_eml(&c1_e3, 4U, c1_sf_marshallOut);
  sf_debug_symbol_scope_add_eml_importable(&c1_e4, 5U, c1_sf_marshallOut,
    c1_sf_marshallIn);
  sf_debug_symbol_scope_add_eml(&c1_f1, 6U, c1_sf_marshallOut);
  sf_debug_symbol_scope_add_eml(&c1_f2, 7U, c1_sf_marshallOut);
  sf_debug_symbol_scope_add_eml(&c1_f4, 8U, c1_sf_marshallOut);
  sf_debug_symbol_scope_add_eml(&c1_g1, 9U, c1_sf_marshallOut);
  sf_debug_symbol_scope_add_eml(&c1_g2, 10U, c1_sf_marshallOut);
  sf_debug_symbol_scope_add_eml(&c1_g4, 11U, c1_sf_marshallOut);
  sf_debug_symbol_scope_add_eml_importable(&c1_b, 12U, c1_sf_marshallOut,
    c1_sf_marshallIn);
  sf_debug_symbol_scope_add_eml(&c1_k, 13U, c1_sf_marshallOut);
  sf_debug_symbol_scope_add_eml_importable(&c1_Tr, 14U, c1_sf_marshallOut,
    c1_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c1_Zmax, 15U, c1_sf_marshallOut,
    c1_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c1_Zmin, 16U, c1_sf_marshallOut,
    c1_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c1_z, 17U, c1_sf_marshallOut,
    c1_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c1_Zmoy, 18U, c1_sf_marshallOut,
    c1_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c1_zer, 19U, c1_sf_marshallOut,
    c1_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c1_fzmoy, 20U, c1_sf_marshallOut,
    c1_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c1_fzmin, 21U, c1_sf_marshallOut,
    c1_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c1_nargin, 22U, c1_sf_marshallOut,
    c1_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c1_nargout, 23U, c1_sf_marshallOut,
    c1_sf_marshallIn);
  sf_debug_symbol_scope_add_eml(&c1_T, 24U, c1_sf_marshallOut);
  sf_debug_symbol_scope_add_eml(&c1_P, 25U, c1_sf_marshallOut);
  sf_debug_symbol_scope_add_eml_importable(&c1_v, 26U, c1_sf_marshallOut,
    c1_sf_marshallIn);
  CV_EML_FCN(0, 0);
  _SFD_EML_CALL(0U, chartInstance->c1_sfEvent, 3);
  if (CV_EML_IF(0, 1, 0, c1_P < 1.0)) {
    _SFD_EML_CALL(0U, chartInstance->c1_sfEvent, 4);
    c1_P = 1.0;
  }

  _SFD_EML_CALL(0U, chartInstance->c1_sfEvent, 6);
  c1_T += 273.15;
  _SFD_EML_CALL(0U, chartInstance->c1_sfEvent, 8);
  c1_Tc = 374.21;
  _SFD_EML_CALL(0U, chartInstance->c1_sfEvent, 10);
  c1_R = 0.000814892;
  _SFD_EML_CALL(0U, chartInstance->c1_sfEvent, 11);
  c1_e1 = -0.00140114;
  _SFD_EML_CALL(0U, chartInstance->c1_sfEvent, 12);
  c1_e2 = 2.19433E-6;
  _SFD_EML_CALL(0U, chartInstance->c1_sfEvent, 13);
  c1_e3 = -6.7358E-10;
  _SFD_EML_CALL(0U, chartInstance->c1_sfEvent, 14);
  c1_e4 = -4.668E-12;
  _SFD_EML_CALL(0U, chartInstance->c1_sfEvent, 15);
  c1_f1 = 1.63714E-6;
  _SFD_EML_CALL(0U, chartInstance->c1_sfEvent, 16);
  c1_f2 = -2.7886E-9;
  _SFD_EML_CALL(0U, chartInstance->c1_sfEvent, 17);
  c1_f4 = 1.02574E-14;
  _SFD_EML_CALL(0U, chartInstance->c1_sfEvent, 18);
  c1_g1 = -0.0269555;
  _SFD_EML_CALL(0U, chartInstance->c1_sfEvent, 19);
  c1_g2 = 2.67772E-5;
  _SFD_EML_CALL(0U, chartInstance->c1_sfEvent, 20);
  c1_g4 = 1.69513E-10;
  _SFD_EML_CALL(0U, chartInstance->c1_sfEvent, 22);
  c1_b = 0.000299628;
  _SFD_EML_CALL(0U, chartInstance->c1_sfEvent, 23);
  c1_k = 5.475;
  _SFD_EML_CALL(0U, chartInstance->c1_sfEvent, 25);
  c1_A = c1_T;
  c1_x = c1_A;
  c1_b_x = c1_x;
  c1_Tr = c1_b_x / 374.21;
  _SFD_EML_CALL(0U, chartInstance->c1_sfEvent, 26);
  c1_Zmax = 1.0;
  _SFD_EML_CALL(0U, chartInstance->c1_sfEvent, 27);
  c1_Zmin = 0.008;
  _SFD_EML_CALL(0U, chartInstance->c1_sfEvent, 28);
  c1_z = 0.0;
  _SFD_EML_CALL(0U, chartInstance->c1_sfEvent, 29);
  while (CV_EML_WHILE(0, 1, 0, c1_Zmax - c1_Zmin >= 1.0E-8)) {
    _SFD_EML_CALL(0U, chartInstance->c1_sfEvent, 30);
    c1_b_A = c1_Zmax + c1_Zmin;
    c1_c_x = c1_b_A;
    c1_d_x = c1_c_x;
    c1_Zmoy = c1_d_x / 2.0;
    _SFD_EML_CALL(0U, chartInstance->c1_sfEvent, 31);
    c1_z = c1_Zmoy;
    _SFD_EML_CALL(0U, chartInstance->c1_sfEvent, 32);
    c1_b_b = c1_T;
    c1_y = 0.000814892 * c1_b_b;
    c1_c_A = c1_y;
    c1_B = c1_z;
    c1_e_x = c1_c_A;
    c1_b_y = c1_B;
    c1_f_x = c1_e_x;
    c1_c_y = c1_b_y;
    c1_d_y = c1_f_x / c1_c_y;
    c1_c_b = c1_T;
    c1_e_y = 1.63714E-6 * c1_c_b;
    c1_d_b = c1_Tr;
    c1_f_y = -5.475 * c1_d_b;
    c1_g_x = c1_f_y;
    c1_h_x = c1_g_x;
    c1_h_x = muDoubleScalarExp(c1_h_x);
    c1_e_b = c1_h_x;
    c1_g_y = -0.0269555 * c1_e_b;
    c1_a = c1_z;
    c1_f_b = c1_z;
    c1_h_y = c1_a * c1_f_b;
    c1_d_A = (c1_e1 + c1_e_y) + c1_g_y;
    c1_b_B = c1_h_y;
    c1_i_x = c1_d_A;
    c1_i_y = c1_b_B;
    c1_j_x = c1_i_x;
    c1_j_y = c1_i_y;
    c1_k_y = c1_j_x / c1_j_y;
    c1_g_b = c1_T;
    c1_l_y = -2.7886E-9 * c1_g_b;
    c1_h_b = c1_Tr;
    c1_m_y = -5.475 * c1_h_b;
    c1_k_x = c1_m_y;
    c1_l_x = c1_k_x;
    c1_l_x = muDoubleScalarExp(c1_l_x);
    c1_i_b = c1_l_x;
    c1_n_y = 2.67772E-5 * c1_i_b;
    c1_b_a = c1_z;
    c1_j_b = c1_z;
    c1_o_y = c1_b_a * c1_j_b;
    c1_c_a = c1_o_y;
    c1_k_b = c1_z;
    c1_p_y = c1_c_a * c1_k_b;
    c1_e_A = (c1_e2 + c1_l_y) + c1_n_y;
    c1_c_B = c1_p_y;
    c1_m_x = c1_e_A;
    c1_q_y = c1_c_B;
    c1_n_x = c1_m_x;
    c1_r_y = c1_q_y;
    c1_s_y = c1_n_x / c1_r_y;
    c1_d_a = c1_z;
    c1_l_b = c1_z;
    c1_t_y = c1_d_a * c1_l_b;
    c1_e_a = c1_t_y;
    c1_m_b = c1_z;
    c1_u_y = c1_e_a * c1_m_b;
    c1_f_a = c1_u_y;
    c1_n_b = c1_z;
    c1_v_y = c1_f_a * c1_n_b;
    c1_d_B = c1_v_y;
    c1_w_y = c1_d_B;
    c1_x_y = c1_w_y;
    c1_y_y = -6.7358E-10 / c1_x_y;
    c1_o_b = c1_T;
    c1_ab_y = 1.02574E-14 * c1_o_b;
    c1_p_b = c1_Tr;
    c1_bb_y = -5.475 * c1_p_b;
    c1_o_x = c1_bb_y;
    c1_p_x = c1_o_x;
    c1_p_x = muDoubleScalarExp(c1_p_x);
    c1_q_b = c1_p_x;
    c1_cb_y = 1.69513E-10 * c1_q_b;
    c1_g_a = c1_z;
    c1_r_b = c1_z;
    c1_db_y = c1_g_a * c1_r_b;
    c1_h_a = c1_db_y;
    c1_s_b = c1_z;
    c1_eb_y = c1_h_a * c1_s_b;
    c1_i_a = c1_eb_y;
    c1_t_b = c1_z;
    c1_fb_y = c1_i_a * c1_t_b;
    c1_j_a = c1_fb_y;
    c1_u_b = c1_z;
    c1_gb_y = c1_j_a * c1_u_b;
    c1_f_A = (c1_e4 + c1_ab_y) + c1_cb_y;
    c1_e_B = c1_gb_y;
    c1_q_x = c1_f_A;
    c1_hb_y = c1_e_B;
    c1_r_x = c1_q_x;
    c1_ib_y = c1_hb_y;
    c1_jb_y = c1_r_x / c1_ib_y;
    c1_zer = ((((c1_P - c1_d_y) - c1_k_y) - c1_s_y) - c1_y_y) - c1_jb_y;
    _SFD_EML_CALL(0U, chartInstance->c1_sfEvent, 33);
    c1_fzmoy = c1_zer;
    _SFD_EML_CALL(0U, chartInstance->c1_sfEvent, 34);
    c1_z = c1_Zmin;
    _SFD_EML_CALL(0U, chartInstance->c1_sfEvent, 35);
    c1_v_b = c1_T;
    c1_kb_y = 0.000814892 * c1_v_b;
    c1_g_A = c1_kb_y;
    c1_f_B = c1_z;
    c1_s_x = c1_g_A;
    c1_lb_y = c1_f_B;
    c1_t_x = c1_s_x;
    c1_mb_y = c1_lb_y;
    c1_nb_y = c1_t_x / c1_mb_y;
    c1_w_b = c1_T;
    c1_ob_y = 1.63714E-6 * c1_w_b;
    c1_x_b = c1_Tr;
    c1_pb_y = -5.475 * c1_x_b;
    c1_u_x = c1_pb_y;
    c1_v_x = c1_u_x;
    c1_v_x = muDoubleScalarExp(c1_v_x);
    c1_y_b = c1_v_x;
    c1_qb_y = -0.0269555 * c1_y_b;
    c1_k_a = c1_z;
    c1_ab_b = c1_z;
    c1_rb_y = c1_k_a * c1_ab_b;
    c1_h_A = (c1_e1 + c1_ob_y) + c1_qb_y;
    c1_g_B = c1_rb_y;
    c1_w_x = c1_h_A;
    c1_sb_y = c1_g_B;
    c1_x_x = c1_w_x;
    c1_tb_y = c1_sb_y;
    c1_ub_y = c1_x_x / c1_tb_y;
    c1_bb_b = c1_T;
    c1_vb_y = -2.7886E-9 * c1_bb_b;
    c1_cb_b = c1_Tr;
    c1_wb_y = -5.475 * c1_cb_b;
    c1_y_x = c1_wb_y;
    c1_ab_x = c1_y_x;
    c1_ab_x = muDoubleScalarExp(c1_ab_x);
    c1_db_b = c1_ab_x;
    c1_xb_y = 2.67772E-5 * c1_db_b;
    c1_l_a = c1_z;
    c1_eb_b = c1_z;
    c1_yb_y = c1_l_a * c1_eb_b;
    c1_m_a = c1_yb_y;
    c1_fb_b = c1_z;
    c1_ac_y = c1_m_a * c1_fb_b;
    c1_i_A = (c1_e2 + c1_vb_y) + c1_xb_y;
    c1_h_B = c1_ac_y;
    c1_bb_x = c1_i_A;
    c1_bc_y = c1_h_B;
    c1_cb_x = c1_bb_x;
    c1_cc_y = c1_bc_y;
    c1_dc_y = c1_cb_x / c1_cc_y;
    c1_n_a = c1_z;
    c1_gb_b = c1_z;
    c1_ec_y = c1_n_a * c1_gb_b;
    c1_o_a = c1_ec_y;
    c1_hb_b = c1_z;
    c1_fc_y = c1_o_a * c1_hb_b;
    c1_p_a = c1_fc_y;
    c1_ib_b = c1_z;
    c1_gc_y = c1_p_a * c1_ib_b;
    c1_i_B = c1_gc_y;
    c1_hc_y = c1_i_B;
    c1_ic_y = c1_hc_y;
    c1_jc_y = -6.7358E-10 / c1_ic_y;
    c1_jb_b = c1_T;
    c1_kc_y = 1.02574E-14 * c1_jb_b;
    c1_kb_b = c1_Tr;
    c1_lc_y = -5.475 * c1_kb_b;
    c1_db_x = c1_lc_y;
    c1_eb_x = c1_db_x;
    c1_eb_x = muDoubleScalarExp(c1_eb_x);
    c1_lb_b = c1_eb_x;
    c1_mc_y = 1.69513E-10 * c1_lb_b;
    c1_q_a = c1_z;
    c1_mb_b = c1_z;
    c1_nc_y = c1_q_a * c1_mb_b;
    c1_r_a = c1_nc_y;
    c1_nb_b = c1_z;
    c1_oc_y = c1_r_a * c1_nb_b;
    c1_s_a = c1_oc_y;
    c1_ob_b = c1_z;
    c1_pc_y = c1_s_a * c1_ob_b;
    c1_t_a = c1_pc_y;
    c1_pb_b = c1_z;
    c1_qc_y = c1_t_a * c1_pb_b;
    c1_j_A = (c1_e4 + c1_kc_y) + c1_mc_y;
    c1_j_B = c1_qc_y;
    c1_fb_x = c1_j_A;
    c1_rc_y = c1_j_B;
    c1_gb_x = c1_fb_x;
    c1_sc_y = c1_rc_y;
    c1_tc_y = c1_gb_x / c1_sc_y;
    c1_zer = ((((c1_P - c1_nb_y) - c1_ub_y) - c1_dc_y) - c1_jc_y) - c1_tc_y;
    _SFD_EML_CALL(0U, chartInstance->c1_sfEvent, 36);
    c1_fzmin = c1_zer;
    _SFD_EML_CALL(0U, chartInstance->c1_sfEvent, 38);
    c1_u_a = c1_fzmoy;
    c1_qb_b = c1_fzmin;
    c1_uc_y = c1_u_a * c1_qb_b;
    if (CV_EML_IF(0, 1, 1, c1_uc_y < 0.0)) {
      _SFD_EML_CALL(0U, chartInstance->c1_sfEvent, 39);
      c1_Zmax = c1_Zmoy;
    } else {
      _SFD_EML_CALL(0U, chartInstance->c1_sfEvent, 40);
      c1_v_a = c1_fzmoy;
      c1_rb_b = c1_fzmin;
      c1_vc_y = c1_v_a * c1_rb_b;
      if (CV_EML_IF(0, 1, 2, c1_vc_y > 0.0)) {
        _SFD_EML_CALL(0U, chartInstance->c1_sfEvent, 41);
        c1_Zmin = c1_Zmoy;
      }
    }

    _SFD_EML_CALL(0U, chartInstance->c1_sfEvent, 43);
    c1_z = c1_Zmoy;
    _SFD_EML_CALL(0U, chartInstance->c1_sfEvent, 29);
    sf_mex_listen_for_ctrl_c(chartInstance->S);
  }

  _SFD_EML_CALL(0U, chartInstance->c1_sfEvent, 47);
  c1_v = c1_z + c1_b;
  _SFD_EML_CALL(0U, chartInstance->c1_sfEvent, -47);
  sf_debug_symbol_scope_pop();
  *c1_b_v = c1_v;
  _SFD_CC_CALL(EXIT_OUT_OF_FUNCTION_TAG, 0U, chartInstance->c1_sfEvent);
}

static void initSimStructsc1_PAC(SFc1_PACInstanceStruct *chartInstance)
{
}

static void init_script_number_translation(uint32_T c1_machineNumber, uint32_T
  c1_chartNumber)
{
}

static const mxArray *c1_sf_marshallOut(void *chartInstanceVoid, void *c1_inData)
{
  const mxArray *c1_mxArrayOutData = NULL;
  real_T c1_u;
  const mxArray *c1_y = NULL;
  SFc1_PACInstanceStruct *chartInstance;
  chartInstance = (SFc1_PACInstanceStruct *)chartInstanceVoid;
  c1_mxArrayOutData = NULL;
  c1_u = *(real_T *)c1_inData;
  c1_y = NULL;
  sf_mex_assign(&c1_y, sf_mex_create("y", &c1_u, 0, 0U, 0U, 0U, 0), FALSE);
  sf_mex_assign(&c1_mxArrayOutData, c1_y, FALSE);
  return c1_mxArrayOutData;
}

static real_T c1_emlrt_marshallIn(SFc1_PACInstanceStruct *chartInstance, const
  mxArray *c1_v, const char_T *c1_identifier)
{
  real_T c1_y;
  emlrtMsgIdentifier c1_thisId;
  c1_thisId.fIdentifier = c1_identifier;
  c1_thisId.fParent = NULL;
  c1_y = c1_b_emlrt_marshallIn(chartInstance, sf_mex_dup(c1_v), &c1_thisId);
  sf_mex_destroy(&c1_v);
  return c1_y;
}

static real_T c1_b_emlrt_marshallIn(SFc1_PACInstanceStruct *chartInstance, const
  mxArray *c1_u, const emlrtMsgIdentifier *c1_parentId)
{
  real_T c1_y;
  real_T c1_d0;
  sf_mex_import(c1_parentId, sf_mex_dup(c1_u), &c1_d0, 1, 0, 0U, 0, 0U, 0);
  c1_y = c1_d0;
  sf_mex_destroy(&c1_u);
  return c1_y;
}

static void c1_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c1_mxArrayInData, const char_T *c1_varName, void *c1_outData)
{
  const mxArray *c1_v;
  const char_T *c1_identifier;
  emlrtMsgIdentifier c1_thisId;
  real_T c1_y;
  SFc1_PACInstanceStruct *chartInstance;
  chartInstance = (SFc1_PACInstanceStruct *)chartInstanceVoid;
  c1_v = sf_mex_dup(c1_mxArrayInData);
  c1_identifier = c1_varName;
  c1_thisId.fIdentifier = c1_identifier;
  c1_thisId.fParent = NULL;
  c1_y = c1_b_emlrt_marshallIn(chartInstance, sf_mex_dup(c1_v), &c1_thisId);
  sf_mex_destroy(&c1_v);
  *(real_T *)c1_outData = c1_y;
  sf_mex_destroy(&c1_mxArrayInData);
}

const mxArray *sf_c1_PAC_get_eml_resolved_functions_info(void)
{
  const mxArray *c1_nameCaptureInfo;
  c1_ResolvedFunctionInfo c1_info[6];
  c1_ResolvedFunctionInfo (*c1_b_info)[6];
  const mxArray *c1_m0 = NULL;
  int32_T c1_i0;
  c1_ResolvedFunctionInfo *c1_r0;
  c1_nameCaptureInfo = NULL;
  c1_nameCaptureInfo = NULL;
  c1_b_info = (c1_ResolvedFunctionInfo (*)[6])c1_info;
  (*c1_b_info)[0].context = "";
  (*c1_b_info)[0].name = "mrdivide";
  (*c1_b_info)[0].dominantType = "double";
  (*c1_b_info)[0].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mrdivide.p";
  (*c1_b_info)[0].fileTimeLo = 1342810944U;
  (*c1_b_info)[0].fileTimeHi = 0U;
  (*c1_b_info)[0].mFileTimeLo = 1319729966U;
  (*c1_b_info)[0].mFileTimeHi = 0U;
  (*c1_b_info)[1].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mrdivide.p";
  (*c1_b_info)[1].name = "rdivide";
  (*c1_b_info)[1].dominantType = "double";
  (*c1_b_info)[1].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/rdivide.m";
  (*c1_b_info)[1].fileTimeLo = 1286818844U;
  (*c1_b_info)[1].fileTimeHi = 0U;
  (*c1_b_info)[1].mFileTimeLo = 0U;
  (*c1_b_info)[1].mFileTimeHi = 0U;
  (*c1_b_info)[2].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/rdivide.m";
  (*c1_b_info)[2].name = "eml_div";
  (*c1_b_info)[2].dominantType = "double";
  (*c1_b_info)[2].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_div.m";
  (*c1_b_info)[2].fileTimeLo = 1313347810U;
  (*c1_b_info)[2].fileTimeHi = 0U;
  (*c1_b_info)[2].mFileTimeLo = 0U;
  (*c1_b_info)[2].mFileTimeHi = 0U;
  (*c1_b_info)[3].context = "";
  (*c1_b_info)[3].name = "mtimes";
  (*c1_b_info)[3].dominantType = "double";
  (*c1_b_info)[3].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mtimes.m";
  (*c1_b_info)[3].fileTimeLo = 1289519692U;
  (*c1_b_info)[3].fileTimeHi = 0U;
  (*c1_b_info)[3].mFileTimeLo = 0U;
  (*c1_b_info)[3].mFileTimeHi = 0U;
  (*c1_b_info)[4].context = "";
  (*c1_b_info)[4].name = "exp";
  (*c1_b_info)[4].dominantType = "double";
  (*c1_b_info)[4].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/exp.m";
  (*c1_b_info)[4].fileTimeLo = 1286818740U;
  (*c1_b_info)[4].fileTimeHi = 0U;
  (*c1_b_info)[4].mFileTimeLo = 0U;
  (*c1_b_info)[4].mFileTimeHi = 0U;
  (*c1_b_info)[5].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/exp.m";
  (*c1_b_info)[5].name = "eml_scalar_exp";
  (*c1_b_info)[5].dominantType = "double";
  (*c1_b_info)[5].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/eml_scalar_exp.m";
  (*c1_b_info)[5].fileTimeLo = 1301328464U;
  (*c1_b_info)[5].fileTimeHi = 0U;
  (*c1_b_info)[5].mFileTimeLo = 0U;
  (*c1_b_info)[5].mFileTimeHi = 0U;
  sf_mex_assign(&c1_m0, sf_mex_createstruct("nameCaptureInfo", 1, 6), FALSE);
  for (c1_i0 = 0; c1_i0 < 6; c1_i0++) {
    c1_r0 = &c1_info[c1_i0];
    sf_mex_addfield(c1_m0, sf_mex_create("nameCaptureInfo", c1_r0->context, 15,
      0U, 0U, 0U, 2, 1, strlen(c1_r0->context)), "context", "nameCaptureInfo",
                    c1_i0);
    sf_mex_addfield(c1_m0, sf_mex_create("nameCaptureInfo", c1_r0->name, 15, 0U,
      0U, 0U, 2, 1, strlen(c1_r0->name)), "name", "nameCaptureInfo", c1_i0);
    sf_mex_addfield(c1_m0, sf_mex_create("nameCaptureInfo", c1_r0->dominantType,
      15, 0U, 0U, 0U, 2, 1, strlen(c1_r0->dominantType)), "dominantType",
                    "nameCaptureInfo", c1_i0);
    sf_mex_addfield(c1_m0, sf_mex_create("nameCaptureInfo", c1_r0->resolved, 15,
      0U, 0U, 0U, 2, 1, strlen(c1_r0->resolved)), "resolved", "nameCaptureInfo",
                    c1_i0);
    sf_mex_addfield(c1_m0, sf_mex_create("nameCaptureInfo", &c1_r0->fileTimeLo,
      7, 0U, 0U, 0U, 0), "fileTimeLo", "nameCaptureInfo", c1_i0);
    sf_mex_addfield(c1_m0, sf_mex_create("nameCaptureInfo", &c1_r0->fileTimeHi,
      7, 0U, 0U, 0U, 0), "fileTimeHi", "nameCaptureInfo", c1_i0);
    sf_mex_addfield(c1_m0, sf_mex_create("nameCaptureInfo", &c1_r0->mFileTimeLo,
      7, 0U, 0U, 0U, 0), "mFileTimeLo", "nameCaptureInfo", c1_i0);
    sf_mex_addfield(c1_m0, sf_mex_create("nameCaptureInfo", &c1_r0->mFileTimeHi,
      7, 0U, 0U, 0U, 0), "mFileTimeHi", "nameCaptureInfo", c1_i0);
  }

  sf_mex_assign(&c1_nameCaptureInfo, c1_m0, FALSE);
  sf_mex_emlrtNameCapturePostProcessR2012a(&c1_nameCaptureInfo);
  return c1_nameCaptureInfo;
}

static const mxArray *c1_b_sf_marshallOut(void *chartInstanceVoid, void
  *c1_inData)
{
  const mxArray *c1_mxArrayOutData = NULL;
  int32_T c1_u;
  const mxArray *c1_y = NULL;
  SFc1_PACInstanceStruct *chartInstance;
  chartInstance = (SFc1_PACInstanceStruct *)chartInstanceVoid;
  c1_mxArrayOutData = NULL;
  c1_u = *(int32_T *)c1_inData;
  c1_y = NULL;
  sf_mex_assign(&c1_y, sf_mex_create("y", &c1_u, 6, 0U, 0U, 0U, 0), FALSE);
  sf_mex_assign(&c1_mxArrayOutData, c1_y, FALSE);
  return c1_mxArrayOutData;
}

static int32_T c1_c_emlrt_marshallIn(SFc1_PACInstanceStruct *chartInstance,
  const mxArray *c1_u, const emlrtMsgIdentifier *c1_parentId)
{
  int32_T c1_y;
  int32_T c1_i1;
  sf_mex_import(c1_parentId, sf_mex_dup(c1_u), &c1_i1, 1, 6, 0U, 0, 0U, 0);
  c1_y = c1_i1;
  sf_mex_destroy(&c1_u);
  return c1_y;
}

static void c1_b_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c1_mxArrayInData, const char_T *c1_varName, void *c1_outData)
{
  const mxArray *c1_b_sfEvent;
  const char_T *c1_identifier;
  emlrtMsgIdentifier c1_thisId;
  int32_T c1_y;
  SFc1_PACInstanceStruct *chartInstance;
  chartInstance = (SFc1_PACInstanceStruct *)chartInstanceVoid;
  c1_b_sfEvent = sf_mex_dup(c1_mxArrayInData);
  c1_identifier = c1_varName;
  c1_thisId.fIdentifier = c1_identifier;
  c1_thisId.fParent = NULL;
  c1_y = c1_c_emlrt_marshallIn(chartInstance, sf_mex_dup(c1_b_sfEvent),
    &c1_thisId);
  sf_mex_destroy(&c1_b_sfEvent);
  *(int32_T *)c1_outData = c1_y;
  sf_mex_destroy(&c1_mxArrayInData);
}

static uint8_T c1_d_emlrt_marshallIn(SFc1_PACInstanceStruct *chartInstance,
  const mxArray *c1_b_is_active_c1_PAC, const char_T *c1_identifier)
{
  uint8_T c1_y;
  emlrtMsgIdentifier c1_thisId;
  c1_thisId.fIdentifier = c1_identifier;
  c1_thisId.fParent = NULL;
  c1_y = c1_e_emlrt_marshallIn(chartInstance, sf_mex_dup(c1_b_is_active_c1_PAC),
    &c1_thisId);
  sf_mex_destroy(&c1_b_is_active_c1_PAC);
  return c1_y;
}

static uint8_T c1_e_emlrt_marshallIn(SFc1_PACInstanceStruct *chartInstance,
  const mxArray *c1_u, const emlrtMsgIdentifier *c1_parentId)
{
  uint8_T c1_y;
  uint8_T c1_u0;
  sf_mex_import(c1_parentId, sf_mex_dup(c1_u), &c1_u0, 1, 3, 0U, 0, 0U, 0);
  c1_y = c1_u0;
  sf_mex_destroy(&c1_u);
  return c1_y;
}

static void init_dsm_address_info(SFc1_PACInstanceStruct *chartInstance)
{
}

/* SFunction Glue Code */
void sf_c1_PAC_get_check_sum(mxArray *plhs[])
{
  ((real_T *)mxGetPr((plhs[0])))[0] = (real_T)(2010210613U);
  ((real_T *)mxGetPr((plhs[0])))[1] = (real_T)(1407531752U);
  ((real_T *)mxGetPr((plhs[0])))[2] = (real_T)(986394070U);
  ((real_T *)mxGetPr((plhs[0])))[3] = (real_T)(1930254454U);
}

mxArray *sf_c1_PAC_get_autoinheritance_info(void)
{
  const char *autoinheritanceFields[] = { "checksum", "inputs", "parameters",
    "outputs", "locals" };

  mxArray *mxAutoinheritanceInfo = mxCreateStructMatrix(1,1,5,
    autoinheritanceFields);

  {
    mxArray *mxChecksum = mxCreateString("ZZ88QYBnaoKYZhdPp2RsLD");
    mxSetField(mxAutoinheritanceInfo,0,"checksum",mxChecksum);
  }

  {
    const char *dataFields[] = { "size", "type", "complexity" };

    mxArray *mxData = mxCreateStructMatrix(1,2,3,dataFields);

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,0,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }

    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,1,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,1,"type",mxType);
    }

    mxSetField(mxData,1,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"inputs",mxData);
  }

  {
    mxSetField(mxAutoinheritanceInfo,0,"parameters",mxCreateDoubleMatrix(0,0,
                mxREAL));
  }

  {
    const char *dataFields[] = { "size", "type", "complexity" };

    mxArray *mxData = mxCreateStructMatrix(1,1,3,dataFields);

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,0,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }

    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"outputs",mxData);
  }

  {
    mxSetField(mxAutoinheritanceInfo,0,"locals",mxCreateDoubleMatrix(0,0,mxREAL));
  }

  return(mxAutoinheritanceInfo);
}

static const mxArray *sf_get_sim_state_info_c1_PAC(void)
{
  const char *infoFields[] = { "chartChecksum", "varInfo" };

  mxArray *mxInfo = mxCreateStructMatrix(1, 1, 2, infoFields);
  const char *infoEncStr[] = {
    "100 S1x2'type','srcId','name','auxInfo'{{M[1],M[5],T\"v\",},{M[8],M[0],T\"is_active_c1_PAC\",}}"
  };

  mxArray *mxVarInfo = sf_mex_decode_encoded_mx_struct_array(infoEncStr, 2, 10);
  mxArray *mxChecksum = mxCreateDoubleMatrix(1, 4, mxREAL);
  sf_c1_PAC_get_check_sum(&mxChecksum);
  mxSetField(mxInfo, 0, infoFields[0], mxChecksum);
  mxSetField(mxInfo, 0, infoFields[1], mxVarInfo);
  return mxInfo;
}

static void chart_debug_initialization(SimStruct *S, unsigned int
  fullDebuggerInitialization)
{
  if (!sim_mode_is_rtw_gen(S)) {
    SFc1_PACInstanceStruct *chartInstance;
    chartInstance = (SFc1_PACInstanceStruct *) ((ChartInfoStruct *)
      (ssGetUserData(S)))->chartInstance;
    if (ssIsFirstInitCond(S) && fullDebuggerInitialization==1) {
      /* do this only if simulation is starting */
      {
        unsigned int chartAlreadyPresent;
        chartAlreadyPresent = sf_debug_initialize_chart(_PACMachineNumber_,
          1,
          1,
          1,
          3,
          0,
          0,
          0,
          0,
          0,
          &(chartInstance->chartNumber),
          &(chartInstance->instanceNumber),
          ssGetPath(S),
          (void *)S);
        if (chartAlreadyPresent==0) {
          /* this is the first instance */
          init_script_number_translation(_PACMachineNumber_,
            chartInstance->chartNumber);
          sf_debug_set_chart_disable_implicit_casting(_PACMachineNumber_,
            chartInstance->chartNumber,1);
          sf_debug_set_chart_event_thresholds(_PACMachineNumber_,
            chartInstance->chartNumber,
            0,
            0,
            0);
          _SFD_SET_DATA_PROPS(0,1,1,0,"T");
          _SFD_SET_DATA_PROPS(1,2,0,1,"v");
          _SFD_SET_DATA_PROPS(2,1,1,0,"P");
          _SFD_STATE_INFO(0,0,2);
          _SFD_CH_SUBSTATE_COUNT(0);
          _SFD_CH_SUBSTATE_DECOMP(0);
        }

        _SFD_CV_INIT_CHART(0,0,0,0);

        {
          _SFD_CV_INIT_STATE(0,0,0,0,0,0,NULL,NULL);
        }

        _SFD_CV_INIT_TRANS(0,0,NULL,NULL,0,NULL);

        /* Initialization of MATLAB Function Model Coverage */
        _SFD_CV_INIT_EML(0,1,1,3,0,0,0,0,1,0,0);
        _SFD_CV_INIT_EML_FCN(0,0,"eML_blk_kernel",0,-1,1147);
        _SFD_CV_INIT_EML_IF(0,1,0,83,91,-1,105);
        _SFD_CV_INIT_EML_IF(0,1,1,971,991,1021,1045);
        _SFD_CV_INIT_EML_IF(0,1,2,1021,1045,-1,1045);
        _SFD_CV_INIT_EML_WHILE(0,1,0,434,466,1113);
        _SFD_TRANS_COV_WTS(0,0,0,1,0);
        if (chartAlreadyPresent==0) {
          _SFD_TRANS_COV_MAPS(0,
                              0,NULL,NULL,
                              0,NULL,NULL,
                              1,NULL,NULL,
                              0,NULL,NULL);
        }

        _SFD_SET_DATA_COMPILED_PROPS(0,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c1_sf_marshallOut,(MexInFcnForType)NULL);
        _SFD_SET_DATA_COMPILED_PROPS(1,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c1_sf_marshallOut,(MexInFcnForType)c1_sf_marshallIn);
        _SFD_SET_DATA_COMPILED_PROPS(2,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c1_sf_marshallOut,(MexInFcnForType)NULL);

        {
          real_T *c1_T;
          real_T *c1_v;
          real_T *c1_P;
          c1_P = (real_T *)ssGetInputPortSignal(chartInstance->S, 1);
          c1_v = (real_T *)ssGetOutputPortSignal(chartInstance->S, 1);
          c1_T = (real_T *)ssGetInputPortSignal(chartInstance->S, 0);
          _SFD_SET_DATA_VALUE_PTR(0U, c1_T);
          _SFD_SET_DATA_VALUE_PTR(1U, c1_v);
          _SFD_SET_DATA_VALUE_PTR(2U, c1_P);
        }
      }
    } else {
      sf_debug_reset_current_state_configuration(_PACMachineNumber_,
        chartInstance->chartNumber,chartInstance->instanceNumber);
    }
  }
}

static const char* sf_get_instance_specialization()
{
  return "52QOf5rzVAbTn0jOzRnnWF";
}

static void sf_opaque_initialize_c1_PAC(void *chartInstanceVar)
{
  chart_debug_initialization(((SFc1_PACInstanceStruct*) chartInstanceVar)->S,0);
  initialize_params_c1_PAC((SFc1_PACInstanceStruct*) chartInstanceVar);
  initialize_c1_PAC((SFc1_PACInstanceStruct*) chartInstanceVar);
}

static void sf_opaque_enable_c1_PAC(void *chartInstanceVar)
{
  enable_c1_PAC((SFc1_PACInstanceStruct*) chartInstanceVar);
}

static void sf_opaque_disable_c1_PAC(void *chartInstanceVar)
{
  disable_c1_PAC((SFc1_PACInstanceStruct*) chartInstanceVar);
}

static void sf_opaque_gateway_c1_PAC(void *chartInstanceVar)
{
  sf_c1_PAC((SFc1_PACInstanceStruct*) chartInstanceVar);
}

extern const mxArray* sf_internal_get_sim_state_c1_PAC(SimStruct* S)
{
  ChartInfoStruct *chartInfo = (ChartInfoStruct*) ssGetUserData(S);
  mxArray *plhs[1] = { NULL };

  mxArray *prhs[4];
  int mxError = 0;
  prhs[0] = mxCreateString("chart_simctx_raw2high");
  prhs[1] = mxCreateDoubleScalar(ssGetSFuncBlockHandle(S));
  prhs[2] = (mxArray*) get_sim_state_c1_PAC((SFc1_PACInstanceStruct*)
    chartInfo->chartInstance);         /* raw sim ctx */
  prhs[3] = (mxArray*) sf_get_sim_state_info_c1_PAC();/* state var info */
  mxError = sf_mex_call_matlab(1, plhs, 4, prhs, "sfprivate");
  mxDestroyArray(prhs[0]);
  mxDestroyArray(prhs[1]);
  mxDestroyArray(prhs[2]);
  mxDestroyArray(prhs[3]);
  if (mxError || plhs[0] == NULL) {
    sf_mex_error_message("Stateflow Internal Error: \nError calling 'chart_simctx_raw2high'.\n");
  }

  return plhs[0];
}

extern void sf_internal_set_sim_state_c1_PAC(SimStruct* S, const mxArray *st)
{
  ChartInfoStruct *chartInfo = (ChartInfoStruct*) ssGetUserData(S);
  mxArray *plhs[1] = { NULL };

  mxArray *prhs[4];
  int mxError = 0;
  prhs[0] = mxCreateString("chart_simctx_high2raw");
  prhs[1] = mxCreateDoubleScalar(ssGetSFuncBlockHandle(S));
  prhs[2] = mxDuplicateArray(st);      /* high level simctx */
  prhs[3] = (mxArray*) sf_get_sim_state_info_c1_PAC();/* state var info */
  mxError = sf_mex_call_matlab(1, plhs, 4, prhs, "sfprivate");
  mxDestroyArray(prhs[0]);
  mxDestroyArray(prhs[1]);
  mxDestroyArray(prhs[2]);
  mxDestroyArray(prhs[3]);
  if (mxError || plhs[0] == NULL) {
    sf_mex_error_message("Stateflow Internal Error: \nError calling 'chart_simctx_high2raw'.\n");
  }

  set_sim_state_c1_PAC((SFc1_PACInstanceStruct*)chartInfo->chartInstance,
                       mxDuplicateArray(plhs[0]));
  mxDestroyArray(plhs[0]);
}

static const mxArray* sf_opaque_get_sim_state_c1_PAC(SimStruct* S)
{
  return sf_internal_get_sim_state_c1_PAC(S);
}

static void sf_opaque_set_sim_state_c1_PAC(SimStruct* S, const mxArray *st)
{
  sf_internal_set_sim_state_c1_PAC(S, st);
}

static void sf_opaque_terminate_c1_PAC(void *chartInstanceVar)
{
  if (chartInstanceVar!=NULL) {
    SimStruct *S = ((SFc1_PACInstanceStruct*) chartInstanceVar)->S;
    if (sim_mode_is_rtw_gen(S) || sim_mode_is_external(S)) {
      sf_clear_rtw_identifier(S);
    }

    finalize_c1_PAC((SFc1_PACInstanceStruct*) chartInstanceVar);
    free((void *)chartInstanceVar);
    ssSetUserData(S,NULL);
  }

  unload_PAC_optimization_info();
}

static void sf_opaque_init_subchart_simstructs(void *chartInstanceVar)
{
  initSimStructsc1_PAC((SFc1_PACInstanceStruct*) chartInstanceVar);
}

extern unsigned int sf_machine_global_initializer_called(void);
static void mdlProcessParameters_c1_PAC(SimStruct *S)
{
  int i;
  for (i=0;i<ssGetNumRunTimeParams(S);i++) {
    if (ssGetSFcnParamTunable(S,i)) {
      ssUpdateDlgParamAsRunTimeParam(S,i);
    }
  }

  if (sf_machine_global_initializer_called()) {
    initialize_params_c1_PAC((SFc1_PACInstanceStruct*)(((ChartInfoStruct *)
      ssGetUserData(S))->chartInstance));
  }
}

static void mdlSetWorkWidths_c1_PAC(SimStruct *S)
{
  if (sim_mode_is_rtw_gen(S) || sim_mode_is_external(S)) {
    mxArray *infoStruct = load_PAC_optimization_info();
    int_T chartIsInlinable =
      (int_T)sf_is_chart_inlinable(S,sf_get_instance_specialization(),infoStruct,
      1);
    ssSetStateflowIsInlinable(S,chartIsInlinable);
    ssSetRTWCG(S,sf_rtw_info_uint_prop(S,sf_get_instance_specialization(),
                infoStruct,1,"RTWCG"));
    ssSetEnableFcnIsTrivial(S,1);
    ssSetDisableFcnIsTrivial(S,1);
    ssSetNotMultipleInlinable(S,sf_rtw_info_uint_prop(S,
      sf_get_instance_specialization(),infoStruct,1,
      "gatewayCannotBeInlinedMultipleTimes"));
    if (chartIsInlinable) {
      ssSetInputPortOptimOpts(S, 0, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 1, SS_REUSABLE_AND_LOCAL);
      sf_mark_chart_expressionable_inputs(S,sf_get_instance_specialization(),
        infoStruct,1,2);
      sf_mark_chart_reusable_outputs(S,sf_get_instance_specialization(),
        infoStruct,1,1);
    }

    sf_set_rtw_dwork_info(S,sf_get_instance_specialization(),infoStruct,1);
    ssSetHasSubFunctions(S,!(chartIsInlinable));
  } else {
  }

  ssSetOptions(S,ssGetOptions(S)|SS_OPTION_WORKS_WITH_CODE_REUSE);
  ssSetChecksum0(S,(740004075U));
  ssSetChecksum1(S,(3016491235U));
  ssSetChecksum2(S,(1764409215U));
  ssSetChecksum3(S,(1176488856U));
  ssSetmdlDerivatives(S, NULL);
  ssSetExplicitFCSSCtrl(S,1);
  ssSupportsMultipleExecInstances(S,1);
}

static void mdlRTW_c1_PAC(SimStruct *S)
{
  if (sim_mode_is_rtw_gen(S)) {
    ssWriteRTWStrParam(S, "StateflowChartType", "Embedded MATLAB");
  }
}

static void mdlStart_c1_PAC(SimStruct *S)
{
  SFc1_PACInstanceStruct *chartInstance;
  chartInstance = (SFc1_PACInstanceStruct *)malloc(sizeof(SFc1_PACInstanceStruct));
  memset(chartInstance, 0, sizeof(SFc1_PACInstanceStruct));
  if (chartInstance==NULL) {
    sf_mex_error_message("Could not allocate memory for chart instance.");
  }

  chartInstance->chartInfo.chartInstance = chartInstance;
  chartInstance->chartInfo.isEMLChart = 1;
  chartInstance->chartInfo.chartInitialized = 0;
  chartInstance->chartInfo.sFunctionGateway = sf_opaque_gateway_c1_PAC;
  chartInstance->chartInfo.initializeChart = sf_opaque_initialize_c1_PAC;
  chartInstance->chartInfo.terminateChart = sf_opaque_terminate_c1_PAC;
  chartInstance->chartInfo.enableChart = sf_opaque_enable_c1_PAC;
  chartInstance->chartInfo.disableChart = sf_opaque_disable_c1_PAC;
  chartInstance->chartInfo.getSimState = sf_opaque_get_sim_state_c1_PAC;
  chartInstance->chartInfo.setSimState = sf_opaque_set_sim_state_c1_PAC;
  chartInstance->chartInfo.getSimStateInfo = sf_get_sim_state_info_c1_PAC;
  chartInstance->chartInfo.zeroCrossings = NULL;
  chartInstance->chartInfo.outputs = NULL;
  chartInstance->chartInfo.derivatives = NULL;
  chartInstance->chartInfo.mdlRTW = mdlRTW_c1_PAC;
  chartInstance->chartInfo.mdlStart = mdlStart_c1_PAC;
  chartInstance->chartInfo.mdlSetWorkWidths = mdlSetWorkWidths_c1_PAC;
  chartInstance->chartInfo.extModeExec = NULL;
  chartInstance->chartInfo.restoreLastMajorStepConfiguration = NULL;
  chartInstance->chartInfo.restoreBeforeLastMajorStepConfiguration = NULL;
  chartInstance->chartInfo.storeCurrentConfiguration = NULL;
  chartInstance->S = S;
  ssSetUserData(S,(void *)(&(chartInstance->chartInfo)));/* register the chart instance with simstruct */
  init_dsm_address_info(chartInstance);
  if (!sim_mode_is_rtw_gen(S)) {
  }

  sf_opaque_init_subchart_simstructs(chartInstance->chartInfo.chartInstance);
  chart_debug_initialization(S,1);
}

void c1_PAC_method_dispatcher(SimStruct *S, int_T method, void *data)
{
  switch (method) {
   case SS_CALL_MDL_START:
    mdlStart_c1_PAC(S);
    break;

   case SS_CALL_MDL_SET_WORK_WIDTHS:
    mdlSetWorkWidths_c1_PAC(S);
    break;

   case SS_CALL_MDL_PROCESS_PARAMETERS:
    mdlProcessParameters_c1_PAC(S);
    break;

   default:
    /* Unhandled method */
    sf_mex_error_message("Stateflow Internal Error:\n"
                         "Error calling c1_PAC_method_dispatcher.\n"
                         "Can't handle method %d.\n", method);
    break;
  }
}
