/* Include files */

#include "blascompat32.h"
#include "PAC_sfun.h"
#include "c4_PAC.h"
#include "mwmathutil.h"
#define CHARTINSTANCE_CHARTNUMBER      (chartInstance->chartNumber)
#define CHARTINSTANCE_INSTANCENUMBER   (chartInstance->instanceNumber)
#include "PAC_sfun_debug_macros.h"

/* Type Definitions */

/* Named Constants */
#define CALL_EVENT                     (-1)

/* Variable Declarations */

/* Variable Definitions */
static const char * c4_debug_family_names[24] = { "a1g", "a2g", "a3g", "a4g",
  "a5g", "a6g", "b1", "b2", "b3", "b4", "Tc", "Pc", "Pr", "Tmax", "Tmin", "Tmoy",
  "Tr", "zer", "zermax", "zermin", "nargin", "nargout", "P", "T" };

/* Function Declarations */
static void initialize_c4_PAC(SFc4_PACInstanceStruct *chartInstance);
static void initialize_params_c4_PAC(SFc4_PACInstanceStruct *chartInstance);
static void enable_c4_PAC(SFc4_PACInstanceStruct *chartInstance);
static void disable_c4_PAC(SFc4_PACInstanceStruct *chartInstance);
static void c4_update_debugger_state_c4_PAC(SFc4_PACInstanceStruct
  *chartInstance);
static const mxArray *get_sim_state_c4_PAC(SFc4_PACInstanceStruct *chartInstance);
static void set_sim_state_c4_PAC(SFc4_PACInstanceStruct *chartInstance, const
  mxArray *c4_st);
static void finalize_c4_PAC(SFc4_PACInstanceStruct *chartInstance);
static void sf_c4_PAC(SFc4_PACInstanceStruct *chartInstance);
static void c4_chartstep_c4_PAC(SFc4_PACInstanceStruct *chartInstance);
static void initSimStructsc4_PAC(SFc4_PACInstanceStruct *chartInstance);
static void init_script_number_translation(uint32_T c4_machineNumber, uint32_T
  c4_chartNumber);
static const mxArray *c4_sf_marshallOut(void *chartInstanceVoid, void *c4_inData);
static real_T c4_emlrt_marshallIn(SFc4_PACInstanceStruct *chartInstance, const
  mxArray *c4_T, const char_T *c4_identifier);
static real_T c4_b_emlrt_marshallIn(SFc4_PACInstanceStruct *chartInstance, const
  mxArray *c4_u, const emlrtMsgIdentifier *c4_parentId);
static void c4_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c4_mxArrayInData, const char_T *c4_varName, void *c4_outData);
static void c4_info_helper(c4_ResolvedFunctionInfo c4_info[13]);
static real_T c4_mpower(SFc4_PACInstanceStruct *chartInstance, real_T c4_a);
static void c4_eml_scalar_eg(SFc4_PACInstanceStruct *chartInstance);
static void c4_eml_error(SFc4_PACInstanceStruct *chartInstance);
static real_T c4_b_mpower(SFc4_PACInstanceStruct *chartInstance, real_T c4_a);
static real_T c4_c_mpower(SFc4_PACInstanceStruct *chartInstance, real_T c4_a);
static real_T c4_d_mpower(SFc4_PACInstanceStruct *chartInstance, real_T c4_a);
static const mxArray *c4_b_sf_marshallOut(void *chartInstanceVoid, void
  *c4_inData);
static int32_T c4_c_emlrt_marshallIn(SFc4_PACInstanceStruct *chartInstance,
  const mxArray *c4_u, const emlrtMsgIdentifier *c4_parentId);
static void c4_b_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c4_mxArrayInData, const char_T *c4_varName, void *c4_outData);
static uint8_T c4_d_emlrt_marshallIn(SFc4_PACInstanceStruct *chartInstance,
  const mxArray *c4_b_is_active_c4_PAC, const char_T *c4_identifier);
static uint8_T c4_e_emlrt_marshallIn(SFc4_PACInstanceStruct *chartInstance,
  const mxArray *c4_u, const emlrtMsgIdentifier *c4_parentId);
static void init_dsm_address_info(SFc4_PACInstanceStruct *chartInstance);

/* Function Definitions */
static void initialize_c4_PAC(SFc4_PACInstanceStruct *chartInstance)
{
  chartInstance->c4_sfEvent = CALL_EVENT;
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
  chartInstance->c4_is_active_c4_PAC = 0U;
}

static void initialize_params_c4_PAC(SFc4_PACInstanceStruct *chartInstance)
{
}

static void enable_c4_PAC(SFc4_PACInstanceStruct *chartInstance)
{
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
}

static void disable_c4_PAC(SFc4_PACInstanceStruct *chartInstance)
{
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
}

static void c4_update_debugger_state_c4_PAC(SFc4_PACInstanceStruct
  *chartInstance)
{
}

static const mxArray *get_sim_state_c4_PAC(SFc4_PACInstanceStruct *chartInstance)
{
  const mxArray *c4_st;
  const mxArray *c4_y = NULL;
  real_T c4_hoistedGlobal;
  real_T c4_u;
  const mxArray *c4_b_y = NULL;
  uint8_T c4_b_hoistedGlobal;
  uint8_T c4_b_u;
  const mxArray *c4_c_y = NULL;
  real_T *c4_T;
  c4_T = (real_T *)ssGetOutputPortSignal(chartInstance->S, 1);
  c4_st = NULL;
  c4_st = NULL;
  c4_y = NULL;
  sf_mex_assign(&c4_y, sf_mex_createcellarray(2), FALSE);
  c4_hoistedGlobal = *c4_T;
  c4_u = c4_hoistedGlobal;
  c4_b_y = NULL;
  sf_mex_assign(&c4_b_y, sf_mex_create("y", &c4_u, 0, 0U, 0U, 0U, 0), FALSE);
  sf_mex_setcell(c4_y, 0, c4_b_y);
  c4_b_hoistedGlobal = chartInstance->c4_is_active_c4_PAC;
  c4_b_u = c4_b_hoistedGlobal;
  c4_c_y = NULL;
  sf_mex_assign(&c4_c_y, sf_mex_create("y", &c4_b_u, 3, 0U, 0U, 0U, 0), FALSE);
  sf_mex_setcell(c4_y, 1, c4_c_y);
  sf_mex_assign(&c4_st, c4_y, FALSE);
  return c4_st;
}

static void set_sim_state_c4_PAC(SFc4_PACInstanceStruct *chartInstance, const
  mxArray *c4_st)
{
  const mxArray *c4_u;
  real_T *c4_T;
  c4_T = (real_T *)ssGetOutputPortSignal(chartInstance->S, 1);
  chartInstance->c4_doneDoubleBufferReInit = TRUE;
  c4_u = sf_mex_dup(c4_st);
  *c4_T = c4_emlrt_marshallIn(chartInstance, sf_mex_dup(sf_mex_getcell(c4_u, 0)),
    "T");
  chartInstance->c4_is_active_c4_PAC = c4_d_emlrt_marshallIn(chartInstance,
    sf_mex_dup(sf_mex_getcell(c4_u, 1)), "is_active_c4_PAC");
  sf_mex_destroy(&c4_u);
  c4_update_debugger_state_c4_PAC(chartInstance);
  sf_mex_destroy(&c4_st);
}

static void finalize_c4_PAC(SFc4_PACInstanceStruct *chartInstance)
{
}

static void sf_c4_PAC(SFc4_PACInstanceStruct *chartInstance)
{
  real_T *c4_T;
  real_T *c4_P;
  c4_P = (real_T *)ssGetInputPortSignal(chartInstance->S, 0);
  c4_T = (real_T *)ssGetOutputPortSignal(chartInstance->S, 1);
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
  _SFD_CC_CALL(CHART_ENTER_SFUNCTION_TAG, 3U, chartInstance->c4_sfEvent);
  _SFD_DATA_RANGE_CHECK(*c4_T, 0U);
  _SFD_DATA_RANGE_CHECK(*c4_P, 1U);
  chartInstance->c4_sfEvent = CALL_EVENT;
  c4_chartstep_c4_PAC(chartInstance);
  sf_debug_check_for_state_inconsistency(_PACMachineNumber_,
    chartInstance->chartNumber, chartInstance->instanceNumber);
}

static void c4_chartstep_c4_PAC(SFc4_PACInstanceStruct *chartInstance)
{
  real_T c4_hoistedGlobal;
  real_T c4_P;
  uint32_T c4_debug_family_var_map[24];
  real_T c4_a1g;
  real_T c4_a2g;
  real_T c4_a3g;
  real_T c4_a4g;
  real_T c4_a5g;
  real_T c4_a6g;
  real_T c4_b1;
  real_T c4_b2;
  real_T c4_b3;
  real_T c4_b4;
  real_T c4_Tc;
  real_T c4_Pc;
  real_T c4_Pr;
  real_T c4_Tmax;
  real_T c4_Tmin;
  real_T c4_Tmoy;
  real_T c4_Tr;
  real_T c4_zer;
  real_T c4_zermax;
  real_T c4_zermin;
  real_T c4_nargin = 1.0;
  real_T c4_nargout = 1.0;
  real_T c4_T;
  real_T c4_A;
  real_T c4_x;
  real_T c4_b_x;
  real_T c4_b_A;
  real_T c4_c_x;
  real_T c4_d_x;
  real_T c4_c_A;
  real_T c4_e_x;
  real_T c4_f_x;
  real_T c4_b;
  real_T c4_y;
  real_T c4_b_b;
  real_T c4_b_y;
  real_T c4_c_b;
  real_T c4_c_y;
  real_T c4_d_b;
  real_T c4_d_y;
  real_T c4_e_b;
  real_T c4_e_y;
  real_T c4_d_A;
  real_T c4_B;
  real_T c4_g_x;
  real_T c4_f_y;
  real_T c4_h_x;
  real_T c4_g_y;
  real_T c4_h_y;
  real_T c4_i_x;
  real_T c4_j_x;
  real_T c4_e_A;
  real_T c4_k_x;
  real_T c4_l_x;
  real_T c4_f_b;
  real_T c4_i_y;
  real_T c4_g_b;
  real_T c4_j_y;
  real_T c4_h_b;
  real_T c4_k_y;
  real_T c4_i_b;
  real_T c4_l_y;
  real_T c4_j_b;
  real_T c4_m_y;
  real_T c4_f_A;
  real_T c4_b_B;
  real_T c4_m_x;
  real_T c4_n_y;
  real_T c4_n_x;
  real_T c4_o_y;
  real_T c4_p_y;
  real_T c4_o_x;
  real_T c4_p_x;
  real_T c4_a;
  real_T c4_k_b;
  real_T c4_q_y;
  real_T c4_b_a;
  real_T c4_l_b;
  real_T c4_r_y;
  real_T c4_g_A;
  real_T c4_q_x;
  real_T c4_r_x;
  real_T *c4_b_P;
  real_T *c4_b_T;
  c4_b_P = (real_T *)ssGetInputPortSignal(chartInstance->S, 0);
  c4_b_T = (real_T *)ssGetOutputPortSignal(chartInstance->S, 1);
  _SFD_CC_CALL(CHART_ENTER_DURING_FUNCTION_TAG, 3U, chartInstance->c4_sfEvent);
  c4_hoistedGlobal = *c4_b_P;
  c4_P = c4_hoistedGlobal;
  sf_debug_symbol_scope_push_eml(0U, 24U, 24U, c4_debug_family_names,
    c4_debug_family_var_map);
  sf_debug_symbol_scope_add_eml(&c4_a1g, 0U, c4_sf_marshallOut);
  sf_debug_symbol_scope_add_eml(&c4_a2g, 1U, c4_sf_marshallOut);
  sf_debug_symbol_scope_add_eml(&c4_a3g, 2U, c4_sf_marshallOut);
  sf_debug_symbol_scope_add_eml(&c4_a4g, 3U, c4_sf_marshallOut);
  sf_debug_symbol_scope_add_eml(&c4_a5g, 4U, c4_sf_marshallOut);
  sf_debug_symbol_scope_add_eml_importable(&c4_a6g, 5U, c4_sf_marshallOut,
    c4_sf_marshallIn);
  sf_debug_symbol_scope_add_eml(&c4_b1, 6U, c4_sf_marshallOut);
  sf_debug_symbol_scope_add_eml(&c4_b2, 7U, c4_sf_marshallOut);
  sf_debug_symbol_scope_add_eml(&c4_b3, 8U, c4_sf_marshallOut);
  sf_debug_symbol_scope_add_eml(&c4_b4, 9U, c4_sf_marshallOut);
  sf_debug_symbol_scope_add_eml(&c4_Tc, 10U, c4_sf_marshallOut);
  sf_debug_symbol_scope_add_eml(&c4_Pc, 11U, c4_sf_marshallOut);
  sf_debug_symbol_scope_add_eml_importable(&c4_Pr, 12U, c4_sf_marshallOut,
    c4_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c4_Tmax, 13U, c4_sf_marshallOut,
    c4_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c4_Tmin, 14U, c4_sf_marshallOut,
    c4_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c4_Tmoy, 15U, c4_sf_marshallOut,
    c4_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c4_Tr, 16U, c4_sf_marshallOut,
    c4_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c4_zer, 17U, c4_sf_marshallOut,
    c4_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c4_zermax, 18U, c4_sf_marshallOut,
    c4_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c4_zermin, 19U, c4_sf_marshallOut,
    c4_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c4_nargin, 20U, c4_sf_marshallOut,
    c4_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c4_nargout, 21U, c4_sf_marshallOut,
    c4_sf_marshallIn);
  sf_debug_symbol_scope_add_eml(&c4_P, 22U, c4_sf_marshallOut);
  sf_debug_symbol_scope_add_eml_importable(&c4_T, 23U, c4_sf_marshallOut,
    c4_sf_marshallIn);
  CV_EML_FCN(0, 0);
  _SFD_EML_CALL(0U, chartInstance->c4_sfEvent, 3);
  if (CV_EML_IF(0, 1, 0, c4_P < 1.0)) {
    _SFD_EML_CALL(0U, chartInstance->c4_sfEvent, 4);
    c4_P = 1.0;
  }

  _SFD_EML_CALL(0U, chartInstance->c4_sfEvent, 7);
  c4_a1g = -7.7069;
  _SFD_EML_CALL(0U, chartInstance->c4_sfEvent, 8);
  c4_a2g = 2.4932;
  _SFD_EML_CALL(0U, chartInstance->c4_sfEvent, 9);
  c4_a3g = -2.9212;
  _SFD_EML_CALL(0U, chartInstance->c4_sfEvent, 10);
  c4_a4g = -3.8684;
  _SFD_EML_CALL(0U, chartInstance->c4_sfEvent, 11);
  c4_a5g = 0.46898;
  _SFD_EML_CALL(0U, chartInstance->c4_sfEvent, 12);
  c4_a6g = -8.336E-5;
  _SFD_EML_CALL(0U, chartInstance->c4_sfEvent, 13);
  c4_b1 = 1.5158;
  _SFD_EML_CALL(0U, chartInstance->c4_sfEvent, 14);
  c4_b2 = 1.9907;
  _SFD_EML_CALL(0U, chartInstance->c4_sfEvent, 15);
  c4_b3 = 4.3798;
  _SFD_EML_CALL(0U, chartInstance->c4_sfEvent, 16);
  c4_b4 = 1.7461;
  _SFD_EML_CALL(0U, chartInstance->c4_sfEvent, 17);
  c4_Tc = 374.21;
  _SFD_EML_CALL(0U, chartInstance->c4_sfEvent, 18);
  c4_Pc = 40.59;
  _SFD_EML_CALL(0U, chartInstance->c4_sfEvent, 19);
  c4_A = c4_P;
  c4_x = c4_A;
  c4_b_x = c4_x;
  c4_Pr = c4_b_x / 40.59;
  _SFD_EML_CALL(0U, chartInstance->c4_sfEvent, 21);
  c4_Tmax = c4_Tc;
  _SFD_EML_CALL(0U, chartInstance->c4_sfEvent, 22);
  c4_Tmin = 100.0;
  _SFD_EML_CALL(0U, chartInstance->c4_sfEvent, 23);
  c4_Tmoy = 100.0;
  _SFD_EML_CALL(0U, chartInstance->c4_sfEvent, 24);
  while (CV_EML_WHILE(0, 1, 0, c4_Tmax - c4_Tmin >= 1.0E-9)) {
    _SFD_EML_CALL(0U, chartInstance->c4_sfEvent, 25);
    c4_b_A = c4_Tmax + c4_Tmin;
    c4_c_x = c4_b_A;
    c4_d_x = c4_c_x;
    c4_Tmoy = c4_d_x / 2.0;
    _SFD_EML_CALL(0U, chartInstance->c4_sfEvent, 26);
    c4_c_A = c4_Tmoy;
    c4_e_x = c4_c_A;
    c4_f_x = c4_e_x;
    c4_Tr = c4_f_x / 374.21;
    _SFD_EML_CALL(0U, chartInstance->c4_sfEvent, 27);
    c4_b = 1.0 - c4_Tr;
    c4_y = -7.7069 * c4_b;
    c4_b_b = c4_mpower(chartInstance, 1.0 - c4_Tr);
    c4_b_y = 2.4932 * c4_b_b;
    c4_c_b = c4_b_mpower(chartInstance, 1.0 - c4_Tr);
    c4_c_y = -2.9212 * c4_c_b;
    c4_d_b = c4_c_mpower(chartInstance, 1.0 - c4_Tr);
    c4_d_y = -3.8684 * c4_d_b;
    c4_e_b = c4_d_mpower(chartInstance, 1.0 - c4_Tr);
    c4_e_y = 0.46898 * c4_e_b;
    c4_d_A = ((((c4_y + c4_b_y) + c4_c_y) + c4_d_y) + c4_e_y) + c4_a6g;
    c4_B = c4_Tr;
    c4_g_x = c4_d_A;
    c4_f_y = c4_B;
    c4_h_x = c4_g_x;
    c4_g_y = c4_f_y;
    c4_h_y = c4_h_x / c4_g_y;
    c4_i_x = c4_h_y;
    c4_j_x = c4_i_x;
    c4_j_x = muDoubleScalarExp(c4_j_x);
    c4_zer = c4_Pr - c4_j_x;
    _SFD_EML_CALL(0U, chartInstance->c4_sfEvent, 28);
    c4_zermax = c4_zer;
    _SFD_EML_CALL(0U, chartInstance->c4_sfEvent, 29);
    c4_e_A = c4_Tmin;
    c4_k_x = c4_e_A;
    c4_l_x = c4_k_x;
    c4_Tr = c4_l_x / 374.21;
    _SFD_EML_CALL(0U, chartInstance->c4_sfEvent, 30);
    c4_f_b = 1.0 - c4_Tr;
    c4_i_y = -7.7069 * c4_f_b;
    c4_g_b = c4_mpower(chartInstance, 1.0 - c4_Tr);
    c4_j_y = 2.4932 * c4_g_b;
    c4_h_b = c4_b_mpower(chartInstance, 1.0 - c4_Tr);
    c4_k_y = -2.9212 * c4_h_b;
    c4_i_b = c4_c_mpower(chartInstance, 1.0 - c4_Tr);
    c4_l_y = -3.8684 * c4_i_b;
    c4_j_b = c4_d_mpower(chartInstance, 1.0 - c4_Tr);
    c4_m_y = 0.46898 * c4_j_b;
    c4_f_A = ((((c4_i_y + c4_j_y) + c4_k_y) + c4_l_y) + c4_m_y) + c4_a6g;
    c4_b_B = c4_Tr;
    c4_m_x = c4_f_A;
    c4_n_y = c4_b_B;
    c4_n_x = c4_m_x;
    c4_o_y = c4_n_y;
    c4_p_y = c4_n_x / c4_o_y;
    c4_o_x = c4_p_y;
    c4_p_x = c4_o_x;
    c4_p_x = muDoubleScalarExp(c4_p_x);
    c4_zer = c4_Pr - c4_p_x;
    _SFD_EML_CALL(0U, chartInstance->c4_sfEvent, 31);
    c4_zermin = c4_zer;
    _SFD_EML_CALL(0U, chartInstance->c4_sfEvent, 33);
    c4_a = c4_zermax;
    c4_k_b = c4_zermin;
    c4_q_y = c4_a * c4_k_b;
    if (CV_EML_IF(0, 1, 1, c4_q_y < 0.0)) {
      _SFD_EML_CALL(0U, chartInstance->c4_sfEvent, 34);
      c4_Tmax = c4_Tmoy;
    } else {
      _SFD_EML_CALL(0U, chartInstance->c4_sfEvent, 35);
      c4_b_a = c4_zermax;
      c4_l_b = c4_zermin;
      c4_r_y = c4_b_a * c4_l_b;
      if (CV_EML_IF(0, 1, 2, c4_r_y > 0.0)) {
        _SFD_EML_CALL(0U, chartInstance->c4_sfEvent, 36);
        c4_Tmin = c4_Tmoy;
      }
    }

    _SFD_EML_CALL(0U, chartInstance->c4_sfEvent, 38);
    c4_g_A = c4_Tmax + c4_Tmin;
    c4_q_x = c4_g_A;
    c4_r_x = c4_q_x;
    c4_Tmoy = c4_r_x / 2.0;
    _SFD_EML_CALL(0U, chartInstance->c4_sfEvent, 24);
    sf_mex_listen_for_ctrl_c(chartInstance->S);
  }

  _SFD_EML_CALL(0U, chartInstance->c4_sfEvent, 44);
  c4_T = c4_Tmoy;
  _SFD_EML_CALL(0U, chartInstance->c4_sfEvent, -44);
  sf_debug_symbol_scope_pop();
  *c4_b_T = c4_T;
  _SFD_CC_CALL(EXIT_OUT_OF_FUNCTION_TAG, 3U, chartInstance->c4_sfEvent);
}

static void initSimStructsc4_PAC(SFc4_PACInstanceStruct *chartInstance)
{
}

static void init_script_number_translation(uint32_T c4_machineNumber, uint32_T
  c4_chartNumber)
{
}

static const mxArray *c4_sf_marshallOut(void *chartInstanceVoid, void *c4_inData)
{
  const mxArray *c4_mxArrayOutData = NULL;
  real_T c4_u;
  const mxArray *c4_y = NULL;
  SFc4_PACInstanceStruct *chartInstance;
  chartInstance = (SFc4_PACInstanceStruct *)chartInstanceVoid;
  c4_mxArrayOutData = NULL;
  c4_u = *(real_T *)c4_inData;
  c4_y = NULL;
  sf_mex_assign(&c4_y, sf_mex_create("y", &c4_u, 0, 0U, 0U, 0U, 0), FALSE);
  sf_mex_assign(&c4_mxArrayOutData, c4_y, FALSE);
  return c4_mxArrayOutData;
}

static real_T c4_emlrt_marshallIn(SFc4_PACInstanceStruct *chartInstance, const
  mxArray *c4_T, const char_T *c4_identifier)
{
  real_T c4_y;
  emlrtMsgIdentifier c4_thisId;
  c4_thisId.fIdentifier = c4_identifier;
  c4_thisId.fParent = NULL;
  c4_y = c4_b_emlrt_marshallIn(chartInstance, sf_mex_dup(c4_T), &c4_thisId);
  sf_mex_destroy(&c4_T);
  return c4_y;
}

static real_T c4_b_emlrt_marshallIn(SFc4_PACInstanceStruct *chartInstance, const
  mxArray *c4_u, const emlrtMsgIdentifier *c4_parentId)
{
  real_T c4_y;
  real_T c4_d0;
  sf_mex_import(c4_parentId, sf_mex_dup(c4_u), &c4_d0, 1, 0, 0U, 0, 0U, 0);
  c4_y = c4_d0;
  sf_mex_destroy(&c4_u);
  return c4_y;
}

static void c4_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c4_mxArrayInData, const char_T *c4_varName, void *c4_outData)
{
  const mxArray *c4_T;
  const char_T *c4_identifier;
  emlrtMsgIdentifier c4_thisId;
  real_T c4_y;
  SFc4_PACInstanceStruct *chartInstance;
  chartInstance = (SFc4_PACInstanceStruct *)chartInstanceVoid;
  c4_T = sf_mex_dup(c4_mxArrayInData);
  c4_identifier = c4_varName;
  c4_thisId.fIdentifier = c4_identifier;
  c4_thisId.fParent = NULL;
  c4_y = c4_b_emlrt_marshallIn(chartInstance, sf_mex_dup(c4_T), &c4_thisId);
  sf_mex_destroy(&c4_T);
  *(real_T *)c4_outData = c4_y;
  sf_mex_destroy(&c4_mxArrayInData);
}

const mxArray *sf_c4_PAC_get_eml_resolved_functions_info(void)
{
  const mxArray *c4_nameCaptureInfo;
  c4_ResolvedFunctionInfo c4_info[13];
  const mxArray *c4_m0 = NULL;
  int32_T c4_i0;
  c4_ResolvedFunctionInfo *c4_r0;
  c4_nameCaptureInfo = NULL;
  c4_nameCaptureInfo = NULL;
  c4_info_helper(c4_info);
  sf_mex_assign(&c4_m0, sf_mex_createstruct("nameCaptureInfo", 1, 13), FALSE);
  for (c4_i0 = 0; c4_i0 < 13; c4_i0++) {
    c4_r0 = &c4_info[c4_i0];
    sf_mex_addfield(c4_m0, sf_mex_create("nameCaptureInfo", c4_r0->context, 15,
      0U, 0U, 0U, 2, 1, strlen(c4_r0->context)), "context", "nameCaptureInfo",
                    c4_i0);
    sf_mex_addfield(c4_m0, sf_mex_create("nameCaptureInfo", c4_r0->name, 15, 0U,
      0U, 0U, 2, 1, strlen(c4_r0->name)), "name", "nameCaptureInfo", c4_i0);
    sf_mex_addfield(c4_m0, sf_mex_create("nameCaptureInfo", c4_r0->dominantType,
      15, 0U, 0U, 0U, 2, 1, strlen(c4_r0->dominantType)), "dominantType",
                    "nameCaptureInfo", c4_i0);
    sf_mex_addfield(c4_m0, sf_mex_create("nameCaptureInfo", c4_r0->resolved, 15,
      0U, 0U, 0U, 2, 1, strlen(c4_r0->resolved)), "resolved", "nameCaptureInfo",
                    c4_i0);
    sf_mex_addfield(c4_m0, sf_mex_create("nameCaptureInfo", &c4_r0->fileTimeLo,
      7, 0U, 0U, 0U, 0), "fileTimeLo", "nameCaptureInfo", c4_i0);
    sf_mex_addfield(c4_m0, sf_mex_create("nameCaptureInfo", &c4_r0->fileTimeHi,
      7, 0U, 0U, 0U, 0), "fileTimeHi", "nameCaptureInfo", c4_i0);
    sf_mex_addfield(c4_m0, sf_mex_create("nameCaptureInfo", &c4_r0->mFileTimeLo,
      7, 0U, 0U, 0U, 0), "mFileTimeLo", "nameCaptureInfo", c4_i0);
    sf_mex_addfield(c4_m0, sf_mex_create("nameCaptureInfo", &c4_r0->mFileTimeHi,
      7, 0U, 0U, 0U, 0), "mFileTimeHi", "nameCaptureInfo", c4_i0);
  }

  sf_mex_assign(&c4_nameCaptureInfo, c4_m0, FALSE);
  sf_mex_emlrtNameCapturePostProcessR2012a(&c4_nameCaptureInfo);
  return c4_nameCaptureInfo;
}

static void c4_info_helper(c4_ResolvedFunctionInfo c4_info[13])
{
  c4_info[0].context = "";
  c4_info[0].name = "mrdivide";
  c4_info[0].dominantType = "double";
  c4_info[0].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mrdivide.p";
  c4_info[0].fileTimeLo = 1342810944U;
  c4_info[0].fileTimeHi = 0U;
  c4_info[0].mFileTimeLo = 1319729966U;
  c4_info[0].mFileTimeHi = 0U;
  c4_info[1].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mrdivide.p";
  c4_info[1].name = "rdivide";
  c4_info[1].dominantType = "double";
  c4_info[1].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/rdivide.m";
  c4_info[1].fileTimeLo = 1286818844U;
  c4_info[1].fileTimeHi = 0U;
  c4_info[1].mFileTimeLo = 0U;
  c4_info[1].mFileTimeHi = 0U;
  c4_info[2].context = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/rdivide.m";
  c4_info[2].name = "eml_div";
  c4_info[2].dominantType = "double";
  c4_info[2].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_div.m";
  c4_info[2].fileTimeLo = 1313347810U;
  c4_info[2].fileTimeHi = 0U;
  c4_info[2].mFileTimeLo = 0U;
  c4_info[2].mFileTimeHi = 0U;
  c4_info[3].context = "";
  c4_info[3].name = "mtimes";
  c4_info[3].dominantType = "double";
  c4_info[3].resolved = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mtimes.m";
  c4_info[3].fileTimeLo = 1289519692U;
  c4_info[3].fileTimeHi = 0U;
  c4_info[3].mFileTimeLo = 0U;
  c4_info[3].mFileTimeHi = 0U;
  c4_info[4].context = "";
  c4_info[4].name = "mpower";
  c4_info[4].dominantType = "double";
  c4_info[4].resolved = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mpower.m";
  c4_info[4].fileTimeLo = 1286818842U;
  c4_info[4].fileTimeHi = 0U;
  c4_info[4].mFileTimeLo = 0U;
  c4_info[4].mFileTimeHi = 0U;
  c4_info[5].context = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mpower.m";
  c4_info[5].name = "power";
  c4_info[5].dominantType = "double";
  c4_info[5].resolved = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/power.m";
  c4_info[5].fileTimeLo = 1336522096U;
  c4_info[5].fileTimeHi = 0U;
  c4_info[5].mFileTimeLo = 0U;
  c4_info[5].mFileTimeHi = 0U;
  c4_info[6].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/power.m!fltpower";
  c4_info[6].name = "eml_scalar_eg";
  c4_info[6].dominantType = "double";
  c4_info[6].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_scalar_eg.m";
  c4_info[6].fileTimeLo = 1286818796U;
  c4_info[6].fileTimeHi = 0U;
  c4_info[6].mFileTimeLo = 0U;
  c4_info[6].mFileTimeHi = 0U;
  c4_info[7].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/power.m!fltpower";
  c4_info[7].name = "eml_scalexp_alloc";
  c4_info[7].dominantType = "double";
  c4_info[7].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_scalexp_alloc.m";
  c4_info[7].fileTimeLo = 1330608434U;
  c4_info[7].fileTimeHi = 0U;
  c4_info[7].mFileTimeLo = 0U;
  c4_info[7].mFileTimeHi = 0U;
  c4_info[8].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/power.m!fltpower";
  c4_info[8].name = "floor";
  c4_info[8].dominantType = "double";
  c4_info[8].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/floor.m";
  c4_info[8].fileTimeLo = 1286818742U;
  c4_info[8].fileTimeHi = 0U;
  c4_info[8].mFileTimeLo = 0U;
  c4_info[8].mFileTimeHi = 0U;
  c4_info[9].context = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/floor.m";
  c4_info[9].name = "eml_scalar_floor";
  c4_info[9].dominantType = "double";
  c4_info[9].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/eml_scalar_floor.m";
  c4_info[9].fileTimeLo = 1286818726U;
  c4_info[9].fileTimeHi = 0U;
  c4_info[9].mFileTimeLo = 0U;
  c4_info[9].mFileTimeHi = 0U;
  c4_info[10].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/power.m!fltpower";
  c4_info[10].name = "eml_error";
  c4_info[10].dominantType = "char";
  c4_info[10].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_error.m";
  c4_info[10].fileTimeLo = 1305318000U;
  c4_info[10].fileTimeHi = 0U;
  c4_info[10].mFileTimeLo = 0U;
  c4_info[10].mFileTimeHi = 0U;
  c4_info[11].context = "";
  c4_info[11].name = "exp";
  c4_info[11].dominantType = "double";
  c4_info[11].resolved = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/exp.m";
  c4_info[11].fileTimeLo = 1286818740U;
  c4_info[11].fileTimeHi = 0U;
  c4_info[11].mFileTimeLo = 0U;
  c4_info[11].mFileTimeHi = 0U;
  c4_info[12].context = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/exp.m";
  c4_info[12].name = "eml_scalar_exp";
  c4_info[12].dominantType = "double";
  c4_info[12].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/eml_scalar_exp.m";
  c4_info[12].fileTimeLo = 1301328464U;
  c4_info[12].fileTimeHi = 0U;
  c4_info[12].mFileTimeLo = 0U;
  c4_info[12].mFileTimeHi = 0U;
}

static real_T c4_mpower(SFc4_PACInstanceStruct *chartInstance, real_T c4_a)
{
  real_T c4_b_a;
  real_T c4_c_a;
  real_T c4_ak;
  c4_b_a = c4_a;
  c4_c_a = c4_b_a;
  c4_eml_scalar_eg(chartInstance);
  c4_ak = c4_c_a;
  if (c4_ak < 0.0) {
    c4_eml_error(chartInstance);
  }

  return muDoubleScalarPower(c4_ak, 1.5158);
}

static void c4_eml_scalar_eg(SFc4_PACInstanceStruct *chartInstance)
{
}

static void c4_eml_error(SFc4_PACInstanceStruct *chartInstance)
{
  int32_T c4_i1;
  static char_T c4_varargin_1[31] = { 'C', 'o', 'd', 'e', 'r', ':', 't', 'o',
    'o', 'l', 'b', 'o', 'x', ':', 'p', 'o', 'w', 'e', 'r', '_', 'd', 'o', 'm',
    'a', 'i', 'n', 'E', 'r', 'r', 'o', 'r' };

  char_T c4_u[31];
  const mxArray *c4_y = NULL;
  for (c4_i1 = 0; c4_i1 < 31; c4_i1++) {
    c4_u[c4_i1] = c4_varargin_1[c4_i1];
  }

  c4_y = NULL;
  sf_mex_assign(&c4_y, sf_mex_create("y", c4_u, 10, 0U, 1U, 0U, 2, 1, 31), FALSE);
  sf_mex_call_debug("error", 0U, 1U, 14, sf_mex_call_debug("message", 1U, 1U, 14,
    c4_y));
}

static real_T c4_b_mpower(SFc4_PACInstanceStruct *chartInstance, real_T c4_a)
{
  real_T c4_b_a;
  real_T c4_c_a;
  real_T c4_ak;
  c4_b_a = c4_a;
  c4_c_a = c4_b_a;
  c4_eml_scalar_eg(chartInstance);
  c4_ak = c4_c_a;
  if (c4_ak < 0.0) {
    c4_eml_error(chartInstance);
  }

  return muDoubleScalarPower(c4_ak, 1.9907);
}

static real_T c4_c_mpower(SFc4_PACInstanceStruct *chartInstance, real_T c4_a)
{
  real_T c4_b_a;
  real_T c4_c_a;
  real_T c4_ak;
  c4_b_a = c4_a;
  c4_c_a = c4_b_a;
  c4_eml_scalar_eg(chartInstance);
  c4_ak = c4_c_a;
  if (c4_ak < 0.0) {
    c4_eml_error(chartInstance);
  }

  return muDoubleScalarPower(c4_ak, 4.3798);
}

static real_T c4_d_mpower(SFc4_PACInstanceStruct *chartInstance, real_T c4_a)
{
  real_T c4_b_a;
  real_T c4_c_a;
  real_T c4_ak;
  c4_b_a = c4_a;
  c4_c_a = c4_b_a;
  c4_eml_scalar_eg(chartInstance);
  c4_ak = c4_c_a;
  if (c4_ak < 0.0) {
    c4_eml_error(chartInstance);
  }

  return muDoubleScalarPower(c4_ak, 1.7461);
}

static const mxArray *c4_b_sf_marshallOut(void *chartInstanceVoid, void
  *c4_inData)
{
  const mxArray *c4_mxArrayOutData = NULL;
  int32_T c4_u;
  const mxArray *c4_y = NULL;
  SFc4_PACInstanceStruct *chartInstance;
  chartInstance = (SFc4_PACInstanceStruct *)chartInstanceVoid;
  c4_mxArrayOutData = NULL;
  c4_u = *(int32_T *)c4_inData;
  c4_y = NULL;
  sf_mex_assign(&c4_y, sf_mex_create("y", &c4_u, 6, 0U, 0U, 0U, 0), FALSE);
  sf_mex_assign(&c4_mxArrayOutData, c4_y, FALSE);
  return c4_mxArrayOutData;
}

static int32_T c4_c_emlrt_marshallIn(SFc4_PACInstanceStruct *chartInstance,
  const mxArray *c4_u, const emlrtMsgIdentifier *c4_parentId)
{
  int32_T c4_y;
  int32_T c4_i2;
  sf_mex_import(c4_parentId, sf_mex_dup(c4_u), &c4_i2, 1, 6, 0U, 0, 0U, 0);
  c4_y = c4_i2;
  sf_mex_destroy(&c4_u);
  return c4_y;
}

static void c4_b_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c4_mxArrayInData, const char_T *c4_varName, void *c4_outData)
{
  const mxArray *c4_b_sfEvent;
  const char_T *c4_identifier;
  emlrtMsgIdentifier c4_thisId;
  int32_T c4_y;
  SFc4_PACInstanceStruct *chartInstance;
  chartInstance = (SFc4_PACInstanceStruct *)chartInstanceVoid;
  c4_b_sfEvent = sf_mex_dup(c4_mxArrayInData);
  c4_identifier = c4_varName;
  c4_thisId.fIdentifier = c4_identifier;
  c4_thisId.fParent = NULL;
  c4_y = c4_c_emlrt_marshallIn(chartInstance, sf_mex_dup(c4_b_sfEvent),
    &c4_thisId);
  sf_mex_destroy(&c4_b_sfEvent);
  *(int32_T *)c4_outData = c4_y;
  sf_mex_destroy(&c4_mxArrayInData);
}

static uint8_T c4_d_emlrt_marshallIn(SFc4_PACInstanceStruct *chartInstance,
  const mxArray *c4_b_is_active_c4_PAC, const char_T *c4_identifier)
{
  uint8_T c4_y;
  emlrtMsgIdentifier c4_thisId;
  c4_thisId.fIdentifier = c4_identifier;
  c4_thisId.fParent = NULL;
  c4_y = c4_e_emlrt_marshallIn(chartInstance, sf_mex_dup(c4_b_is_active_c4_PAC),
    &c4_thisId);
  sf_mex_destroy(&c4_b_is_active_c4_PAC);
  return c4_y;
}

static uint8_T c4_e_emlrt_marshallIn(SFc4_PACInstanceStruct *chartInstance,
  const mxArray *c4_u, const emlrtMsgIdentifier *c4_parentId)
{
  uint8_T c4_y;
  uint8_T c4_u0;
  sf_mex_import(c4_parentId, sf_mex_dup(c4_u), &c4_u0, 1, 3, 0U, 0, 0U, 0);
  c4_y = c4_u0;
  sf_mex_destroy(&c4_u);
  return c4_y;
}

static void init_dsm_address_info(SFc4_PACInstanceStruct *chartInstance)
{
}

/* SFunction Glue Code */
void sf_c4_PAC_get_check_sum(mxArray *plhs[])
{
  ((real_T *)mxGetPr((plhs[0])))[0] = (real_T)(4146264498U);
  ((real_T *)mxGetPr((plhs[0])))[1] = (real_T)(434514724U);
  ((real_T *)mxGetPr((plhs[0])))[2] = (real_T)(1200559168U);
  ((real_T *)mxGetPr((plhs[0])))[3] = (real_T)(1868183727U);
}

mxArray *sf_c4_PAC_get_autoinheritance_info(void)
{
  const char *autoinheritanceFields[] = { "checksum", "inputs", "parameters",
    "outputs", "locals" };

  mxArray *mxAutoinheritanceInfo = mxCreateStructMatrix(1,1,5,
    autoinheritanceFields);

  {
    mxArray *mxChecksum = mxCreateString("vIMOwh5T0dh3V9GlVOYTRE");
    mxSetField(mxAutoinheritanceInfo,0,"checksum",mxChecksum);
  }

  {
    const char *dataFields[] = { "size", "type", "complexity" };

    mxArray *mxData = mxCreateStructMatrix(1,1,3,dataFields);

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,0,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }

    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"inputs",mxData);
  }

  {
    mxSetField(mxAutoinheritanceInfo,0,"parameters",mxCreateDoubleMatrix(0,0,
                mxREAL));
  }

  {
    const char *dataFields[] = { "size", "type", "complexity" };

    mxArray *mxData = mxCreateStructMatrix(1,1,3,dataFields);

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,0,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }

    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"outputs",mxData);
  }

  {
    mxSetField(mxAutoinheritanceInfo,0,"locals",mxCreateDoubleMatrix(0,0,mxREAL));
  }

  return(mxAutoinheritanceInfo);
}

static const mxArray *sf_get_sim_state_info_c4_PAC(void)
{
  const char *infoFields[] = { "chartChecksum", "varInfo" };

  mxArray *mxInfo = mxCreateStructMatrix(1, 1, 2, infoFields);
  const char *infoEncStr[] = {
    "100 S1x2'type','srcId','name','auxInfo'{{M[1],M[6],T\"T\",},{M[8],M[0],T\"is_active_c4_PAC\",}}"
  };

  mxArray *mxVarInfo = sf_mex_decode_encoded_mx_struct_array(infoEncStr, 2, 10);
  mxArray *mxChecksum = mxCreateDoubleMatrix(1, 4, mxREAL);
  sf_c4_PAC_get_check_sum(&mxChecksum);
  mxSetField(mxInfo, 0, infoFields[0], mxChecksum);
  mxSetField(mxInfo, 0, infoFields[1], mxVarInfo);
  return mxInfo;
}

static void chart_debug_initialization(SimStruct *S, unsigned int
  fullDebuggerInitialization)
{
  if (!sim_mode_is_rtw_gen(S)) {
    SFc4_PACInstanceStruct *chartInstance;
    chartInstance = (SFc4_PACInstanceStruct *) ((ChartInfoStruct *)
      (ssGetUserData(S)))->chartInstance;
    if (ssIsFirstInitCond(S) && fullDebuggerInitialization==1) {
      /* do this only if simulation is starting */
      {
        unsigned int chartAlreadyPresent;
        chartAlreadyPresent = sf_debug_initialize_chart(_PACMachineNumber_,
          4,
          1,
          1,
          2,
          0,
          0,
          0,
          0,
          0,
          &(chartInstance->chartNumber),
          &(chartInstance->instanceNumber),
          ssGetPath(S),
          (void *)S);
        if (chartAlreadyPresent==0) {
          /* this is the first instance */
          init_script_number_translation(_PACMachineNumber_,
            chartInstance->chartNumber);
          sf_debug_set_chart_disable_implicit_casting(_PACMachineNumber_,
            chartInstance->chartNumber,1);
          sf_debug_set_chart_event_thresholds(_PACMachineNumber_,
            chartInstance->chartNumber,
            0,
            0,
            0);
          _SFD_SET_DATA_PROPS(0,2,0,1,"T");
          _SFD_SET_DATA_PROPS(1,1,1,0,"P");
          _SFD_STATE_INFO(0,0,2);
          _SFD_CH_SUBSTATE_COUNT(0);
          _SFD_CH_SUBSTATE_DECOMP(0);
        }

        _SFD_CV_INIT_CHART(0,0,0,0);

        {
          _SFD_CV_INIT_STATE(0,0,0,0,0,0,NULL,NULL);
        }

        _SFD_CV_INIT_TRANS(0,0,NULL,NULL,0,NULL);

        /* Initialization of MATLAB Function Model Coverage */
        _SFD_CV_INIT_EML(0,1,1,3,0,0,0,0,1,0,0);
        _SFD_CV_INIT_EML_FCN(0,0,"eML_blk_kernel",0,-1,887);
        _SFD_CV_INIT_EML_IF(0,1,0,80,88,-1,99);
        _SFD_CV_INIT_EML_IF(0,1,1,727,749,768,794);
        _SFD_CV_INIT_EML_IF(0,1,2,768,794,-1,794);
        _SFD_CV_INIT_EML_WHILE(0,1,0,340,373,848);
        _SFD_TRANS_COV_WTS(0,0,0,1,0);
        if (chartAlreadyPresent==0) {
          _SFD_TRANS_COV_MAPS(0,
                              0,NULL,NULL,
                              0,NULL,NULL,
                              1,NULL,NULL,
                              0,NULL,NULL);
        }

        _SFD_SET_DATA_COMPILED_PROPS(0,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c4_sf_marshallOut,(MexInFcnForType)c4_sf_marshallIn);
        _SFD_SET_DATA_COMPILED_PROPS(1,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c4_sf_marshallOut,(MexInFcnForType)NULL);

        {
          real_T *c4_T;
          real_T *c4_P;
          c4_P = (real_T *)ssGetInputPortSignal(chartInstance->S, 0);
          c4_T = (real_T *)ssGetOutputPortSignal(chartInstance->S, 1);
          _SFD_SET_DATA_VALUE_PTR(0U, c4_T);
          _SFD_SET_DATA_VALUE_PTR(1U, c4_P);
        }
      }
    } else {
      sf_debug_reset_current_state_configuration(_PACMachineNumber_,
        chartInstance->chartNumber,chartInstance->instanceNumber);
    }
  }
}

static const char* sf_get_instance_specialization()
{
  return "pv0pXyPVYzM6MyLHlt0yGD";
}

static void sf_opaque_initialize_c4_PAC(void *chartInstanceVar)
{
  chart_debug_initialization(((SFc4_PACInstanceStruct*) chartInstanceVar)->S,0);
  initialize_params_c4_PAC((SFc4_PACInstanceStruct*) chartInstanceVar);
  initialize_c4_PAC((SFc4_PACInstanceStruct*) chartInstanceVar);
}

static void sf_opaque_enable_c4_PAC(void *chartInstanceVar)
{
  enable_c4_PAC((SFc4_PACInstanceStruct*) chartInstanceVar);
}

static void sf_opaque_disable_c4_PAC(void *chartInstanceVar)
{
  disable_c4_PAC((SFc4_PACInstanceStruct*) chartInstanceVar);
}

static void sf_opaque_gateway_c4_PAC(void *chartInstanceVar)
{
  sf_c4_PAC((SFc4_PACInstanceStruct*) chartInstanceVar);
}

extern const mxArray* sf_internal_get_sim_state_c4_PAC(SimStruct* S)
{
  ChartInfoStruct *chartInfo = (ChartInfoStruct*) ssGetUserData(S);
  mxArray *plhs[1] = { NULL };

  mxArray *prhs[4];
  int mxError = 0;
  prhs[0] = mxCreateString("chart_simctx_raw2high");
  prhs[1] = mxCreateDoubleScalar(ssGetSFuncBlockHandle(S));
  prhs[2] = (mxArray*) get_sim_state_c4_PAC((SFc4_PACInstanceStruct*)
    chartInfo->chartInstance);         /* raw sim ctx */
  prhs[3] = (mxArray*) sf_get_sim_state_info_c4_PAC();/* state var info */
  mxError = sf_mex_call_matlab(1, plhs, 4, prhs, "sfprivate");
  mxDestroyArray(prhs[0]);
  mxDestroyArray(prhs[1]);
  mxDestroyArray(prhs[2]);
  mxDestroyArray(prhs[3]);
  if (mxError || plhs[0] == NULL) {
    sf_mex_error_message("Stateflow Internal Error: \nError calling 'chart_simctx_raw2high'.\n");
  }

  return plhs[0];
}

extern void sf_internal_set_sim_state_c4_PAC(SimStruct* S, const mxArray *st)
{
  ChartInfoStruct *chartInfo = (ChartInfoStruct*) ssGetUserData(S);
  mxArray *plhs[1] = { NULL };

  mxArray *prhs[4];
  int mxError = 0;
  prhs[0] = mxCreateString("chart_simctx_high2raw");
  prhs[1] = mxCreateDoubleScalar(ssGetSFuncBlockHandle(S));
  prhs[2] = mxDuplicateArray(st);      /* high level simctx */
  prhs[3] = (mxArray*) sf_get_sim_state_info_c4_PAC();/* state var info */
  mxError = sf_mex_call_matlab(1, plhs, 4, prhs, "sfprivate");
  mxDestroyArray(prhs[0]);
  mxDestroyArray(prhs[1]);
  mxDestroyArray(prhs[2]);
  mxDestroyArray(prhs[3]);
  if (mxError || plhs[0] == NULL) {
    sf_mex_error_message("Stateflow Internal Error: \nError calling 'chart_simctx_high2raw'.\n");
  }

  set_sim_state_c4_PAC((SFc4_PACInstanceStruct*)chartInfo->chartInstance,
                       mxDuplicateArray(plhs[0]));
  mxDestroyArray(plhs[0]);
}

static const mxArray* sf_opaque_get_sim_state_c4_PAC(SimStruct* S)
{
  return sf_internal_get_sim_state_c4_PAC(S);
}

static void sf_opaque_set_sim_state_c4_PAC(SimStruct* S, const mxArray *st)
{
  sf_internal_set_sim_state_c4_PAC(S, st);
}

static void sf_opaque_terminate_c4_PAC(void *chartInstanceVar)
{
  if (chartInstanceVar!=NULL) {
    SimStruct *S = ((SFc4_PACInstanceStruct*) chartInstanceVar)->S;
    if (sim_mode_is_rtw_gen(S) || sim_mode_is_external(S)) {
      sf_clear_rtw_identifier(S);
    }

    finalize_c4_PAC((SFc4_PACInstanceStruct*) chartInstanceVar);
    free((void *)chartInstanceVar);
    ssSetUserData(S,NULL);
  }

  unload_PAC_optimization_info();
}

static void sf_opaque_init_subchart_simstructs(void *chartInstanceVar)
{
  initSimStructsc4_PAC((SFc4_PACInstanceStruct*) chartInstanceVar);
}

extern unsigned int sf_machine_global_initializer_called(void);
static void mdlProcessParameters_c4_PAC(SimStruct *S)
{
  int i;
  for (i=0;i<ssGetNumRunTimeParams(S);i++) {
    if (ssGetSFcnParamTunable(S,i)) {
      ssUpdateDlgParamAsRunTimeParam(S,i);
    }
  }

  if (sf_machine_global_initializer_called()) {
    initialize_params_c4_PAC((SFc4_PACInstanceStruct*)(((ChartInfoStruct *)
      ssGetUserData(S))->chartInstance));
  }
}

static void mdlSetWorkWidths_c4_PAC(SimStruct *S)
{
  if (sim_mode_is_rtw_gen(S) || sim_mode_is_external(S)) {
    mxArray *infoStruct = load_PAC_optimization_info();
    int_T chartIsInlinable =
      (int_T)sf_is_chart_inlinable(S,sf_get_instance_specialization(),infoStruct,
      4);
    ssSetStateflowIsInlinable(S,chartIsInlinable);
    ssSetRTWCG(S,sf_rtw_info_uint_prop(S,sf_get_instance_specialization(),
                infoStruct,4,"RTWCG"));
    ssSetEnableFcnIsTrivial(S,1);
    ssSetDisableFcnIsTrivial(S,1);
    ssSetNotMultipleInlinable(S,sf_rtw_info_uint_prop(S,
      sf_get_instance_specialization(),infoStruct,4,
      "gatewayCannotBeInlinedMultipleTimes"));
    if (chartIsInlinable) {
      ssSetInputPortOptimOpts(S, 0, SS_REUSABLE_AND_LOCAL);
      sf_mark_chart_expressionable_inputs(S,sf_get_instance_specialization(),
        infoStruct,4,1);
      sf_mark_chart_reusable_outputs(S,sf_get_instance_specialization(),
        infoStruct,4,1);
    }

    sf_set_rtw_dwork_info(S,sf_get_instance_specialization(),infoStruct,4);
    ssSetHasSubFunctions(S,!(chartIsInlinable));
  } else {
  }

  ssSetOptions(S,ssGetOptions(S)|SS_OPTION_WORKS_WITH_CODE_REUSE);
  ssSetChecksum0(S,(3090664434U));
  ssSetChecksum1(S,(2467521610U));
  ssSetChecksum2(S,(3127866878U));
  ssSetChecksum3(S,(1889839489U));
  ssSetmdlDerivatives(S, NULL);
  ssSetExplicitFCSSCtrl(S,1);
  ssSupportsMultipleExecInstances(S,1);
}

static void mdlRTW_c4_PAC(SimStruct *S)
{
  if (sim_mode_is_rtw_gen(S)) {
    ssWriteRTWStrParam(S, "StateflowChartType", "Embedded MATLAB");
  }
}

static void mdlStart_c4_PAC(SimStruct *S)
{
  SFc4_PACInstanceStruct *chartInstance;
  chartInstance = (SFc4_PACInstanceStruct *)malloc(sizeof(SFc4_PACInstanceStruct));
  memset(chartInstance, 0, sizeof(SFc4_PACInstanceStruct));
  if (chartInstance==NULL) {
    sf_mex_error_message("Could not allocate memory for chart instance.");
  }

  chartInstance->chartInfo.chartInstance = chartInstance;
  chartInstance->chartInfo.isEMLChart = 1;
  chartInstance->chartInfo.chartInitialized = 0;
  chartInstance->chartInfo.sFunctionGateway = sf_opaque_gateway_c4_PAC;
  chartInstance->chartInfo.initializeChart = sf_opaque_initialize_c4_PAC;
  chartInstance->chartInfo.terminateChart = sf_opaque_terminate_c4_PAC;
  chartInstance->chartInfo.enableChart = sf_opaque_enable_c4_PAC;
  chartInstance->chartInfo.disableChart = sf_opaque_disable_c4_PAC;
  chartInstance->chartInfo.getSimState = sf_opaque_get_sim_state_c4_PAC;
  chartInstance->chartInfo.setSimState = sf_opaque_set_sim_state_c4_PAC;
  chartInstance->chartInfo.getSimStateInfo = sf_get_sim_state_info_c4_PAC;
  chartInstance->chartInfo.zeroCrossings = NULL;
  chartInstance->chartInfo.outputs = NULL;
  chartInstance->chartInfo.derivatives = NULL;
  chartInstance->chartInfo.mdlRTW = mdlRTW_c4_PAC;
  chartInstance->chartInfo.mdlStart = mdlStart_c4_PAC;
  chartInstance->chartInfo.mdlSetWorkWidths = mdlSetWorkWidths_c4_PAC;
  chartInstance->chartInfo.extModeExec = NULL;
  chartInstance->chartInfo.restoreLastMajorStepConfiguration = NULL;
  chartInstance->chartInfo.restoreBeforeLastMajorStepConfiguration = NULL;
  chartInstance->chartInfo.storeCurrentConfiguration = NULL;
  chartInstance->S = S;
  ssSetUserData(S,(void *)(&(chartInstance->chartInfo)));/* register the chart instance with simstruct */
  init_dsm_address_info(chartInstance);
  if (!sim_mode_is_rtw_gen(S)) {
  }

  sf_opaque_init_subchart_simstructs(chartInstance->chartInfo.chartInstance);
  chart_debug_initialization(S,1);
}

void c4_PAC_method_dispatcher(SimStruct *S, int_T method, void *data)
{
  switch (method) {
   case SS_CALL_MDL_START:
    mdlStart_c4_PAC(S);
    break;

   case SS_CALL_MDL_SET_WORK_WIDTHS:
    mdlSetWorkWidths_c4_PAC(S);
    break;

   case SS_CALL_MDL_PROCESS_PARAMETERS:
    mdlProcessParameters_c4_PAC(S);
    break;

   default:
    /* Unhandled method */
    sf_mex_error_message("Stateflow Internal Error:\n"
                         "Error calling c4_PAC_method_dispatcher.\n"
                         "Can't handle method %d.\n", method);
    break;
  }
}
