/* Include files */

#include "blascompat32.h"
#include "PAC12_sfun.h"
#include "c3_PAC12.h"
#define CHARTINSTANCE_CHARTNUMBER      (chartInstance->chartNumber)
#define CHARTINSTANCE_INSTANCENUMBER   (chartInstance->instanceNumber)
#include "PAC12_sfun_debug_macros.h"

/* Type Definitions */

/* Named Constants */
#define CALL_EVENT                     (-1)

/* Variable Declarations */

/* Variable Definitions */
static const char * c3_debug_family_names[12] = { "nargin", "nargout", "Tee",
  "h2", "qmff", "qveau", "Pcomp", "Pevapo", "HP", "h3", "Tse", "Pcond" };

/* Function Declarations */
static void initialize_c3_PAC12(SFc3_PAC12InstanceStruct *chartInstance);
static void initialize_params_c3_PAC12(SFc3_PAC12InstanceStruct *chartInstance);
static void enable_c3_PAC12(SFc3_PAC12InstanceStruct *chartInstance);
static void disable_c3_PAC12(SFc3_PAC12InstanceStruct *chartInstance);
static void c3_update_debugger_state_c3_PAC12(SFc3_PAC12InstanceStruct
  *chartInstance);
static void ext_mode_exec_c3_PAC12(SFc3_PAC12InstanceStruct *chartInstance);
static const mxArray *get_sim_state_c3_PAC12(SFc3_PAC12InstanceStruct
  *chartInstance);
static void set_sim_state_c3_PAC12(SFc3_PAC12InstanceStruct *chartInstance,
  const mxArray *c3_st);
static void finalize_c3_PAC12(SFc3_PAC12InstanceStruct *chartInstance);
static void sf_c3_PAC12(SFc3_PAC12InstanceStruct *chartInstance);
static void initSimStructsc3_PAC12(SFc3_PAC12InstanceStruct *chartInstance);
static void init_script_number_translation(uint32_T c3_machineNumber, uint32_T
  c3_chartNumber);
static const mxArray *c3_sf_marshallOut(void *chartInstanceVoid, void *c3_inData);
static real_T c3_emlrt_marshallIn(SFc3_PAC12InstanceStruct *chartInstance, const
  mxArray *c3_Pcond, const char_T *c3_identifier);
static real_T c3_b_emlrt_marshallIn(SFc3_PAC12InstanceStruct *chartInstance,
  const mxArray *c3_u, const emlrtMsgIdentifier *c3_parentId);
static void c3_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c3_mxArrayInData, const char_T *c3_varName, void *c3_outData);
static const mxArray *c3_b_sf_marshallOut(void *chartInstanceVoid, void
  *c3_inData);
static int32_T c3_c_emlrt_marshallIn(SFc3_PAC12InstanceStruct *chartInstance,
  const mxArray *c3_u, const emlrtMsgIdentifier *c3_parentId);
static void c3_b_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c3_mxArrayInData, const char_T *c3_varName, void *c3_outData);
static uint8_T c3_d_emlrt_marshallIn(SFc3_PAC12InstanceStruct *chartInstance,
  const mxArray *c3_is_active_c3_PAC12, const char_T *c3_identifier);
static uint8_T c3_e_emlrt_marshallIn(SFc3_PAC12InstanceStruct *chartInstance,
  const mxArray *c3_u, const emlrtMsgIdentifier *c3_parentId);
static void init_dsm_address_info(SFc3_PAC12InstanceStruct *chartInstance);

/* Function Definitions */
static void initialize_c3_PAC12(SFc3_PAC12InstanceStruct *chartInstance)
{
  int32_T *c3_sfEvent;
  uint8_T *c3_is_active_c3_PAC12;
  c3_is_active_c3_PAC12 = (uint8_T *)ssGetDWork(chartInstance->S, 3);
  c3_sfEvent = (int32_T *)ssGetDWork(chartInstance->S, 0);
  *c3_sfEvent = CALL_EVENT;
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
  *c3_is_active_c3_PAC12 = 0U;
}

static void initialize_params_c3_PAC12(SFc3_PAC12InstanceStruct *chartInstance)
{
}

static void enable_c3_PAC12(SFc3_PAC12InstanceStruct *chartInstance)
{
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
}

static void disable_c3_PAC12(SFc3_PAC12InstanceStruct *chartInstance)
{
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
}

static void c3_update_debugger_state_c3_PAC12(SFc3_PAC12InstanceStruct
  *chartInstance)
{
}

static void ext_mode_exec_c3_PAC12(SFc3_PAC12InstanceStruct *chartInstance)
{
  c3_update_debugger_state_c3_PAC12(chartInstance);
}

static const mxArray *get_sim_state_c3_PAC12(SFc3_PAC12InstanceStruct
  *chartInstance)
{
  const mxArray *c3_st;
  const mxArray *c3_y = NULL;
  real_T c3_hoistedGlobal;
  real_T c3_u;
  const mxArray *c3_b_y = NULL;
  real_T c3_b_hoistedGlobal;
  real_T c3_b_u;
  const mxArray *c3_c_y = NULL;
  real_T c3_c_hoistedGlobal;
  real_T c3_c_u;
  const mxArray *c3_d_y = NULL;
  real_T c3_d_hoistedGlobal;
  real_T c3_d_u;
  const mxArray *c3_e_y = NULL;
  uint8_T c3_e_hoistedGlobal;
  uint8_T c3_e_u;
  const mxArray *c3_f_y = NULL;
  real_T *c3_HP;
  real_T *c3_Pcond;
  real_T *c3_Tse;
  real_T *c3_h3;
  uint8_T *c3_is_active_c3_PAC12;
  c3_Pcond = (real_T *)ssGetOutputPortSignal(chartInstance->S, 4);
  c3_Tse = (real_T *)ssGetOutputPortSignal(chartInstance->S, 3);
  c3_h3 = (real_T *)ssGetOutputPortSignal(chartInstance->S, 2);
  c3_HP = (real_T *)ssGetOutputPortSignal(chartInstance->S, 1);
  c3_is_active_c3_PAC12 = (uint8_T *)ssGetDWork(chartInstance->S, 3);
  c3_st = NULL;
  c3_st = NULL;
  c3_y = NULL;
  sf_mex_assign(&c3_y, sf_mex_createcellarray(5), FALSE);
  c3_hoistedGlobal = *c3_HP;
  c3_u = c3_hoistedGlobal;
  c3_b_y = NULL;
  sf_mex_assign(&c3_b_y, sf_mex_create("y", &c3_u, 0, 0U, 0U, 0U, 0), FALSE);
  sf_mex_setcell(c3_y, 0, c3_b_y);
  c3_b_hoistedGlobal = *c3_Pcond;
  c3_b_u = c3_b_hoistedGlobal;
  c3_c_y = NULL;
  sf_mex_assign(&c3_c_y, sf_mex_create("y", &c3_b_u, 0, 0U, 0U, 0U, 0), FALSE);
  sf_mex_setcell(c3_y, 1, c3_c_y);
  c3_c_hoistedGlobal = *c3_Tse;
  c3_c_u = c3_c_hoistedGlobal;
  c3_d_y = NULL;
  sf_mex_assign(&c3_d_y, sf_mex_create("y", &c3_c_u, 0, 0U, 0U, 0U, 0), FALSE);
  sf_mex_setcell(c3_y, 2, c3_d_y);
  c3_d_hoistedGlobal = *c3_h3;
  c3_d_u = c3_d_hoistedGlobal;
  c3_e_y = NULL;
  sf_mex_assign(&c3_e_y, sf_mex_create("y", &c3_d_u, 0, 0U, 0U, 0U, 0), FALSE);
  sf_mex_setcell(c3_y, 3, c3_e_y);
  c3_e_hoistedGlobal = *c3_is_active_c3_PAC12;
  c3_e_u = c3_e_hoistedGlobal;
  c3_f_y = NULL;
  sf_mex_assign(&c3_f_y, sf_mex_create("y", &c3_e_u, 3, 0U, 0U, 0U, 0), FALSE);
  sf_mex_setcell(c3_y, 4, c3_f_y);
  sf_mex_assign(&c3_st, c3_y, FALSE);
  return c3_st;
}

static void set_sim_state_c3_PAC12(SFc3_PAC12InstanceStruct *chartInstance,
  const mxArray *c3_st)
{
  const mxArray *c3_u;
  boolean_T *c3_doneDoubleBufferReInit;
  real_T *c3_HP;
  real_T *c3_Pcond;
  real_T *c3_Tse;
  real_T *c3_h3;
  uint8_T *c3_is_active_c3_PAC12;
  c3_Pcond = (real_T *)ssGetOutputPortSignal(chartInstance->S, 4);
  c3_Tse = (real_T *)ssGetOutputPortSignal(chartInstance->S, 3);
  c3_h3 = (real_T *)ssGetOutputPortSignal(chartInstance->S, 2);
  c3_HP = (real_T *)ssGetOutputPortSignal(chartInstance->S, 1);
  c3_is_active_c3_PAC12 = (uint8_T *)ssGetDWork(chartInstance->S, 3);
  c3_doneDoubleBufferReInit = (boolean_T *)ssGetDWork(chartInstance->S, 2);
  *c3_doneDoubleBufferReInit = TRUE;
  c3_u = sf_mex_dup(c3_st);
  *c3_HP = c3_emlrt_marshallIn(chartInstance, sf_mex_dup(sf_mex_getcell(c3_u, 0)),
    "HP");
  *c3_Pcond = c3_emlrt_marshallIn(chartInstance, sf_mex_dup(sf_mex_getcell(c3_u,
    1)), "Pcond");
  *c3_Tse = c3_emlrt_marshallIn(chartInstance, sf_mex_dup(sf_mex_getcell(c3_u, 2)),
    "Tse");
  *c3_h3 = c3_emlrt_marshallIn(chartInstance, sf_mex_dup(sf_mex_getcell(c3_u, 3)),
    "h3");
  *c3_is_active_c3_PAC12 = c3_d_emlrt_marshallIn(chartInstance, sf_mex_dup
    (sf_mex_getcell(c3_u, 4)), "is_active_c3_PAC12");
  sf_mex_destroy(&c3_u);
  c3_update_debugger_state_c3_PAC12(chartInstance);
  sf_mex_destroy(&c3_st);
}

static void finalize_c3_PAC12(SFc3_PAC12InstanceStruct *chartInstance)
{
}

static void sf_c3_PAC12(SFc3_PAC12InstanceStruct *chartInstance)
{
  real_T c3_hoistedGlobal;
  real_T c3_b_hoistedGlobal;
  real_T c3_c_hoistedGlobal;
  real_T c3_d_hoistedGlobal;
  real_T c3_e_hoistedGlobal;
  real_T c3_f_hoistedGlobal;
  real_T c3_Tee;
  real_T c3_h2;
  real_T c3_qmff;
  real_T c3_qveau;
  real_T c3_Pcomp;
  real_T c3_Pevapo;
  uint32_T c3_debug_family_var_map[12];
  real_T c3_nargin = 6.0;
  real_T c3_nargout = 4.0;
  real_T c3_HP;
  real_T c3_h3;
  real_T c3_Tse;
  real_T c3_Pcond;
  real_T c3_b;
  real_T c3_y;
  real_T c3_A;
  real_T c3_B;
  real_T c3_x;
  real_T c3_b_y;
  real_T c3_b_x;
  real_T c3_c_y;
  real_T c3_d_y;
  real_T c3_a;
  real_T c3_e_y;
  real_T c3_b_A;
  real_T c3_c_x;
  real_T c3_d_x;
  real_T c3_f_y;
  real_T c3_c_A;
  real_T c3_e_x;
  real_T c3_f_x;
  real_T c3_g_y;
  real_T c3_d_A;
  real_T c3_b_B;
  real_T c3_g_x;
  real_T c3_h_y;
  real_T c3_h_x;
  real_T c3_i_y;
  real_T c3_j_y;
  real_T *c3_b_Pcond;
  real_T *c3_b_Tse;
  real_T *c3_b_h3;
  real_T *c3_b_HP;
  real_T *c3_b_Pevapo;
  real_T *c3_b_Pcomp;
  real_T *c3_b_qveau;
  real_T *c3_b_qmff;
  real_T *c3_b_h2;
  real_T *c3_b_Tee;
  int32_T *c3_sfEvent;
  c3_b_Pcond = (real_T *)ssGetOutputPortSignal(chartInstance->S, 4);
  c3_b_Tse = (real_T *)ssGetOutputPortSignal(chartInstance->S, 3);
  c3_b_h3 = (real_T *)ssGetOutputPortSignal(chartInstance->S, 2);
  c3_b_Pevapo = (real_T *)ssGetInputPortSignal(chartInstance->S, 5);
  c3_b_Pcomp = (real_T *)ssGetInputPortSignal(chartInstance->S, 4);
  c3_b_qveau = (real_T *)ssGetInputPortSignal(chartInstance->S, 3);
  c3_b_qmff = (real_T *)ssGetInputPortSignal(chartInstance->S, 2);
  c3_b_h2 = (real_T *)ssGetInputPortSignal(chartInstance->S, 1);
  c3_b_HP = (real_T *)ssGetOutputPortSignal(chartInstance->S, 1);
  c3_b_Tee = (real_T *)ssGetInputPortSignal(chartInstance->S, 0);
  c3_sfEvent = (int32_T *)ssGetDWork(chartInstance->S, 0);
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
  _SFD_CC_CALL(CHART_ENTER_SFUNCTION_TAG, 2U, *c3_sfEvent);
  _SFD_DATA_RANGE_CHECK(*c3_b_Tee, 0U);
  _SFD_DATA_RANGE_CHECK(*c3_b_HP, 1U);
  _SFD_DATA_RANGE_CHECK(*c3_b_h2, 2U);
  _SFD_DATA_RANGE_CHECK(*c3_b_qmff, 3U);
  _SFD_DATA_RANGE_CHECK(*c3_b_qveau, 4U);
  _SFD_DATA_RANGE_CHECK(*c3_b_Pcomp, 5U);
  _SFD_DATA_RANGE_CHECK(*c3_b_Pevapo, 6U);
  _SFD_DATA_RANGE_CHECK(*c3_b_h3, 7U);
  _SFD_DATA_RANGE_CHECK(*c3_b_Tse, 8U);
  _SFD_DATA_RANGE_CHECK(*c3_b_Pcond, 9U);
  *c3_sfEvent = CALL_EVENT;
  _SFD_CC_CALL(CHART_ENTER_DURING_FUNCTION_TAG, 2U, *c3_sfEvent);
  c3_hoistedGlobal = *c3_b_Tee;
  c3_b_hoistedGlobal = *c3_b_h2;
  c3_c_hoistedGlobal = *c3_b_qmff;
  c3_d_hoistedGlobal = *c3_b_qveau;
  c3_e_hoistedGlobal = *c3_b_Pcomp;
  c3_f_hoistedGlobal = *c3_b_Pevapo;
  c3_Tee = c3_hoistedGlobal;
  c3_h2 = c3_b_hoistedGlobal;
  c3_qmff = c3_c_hoistedGlobal;
  c3_qveau = c3_d_hoistedGlobal;
  c3_Pcomp = c3_e_hoistedGlobal;
  c3_Pevapo = c3_f_hoistedGlobal;
  sf_debug_symbol_scope_push_eml(0U, 12U, 12U, c3_debug_family_names,
    c3_debug_family_var_map);
  sf_debug_symbol_scope_add_eml_importable(&c3_nargin, 0U, c3_sf_marshallOut,
    c3_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c3_nargout, 1U, c3_sf_marshallOut,
    c3_sf_marshallIn);
  sf_debug_symbol_scope_add_eml(&c3_Tee, 2U, c3_sf_marshallOut);
  sf_debug_symbol_scope_add_eml(&c3_h2, 3U, c3_sf_marshallOut);
  sf_debug_symbol_scope_add_eml(&c3_qmff, 4U, c3_sf_marshallOut);
  sf_debug_symbol_scope_add_eml(&c3_qveau, 5U, c3_sf_marshallOut);
  sf_debug_symbol_scope_add_eml(&c3_Pcomp, 6U, c3_sf_marshallOut);
  sf_debug_symbol_scope_add_eml(&c3_Pevapo, 7U, c3_sf_marshallOut);
  sf_debug_symbol_scope_add_eml_importable(&c3_HP, 8U, c3_sf_marshallOut,
    c3_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c3_h3, 9U, c3_sf_marshallOut,
    c3_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c3_Tse, 10U, c3_sf_marshallOut,
    c3_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c3_Pcond, 11U, c3_sf_marshallOut,
    c3_sf_marshallIn);
  CV_EML_FCN(0, 0);
  _SFD_EML_CALL(0U, *c3_sfEvent, 4);
  c3_b = c3_Tee;
  c3_y = 0.255 * c3_b;
  c3_HP = c3_y + 3.667;
  _SFD_EML_CALL(0U, *c3_sfEvent, 6);
  c3_A = c3_Pcomp + c3_Pevapo;
  c3_B = c3_qmff;
  c3_x = c3_A;
  c3_b_y = c3_B;
  c3_b_x = c3_x;
  c3_c_y = c3_b_y;
  c3_d_y = c3_b_x / c3_c_y;
  c3_h3 = c3_h2 - c3_d_y;
  _SFD_EML_CALL(0U, *c3_sfEvent, 8);
  c3_a = c3_Pcomp + c3_Pevapo;
  c3_e_y = c3_a * 1000.0;
  c3_b_A = c3_e_y;
  c3_c_x = c3_b_A;
  c3_d_x = c3_c_x;
  c3_f_y = c3_d_x / 4185.0;
  c3_c_A = c3_qveau;
  c3_e_x = c3_c_A;
  c3_f_x = c3_e_x;
  c3_g_y = c3_f_x / 3600.0;
  c3_d_A = c3_f_y;
  c3_b_B = c3_g_y;
  c3_g_x = c3_d_A;
  c3_h_y = c3_b_B;
  c3_h_x = c3_g_x;
  c3_i_y = c3_h_y;
  c3_j_y = c3_h_x / c3_i_y;
  c3_Tse = c3_Tee + c3_j_y;
  _SFD_EML_CALL(0U, *c3_sfEvent, 10);
  c3_Pcond = c3_Pcomp + c3_Pevapo;
  _SFD_EML_CALL(0U, *c3_sfEvent, -10);
  sf_debug_symbol_scope_pop();
  *c3_b_HP = c3_HP;
  *c3_b_h3 = c3_h3;
  *c3_b_Tse = c3_Tse;
  *c3_b_Pcond = c3_Pcond;
  _SFD_CC_CALL(EXIT_OUT_OF_FUNCTION_TAG, 2U, *c3_sfEvent);
  sf_debug_check_for_state_inconsistency(_PAC12MachineNumber_,
    chartInstance->chartNumber, chartInstance->instanceNumber);
}

static void initSimStructsc3_PAC12(SFc3_PAC12InstanceStruct *chartInstance)
{
}

static void init_script_number_translation(uint32_T c3_machineNumber, uint32_T
  c3_chartNumber)
{
}

static const mxArray *c3_sf_marshallOut(void *chartInstanceVoid, void *c3_inData)
{
  const mxArray *c3_mxArrayOutData = NULL;
  real_T c3_u;
  const mxArray *c3_y = NULL;
  SFc3_PAC12InstanceStruct *chartInstance;
  chartInstance = (SFc3_PAC12InstanceStruct *)chartInstanceVoid;
  c3_mxArrayOutData = NULL;
  c3_u = *(real_T *)c3_inData;
  c3_y = NULL;
  sf_mex_assign(&c3_y, sf_mex_create("y", &c3_u, 0, 0U, 0U, 0U, 0), FALSE);
  sf_mex_assign(&c3_mxArrayOutData, c3_y, FALSE);
  return c3_mxArrayOutData;
}

static real_T c3_emlrt_marshallIn(SFc3_PAC12InstanceStruct *chartInstance, const
  mxArray *c3_Pcond, const char_T *c3_identifier)
{
  real_T c3_y;
  emlrtMsgIdentifier c3_thisId;
  c3_thisId.fIdentifier = c3_identifier;
  c3_thisId.fParent = NULL;
  c3_y = c3_b_emlrt_marshallIn(chartInstance, sf_mex_dup(c3_Pcond), &c3_thisId);
  sf_mex_destroy(&c3_Pcond);
  return c3_y;
}

static real_T c3_b_emlrt_marshallIn(SFc3_PAC12InstanceStruct *chartInstance,
  const mxArray *c3_u, const emlrtMsgIdentifier *c3_parentId)
{
  real_T c3_y;
  real_T c3_d0;
  sf_mex_import(c3_parentId, sf_mex_dup(c3_u), &c3_d0, 1, 0, 0U, 0, 0U, 0);
  c3_y = c3_d0;
  sf_mex_destroy(&c3_u);
  return c3_y;
}

static void c3_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c3_mxArrayInData, const char_T *c3_varName, void *c3_outData)
{
  const mxArray *c3_Pcond;
  const char_T *c3_identifier;
  emlrtMsgIdentifier c3_thisId;
  real_T c3_y;
  SFc3_PAC12InstanceStruct *chartInstance;
  chartInstance = (SFc3_PAC12InstanceStruct *)chartInstanceVoid;
  c3_Pcond = sf_mex_dup(c3_mxArrayInData);
  c3_identifier = c3_varName;
  c3_thisId.fIdentifier = c3_identifier;
  c3_thisId.fParent = NULL;
  c3_y = c3_b_emlrt_marshallIn(chartInstance, sf_mex_dup(c3_Pcond), &c3_thisId);
  sf_mex_destroy(&c3_Pcond);
  *(real_T *)c3_outData = c3_y;
  sf_mex_destroy(&c3_mxArrayInData);
}

const mxArray *sf_c3_PAC12_get_eml_resolved_functions_info(void)
{
  const mxArray *c3_nameCaptureInfo;
  c3_ResolvedFunctionInfo c3_info[4];
  c3_ResolvedFunctionInfo (*c3_b_info)[4];
  const mxArray *c3_m0 = NULL;
  int32_T c3_i0;
  c3_ResolvedFunctionInfo *c3_r0;
  c3_nameCaptureInfo = NULL;
  c3_nameCaptureInfo = NULL;
  c3_b_info = (c3_ResolvedFunctionInfo (*)[4])c3_info;
  (*c3_b_info)[0].context = "";
  (*c3_b_info)[0].name = "mtimes";
  (*c3_b_info)[0].dominantType = "double";
  (*c3_b_info)[0].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mtimes.m";
  (*c3_b_info)[0].fileTimeLo = 1289519692U;
  (*c3_b_info)[0].fileTimeHi = 0U;
  (*c3_b_info)[0].mFileTimeLo = 0U;
  (*c3_b_info)[0].mFileTimeHi = 0U;
  (*c3_b_info)[1].context = "";
  (*c3_b_info)[1].name = "mrdivide";
  (*c3_b_info)[1].dominantType = "double";
  (*c3_b_info)[1].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mrdivide.p";
  (*c3_b_info)[1].fileTimeLo = 1342810944U;
  (*c3_b_info)[1].fileTimeHi = 0U;
  (*c3_b_info)[1].mFileTimeLo = 1319729966U;
  (*c3_b_info)[1].mFileTimeHi = 0U;
  (*c3_b_info)[2].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mrdivide.p";
  (*c3_b_info)[2].name = "rdivide";
  (*c3_b_info)[2].dominantType = "double";
  (*c3_b_info)[2].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/rdivide.m";
  (*c3_b_info)[2].fileTimeLo = 1286818844U;
  (*c3_b_info)[2].fileTimeHi = 0U;
  (*c3_b_info)[2].mFileTimeLo = 0U;
  (*c3_b_info)[2].mFileTimeHi = 0U;
  (*c3_b_info)[3].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/rdivide.m";
  (*c3_b_info)[3].name = "eml_div";
  (*c3_b_info)[3].dominantType = "double";
  (*c3_b_info)[3].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_div.m";
  (*c3_b_info)[3].fileTimeLo = 1313347810U;
  (*c3_b_info)[3].fileTimeHi = 0U;
  (*c3_b_info)[3].mFileTimeLo = 0U;
  (*c3_b_info)[3].mFileTimeHi = 0U;
  sf_mex_assign(&c3_m0, sf_mex_createstruct("nameCaptureInfo", 1, 4), FALSE);
  for (c3_i0 = 0; c3_i0 < 4; c3_i0++) {
    c3_r0 = &c3_info[c3_i0];
    sf_mex_addfield(c3_m0, sf_mex_create("nameCaptureInfo", c3_r0->context, 15,
      0U, 0U, 0U, 2, 1, strlen(c3_r0->context)), "context", "nameCaptureInfo",
                    c3_i0);
    sf_mex_addfield(c3_m0, sf_mex_create("nameCaptureInfo", c3_r0->name, 15, 0U,
      0U, 0U, 2, 1, strlen(c3_r0->name)), "name", "nameCaptureInfo", c3_i0);
    sf_mex_addfield(c3_m0, sf_mex_create("nameCaptureInfo", c3_r0->dominantType,
      15, 0U, 0U, 0U, 2, 1, strlen(c3_r0->dominantType)), "dominantType",
                    "nameCaptureInfo", c3_i0);
    sf_mex_addfield(c3_m0, sf_mex_create("nameCaptureInfo", c3_r0->resolved, 15,
      0U, 0U, 0U, 2, 1, strlen(c3_r0->resolved)), "resolved", "nameCaptureInfo",
                    c3_i0);
    sf_mex_addfield(c3_m0, sf_mex_create("nameCaptureInfo", &c3_r0->fileTimeLo,
      7, 0U, 0U, 0U, 0), "fileTimeLo", "nameCaptureInfo", c3_i0);
    sf_mex_addfield(c3_m0, sf_mex_create("nameCaptureInfo", &c3_r0->fileTimeHi,
      7, 0U, 0U, 0U, 0), "fileTimeHi", "nameCaptureInfo", c3_i0);
    sf_mex_addfield(c3_m0, sf_mex_create("nameCaptureInfo", &c3_r0->mFileTimeLo,
      7, 0U, 0U, 0U, 0), "mFileTimeLo", "nameCaptureInfo", c3_i0);
    sf_mex_addfield(c3_m0, sf_mex_create("nameCaptureInfo", &c3_r0->mFileTimeHi,
      7, 0U, 0U, 0U, 0), "mFileTimeHi", "nameCaptureInfo", c3_i0);
  }

  sf_mex_assign(&c3_nameCaptureInfo, c3_m0, FALSE);
  sf_mex_emlrtNameCapturePostProcessR2012a(&c3_nameCaptureInfo);
  return c3_nameCaptureInfo;
}

static const mxArray *c3_b_sf_marshallOut(void *chartInstanceVoid, void
  *c3_inData)
{
  const mxArray *c3_mxArrayOutData = NULL;
  int32_T c3_u;
  const mxArray *c3_y = NULL;
  SFc3_PAC12InstanceStruct *chartInstance;
  chartInstance = (SFc3_PAC12InstanceStruct *)chartInstanceVoid;
  c3_mxArrayOutData = NULL;
  c3_u = *(int32_T *)c3_inData;
  c3_y = NULL;
  sf_mex_assign(&c3_y, sf_mex_create("y", &c3_u, 6, 0U, 0U, 0U, 0), FALSE);
  sf_mex_assign(&c3_mxArrayOutData, c3_y, FALSE);
  return c3_mxArrayOutData;
}

static int32_T c3_c_emlrt_marshallIn(SFc3_PAC12InstanceStruct *chartInstance,
  const mxArray *c3_u, const emlrtMsgIdentifier *c3_parentId)
{
  int32_T c3_y;
  int32_T c3_i1;
  sf_mex_import(c3_parentId, sf_mex_dup(c3_u), &c3_i1, 1, 6, 0U, 0, 0U, 0);
  c3_y = c3_i1;
  sf_mex_destroy(&c3_u);
  return c3_y;
}

static void c3_b_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c3_mxArrayInData, const char_T *c3_varName, void *c3_outData)
{
  const mxArray *c3_sfEvent;
  const char_T *c3_identifier;
  emlrtMsgIdentifier c3_thisId;
  int32_T c3_y;
  SFc3_PAC12InstanceStruct *chartInstance;
  chartInstance = (SFc3_PAC12InstanceStruct *)chartInstanceVoid;
  c3_sfEvent = sf_mex_dup(c3_mxArrayInData);
  c3_identifier = c3_varName;
  c3_thisId.fIdentifier = c3_identifier;
  c3_thisId.fParent = NULL;
  c3_y = c3_c_emlrt_marshallIn(chartInstance, sf_mex_dup(c3_sfEvent), &c3_thisId);
  sf_mex_destroy(&c3_sfEvent);
  *(int32_T *)c3_outData = c3_y;
  sf_mex_destroy(&c3_mxArrayInData);
}

static uint8_T c3_d_emlrt_marshallIn(SFc3_PAC12InstanceStruct *chartInstance,
  const mxArray *c3_is_active_c3_PAC12, const char_T *c3_identifier)
{
  uint8_T c3_y;
  emlrtMsgIdentifier c3_thisId;
  c3_thisId.fIdentifier = c3_identifier;
  c3_thisId.fParent = NULL;
  c3_y = c3_e_emlrt_marshallIn(chartInstance, sf_mex_dup(c3_is_active_c3_PAC12),
    &c3_thisId);
  sf_mex_destroy(&c3_is_active_c3_PAC12);
  return c3_y;
}

static uint8_T c3_e_emlrt_marshallIn(SFc3_PAC12InstanceStruct *chartInstance,
  const mxArray *c3_u, const emlrtMsgIdentifier *c3_parentId)
{
  uint8_T c3_y;
  uint8_T c3_u0;
  sf_mex_import(c3_parentId, sf_mex_dup(c3_u), &c3_u0, 1, 3, 0U, 0, 0U, 0);
  c3_y = c3_u0;
  sf_mex_destroy(&c3_u);
  return c3_y;
}

static void init_dsm_address_info(SFc3_PAC12InstanceStruct *chartInstance)
{
}

/* SFunction Glue Code */
static uint32_T* sf_get_sfun_dwork_checksum();
void sf_c3_PAC12_get_check_sum(mxArray *plhs[])
{
  ((real_T *)mxGetPr((plhs[0])))[0] = (real_T)(187033522U);
  ((real_T *)mxGetPr((plhs[0])))[1] = (real_T)(2092473399U);
  ((real_T *)mxGetPr((plhs[0])))[2] = (real_T)(3735959460U);
  ((real_T *)mxGetPr((plhs[0])))[3] = (real_T)(1016749522U);
}

mxArray *sf_c3_PAC12_get_autoinheritance_info(void)
{
  const char *autoinheritanceFields[] = { "checksum", "inputs", "parameters",
    "outputs", "locals" };

  mxArray *mxAutoinheritanceInfo = mxCreateStructMatrix(1,1,5,
    autoinheritanceFields);

  {
    mxArray *mxChecksum = mxCreateString("4xTdZSUy2oRCWWBsehjJt");
    mxSetField(mxAutoinheritanceInfo,0,"checksum",mxChecksum);
  }

  {
    const char *dataFields[] = { "size", "type", "complexity" };

    mxArray *mxData = mxCreateStructMatrix(1,6,3,dataFields);

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,0,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }

    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,1,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,1,"type",mxType);
    }

    mxSetField(mxData,1,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,2,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,2,"type",mxType);
    }

    mxSetField(mxData,2,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,3,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,3,"type",mxType);
    }

    mxSetField(mxData,3,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,4,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,4,"type",mxType);
    }

    mxSetField(mxData,4,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,5,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,5,"type",mxType);
    }

    mxSetField(mxData,5,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"inputs",mxData);
  }

  {
    mxSetField(mxAutoinheritanceInfo,0,"parameters",mxCreateDoubleMatrix(0,0,
                mxREAL));
  }

  {
    const char *dataFields[] = { "size", "type", "complexity" };

    mxArray *mxData = mxCreateStructMatrix(1,4,3,dataFields);

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,0,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }

    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,1,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,1,"type",mxType);
    }

    mxSetField(mxData,1,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,2,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,2,"type",mxType);
    }

    mxSetField(mxData,2,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,3,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,3,"type",mxType);
    }

    mxSetField(mxData,3,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"outputs",mxData);
  }

  {
    mxSetField(mxAutoinheritanceInfo,0,"locals",mxCreateDoubleMatrix(0,0,mxREAL));
  }

  return(mxAutoinheritanceInfo);
}

static const mxArray *sf_get_sim_state_info_c3_PAC12(void)
{
  const char *infoFields[] = { "chartChecksum", "varInfo" };

  mxArray *mxInfo = mxCreateStructMatrix(1, 1, 2, infoFields);
  const char *infoEncStr[] = {
    "100 S1x5'type','srcId','name','auxInfo'{{M[1],M[5],T\"HP\",},{M[1],M[14],T\"Pcond\",},{M[1],M[13],T\"Tse\",},{M[1],M[11],T\"h3\",},{M[8],M[0],T\"is_active_c3_PAC12\",}}"
  };

  mxArray *mxVarInfo = sf_mex_decode_encoded_mx_struct_array(infoEncStr, 5, 10);
  mxArray *mxChecksum = mxCreateDoubleMatrix(1, 4, mxREAL);
  sf_c3_PAC12_get_check_sum(&mxChecksum);
  mxSetField(mxInfo, 0, infoFields[0], mxChecksum);
  mxSetField(mxInfo, 0, infoFields[1], mxVarInfo);
  return mxInfo;
}

static void chart_debug_initialization(SimStruct *S, unsigned int
  fullDebuggerInitialization)
{
  if (!sim_mode_is_rtw_gen(S)) {
    SFc3_PAC12InstanceStruct *chartInstance;
    chartInstance = (SFc3_PAC12InstanceStruct *) ((ChartInfoStruct *)
      (ssGetUserData(S)))->chartInstance;
    if (ssIsFirstInitCond(S) && fullDebuggerInitialization==1) {
      /* do this only if simulation is starting */
      {
        unsigned int chartAlreadyPresent;
        chartAlreadyPresent = sf_debug_initialize_chart(_PAC12MachineNumber_,
          3,
          1,
          1,
          10,
          0,
          0,
          0,
          0,
          0,
          &(chartInstance->chartNumber),
          &(chartInstance->instanceNumber),
          ssGetPath(S),
          (void *)S);
        if (chartAlreadyPresent==0) {
          /* this is the first instance */
          init_script_number_translation(_PAC12MachineNumber_,
            chartInstance->chartNumber);
          sf_debug_set_chart_disable_implicit_casting(_PAC12MachineNumber_,
            chartInstance->chartNumber,1);
          sf_debug_set_chart_event_thresholds(_PAC12MachineNumber_,
            chartInstance->chartNumber,
            0,
            0,
            0);
          _SFD_SET_DATA_PROPS(0,1,1,0,"Tee");
          _SFD_SET_DATA_PROPS(1,2,0,1,"HP");
          _SFD_SET_DATA_PROPS(2,1,1,0,"h2");
          _SFD_SET_DATA_PROPS(3,1,1,0,"qmff");
          _SFD_SET_DATA_PROPS(4,1,1,0,"qveau");
          _SFD_SET_DATA_PROPS(5,1,1,0,"Pcomp");
          _SFD_SET_DATA_PROPS(6,1,1,0,"Pevapo");
          _SFD_SET_DATA_PROPS(7,2,0,1,"h3");
          _SFD_SET_DATA_PROPS(8,2,0,1,"Tse");
          _SFD_SET_DATA_PROPS(9,2,0,1,"Pcond");
          _SFD_STATE_INFO(0,0,2);
          _SFD_CH_SUBSTATE_COUNT(0);
          _SFD_CH_SUBSTATE_DECOMP(0);
        }

        _SFD_CV_INIT_CHART(0,0,0,0);

        {
          _SFD_CV_INIT_STATE(0,0,0,0,0,0,NULL,NULL);
        }

        _SFD_CV_INIT_TRANS(0,0,NULL,NULL,0,NULL);

        /* Initialization of MATLAB Function Model Coverage */
        _SFD_CV_INIT_EML(0,1,1,0,0,0,0,0,0,0,0);
        _SFD_CV_INIT_EML_FCN(0,0,"eML_blk_kernel",0,-1,238);
        _SFD_TRANS_COV_WTS(0,0,0,1,0);
        if (chartAlreadyPresent==0) {
          _SFD_TRANS_COV_MAPS(0,
                              0,NULL,NULL,
                              0,NULL,NULL,
                              1,NULL,NULL,
                              0,NULL,NULL);
        }

        _SFD_SET_DATA_COMPILED_PROPS(0,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c3_sf_marshallOut,(MexInFcnForType)NULL);
        _SFD_SET_DATA_COMPILED_PROPS(1,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c3_sf_marshallOut,(MexInFcnForType)c3_sf_marshallIn);
        _SFD_SET_DATA_COMPILED_PROPS(2,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c3_sf_marshallOut,(MexInFcnForType)NULL);
        _SFD_SET_DATA_COMPILED_PROPS(3,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c3_sf_marshallOut,(MexInFcnForType)NULL);
        _SFD_SET_DATA_COMPILED_PROPS(4,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c3_sf_marshallOut,(MexInFcnForType)NULL);
        _SFD_SET_DATA_COMPILED_PROPS(5,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c3_sf_marshallOut,(MexInFcnForType)NULL);
        _SFD_SET_DATA_COMPILED_PROPS(6,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c3_sf_marshallOut,(MexInFcnForType)NULL);
        _SFD_SET_DATA_COMPILED_PROPS(7,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c3_sf_marshallOut,(MexInFcnForType)c3_sf_marshallIn);
        _SFD_SET_DATA_COMPILED_PROPS(8,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c3_sf_marshallOut,(MexInFcnForType)c3_sf_marshallIn);
        _SFD_SET_DATA_COMPILED_PROPS(9,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c3_sf_marshallOut,(MexInFcnForType)c3_sf_marshallIn);

        {
          real_T *c3_Tee;
          real_T *c3_HP;
          real_T *c3_h2;
          real_T *c3_qmff;
          real_T *c3_qveau;
          real_T *c3_Pcomp;
          real_T *c3_Pevapo;
          real_T *c3_h3;
          real_T *c3_Tse;
          real_T *c3_Pcond;
          c3_Pcond = (real_T *)ssGetOutputPortSignal(chartInstance->S, 4);
          c3_Tse = (real_T *)ssGetOutputPortSignal(chartInstance->S, 3);
          c3_h3 = (real_T *)ssGetOutputPortSignal(chartInstance->S, 2);
          c3_Pevapo = (real_T *)ssGetInputPortSignal(chartInstance->S, 5);
          c3_Pcomp = (real_T *)ssGetInputPortSignal(chartInstance->S, 4);
          c3_qveau = (real_T *)ssGetInputPortSignal(chartInstance->S, 3);
          c3_qmff = (real_T *)ssGetInputPortSignal(chartInstance->S, 2);
          c3_h2 = (real_T *)ssGetInputPortSignal(chartInstance->S, 1);
          c3_HP = (real_T *)ssGetOutputPortSignal(chartInstance->S, 1);
          c3_Tee = (real_T *)ssGetInputPortSignal(chartInstance->S, 0);
          _SFD_SET_DATA_VALUE_PTR(0U, c3_Tee);
          _SFD_SET_DATA_VALUE_PTR(1U, c3_HP);
          _SFD_SET_DATA_VALUE_PTR(2U, c3_h2);
          _SFD_SET_DATA_VALUE_PTR(3U, c3_qmff);
          _SFD_SET_DATA_VALUE_PTR(4U, c3_qveau);
          _SFD_SET_DATA_VALUE_PTR(5U, c3_Pcomp);
          _SFD_SET_DATA_VALUE_PTR(6U, c3_Pevapo);
          _SFD_SET_DATA_VALUE_PTR(7U, c3_h3);
          _SFD_SET_DATA_VALUE_PTR(8U, c3_Tse);
          _SFD_SET_DATA_VALUE_PTR(9U, c3_Pcond);
        }
      }
    } else {
      sf_debug_reset_current_state_configuration(_PAC12MachineNumber_,
        chartInstance->chartNumber,chartInstance->instanceNumber);
    }
  }
}

static const char* sf_get_instance_specialization()
{
  return "dKbHYNfENxbmF42QBd95jC";
}

static void sf_check_dwork_consistency(SimStruct *S)
{
  if (sim_mode_is_rtw_gen(S) || sim_mode_is_external(S)) {
    const uint32_T *sfunDWorkChecksum = sf_get_sfun_dwork_checksum();
    mxArray *infoStruct = load_PAC12_optimization_info();
    mxArray* mxRTWDWorkChecksum = sf_get_dwork_info_from_mat_file(S,
      sf_get_instance_specialization(), infoStruct, 3, "dworkChecksum");
    if (mxRTWDWorkChecksum != NULL) {
      double *pr = mxGetPr(mxRTWDWorkChecksum);
      if ((uint32_T)pr[0] != sfunDWorkChecksum[0] ||
          (uint32_T)pr[1] != sfunDWorkChecksum[1] ||
          (uint32_T)pr[2] != sfunDWorkChecksum[2] ||
          (uint32_T)pr[3] != sfunDWorkChecksum[3]) {
        sf_mex_error_message("Code generation and simulation targets registered different sets of persistent variables for the block. "
                             "External or Rapid Accelerator mode simulation requires code generation and simulation targets to "
                             "register the same set of persistent variables for this block. "
                             "This discrepancy is typically caused by MATLAB functions that have different code paths for "
                             "simulation and code generation targets where these code paths define different sets of persistent variables. "
                             "Please identify these code paths in the offending block and rewrite the MATLAB code so that "
                             "the set of persistent variables is the same between simulation and code generation.");
      }
    }
  }
}

static void sf_opaque_initialize_c3_PAC12(void *chartInstanceVar)
{
  sf_check_dwork_consistency(((SFc3_PAC12InstanceStruct*) chartInstanceVar)->S);
  chart_debug_initialization(((SFc3_PAC12InstanceStruct*) chartInstanceVar)->S,0);
  initialize_params_c3_PAC12((SFc3_PAC12InstanceStruct*) chartInstanceVar);
  initialize_c3_PAC12((SFc3_PAC12InstanceStruct*) chartInstanceVar);
}

static void sf_opaque_enable_c3_PAC12(void *chartInstanceVar)
{
  enable_c3_PAC12((SFc3_PAC12InstanceStruct*) chartInstanceVar);
}

static void sf_opaque_disable_c3_PAC12(void *chartInstanceVar)
{
  disable_c3_PAC12((SFc3_PAC12InstanceStruct*) chartInstanceVar);
}

static void sf_opaque_gateway_c3_PAC12(void *chartInstanceVar)
{
  sf_c3_PAC12((SFc3_PAC12InstanceStruct*) chartInstanceVar);
}

static void sf_opaque_ext_mode_exec_c3_PAC12(void *chartInstanceVar)
{
  ext_mode_exec_c3_PAC12((SFc3_PAC12InstanceStruct*) chartInstanceVar);
}

extern const mxArray* sf_internal_get_sim_state_c3_PAC12(SimStruct* S)
{
  ChartInfoStruct *chartInfo = (ChartInfoStruct*) ssGetUserData(S);
  mxArray *plhs[1] = { NULL };

  mxArray *prhs[4];
  int mxError = 0;
  prhs[0] = mxCreateString("chart_simctx_raw2high");
  prhs[1] = mxCreateDoubleScalar(ssGetSFuncBlockHandle(S));
  prhs[2] = (mxArray*) get_sim_state_c3_PAC12((SFc3_PAC12InstanceStruct*)
    chartInfo->chartInstance);         /* raw sim ctx */
  prhs[3] = (mxArray*) sf_get_sim_state_info_c3_PAC12();/* state var info */
  mxError = sf_mex_call_matlab(1, plhs, 4, prhs, "sfprivate");
  mxDestroyArray(prhs[0]);
  mxDestroyArray(prhs[1]);
  mxDestroyArray(prhs[2]);
  mxDestroyArray(prhs[3]);
  if (mxError || plhs[0] == NULL) {
    sf_mex_error_message("Stateflow Internal Error: \nError calling 'chart_simctx_raw2high'.\n");
  }

  return plhs[0];
}

extern void sf_internal_set_sim_state_c3_PAC12(SimStruct* S, const mxArray *st)
{
  ChartInfoStruct *chartInfo = (ChartInfoStruct*) ssGetUserData(S);
  mxArray *plhs[1] = { NULL };

  mxArray *prhs[4];
  int mxError = 0;
  prhs[0] = mxCreateString("chart_simctx_high2raw");
  prhs[1] = mxCreateDoubleScalar(ssGetSFuncBlockHandle(S));
  prhs[2] = mxDuplicateArray(st);      /* high level simctx */
  prhs[3] = (mxArray*) sf_get_sim_state_info_c3_PAC12();/* state var info */
  mxError = sf_mex_call_matlab(1, plhs, 4, prhs, "sfprivate");
  mxDestroyArray(prhs[0]);
  mxDestroyArray(prhs[1]);
  mxDestroyArray(prhs[2]);
  mxDestroyArray(prhs[3]);
  if (mxError || plhs[0] == NULL) {
    sf_mex_error_message("Stateflow Internal Error: \nError calling 'chart_simctx_high2raw'.\n");
  }

  set_sim_state_c3_PAC12((SFc3_PAC12InstanceStruct*)chartInfo->chartInstance,
    mxDuplicateArray(plhs[0]));
  mxDestroyArray(plhs[0]);
}

static const mxArray* sf_opaque_get_sim_state_c3_PAC12(SimStruct* S)
{
  return sf_internal_get_sim_state_c3_PAC12(S);
}

static void sf_opaque_set_sim_state_c3_PAC12(SimStruct* S, const mxArray *st)
{
  sf_internal_set_sim_state_c3_PAC12(S, st);
}

static void sf_opaque_terminate_c3_PAC12(void *chartInstanceVar)
{
  if (chartInstanceVar!=NULL) {
    SimStruct *S = ((SFc3_PAC12InstanceStruct*) chartInstanceVar)->S;
    if (sim_mode_is_rtw_gen(S) || sim_mode_is_external(S)) {
      sf_clear_rtw_identifier(S);
    }

    finalize_c3_PAC12((SFc3_PAC12InstanceStruct*) chartInstanceVar);
    free((void *)chartInstanceVar);
    ssSetUserData(S,NULL);
  }

  unload_PAC12_optimization_info();
}

static void sf_opaque_init_subchart_simstructs(void *chartInstanceVar)
{
  initSimStructsc3_PAC12((SFc3_PAC12InstanceStruct*) chartInstanceVar);
}

extern unsigned int sf_machine_global_initializer_called(void);
static void mdlProcessParameters_c3_PAC12(SimStruct *S)
{
  int i;
  for (i=0;i<ssGetNumRunTimeParams(S);i++) {
    if (ssGetSFcnParamTunable(S,i)) {
      ssUpdateDlgParamAsRunTimeParam(S,i);
    }
  }

  if (sf_machine_global_initializer_called()) {
    initialize_params_c3_PAC12((SFc3_PAC12InstanceStruct*)(((ChartInfoStruct *)
      ssGetUserData(S))->chartInstance));
  }
}

mxArray *sf_c3_PAC12_get_testpoint_info(void)
{
  const char *infoEncStr[] = {
    "100 S'varName','path'{{T\"is_active_c3_PAC12\",T\"is_active_c3_PAC12\"}}"
  };

  mxArray *mxTpInfo = sf_mex_decode_encoded_mx_struct_array(infoEncStr, 1, 10);
  return mxTpInfo;
}

static void sf_set_sfun_dwork_info(SimStruct *S)
{
  const char *dworkEncStr[] = {
    "100 S1x4'type','isSigned','wordLength','bias','slope','exponent','isComplex','size'{{T\"int32\",,,,,,M[0],M[]},{T\"boolean\",,,,,,M[0],M[]},{T\"boolean\",,,,,,M[0],M[]},{T\"uint8\",,,,,,M[0],M[]}}"
  };

  sf_set_encoded_dwork_info(S, dworkEncStr, 4, 10);
}

static uint32_T* sf_get_sfun_dwork_checksum()
{
  static uint32_T checksum[4] = { 3851270630U, 3363230343U, 1651207761U,
    946165807U };

  return checksum;
}

static void mdlSetWorkWidths_c3_PAC12(SimStruct *S)
{
  if (sim_mode_is_rtw_gen(S) || sim_mode_is_external(S)) {
    mxArray *infoStruct = load_PAC12_optimization_info();
    int_T chartIsInlinable =
      (int_T)sf_is_chart_inlinable(S,sf_get_instance_specialization(),infoStruct,
      3);
    ssSetStateflowIsInlinable(S,chartIsInlinable);
    ssSetRTWCG(S,sf_rtw_info_uint_prop(S,sf_get_instance_specialization(),
                infoStruct,3,"RTWCG"));
    ssSetEnableFcnIsTrivial(S,1);
    ssSetDisableFcnIsTrivial(S,1);
    ssSetNotMultipleInlinable(S,sf_rtw_info_uint_prop(S,
      sf_get_instance_specialization(),infoStruct,3,
      "gatewayCannotBeInlinedMultipleTimes"));
    if (chartIsInlinable) {
      ssSetInputPortOptimOpts(S, 0, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 1, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 2, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 3, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 4, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 5, SS_REUSABLE_AND_LOCAL);
      sf_mark_chart_expressionable_inputs(S,sf_get_instance_specialization(),
        infoStruct,3,6);
      sf_mark_chart_reusable_outputs(S,sf_get_instance_specialization(),
        infoStruct,3,4);
    }

    sf_set_rtw_dwork_info(S,sf_get_instance_specialization(),infoStruct,3);
    ssSetHasSubFunctions(S,!(chartIsInlinable));
  } else {
    sf_set_sfun_dwork_info(S);
  }

  ssSetOptions(S,ssGetOptions(S)|SS_OPTION_WORKS_WITH_CODE_REUSE);
  ssSetChecksum0(S,(2982935141U));
  ssSetChecksum1(S,(2327266740U));
  ssSetChecksum2(S,(502868573U));
  ssSetChecksum3(S,(1476957998U));
  ssSetmdlDerivatives(S, NULL);
  ssSetExplicitFCSSCtrl(S,1);
  ssSupportsMultipleExecInstances(S,1);
}

static void mdlRTW_c3_PAC12(SimStruct *S)
{
  if (sim_mode_is_rtw_gen(S)) {
    ssWriteRTWStrParam(S, "StateflowChartType", "Embedded MATLAB");
  }
}

static void mdlStart_c3_PAC12(SimStruct *S)
{
  SFc3_PAC12InstanceStruct *chartInstance;
  chartInstance = (SFc3_PAC12InstanceStruct *)malloc(sizeof
    (SFc3_PAC12InstanceStruct));
  memset(chartInstance, 0, sizeof(SFc3_PAC12InstanceStruct));
  if (chartInstance==NULL) {
    sf_mex_error_message("Could not allocate memory for chart instance.");
  }

  chartInstance->chartInfo.chartInstance = chartInstance;
  chartInstance->chartInfo.isEMLChart = 1;
  chartInstance->chartInfo.chartInitialized = 0;
  chartInstance->chartInfo.sFunctionGateway = sf_opaque_gateway_c3_PAC12;
  chartInstance->chartInfo.initializeChart = sf_opaque_initialize_c3_PAC12;
  chartInstance->chartInfo.terminateChart = sf_opaque_terminate_c3_PAC12;
  chartInstance->chartInfo.enableChart = sf_opaque_enable_c3_PAC12;
  chartInstance->chartInfo.disableChart = sf_opaque_disable_c3_PAC12;
  chartInstance->chartInfo.getSimState = sf_opaque_get_sim_state_c3_PAC12;
  chartInstance->chartInfo.setSimState = sf_opaque_set_sim_state_c3_PAC12;
  chartInstance->chartInfo.getSimStateInfo = sf_get_sim_state_info_c3_PAC12;
  chartInstance->chartInfo.zeroCrossings = NULL;
  chartInstance->chartInfo.outputs = NULL;
  chartInstance->chartInfo.derivatives = NULL;
  chartInstance->chartInfo.mdlRTW = mdlRTW_c3_PAC12;
  chartInstance->chartInfo.mdlStart = mdlStart_c3_PAC12;
  chartInstance->chartInfo.mdlSetWorkWidths = mdlSetWorkWidths_c3_PAC12;
  chartInstance->chartInfo.extModeExec = sf_opaque_ext_mode_exec_c3_PAC12;
  chartInstance->chartInfo.restoreLastMajorStepConfiguration = NULL;
  chartInstance->chartInfo.restoreBeforeLastMajorStepConfiguration = NULL;
  chartInstance->chartInfo.storeCurrentConfiguration = NULL;
  chartInstance->S = S;
  ssSetUserData(S,(void *)(&(chartInstance->chartInfo)));/* register the chart instance with simstruct */
  init_dsm_address_info(chartInstance);
  if (!sim_mode_is_rtw_gen(S)) {
  }

  sf_opaque_init_subchart_simstructs(chartInstance->chartInfo.chartInstance);
  chart_debug_initialization(S,1);
}

void c3_PAC12_method_dispatcher(SimStruct *S, int_T method, void *data)
{
  switch (method) {
   case SS_CALL_MDL_START:
    mdlStart_c3_PAC12(S);
    break;

   case SS_CALL_MDL_SET_WORK_WIDTHS:
    mdlSetWorkWidths_c3_PAC12(S);
    break;

   case SS_CALL_MDL_PROCESS_PARAMETERS:
    mdlProcessParameters_c3_PAC12(S);
    break;

   default:
    /* Unhandled method */
    sf_mex_error_message("Stateflow Internal Error:\n"
                         "Error calling c3_PAC12_method_dispatcher.\n"
                         "Can't handle method %d.\n", method);
    break;
  }
}
