#include "__cf_PAC12.h"
#ifndef RTW_HEADER_PAC12_h_
#define RTW_HEADER_PAC12_h_
#ifndef PAC12_COMMON_INCLUDES_
#define PAC12_COMMON_INCLUDES_
#include <stdlib.h>
#include <stddef.h>
#include <float.h>
#include <string.h>
#include "rtwtypes.h"
#include "simstruc.h"
#include "fixedpoint.h"
#include "raccel.h"
#include "rt_logging.h"
#include "dt_info.h"
#include "ext_work.h"
#include "mwmathutil.h"
#include "rt_defines.h"
#include "rt_nonfinite.h"
#endif
#include "PAC12_types.h"
#define MODEL_NAME PAC12
#define NSAMPLE_TIMES (3) 
#define NINPUTS (0)       
#define NOUTPUTS (0)     
#define NBLOCKIO (47) 
#define NUM_ZC_EVENTS (0) 
#ifndef NCSTATES
#define NCSTATES (11)   
#elif NCSTATES != 11
#error Invalid specification of NCSTATES defined in compiler command
#endif
#ifndef rtmGetDataMapInfo
#define rtmGetDataMapInfo(rtm) (NULL)
#endif
#ifndef rtmSetDataMapInfo
#define rtmSetDataMapInfo(rtm, val)
#endif
typedef struct { real_T aazfgutwf2 ; real_T kstmgnxbbs [ 2 ] ; real_T
kublxa5uft ; real_T ii1horojev ; real_T jjivxgukxx ; real_T kwxwrynpy2 ;
real_T mcn2dg1hi1 ; real_T nopl35n0a3 ; real_T dkvjxa1iwb ; real_T byzgo32ouc
; real_T epbtyfsuda ; real_T f32yh101ne ; real_T liae1nd5vq ; real_T
dnwxjx3cqi ; real_T ilnkttw2jj ; real_T lubsg3dawr ; real_T joye4al5nt ;
real_T g1n2jqbq0b ; real_T grie2hlju0 ; real_T e0jh0lyecp ; real_T fgc4rxtlwm
; real_T jqwb2weqm1 ; real_T ccmjaxx0va ; real_T mcbynlirst ; real_T
fwsgyas504 ; real_T j2nm0cfeia ; real_T lsvpk3yw03 ; real_T ejmzwqhnre ;
real_T efzdviak5z ; real_T inzwpbdxco ; real_T elp5rgtxvh ; real_T ms2tyxdrcs
; real_T ovosinzbnk ; real_T itxkxczzps ; real_T cik33gzpau ; real_T
befsulcjsy ; real_T kgi1w3soeg ; real_T agdj3r1o5y ; real_T e5vdbbv30k ;
real_T aioybn54px ; real_T ko1gxrwnbq ; real_T gea2hlyqag ; boolean_T
i0tfmznb5h [ 2 ] ; boolean_T bihabp0gjp [ 2 ] ; boolean_T entric4v54 ;
boolean_T jondunmcet ; boolean_T nchpgabku0 ; } BlockIO ; typedef struct {
real_T grrowhozde ; real_T adyk0iqvfs ; real_T b4j5x5lzdg ; struct { real_T
modelTStart ; } nuzau4j5gi ; struct { real_T modelTStart ; } mh2dok4awx ;
struct { real_T modelTStart ; } cpgnih0ra4 ; struct { real_T modelTStart ; }
cihvi12hpi ; struct { void * TUbufferPtrs [ 2 ] ; } iut2r435qv ; struct {
void * TUbufferPtrs [ 2 ] ; } aeuandkef3 ; struct { void * TUbufferPtrs [ 2 ]
; } b5bxcmuezp ; struct { void * TUbufferPtrs [ 2 ] ; } n4zxkezhac ; int32_T
dve1sawdqi ; int32_T orejvmvykp ; int32_T enhmhwt2qw ; int32_T k5mg3b12uc ;
int32_T mk1r5e5vsx ; int32_T icouiufvpi ; int32_T a5qgajufny ; struct { int_T
Tail ; int_T Head ; int_T Last ; int_T CircularBufSize ; int_T MaxNewBufSize
; } a2mhmvb3lk ; struct { int_T Tail ; int_T Head ; int_T Last ; int_T
CircularBufSize ; int_T MaxNewBufSize ; } d3upmmysrm ; struct { int_T Tail ;
int_T Head ; int_T Last ; int_T CircularBufSize ; int_T MaxNewBufSize ; }
dm5tjhfas0 ; struct { int_T Tail ; int_T Head ; int_T Last ; int_T
CircularBufSize ; int_T MaxNewBufSize ; } gcrmjp2l1a ; int_T g4h0q5fh04 ;
int8_T lhijssqokf ; int8_T p0ht22gzar ; uint8_T pf2yw0somj ; uint8_T
j2egqy2oow ; uint8_T bm511otbxu ; uint8_T g5nm1vnsq4 ; uint8_T mol1oxq3se ;
uint8_T j0j5n5ggyn ; uint8_T htsdqfry1g ; boolean_T khrr0qka05 ; boolean_T
kyhtgey0ks ; boolean_T ezmcfllgpn ; boolean_T nq31ijacpk ; boolean_T
fimv0gqx0u ; boolean_T bckylw554t ; boolean_T i1pseq32nx ; boolean_T
j0pyfi1tdq ; boolean_T d3n1qxhsgo ; boolean_T opezxq0dfe ; boolean_T
d1obwp1c0g ; boolean_T p00kkrvn0k ; boolean_T cq1klhhgvq ; boolean_T
dqq0sn3req ; boolean_T dxmhecszp2 ; boolean_T lpq3krur30 ; boolean_T
opfkxn5bax ; boolean_T e0udlw0xlb ; } D_Work ; typedef struct { real_T
ltf23ctade ; real_T cahlezrpz2 ; real_T p1uwrsxl0r ; real_T dqstdcth5r ;
real_T apt43y3vkc ; real_T huak42uvyj ; real_T gduezbsvcw ; real_T kkljodbkqh
; real_T gnhaahmtqg ; real_T j43kdojhvf ; real_T jiz03m5xlu ; }
ContinuousStates ; typedef struct { real_T ltf23ctade ; real_T cahlezrpz2 ;
real_T p1uwrsxl0r ; real_T dqstdcth5r ; real_T apt43y3vkc ; real_T huak42uvyj
; real_T gduezbsvcw ; real_T kkljodbkqh ; real_T gnhaahmtqg ; real_T
j43kdojhvf ; real_T jiz03m5xlu ; } StateDerivatives ; typedef struct {
boolean_T ltf23ctade ; boolean_T cahlezrpz2 ; boolean_T p1uwrsxl0r ;
boolean_T dqstdcth5r ; boolean_T apt43y3vkc ; boolean_T huak42uvyj ;
boolean_T gduezbsvcw ; boolean_T kkljodbkqh ; boolean_T gnhaahmtqg ;
boolean_T j43kdojhvf ; boolean_T jiz03m5xlu ; } StateDisabled ; typedef
struct { real_T ltf23ctade ; real_T cahlezrpz2 ; real_T p1uwrsxl0r ; real_T
dqstdcth5r ; real_T apt43y3vkc ; real_T huak42uvyj ; real_T gduezbsvcw ;
real_T kkljodbkqh ; real_T gnhaahmtqg ; real_T j43kdojhvf ; real_T jiz03m5xlu
; } CStateAbsTol ; typedef struct { real_T bmmhw1u2ut ; real_T dyyhpltrzn ;
real_T bbvbtpffdp ; } ZCSignalValues ; typedef struct { ZCSigState kjhksqcfrw
; ZCSigState coxi55e4qi ; ZCSigState in4olkplxq ; } PrevZCSigStates ; struct
Parameters_ { real_T Rcstart_Gain ; real_T Rcrun_Gain ; real_T Gain3_Gain ;
real_T Gain14_Gain ; real_T Cstart_Gain ; real_T Crun_Gain ; real_T
Integrator1_IC ; real_T Gain2_Gain ; real_T Integrator_IC ; real_T Gain8_Gain
; real_T Gain15_Gain ; real_T Integrator3_IC ; real_T Gain7_Gain ; real_T
Integrator2_IC ; real_T Gain24_Gain ; real_T Gain15_Gain_jze1hxseg5 ; real_T
Gain4_Gain ; real_T ConvertputoSI_Gain ; real_T AC_Amp ; real_T AC_Bias ;
real_T AC_Freq ; real_T AC_Phase ; real_T StateSpace_D [ 5 ] ; real_T
Delay2_InitialCondition ; real_T TetaEntreEauC_Value ; real_T
Integrator1_IC_aehowymbvi ; real_T Gain18_Gain ; real_T Gain3_Gain_fj10whbwhs
; real_T Gain18_Gain_ob3afy332o ; real_T Gain4_Gain_iuyhput4ar ; real_T
Gain2_Gain_csrq1gymrc ; real_T Integrator_IC_pngt4mv1fd ; real_T p_Gain ;
real_T ConvertputoSIwhenSIUnitsareselected_Gain [ 3 ] ; real_T rpm_Gain ;
real_T Delay_InitialCondition ; real_T TairC_Value ; real_T
Delay1_InitialCondition ; real_T Efficacit_Value ; real_T dbitdeaulh_Value ;
real_T integ1_IC ; real_T T_Delay ; real_T T_InitOutput ; real_T Integ2_IC ;
real_T T1_Delay ; real_T T1_InitOutput ; real_T integ1_IC_glu1ekuz4t ; real_T
T_Delay_h2xo2qxqld ; real_T T_InitOutput_fqms4dx05u ; real_T
Integ2_IC_lmely2xtya ; real_T T1_Delay_htcndl55sy ; real_T
T1_InitOutput_gbax24wjej ; real_T Gain2_Gain_hgqqxnrsg4 ; real_T
Gain2_Gain_kxrioqygbn ; real_T DegRad_Gain ; real_T Gain_Gain ; real_T
Gain1_Gain ; real_T donotdeletethisgain_Gain ; real_T Gain1_Gain_ixv12z3bdm ;
real_T sinnwt_Amp ; real_T sinnwt_Bias ; real_T sinnwt_Freq ; real_T
sinnwt_Phase ; real_T cosnwt_Amp ; real_T cosnwt_Bias ; real_T cosnwt_Freq ;
real_T cosnwt_Phase ; real_T donotdeletethisgain_Gain_pyhg5vqo40 ; real_T
Gain1_Gain_ej4ubzun0m ; real_T sinnwt_Amp_ipv0egzt4q ; real_T
sinnwt_Bias_dxswg1nwhp ; real_T sinnwt_Freq_mepyvywbdr ; real_T
sinnwt_Phase_p3zhnrbt4y ; real_T cosnwt_Amp_bnjyav0xlc ; real_T
cosnwt_Bias_m1y4i4sek1 ; real_T cosnwt_Freq_phqhto54eh ; real_T
cosnwt_Phase_fgqlpmrnjy ; real_T Gain_Gain_ae402yxlvy ; real_T Gain19_Gain ;
real_T Gain23_Gain ; real_T Gain5_Gain ; real_T Gain25_Gain ; real_T
Gain22_Gain ; real_T Gain6_Gain ; real_T eps_Value ; real_T
disconnectionspeed_Value ; real_T Integrator_IC_j055cwwqfn ; real_T
Gain8_Gain_gd3v4iussi ; real_T Gain2_Gain_pt05gztupt ; real_T
Gain4_Gain_bn3fb1ddcj ; real_T Gain1_Gain_fues3ic5k1 ; real_T
Gain3_Gain_dabuchjsw4 ; real_T Gain10_Gain ; real_T Gain7_Gain_l5ahylter2 ;
real_T Gain9_Gain ; real_T Gain6_Gain_mqc2nbp251 ; real_T Gain11_Gain ;
real_T Rcrun1_Gain ; real_T ConvertSItopuwhenSIUnitsareselected_Gain ; real_T
F_Gain ; real_T _2H_Gain ; real_T web_psb1_Gain ; uint32_T Delay2_DelayLength
; uint32_T Delay_DelayLength ; uint32_T Delay1_DelayLength ; boolean_T
Capstart_Value ; boolean_T Memory_X0 ; boolean_T Memory_X0_nenp1n44ho ;
boolean_T Logic_table [ 16 ] ; boolean_T Logic_table_ohgytdol4z [ 16 ] ;
boolean_T Capstart1_Value ; boolean_T Caprun1_Value ; boolean_T Caprun_Value
; } ; extern Parameters rtP ; extern const char * RT_MEMORY_ALLOCATION_ERROR
; extern BlockIO rtB ; extern ContinuousStates rtX ; extern D_Work rtDWork ;
extern PrevZCSigStates rtPrevZCSigState ; extern SimStruct * const rtS ;
extern const int_T gblNumToFiles ; extern const int_T gblNumFrFiles ; extern
const int_T gblNumFrWksBlocks ; extern rtInportTUtable * gblInportTUtables ;
extern const char * gblInportFileName ; extern const int_T
gblNumRootInportBlks ; extern const int_T gblNumModelInputs ; extern const
int_T gblInportDataTypeIdx [ ] ; extern const int_T gblInportDims [ ] ;
extern const int_T gblInportComplex [ ] ; extern const int_T
gblInportInterpoFlag [ ] ; extern const int_T gblInportContinuous [ ] ;
#endif
