  function targMap = targDataMap(),

  ;%***********************
  ;% Create Parameter Map *
  ;%***********************
      
    nTotData      = 0; %add to this count as we go
    nTotSects     = 3;
    sectIdxOffset = 0;
    
    ;%
    ;% Define dummy sections & preallocate arrays
    ;%
    dumSection.nData = -1;  
    dumSection.data  = [];
    
    dumData.logicalSrcIdx = -1;
    dumData.dtTransOffset = -1;
    
    ;%
    ;% Init/prealloc paramMap
    ;%
    paramMap.nSections           = nTotSects;
    paramMap.sectIdxOffset       = sectIdxOffset;
      paramMap.sections(nTotSects) = dumSection; %prealloc
    paramMap.nTotData            = -1;
    
    ;%
    ;% Auto data (rtP)
    ;%
      section.nData     = 102;
      section.data(102)  = dumData; %prealloc
      
	  ;% rtP.Rcstart_Gain
	  section.data(1).logicalSrcIdx = 0;
	  section.data(1).dtTransOffset = 0;
	
	  ;% rtP.Rcrun_Gain
	  section.data(2).logicalSrcIdx = 1;
	  section.data(2).dtTransOffset = 1;
	
	  ;% rtP.Gain3_Gain
	  section.data(3).logicalSrcIdx = 2;
	  section.data(3).dtTransOffset = 2;
	
	  ;% rtP.Gain14_Gain
	  section.data(4).logicalSrcIdx = 3;
	  section.data(4).dtTransOffset = 3;
	
	  ;% rtP.Cstart_Gain
	  section.data(5).logicalSrcIdx = 4;
	  section.data(5).dtTransOffset = 4;
	
	  ;% rtP.Crun_Gain
	  section.data(6).logicalSrcIdx = 5;
	  section.data(6).dtTransOffset = 5;
	
	  ;% rtP.Integrator1_IC
	  section.data(7).logicalSrcIdx = 6;
	  section.data(7).dtTransOffset = 6;
	
	  ;% rtP.Gain2_Gain
	  section.data(8).logicalSrcIdx = 7;
	  section.data(8).dtTransOffset = 7;
	
	  ;% rtP.Integrator_IC
	  section.data(9).logicalSrcIdx = 8;
	  section.data(9).dtTransOffset = 8;
	
	  ;% rtP.Gain8_Gain
	  section.data(10).logicalSrcIdx = 9;
	  section.data(10).dtTransOffset = 9;
	
	  ;% rtP.Gain15_Gain
	  section.data(11).logicalSrcIdx = 10;
	  section.data(11).dtTransOffset = 10;
	
	  ;% rtP.Integrator3_IC
	  section.data(12).logicalSrcIdx = 11;
	  section.data(12).dtTransOffset = 11;
	
	  ;% rtP.Gain7_Gain
	  section.data(13).logicalSrcIdx = 12;
	  section.data(13).dtTransOffset = 12;
	
	  ;% rtP.Integrator2_IC
	  section.data(14).logicalSrcIdx = 13;
	  section.data(14).dtTransOffset = 13;
	
	  ;% rtP.Gain24_Gain
	  section.data(15).logicalSrcIdx = 14;
	  section.data(15).dtTransOffset = 14;
	
	  ;% rtP.Gain15_Gain_jze1hxseg5
	  section.data(16).logicalSrcIdx = 15;
	  section.data(16).dtTransOffset = 15;
	
	  ;% rtP.Gain4_Gain
	  section.data(17).logicalSrcIdx = 16;
	  section.data(17).dtTransOffset = 16;
	
	  ;% rtP.ConvertputoSI_Gain
	  section.data(18).logicalSrcIdx = 17;
	  section.data(18).dtTransOffset = 17;
	
	  ;% rtP.AC_Amp
	  section.data(19).logicalSrcIdx = 18;
	  section.data(19).dtTransOffset = 18;
	
	  ;% rtP.AC_Bias
	  section.data(20).logicalSrcIdx = 19;
	  section.data(20).dtTransOffset = 19;
	
	  ;% rtP.AC_Freq
	  section.data(21).logicalSrcIdx = 20;
	  section.data(21).dtTransOffset = 20;
	
	  ;% rtP.AC_Phase
	  section.data(22).logicalSrcIdx = 21;
	  section.data(22).dtTransOffset = 21;
	
	  ;% rtP.StateSpace_D
	  section.data(23).logicalSrcIdx = 25;
	  section.data(23).dtTransOffset = 22;
	
	  ;% rtP.Delay2_InitialCondition
	  section.data(24).logicalSrcIdx = 27;
	  section.data(24).dtTransOffset = 27;
	
	  ;% rtP.TetaEntreEauC_Value
	  section.data(25).logicalSrcIdx = 28;
	  section.data(25).dtTransOffset = 28;
	
	  ;% rtP.Integrator1_IC_aehowymbvi
	  section.data(26).logicalSrcIdx = 29;
	  section.data(26).dtTransOffset = 29;
	
	  ;% rtP.Gain18_Gain
	  section.data(27).logicalSrcIdx = 30;
	  section.data(27).dtTransOffset = 30;
	
	  ;% rtP.Gain3_Gain_fj10whbwhs
	  section.data(28).logicalSrcIdx = 31;
	  section.data(28).dtTransOffset = 31;
	
	  ;% rtP.Gain18_Gain_ob3afy332o
	  section.data(29).logicalSrcIdx = 32;
	  section.data(29).dtTransOffset = 32;
	
	  ;% rtP.Gain4_Gain_iuyhput4ar
	  section.data(30).logicalSrcIdx = 33;
	  section.data(30).dtTransOffset = 33;
	
	  ;% rtP.Gain2_Gain_csrq1gymrc
	  section.data(31).logicalSrcIdx = 34;
	  section.data(31).dtTransOffset = 34;
	
	  ;% rtP.Integrator_IC_pngt4mv1fd
	  section.data(32).logicalSrcIdx = 35;
	  section.data(32).dtTransOffset = 35;
	
	  ;% rtP.p_Gain
	  section.data(33).logicalSrcIdx = 36;
	  section.data(33).dtTransOffset = 36;
	
	  ;% rtP.ConvertputoSIwhenSIUnitsareselected_Gain
	  section.data(34).logicalSrcIdx = 37;
	  section.data(34).dtTransOffset = 37;
	
	  ;% rtP.rpm_Gain
	  section.data(35).logicalSrcIdx = 38;
	  section.data(35).dtTransOffset = 40;
	
	  ;% rtP.Delay_InitialCondition
	  section.data(36).logicalSrcIdx = 39;
	  section.data(36).dtTransOffset = 41;
	
	  ;% rtP.TairC_Value
	  section.data(37).logicalSrcIdx = 40;
	  section.data(37).dtTransOffset = 42;
	
	  ;% rtP.Delay1_InitialCondition
	  section.data(38).logicalSrcIdx = 41;
	  section.data(38).dtTransOffset = 43;
	
	  ;% rtP.Efficacit_Value
	  section.data(39).logicalSrcIdx = 42;
	  section.data(39).dtTransOffset = 44;
	
	  ;% rtP.dbitdeaulh_Value
	  section.data(40).logicalSrcIdx = 43;
	  section.data(40).dtTransOffset = 45;
	
	  ;% rtP.integ1_IC
	  section.data(41).logicalSrcIdx = 44;
	  section.data(41).dtTransOffset = 46;
	
	  ;% rtP.T_Delay
	  section.data(42).logicalSrcIdx = 45;
	  section.data(42).dtTransOffset = 47;
	
	  ;% rtP.T_InitOutput
	  section.data(43).logicalSrcIdx = 46;
	  section.data(43).dtTransOffset = 48;
	
	  ;% rtP.Integ2_IC
	  section.data(44).logicalSrcIdx = 47;
	  section.data(44).dtTransOffset = 49;
	
	  ;% rtP.T1_Delay
	  section.data(45).logicalSrcIdx = 48;
	  section.data(45).dtTransOffset = 50;
	
	  ;% rtP.T1_InitOutput
	  section.data(46).logicalSrcIdx = 49;
	  section.data(46).dtTransOffset = 51;
	
	  ;% rtP.integ1_IC_glu1ekuz4t
	  section.data(47).logicalSrcIdx = 50;
	  section.data(47).dtTransOffset = 52;
	
	  ;% rtP.T_Delay_h2xo2qxqld
	  section.data(48).logicalSrcIdx = 51;
	  section.data(48).dtTransOffset = 53;
	
	  ;% rtP.T_InitOutput_fqms4dx05u
	  section.data(49).logicalSrcIdx = 52;
	  section.data(49).dtTransOffset = 54;
	
	  ;% rtP.Integ2_IC_lmely2xtya
	  section.data(50).logicalSrcIdx = 53;
	  section.data(50).dtTransOffset = 55;
	
	  ;% rtP.T1_Delay_htcndl55sy
	  section.data(51).logicalSrcIdx = 54;
	  section.data(51).dtTransOffset = 56;
	
	  ;% rtP.T1_InitOutput_gbax24wjej
	  section.data(52).logicalSrcIdx = 55;
	  section.data(52).dtTransOffset = 57;
	
	  ;% rtP.Gain2_Gain_hgqqxnrsg4
	  section.data(53).logicalSrcIdx = 56;
	  section.data(53).dtTransOffset = 58;
	
	  ;% rtP.Gain2_Gain_kxrioqygbn
	  section.data(54).logicalSrcIdx = 57;
	  section.data(54).dtTransOffset = 59;
	
	  ;% rtP.DegRad_Gain
	  section.data(55).logicalSrcIdx = 58;
	  section.data(55).dtTransOffset = 60;
	
	  ;% rtP.Gain_Gain
	  section.data(56).logicalSrcIdx = 59;
	  section.data(56).dtTransOffset = 61;
	
	  ;% rtP.Gain1_Gain
	  section.data(57).logicalSrcIdx = 60;
	  section.data(57).dtTransOffset = 62;
	
	  ;% rtP.donotdeletethisgain_Gain
	  section.data(58).logicalSrcIdx = 61;
	  section.data(58).dtTransOffset = 63;
	
	  ;% rtP.Gain1_Gain_ixv12z3bdm
	  section.data(59).logicalSrcIdx = 62;
	  section.data(59).dtTransOffset = 64;
	
	  ;% rtP.sinnwt_Amp
	  section.data(60).logicalSrcIdx = 63;
	  section.data(60).dtTransOffset = 65;
	
	  ;% rtP.sinnwt_Bias
	  section.data(61).logicalSrcIdx = 64;
	  section.data(61).dtTransOffset = 66;
	
	  ;% rtP.sinnwt_Freq
	  section.data(62).logicalSrcIdx = 65;
	  section.data(62).dtTransOffset = 67;
	
	  ;% rtP.sinnwt_Phase
	  section.data(63).logicalSrcIdx = 66;
	  section.data(63).dtTransOffset = 68;
	
	  ;% rtP.cosnwt_Amp
	  section.data(64).logicalSrcIdx = 67;
	  section.data(64).dtTransOffset = 69;
	
	  ;% rtP.cosnwt_Bias
	  section.data(65).logicalSrcIdx = 68;
	  section.data(65).dtTransOffset = 70;
	
	  ;% rtP.cosnwt_Freq
	  section.data(66).logicalSrcIdx = 69;
	  section.data(66).dtTransOffset = 71;
	
	  ;% rtP.cosnwt_Phase
	  section.data(67).logicalSrcIdx = 70;
	  section.data(67).dtTransOffset = 72;
	
	  ;% rtP.donotdeletethisgain_Gain_pyhg5vqo40
	  section.data(68).logicalSrcIdx = 71;
	  section.data(68).dtTransOffset = 73;
	
	  ;% rtP.Gain1_Gain_ej4ubzun0m
	  section.data(69).logicalSrcIdx = 72;
	  section.data(69).dtTransOffset = 74;
	
	  ;% rtP.sinnwt_Amp_ipv0egzt4q
	  section.data(70).logicalSrcIdx = 73;
	  section.data(70).dtTransOffset = 75;
	
	  ;% rtP.sinnwt_Bias_dxswg1nwhp
	  section.data(71).logicalSrcIdx = 74;
	  section.data(71).dtTransOffset = 76;
	
	  ;% rtP.sinnwt_Freq_mepyvywbdr
	  section.data(72).logicalSrcIdx = 75;
	  section.data(72).dtTransOffset = 77;
	
	  ;% rtP.sinnwt_Phase_p3zhnrbt4y
	  section.data(73).logicalSrcIdx = 76;
	  section.data(73).dtTransOffset = 78;
	
	  ;% rtP.cosnwt_Amp_bnjyav0xlc
	  section.data(74).logicalSrcIdx = 77;
	  section.data(74).dtTransOffset = 79;
	
	  ;% rtP.cosnwt_Bias_m1y4i4sek1
	  section.data(75).logicalSrcIdx = 78;
	  section.data(75).dtTransOffset = 80;
	
	  ;% rtP.cosnwt_Freq_phqhto54eh
	  section.data(76).logicalSrcIdx = 79;
	  section.data(76).dtTransOffset = 81;
	
	  ;% rtP.cosnwt_Phase_fgqlpmrnjy
	  section.data(77).logicalSrcIdx = 80;
	  section.data(77).dtTransOffset = 82;
	
	  ;% rtP.Gain_Gain_ae402yxlvy
	  section.data(78).logicalSrcIdx = 81;
	  section.data(78).dtTransOffset = 83;
	
	  ;% rtP.Gain19_Gain
	  section.data(79).logicalSrcIdx = 82;
	  section.data(79).dtTransOffset = 84;
	
	  ;% rtP.Gain23_Gain
	  section.data(80).logicalSrcIdx = 83;
	  section.data(80).dtTransOffset = 85;
	
	  ;% rtP.Gain5_Gain
	  section.data(81).logicalSrcIdx = 84;
	  section.data(81).dtTransOffset = 86;
	
	  ;% rtP.Gain25_Gain
	  section.data(82).logicalSrcIdx = 85;
	  section.data(82).dtTransOffset = 87;
	
	  ;% rtP.Gain22_Gain
	  section.data(83).logicalSrcIdx = 86;
	  section.data(83).dtTransOffset = 88;
	
	  ;% rtP.Gain6_Gain
	  section.data(84).logicalSrcIdx = 87;
	  section.data(84).dtTransOffset = 89;
	
	  ;% rtP.eps_Value
	  section.data(85).logicalSrcIdx = 88;
	  section.data(85).dtTransOffset = 90;
	
	  ;% rtP.disconnectionspeed_Value
	  section.data(86).logicalSrcIdx = 89;
	  section.data(86).dtTransOffset = 91;
	
	  ;% rtP.Integrator_IC_j055cwwqfn
	  section.data(87).logicalSrcIdx = 90;
	  section.data(87).dtTransOffset = 92;
	
	  ;% rtP.Gain8_Gain_gd3v4iussi
	  section.data(88).logicalSrcIdx = 91;
	  section.data(88).dtTransOffset = 93;
	
	  ;% rtP.Gain2_Gain_pt05gztupt
	  section.data(89).logicalSrcIdx = 92;
	  section.data(89).dtTransOffset = 94;
	
	  ;% rtP.Gain4_Gain_bn3fb1ddcj
	  section.data(90).logicalSrcIdx = 93;
	  section.data(90).dtTransOffset = 95;
	
	  ;% rtP.Gain1_Gain_fues3ic5k1
	  section.data(91).logicalSrcIdx = 94;
	  section.data(91).dtTransOffset = 96;
	
	  ;% rtP.Gain3_Gain_dabuchjsw4
	  section.data(92).logicalSrcIdx = 95;
	  section.data(92).dtTransOffset = 97;
	
	  ;% rtP.Gain10_Gain
	  section.data(93).logicalSrcIdx = 96;
	  section.data(93).dtTransOffset = 98;
	
	  ;% rtP.Gain7_Gain_l5ahylter2
	  section.data(94).logicalSrcIdx = 97;
	  section.data(94).dtTransOffset = 99;
	
	  ;% rtP.Gain9_Gain
	  section.data(95).logicalSrcIdx = 98;
	  section.data(95).dtTransOffset = 100;
	
	  ;% rtP.Gain6_Gain_mqc2nbp251
	  section.data(96).logicalSrcIdx = 99;
	  section.data(96).dtTransOffset = 101;
	
	  ;% rtP.Gain11_Gain
	  section.data(97).logicalSrcIdx = 100;
	  section.data(97).dtTransOffset = 102;
	
	  ;% rtP.Rcrun1_Gain
	  section.data(98).logicalSrcIdx = 101;
	  section.data(98).dtTransOffset = 103;
	
	  ;% rtP.ConvertSItopuwhenSIUnitsareselected_Gain
	  section.data(99).logicalSrcIdx = 102;
	  section.data(99).dtTransOffset = 104;
	
	  ;% rtP.F_Gain
	  section.data(100).logicalSrcIdx = 103;
	  section.data(100).dtTransOffset = 105;
	
	  ;% rtP._2H_Gain
	  section.data(101).logicalSrcIdx = 104;
	  section.data(101).dtTransOffset = 106;
	
	  ;% rtP.web_psb1_Gain
	  section.data(102).logicalSrcIdx = 105;
	  section.data(102).dtTransOffset = 107;
	
      nTotData = nTotData + section.nData;
      paramMap.sections(1) = section;
      clear section
      
      section.nData     = 3;
      section.data(3)  = dumData; %prealloc
      
	  ;% rtP.Delay2_DelayLength
	  section.data(1).logicalSrcIdx = 106;
	  section.data(1).dtTransOffset = 0;
	
	  ;% rtP.Delay_DelayLength
	  section.data(2).logicalSrcIdx = 107;
	  section.data(2).dtTransOffset = 1;
	
	  ;% rtP.Delay1_DelayLength
	  section.data(3).logicalSrcIdx = 108;
	  section.data(3).dtTransOffset = 2;
	
      nTotData = nTotData + section.nData;
      paramMap.sections(2) = section;
      clear section
      
      section.nData     = 8;
      section.data(8)  = dumData; %prealloc
      
	  ;% rtP.Capstart_Value
	  section.data(1).logicalSrcIdx = 109;
	  section.data(1).dtTransOffset = 0;
	
	  ;% rtP.Memory_X0
	  section.data(2).logicalSrcIdx = 110;
	  section.data(2).dtTransOffset = 1;
	
	  ;% rtP.Memory_X0_nenp1n44ho
	  section.data(3).logicalSrcIdx = 111;
	  section.data(3).dtTransOffset = 2;
	
	  ;% rtP.Logic_table
	  section.data(4).logicalSrcIdx = 112;
	  section.data(4).dtTransOffset = 3;
	
	  ;% rtP.Logic_table_ohgytdol4z
	  section.data(5).logicalSrcIdx = 113;
	  section.data(5).dtTransOffset = 19;
	
	  ;% rtP.Capstart1_Value
	  section.data(6).logicalSrcIdx = 114;
	  section.data(6).dtTransOffset = 35;
	
	  ;% rtP.Caprun1_Value
	  section.data(7).logicalSrcIdx = 115;
	  section.data(7).dtTransOffset = 36;
	
	  ;% rtP.Caprun_Value
	  section.data(8).logicalSrcIdx = 116;
	  section.data(8).dtTransOffset = 37;
	
      nTotData = nTotData + section.nData;
      paramMap.sections(3) = section;
      clear section
      
    
      ;%
      ;% Non-auto Data (parameter)
      ;%
    

    ;%
    ;% Add final counts to struct.
    ;%
    paramMap.nTotData = nTotData;
    


  ;%**************************
  ;% Create Block Output Map *
  ;%**************************
      
    nTotData      = 0; %add to this count as we go
    nTotSects     = 2;
    sectIdxOffset = 0;
    
    ;%
    ;% Define dummy sections & preallocate arrays
    ;%
    dumSection.nData = -1;  
    dumSection.data  = [];
    
    dumData.logicalSrcIdx = -1;
    dumData.dtTransOffset = -1;
    
    ;%
    ;% Init/prealloc sigMap
    ;%
    sigMap.nSections           = nTotSects;
    sigMap.sectIdxOffset       = sectIdxOffset;
      sigMap.sections(nTotSects) = dumSection; %prealloc
    sigMap.nTotData            = -1;
    
    ;%
    ;% Auto data (rtB)
    ;%
      section.nData     = 42;
      section.data(42)  = dumData; %prealloc
      
	  ;% rtB.aazfgutwf2
	  section.data(1).logicalSrcIdx = 0;
	  section.data(1).dtTransOffset = 0;
	
	  ;% rtB.kstmgnxbbs
	  section.data(2).logicalSrcIdx = 1;
	  section.data(2).dtTransOffset = 1;
	
	  ;% rtB.kublxa5uft
	  section.data(3).logicalSrcIdx = 2;
	  section.data(3).dtTransOffset = 3;
	
	  ;% rtB.ii1horojev
	  section.data(4).logicalSrcIdx = 3;
	  section.data(4).dtTransOffset = 4;
	
	  ;% rtB.jjivxgukxx
	  section.data(5).logicalSrcIdx = 4;
	  section.data(5).dtTransOffset = 5;
	
	  ;% rtB.kwxwrynpy2
	  section.data(6).logicalSrcIdx = 5;
	  section.data(6).dtTransOffset = 6;
	
	  ;% rtB.mcn2dg1hi1
	  section.data(7).logicalSrcIdx = 6;
	  section.data(7).dtTransOffset = 7;
	
	  ;% rtB.nopl35n0a3
	  section.data(8).logicalSrcIdx = 7;
	  section.data(8).dtTransOffset = 8;
	
	  ;% rtB.dkvjxa1iwb
	  section.data(9).logicalSrcIdx = 8;
	  section.data(9).dtTransOffset = 9;
	
	  ;% rtB.byzgo32ouc
	  section.data(10).logicalSrcIdx = 9;
	  section.data(10).dtTransOffset = 10;
	
	  ;% rtB.epbtyfsuda
	  section.data(11).logicalSrcIdx = 10;
	  section.data(11).dtTransOffset = 11;
	
	  ;% rtB.f32yh101ne
	  section.data(12).logicalSrcIdx = 11;
	  section.data(12).dtTransOffset = 12;
	
	  ;% rtB.liae1nd5vq
	  section.data(13).logicalSrcIdx = 12;
	  section.data(13).dtTransOffset = 13;
	
	  ;% rtB.dnwxjx3cqi
	  section.data(14).logicalSrcIdx = 13;
	  section.data(14).dtTransOffset = 14;
	
	  ;% rtB.ilnkttw2jj
	  section.data(15).logicalSrcIdx = 14;
	  section.data(15).dtTransOffset = 15;
	
	  ;% rtB.lubsg3dawr
	  section.data(16).logicalSrcIdx = 15;
	  section.data(16).dtTransOffset = 16;
	
	  ;% rtB.joye4al5nt
	  section.data(17).logicalSrcIdx = 16;
	  section.data(17).dtTransOffset = 17;
	
	  ;% rtB.g1n2jqbq0b
	  section.data(18).logicalSrcIdx = 17;
	  section.data(18).dtTransOffset = 18;
	
	  ;% rtB.grie2hlju0
	  section.data(19).logicalSrcIdx = 18;
	  section.data(19).dtTransOffset = 19;
	
	  ;% rtB.e0jh0lyecp
	  section.data(20).logicalSrcIdx = 19;
	  section.data(20).dtTransOffset = 20;
	
	  ;% rtB.fgc4rxtlwm
	  section.data(21).logicalSrcIdx = 20;
	  section.data(21).dtTransOffset = 21;
	
	  ;% rtB.jqwb2weqm1
	  section.data(22).logicalSrcIdx = 21;
	  section.data(22).dtTransOffset = 22;
	
	  ;% rtB.ccmjaxx0va
	  section.data(23).logicalSrcIdx = 22;
	  section.data(23).dtTransOffset = 23;
	
	  ;% rtB.mcbynlirst
	  section.data(24).logicalSrcIdx = 23;
	  section.data(24).dtTransOffset = 24;
	
	  ;% rtB.fwsgyas504
	  section.data(25).logicalSrcIdx = 24;
	  section.data(25).dtTransOffset = 25;
	
	  ;% rtB.j2nm0cfeia
	  section.data(26).logicalSrcIdx = 25;
	  section.data(26).dtTransOffset = 26;
	
	  ;% rtB.lsvpk3yw03
	  section.data(27).logicalSrcIdx = 26;
	  section.data(27).dtTransOffset = 27;
	
	  ;% rtB.ejmzwqhnre
	  section.data(28).logicalSrcIdx = 27;
	  section.data(28).dtTransOffset = 28;
	
	  ;% rtB.efzdviak5z
	  section.data(29).logicalSrcIdx = 28;
	  section.data(29).dtTransOffset = 29;
	
	  ;% rtB.inzwpbdxco
	  section.data(30).logicalSrcIdx = 29;
	  section.data(30).dtTransOffset = 30;
	
	  ;% rtB.elp5rgtxvh
	  section.data(31).logicalSrcIdx = 30;
	  section.data(31).dtTransOffset = 31;
	
	  ;% rtB.ms2tyxdrcs
	  section.data(32).logicalSrcIdx = 31;
	  section.data(32).dtTransOffset = 32;
	
	  ;% rtB.ovosinzbnk
	  section.data(33).logicalSrcIdx = 32;
	  section.data(33).dtTransOffset = 33;
	
	  ;% rtB.itxkxczzps
	  section.data(34).logicalSrcIdx = 33;
	  section.data(34).dtTransOffset = 34;
	
	  ;% rtB.cik33gzpau
	  section.data(35).logicalSrcIdx = 34;
	  section.data(35).dtTransOffset = 35;
	
	  ;% rtB.befsulcjsy
	  section.data(36).logicalSrcIdx = 35;
	  section.data(36).dtTransOffset = 36;
	
	  ;% rtB.kgi1w3soeg
	  section.data(37).logicalSrcIdx = 36;
	  section.data(37).dtTransOffset = 37;
	
	  ;% rtB.agdj3r1o5y
	  section.data(38).logicalSrcIdx = 37;
	  section.data(38).dtTransOffset = 38;
	
	  ;% rtB.e5vdbbv30k
	  section.data(39).logicalSrcIdx = 38;
	  section.data(39).dtTransOffset = 39;
	
	  ;% rtB.aioybn54px
	  section.data(40).logicalSrcIdx = 39;
	  section.data(40).dtTransOffset = 40;
	
	  ;% rtB.ko1gxrwnbq
	  section.data(41).logicalSrcIdx = 40;
	  section.data(41).dtTransOffset = 41;
	
	  ;% rtB.gea2hlyqag
	  section.data(42).logicalSrcIdx = 41;
	  section.data(42).dtTransOffset = 42;
	
      nTotData = nTotData + section.nData;
      sigMap.sections(1) = section;
      clear section
      
      section.nData     = 5;
      section.data(5)  = dumData; %prealloc
      
	  ;% rtB.i0tfmznb5h
	  section.data(1).logicalSrcIdx = 42;
	  section.data(1).dtTransOffset = 0;
	
	  ;% rtB.bihabp0gjp
	  section.data(2).logicalSrcIdx = 43;
	  section.data(2).dtTransOffset = 2;
	
	  ;% rtB.entric4v54
	  section.data(3).logicalSrcIdx = 44;
	  section.data(3).dtTransOffset = 4;
	
	  ;% rtB.jondunmcet
	  section.data(4).logicalSrcIdx = 45;
	  section.data(4).dtTransOffset = 5;
	
	  ;% rtB.nchpgabku0
	  section.data(5).logicalSrcIdx = 46;
	  section.data(5).dtTransOffset = 6;
	
      nTotData = nTotData + section.nData;
      sigMap.sections(2) = section;
      clear section
      
    
      ;%
      ;% Non-auto Data (signal)
      ;%
    

    ;%
    ;% Add final counts to struct.
    ;%
    sigMap.nTotData = nTotData;
    


  ;%*******************
  ;% Create DWork Map *
  ;%*******************
      
    nTotData      = 0; %add to this count as we go
    nTotSects     = 7;
    sectIdxOffset = 2;
    
    ;%
    ;% Define dummy sections & preallocate arrays
    ;%
    dumSection.nData = -1;  
    dumSection.data  = [];
    
    dumData.logicalSrcIdx = -1;
    dumData.dtTransOffset = -1;
    
    ;%
    ;% Init/prealloc dworkMap
    ;%
    dworkMap.nSections           = nTotSects;
    dworkMap.sectIdxOffset       = sectIdxOffset;
      dworkMap.sections(nTotSects) = dumSection; %prealloc
    dworkMap.nTotData            = -1;
    
    ;%
    ;% Auto data (rtDWork)
    ;%
      section.nData     = 7;
      section.data(7)  = dumData; %prealloc
      
	  ;% rtDWork.grrowhozde
	  section.data(1).logicalSrcIdx = 0;
	  section.data(1).dtTransOffset = 0;
	
	  ;% rtDWork.adyk0iqvfs
	  section.data(2).logicalSrcIdx = 1;
	  section.data(2).dtTransOffset = 1;
	
	  ;% rtDWork.b4j5x5lzdg
	  section.data(3).logicalSrcIdx = 2;
	  section.data(3).dtTransOffset = 2;
	
	  ;% rtDWork.nuzau4j5gi.modelTStart
	  section.data(4).logicalSrcIdx = 3;
	  section.data(4).dtTransOffset = 3;
	
	  ;% rtDWork.mh2dok4awx.modelTStart
	  section.data(5).logicalSrcIdx = 4;
	  section.data(5).dtTransOffset = 4;
	
	  ;% rtDWork.cpgnih0ra4.modelTStart
	  section.data(6).logicalSrcIdx = 5;
	  section.data(6).dtTransOffset = 5;
	
	  ;% rtDWork.cihvi12hpi.modelTStart
	  section.data(7).logicalSrcIdx = 6;
	  section.data(7).dtTransOffset = 6;
	
      nTotData = nTotData + section.nData;
      dworkMap.sections(1) = section;
      clear section
      
      section.nData     = 4;
      section.data(4)  = dumData; %prealloc
      
	  ;% rtDWork.iut2r435qv.TUbufferPtrs
	  section.data(1).logicalSrcIdx = 7;
	  section.data(1).dtTransOffset = 0;
	
	  ;% rtDWork.aeuandkef3.TUbufferPtrs
	  section.data(2).logicalSrcIdx = 8;
	  section.data(2).dtTransOffset = 2;
	
	  ;% rtDWork.b5bxcmuezp.TUbufferPtrs
	  section.data(3).logicalSrcIdx = 9;
	  section.data(3).dtTransOffset = 4;
	
	  ;% rtDWork.n4zxkezhac.TUbufferPtrs
	  section.data(4).logicalSrcIdx = 10;
	  section.data(4).dtTransOffset = 6;
	
      nTotData = nTotData + section.nData;
      dworkMap.sections(2) = section;
      clear section
      
      section.nData     = 7;
      section.data(7)  = dumData; %prealloc
      
	  ;% rtDWork.dve1sawdqi
	  section.data(1).logicalSrcIdx = 11;
	  section.data(1).dtTransOffset = 0;
	
	  ;% rtDWork.orejvmvykp
	  section.data(2).logicalSrcIdx = 12;
	  section.data(2).dtTransOffset = 1;
	
	  ;% rtDWork.enhmhwt2qw
	  section.data(3).logicalSrcIdx = 13;
	  section.data(3).dtTransOffset = 2;
	
	  ;% rtDWork.k5mg3b12uc
	  section.data(4).logicalSrcIdx = 14;
	  section.data(4).dtTransOffset = 3;
	
	  ;% rtDWork.mk1r5e5vsx
	  section.data(5).logicalSrcIdx = 15;
	  section.data(5).dtTransOffset = 4;
	
	  ;% rtDWork.icouiufvpi
	  section.data(6).logicalSrcIdx = 16;
	  section.data(6).dtTransOffset = 5;
	
	  ;% rtDWork.a5qgajufny
	  section.data(7).logicalSrcIdx = 17;
	  section.data(7).dtTransOffset = 6;
	
      nTotData = nTotData + section.nData;
      dworkMap.sections(3) = section;
      clear section
      
      section.nData     = 5;
      section.data(5)  = dumData; %prealloc
      
	  ;% rtDWork.a2mhmvb3lk.Tail
	  section.data(1).logicalSrcIdx = 18;
	  section.data(1).dtTransOffset = 0;
	
	  ;% rtDWork.d3upmmysrm.Tail
	  section.data(2).logicalSrcIdx = 19;
	  section.data(2).dtTransOffset = 1;
	
	  ;% rtDWork.dm5tjhfas0.Tail
	  section.data(3).logicalSrcIdx = 20;
	  section.data(3).dtTransOffset = 2;
	
	  ;% rtDWork.gcrmjp2l1a.Tail
	  section.data(4).logicalSrcIdx = 21;
	  section.data(4).dtTransOffset = 3;
	
	  ;% rtDWork.g4h0q5fh04
	  section.data(5).logicalSrcIdx = 22;
	  section.data(5).dtTransOffset = 4;
	
      nTotData = nTotData + section.nData;
      dworkMap.sections(4) = section;
      clear section
      
      section.nData     = 2;
      section.data(2)  = dumData; %prealloc
      
	  ;% rtDWork.lhijssqokf
	  section.data(1).logicalSrcIdx = 23;
	  section.data(1).dtTransOffset = 0;
	
	  ;% rtDWork.p0ht22gzar
	  section.data(2).logicalSrcIdx = 24;
	  section.data(2).dtTransOffset = 1;
	
      nTotData = nTotData + section.nData;
      dworkMap.sections(5) = section;
      clear section
      
      section.nData     = 7;
      section.data(7)  = dumData; %prealloc
      
	  ;% rtDWork.pf2yw0somj
	  section.data(1).logicalSrcIdx = 25;
	  section.data(1).dtTransOffset = 0;
	
	  ;% rtDWork.j2egqy2oow
	  section.data(2).logicalSrcIdx = 26;
	  section.data(2).dtTransOffset = 1;
	
	  ;% rtDWork.bm511otbxu
	  section.data(3).logicalSrcIdx = 27;
	  section.data(3).dtTransOffset = 2;
	
	  ;% rtDWork.g5nm1vnsq4
	  section.data(4).logicalSrcIdx = 28;
	  section.data(4).dtTransOffset = 3;
	
	  ;% rtDWork.mol1oxq3se
	  section.data(5).logicalSrcIdx = 29;
	  section.data(5).dtTransOffset = 4;
	
	  ;% rtDWork.j0j5n5ggyn
	  section.data(6).logicalSrcIdx = 30;
	  section.data(6).dtTransOffset = 5;
	
	  ;% rtDWork.htsdqfry1g
	  section.data(7).logicalSrcIdx = 31;
	  section.data(7).dtTransOffset = 6;
	
      nTotData = nTotData + section.nData;
      dworkMap.sections(6) = section;
      clear section
      
      section.nData     = 18;
      section.data(18)  = dumData; %prealloc
      
	  ;% rtDWork.khrr0qka05
	  section.data(1).logicalSrcIdx = 32;
	  section.data(1).dtTransOffset = 0;
	
	  ;% rtDWork.kyhtgey0ks
	  section.data(2).logicalSrcIdx = 33;
	  section.data(2).dtTransOffset = 1;
	
	  ;% rtDWork.ezmcfllgpn
	  section.data(3).logicalSrcIdx = 34;
	  section.data(3).dtTransOffset = 2;
	
	  ;% rtDWork.nq31ijacpk
	  section.data(4).logicalSrcIdx = 35;
	  section.data(4).dtTransOffset = 3;
	
	  ;% rtDWork.fimv0gqx0u
	  section.data(5).logicalSrcIdx = 36;
	  section.data(5).dtTransOffset = 4;
	
	  ;% rtDWork.bckylw554t
	  section.data(6).logicalSrcIdx = 37;
	  section.data(6).dtTransOffset = 5;
	
	  ;% rtDWork.i1pseq32nx
	  section.data(7).logicalSrcIdx = 38;
	  section.data(7).dtTransOffset = 6;
	
	  ;% rtDWork.j0pyfi1tdq
	  section.data(8).logicalSrcIdx = 39;
	  section.data(8).dtTransOffset = 7;
	
	  ;% rtDWork.d3n1qxhsgo
	  section.data(9).logicalSrcIdx = 40;
	  section.data(9).dtTransOffset = 8;
	
	  ;% rtDWork.opezxq0dfe
	  section.data(10).logicalSrcIdx = 41;
	  section.data(10).dtTransOffset = 9;
	
	  ;% rtDWork.d1obwp1c0g
	  section.data(11).logicalSrcIdx = 42;
	  section.data(11).dtTransOffset = 10;
	
	  ;% rtDWork.p00kkrvn0k
	  section.data(12).logicalSrcIdx = 43;
	  section.data(12).dtTransOffset = 11;
	
	  ;% rtDWork.cq1klhhgvq
	  section.data(13).logicalSrcIdx = 44;
	  section.data(13).dtTransOffset = 12;
	
	  ;% rtDWork.dqq0sn3req
	  section.data(14).logicalSrcIdx = 45;
	  section.data(14).dtTransOffset = 13;
	
	  ;% rtDWork.dxmhecszp2
	  section.data(15).logicalSrcIdx = 46;
	  section.data(15).dtTransOffset = 14;
	
	  ;% rtDWork.lpq3krur30
	  section.data(16).logicalSrcIdx = 47;
	  section.data(16).dtTransOffset = 15;
	
	  ;% rtDWork.opfkxn5bax
	  section.data(17).logicalSrcIdx = 48;
	  section.data(17).dtTransOffset = 16;
	
	  ;% rtDWork.e0udlw0xlb
	  section.data(18).logicalSrcIdx = 49;
	  section.data(18).dtTransOffset = 17;
	
      nTotData = nTotData + section.nData;
      dworkMap.sections(7) = section;
      clear section
      
    
      ;%
      ;% Non-auto Data (dwork)
      ;%
    

    ;%
    ;% Add final counts to struct.
    ;%
    dworkMap.nTotData = nTotData;
    


  ;%
  ;% Add individual maps to base struct.
  ;%

  targMap.paramMap  = paramMap;    
  targMap.signalMap = sigMap;
  targMap.dworkMap  = dworkMap;
  
  ;%
  ;% Add checksums to base struct.
  ;%


  targMap.checksum0 = 2232961427;
  targMap.checksum1 = 1651030777;
  targMap.checksum2 = 1031803174;
  targMap.checksum3 = 938836361;

