/* Include files */

#include "blascompat32.h"
#include "Compresseur_sfun.h"
#include "c2_Compresseur.h"
#include "mwmathutil.h"
#define CHARTINSTANCE_CHARTNUMBER      (chartInstance->chartNumber)
#define CHARTINSTANCE_INSTANCENUMBER   (chartInstance->instanceNumber)
#include "Compresseur_sfun_debug_macros.h"

/* Type Definitions */

/* Named Constants */
#define CALL_EVENT                     (-1)

/* Variable Declarations */

/* Variable Definitions */
static const char * c2_debug_family_names[25] = { "d1", "d2", "d3", "d4", "d5",
  "T", "cp", "R", "gam", "vpmb", "vpmh", "Wtot", "neff", "nv", "nargin",
  "nargout", "N", "HP", "BP", "h1", "v1", "P", "Tm", "h2", "qmff" };

/* Function Declarations */
static void initialize_c2_Compresseur(SFc2_CompresseurInstanceStruct
  *chartInstance);
static void initialize_params_c2_Compresseur(SFc2_CompresseurInstanceStruct
  *chartInstance);
static void enable_c2_Compresseur(SFc2_CompresseurInstanceStruct *chartInstance);
static void disable_c2_Compresseur(SFc2_CompresseurInstanceStruct *chartInstance);
static void c2_update_debugger_state_c2_Compresseur
  (SFc2_CompresseurInstanceStruct *chartInstance);
static const mxArray *get_sim_state_c2_Compresseur
  (SFc2_CompresseurInstanceStruct *chartInstance);
static void set_sim_state_c2_Compresseur(SFc2_CompresseurInstanceStruct
  *chartInstance, const mxArray *c2_st);
static void finalize_c2_Compresseur(SFc2_CompresseurInstanceStruct
  *chartInstance);
static void sf_c2_Compresseur(SFc2_CompresseurInstanceStruct *chartInstance);
static void c2_chartstep_c2_Compresseur(SFc2_CompresseurInstanceStruct
  *chartInstance);
static void initSimStructsc2_Compresseur(SFc2_CompresseurInstanceStruct
  *chartInstance);
static void init_script_number_translation(uint32_T c2_machineNumber, uint32_T
  c2_chartNumber);
static const mxArray *c2_sf_marshallOut(void *chartInstanceVoid, void *c2_inData);
static real_T c2_emlrt_marshallIn(SFc2_CompresseurInstanceStruct *chartInstance,
  const mxArray *c2_qmff, const char_T *c2_identifier);
static real_T c2_b_emlrt_marshallIn(SFc2_CompresseurInstanceStruct
  *chartInstance, const mxArray *c2_u, const emlrtMsgIdentifier *c2_parentId);
static void c2_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c2_mxArrayInData, const char_T *c2_varName, void *c2_outData);
static void c2_eml_scalar_eg(SFc2_CompresseurInstanceStruct *chartInstance);
static void c2_eml_error(SFc2_CompresseurInstanceStruct *chartInstance);
static const mxArray *c2_b_sf_marshallOut(void *chartInstanceVoid, void
  *c2_inData);
static int32_T c2_c_emlrt_marshallIn(SFc2_CompresseurInstanceStruct
  *chartInstance, const mxArray *c2_u, const emlrtMsgIdentifier *c2_parentId);
static void c2_b_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c2_mxArrayInData, const char_T *c2_varName, void *c2_outData);
static uint8_T c2_d_emlrt_marshallIn(SFc2_CompresseurInstanceStruct
  *chartInstance, const mxArray *c2_b_is_active_c2_Compresseur, const char_T
  *c2_identifier);
static uint8_T c2_e_emlrt_marshallIn(SFc2_CompresseurInstanceStruct
  *chartInstance, const mxArray *c2_u, const emlrtMsgIdentifier *c2_parentId);
static void init_dsm_address_info(SFc2_CompresseurInstanceStruct *chartInstance);

/* Function Definitions */
static void initialize_c2_Compresseur(SFc2_CompresseurInstanceStruct
  *chartInstance)
{
  chartInstance->c2_sfEvent = CALL_EVENT;
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
  chartInstance->c2_is_active_c2_Compresseur = 0U;
}

static void initialize_params_c2_Compresseur(SFc2_CompresseurInstanceStruct
  *chartInstance)
{
}

static void enable_c2_Compresseur(SFc2_CompresseurInstanceStruct *chartInstance)
{
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
}

static void disable_c2_Compresseur(SFc2_CompresseurInstanceStruct *chartInstance)
{
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
}

static void c2_update_debugger_state_c2_Compresseur
  (SFc2_CompresseurInstanceStruct *chartInstance)
{
}

static const mxArray *get_sim_state_c2_Compresseur
  (SFc2_CompresseurInstanceStruct *chartInstance)
{
  const mxArray *c2_st;
  const mxArray *c2_y = NULL;
  real_T c2_hoistedGlobal;
  real_T c2_u;
  const mxArray *c2_b_y = NULL;
  real_T c2_b_hoistedGlobal;
  real_T c2_b_u;
  const mxArray *c2_c_y = NULL;
  real_T c2_c_hoistedGlobal;
  real_T c2_c_u;
  const mxArray *c2_d_y = NULL;
  real_T c2_d_hoistedGlobal;
  real_T c2_d_u;
  const mxArray *c2_e_y = NULL;
  uint8_T c2_e_hoistedGlobal;
  uint8_T c2_e_u;
  const mxArray *c2_f_y = NULL;
  real_T *c2_P;
  real_T *c2_Tm;
  real_T *c2_h2;
  real_T *c2_qmff;
  c2_qmff = (real_T *)ssGetOutputPortSignal(chartInstance->S, 4);
  c2_h2 = (real_T *)ssGetOutputPortSignal(chartInstance->S, 3);
  c2_Tm = (real_T *)ssGetOutputPortSignal(chartInstance->S, 2);
  c2_P = (real_T *)ssGetOutputPortSignal(chartInstance->S, 1);
  c2_st = NULL;
  c2_st = NULL;
  c2_y = NULL;
  sf_mex_assign(&c2_y, sf_mex_createcellarray(5), FALSE);
  c2_hoistedGlobal = *c2_P;
  c2_u = c2_hoistedGlobal;
  c2_b_y = NULL;
  sf_mex_assign(&c2_b_y, sf_mex_create("y", &c2_u, 0, 0U, 0U, 0U, 0), FALSE);
  sf_mex_setcell(c2_y, 0, c2_b_y);
  c2_b_hoistedGlobal = *c2_Tm;
  c2_b_u = c2_b_hoistedGlobal;
  c2_c_y = NULL;
  sf_mex_assign(&c2_c_y, sf_mex_create("y", &c2_b_u, 0, 0U, 0U, 0U, 0), FALSE);
  sf_mex_setcell(c2_y, 1, c2_c_y);
  c2_c_hoistedGlobal = *c2_h2;
  c2_c_u = c2_c_hoistedGlobal;
  c2_d_y = NULL;
  sf_mex_assign(&c2_d_y, sf_mex_create("y", &c2_c_u, 0, 0U, 0U, 0U, 0), FALSE);
  sf_mex_setcell(c2_y, 2, c2_d_y);
  c2_d_hoistedGlobal = *c2_qmff;
  c2_d_u = c2_d_hoistedGlobal;
  c2_e_y = NULL;
  sf_mex_assign(&c2_e_y, sf_mex_create("y", &c2_d_u, 0, 0U, 0U, 0U, 0), FALSE);
  sf_mex_setcell(c2_y, 3, c2_e_y);
  c2_e_hoistedGlobal = chartInstance->c2_is_active_c2_Compresseur;
  c2_e_u = c2_e_hoistedGlobal;
  c2_f_y = NULL;
  sf_mex_assign(&c2_f_y, sf_mex_create("y", &c2_e_u, 3, 0U, 0U, 0U, 0), FALSE);
  sf_mex_setcell(c2_y, 4, c2_f_y);
  sf_mex_assign(&c2_st, c2_y, FALSE);
  return c2_st;
}

static void set_sim_state_c2_Compresseur(SFc2_CompresseurInstanceStruct
  *chartInstance, const mxArray *c2_st)
{
  const mxArray *c2_u;
  real_T *c2_P;
  real_T *c2_Tm;
  real_T *c2_h2;
  real_T *c2_qmff;
  c2_qmff = (real_T *)ssGetOutputPortSignal(chartInstance->S, 4);
  c2_h2 = (real_T *)ssGetOutputPortSignal(chartInstance->S, 3);
  c2_Tm = (real_T *)ssGetOutputPortSignal(chartInstance->S, 2);
  c2_P = (real_T *)ssGetOutputPortSignal(chartInstance->S, 1);
  chartInstance->c2_doneDoubleBufferReInit = TRUE;
  c2_u = sf_mex_dup(c2_st);
  *c2_P = c2_emlrt_marshallIn(chartInstance, sf_mex_dup(sf_mex_getcell(c2_u, 0)),
    "P");
  *c2_Tm = c2_emlrt_marshallIn(chartInstance, sf_mex_dup(sf_mex_getcell(c2_u, 1)),
    "Tm");
  *c2_h2 = c2_emlrt_marshallIn(chartInstance, sf_mex_dup(sf_mex_getcell(c2_u, 2)),
    "h2");
  *c2_qmff = c2_emlrt_marshallIn(chartInstance, sf_mex_dup(sf_mex_getcell(c2_u,
    3)), "qmff");
  chartInstance->c2_is_active_c2_Compresseur = c2_d_emlrt_marshallIn
    (chartInstance, sf_mex_dup(sf_mex_getcell(c2_u, 4)),
     "is_active_c2_Compresseur");
  sf_mex_destroy(&c2_u);
  c2_update_debugger_state_c2_Compresseur(chartInstance);
  sf_mex_destroy(&c2_st);
}

static void finalize_c2_Compresseur(SFc2_CompresseurInstanceStruct
  *chartInstance)
{
}

static void sf_c2_Compresseur(SFc2_CompresseurInstanceStruct *chartInstance)
{
  real_T *c2_N;
  real_T *c2_P;
  real_T *c2_HP;
  real_T *c2_BP;
  real_T *c2_h1;
  real_T *c2_v1;
  real_T *c2_Tm;
  real_T *c2_h2;
  real_T *c2_qmff;
  c2_qmff = (real_T *)ssGetOutputPortSignal(chartInstance->S, 4);
  c2_h2 = (real_T *)ssGetOutputPortSignal(chartInstance->S, 3);
  c2_Tm = (real_T *)ssGetOutputPortSignal(chartInstance->S, 2);
  c2_v1 = (real_T *)ssGetInputPortSignal(chartInstance->S, 4);
  c2_h1 = (real_T *)ssGetInputPortSignal(chartInstance->S, 3);
  c2_BP = (real_T *)ssGetInputPortSignal(chartInstance->S, 2);
  c2_HP = (real_T *)ssGetInputPortSignal(chartInstance->S, 1);
  c2_P = (real_T *)ssGetOutputPortSignal(chartInstance->S, 1);
  c2_N = (real_T *)ssGetInputPortSignal(chartInstance->S, 0);
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
  _SFD_CC_CALL(CHART_ENTER_SFUNCTION_TAG, 0U, chartInstance->c2_sfEvent);
  _SFD_DATA_RANGE_CHECK(*c2_N, 0U);
  _SFD_DATA_RANGE_CHECK(*c2_P, 1U);
  _SFD_DATA_RANGE_CHECK(*c2_HP, 2U);
  _SFD_DATA_RANGE_CHECK(*c2_BP, 3U);
  _SFD_DATA_RANGE_CHECK(*c2_h1, 4U);
  _SFD_DATA_RANGE_CHECK(*c2_v1, 5U);
  _SFD_DATA_RANGE_CHECK(*c2_Tm, 6U);
  _SFD_DATA_RANGE_CHECK(*c2_h2, 7U);
  _SFD_DATA_RANGE_CHECK(*c2_qmff, 8U);
  chartInstance->c2_sfEvent = CALL_EVENT;
  c2_chartstep_c2_Compresseur(chartInstance);
  sf_debug_check_for_state_inconsistency(_CompresseurMachineNumber_,
    chartInstance->chartNumber, chartInstance->instanceNumber);
}

static void c2_chartstep_c2_Compresseur(SFc2_CompresseurInstanceStruct
  *chartInstance)
{
  real_T c2_hoistedGlobal;
  real_T c2_b_hoistedGlobal;
  real_T c2_c_hoistedGlobal;
  real_T c2_d_hoistedGlobal;
  real_T c2_e_hoistedGlobal;
  real_T c2_N;
  real_T c2_HP;
  real_T c2_BP;
  real_T c2_h1;
  real_T c2_v1;
  uint32_T c2_debug_family_var_map[25];
  real_T c2_d1;
  real_T c2_d2;
  real_T c2_d3;
  real_T c2_d4;
  real_T c2_d5;
  real_T c2_T;
  real_T c2_cp;
  real_T c2_R;
  real_T c2_gam;
  real_T c2_vpmb;
  real_T c2_vpmh;
  real_T c2_Wtot;
  real_T c2_neff;
  real_T c2_nv;
  real_T c2_nargin = 5.0;
  real_T c2_nargout = 4.0;
  real_T c2_P;
  real_T c2_Tm;
  real_T c2_h2;
  real_T c2_qmff;
  real_T c2_a;
  real_T c2_b_a;
  real_T c2_A;
  real_T c2_B;
  real_T c2_x;
  real_T c2_y;
  real_T c2_b_x;
  real_T c2_b_y;
  real_T c2_c_y;
  real_T c2_c_a;
  real_T c2_d_a;
  real_T c2_e_a;
  real_T c2_ak;
  real_T c2_c;
  real_T c2_f_a;
  real_T c2_b;
  real_T c2_d_y;
  real_T c2_b_b;
  real_T c2_e_y;
  real_T c2_c_b;
  real_T c2_f_y;
  real_T c2_g_a;
  real_T c2_d_b;
  real_T c2_g_y;
  real_T c2_b_A;
  real_T c2_c_x;
  real_T c2_d_x;
  real_T c2_h_y;
  real_T c2_c_A;
  real_T c2_e_x;
  real_T c2_f_x;
  real_T c2_d_A;
  real_T c2_b_B;
  real_T c2_g_x;
  real_T c2_i_y;
  real_T c2_h_x;
  real_T c2_j_y;
  real_T c2_k_y;
  real_T c2_h_a;
  real_T c2_i_a;
  real_T c2_j_a;
  real_T c2_b_ak;
  real_T c2_b_c;
  real_T c2_e_b;
  real_T c2_l_y;
  real_T c2_e_A;
  real_T c2_c_B;
  real_T c2_i_x;
  real_T c2_m_y;
  real_T c2_j_x;
  real_T c2_n_y;
  real_T c2_o_y;
  real_T c2_d_B;
  real_T c2_p_y;
  real_T c2_q_y;
  real_T c2_r_y;
  real_T c2_f_A;
  real_T c2_e_B;
  real_T c2_k_x;
  real_T c2_s_y;
  real_T c2_l_x;
  real_T c2_t_y;
  real_T c2_u_y;
  real_T c2_k_a;
  real_T c2_l_a;
  real_T c2_m_a;
  real_T c2_c_ak;
  real_T c2_c_c;
  real_T c2_f_b;
  real_T c2_v_y;
  real_T c2_g_b;
  real_T c2_n_a;
  real_T c2_w_y;
  real_T c2_g_A;
  real_T c2_f_B;
  real_T c2_m_x;
  real_T c2_x_y;
  real_T c2_n_x;
  real_T c2_y_y;
  real_T c2_ab_y;
  real_T c2_o_a;
  real_T c2_h_b;
  real_T c2_bb_y;
  real_T c2_h_A;
  real_T c2_o_x;
  real_T c2_p_x;
  real_T c2_i_A;
  real_T c2_q_x;
  real_T c2_r_x;
  real_T c2_cb_y;
  real_T c2_j_A;
  real_T c2_g_B;
  real_T c2_s_x;
  real_T c2_db_y;
  real_T c2_t_x;
  real_T c2_eb_y;
  real_T c2_fb_y;
  real_T c2_k_A;
  real_T c2_u_x;
  real_T c2_v_x;
  real_T c2_gb_y;
  real_T c2_p_a;
  real_T c2_i_b;
  real_T c2_hb_y;
  real_T c2_l_A;
  real_T c2_h_B;
  real_T c2_w_x;
  real_T c2_ib_y;
  real_T c2_x_x;
  real_T c2_jb_y;
  real_T c2_kb_y;
  real_T c2_m_A;
  real_T c2_y_x;
  real_T c2_ab_x;
  real_T c2_lb_y;
  real_T c2_n_A;
  real_T c2_bb_x;
  real_T c2_cb_x;
  real_T *c2_b_qmff;
  real_T *c2_b_h2;
  real_T *c2_b_Tm;
  real_T *c2_b_P;
  real_T *c2_b_v1;
  real_T *c2_b_h1;
  real_T *c2_b_BP;
  real_T *c2_b_HP;
  real_T *c2_b_N;
  c2_b_qmff = (real_T *)ssGetOutputPortSignal(chartInstance->S, 4);
  c2_b_h2 = (real_T *)ssGetOutputPortSignal(chartInstance->S, 3);
  c2_b_Tm = (real_T *)ssGetOutputPortSignal(chartInstance->S, 2);
  c2_b_v1 = (real_T *)ssGetInputPortSignal(chartInstance->S, 4);
  c2_b_h1 = (real_T *)ssGetInputPortSignal(chartInstance->S, 3);
  c2_b_BP = (real_T *)ssGetInputPortSignal(chartInstance->S, 2);
  c2_b_HP = (real_T *)ssGetInputPortSignal(chartInstance->S, 1);
  c2_b_P = (real_T *)ssGetOutputPortSignal(chartInstance->S, 1);
  c2_b_N = (real_T *)ssGetInputPortSignal(chartInstance->S, 0);
  _SFD_CC_CALL(CHART_ENTER_DURING_FUNCTION_TAG, 0U, chartInstance->c2_sfEvent);
  c2_hoistedGlobal = *c2_b_N;
  c2_b_hoistedGlobal = *c2_b_HP;
  c2_c_hoistedGlobal = *c2_b_BP;
  c2_d_hoistedGlobal = *c2_b_h1;
  c2_e_hoistedGlobal = *c2_b_v1;
  c2_N = c2_hoistedGlobal;
  c2_HP = c2_b_hoistedGlobal;
  c2_BP = c2_c_hoistedGlobal;
  c2_h1 = c2_d_hoistedGlobal;
  c2_v1 = c2_e_hoistedGlobal;
  sf_debug_symbol_scope_push_eml(0U, 25U, 25U, c2_debug_family_names,
    c2_debug_family_var_map);
  sf_debug_symbol_scope_add_eml(&c2_d1, 0U, c2_sf_marshallOut);
  sf_debug_symbol_scope_add_eml(&c2_d2, 1U, c2_sf_marshallOut);
  sf_debug_symbol_scope_add_eml(&c2_d3, 2U, c2_sf_marshallOut);
  sf_debug_symbol_scope_add_eml(&c2_d4, 3U, c2_sf_marshallOut);
  sf_debug_symbol_scope_add_eml(&c2_d5, 4U, c2_sf_marshallOut);
  sf_debug_symbol_scope_add_eml(&c2_T, 5U, c2_sf_marshallOut);
  sf_debug_symbol_scope_add_eml(&c2_cp, 6U, c2_sf_marshallOut);
  sf_debug_symbol_scope_add_eml(&c2_R, 7U, c2_sf_marshallOut);
  sf_debug_symbol_scope_add_eml(&c2_gam, 8U, c2_sf_marshallOut);
  sf_debug_symbol_scope_add_eml(&c2_vpmb, 9U, c2_sf_marshallOut);
  sf_debug_symbol_scope_add_eml(&c2_vpmh, 10U, c2_sf_marshallOut);
  sf_debug_symbol_scope_add_eml_importable(&c2_Wtot, 11U, c2_sf_marshallOut,
    c2_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c2_neff, 12U, c2_sf_marshallOut,
    c2_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c2_nv, 13U, c2_sf_marshallOut,
    c2_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c2_nargin, 14U, c2_sf_marshallOut,
    c2_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c2_nargout, 15U, c2_sf_marshallOut,
    c2_sf_marshallIn);
  sf_debug_symbol_scope_add_eml(&c2_N, 16U, c2_sf_marshallOut);
  sf_debug_symbol_scope_add_eml(&c2_HP, 17U, c2_sf_marshallOut);
  sf_debug_symbol_scope_add_eml(&c2_BP, 18U, c2_sf_marshallOut);
  sf_debug_symbol_scope_add_eml(&c2_h1, 19U, c2_sf_marshallOut);
  sf_debug_symbol_scope_add_eml(&c2_v1, 20U, c2_sf_marshallOut);
  sf_debug_symbol_scope_add_eml_importable(&c2_P, 21U, c2_sf_marshallOut,
    c2_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c2_Tm, 22U, c2_sf_marshallOut,
    c2_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c2_h2, 23U, c2_sf_marshallOut,
    c2_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c2_qmff, 24U, c2_sf_marshallOut,
    c2_sf_marshallIn);
  CV_EML_FCN(0, 0);
  _SFD_EML_CALL(0U, chartInstance->c2_sfEvent, 4);
  c2_d1 = 0.249202;
  _SFD_EML_CALL(0U, chartInstance->c2_sfEvent, 5);
  c2_d2 = 0.00245251;
  _SFD_EML_CALL(0U, chartInstance->c2_sfEvent, 6);
  c2_d3 = -1.6565E-6;
  _SFD_EML_CALL(0U, chartInstance->c2_sfEvent, 7);
  c2_d4 = 8.91048E-10;
  _SFD_EML_CALL(0U, chartInstance->c2_sfEvent, 8);
  c2_d5 = -6.96764;
  _SFD_EML_CALL(0U, chartInstance->c2_sfEvent, 10);
  c2_T = 306.0;
  _SFD_EML_CALL(0U, chartInstance->c2_sfEvent, 11);
  c2_cp = 0.8473228168220911;
  _SFD_EML_CALL(0U, chartInstance->c2_sfEvent, 13);
  c2_R = 0.0814892;
  _SFD_EML_CALL(0U, chartInstance->c2_sfEvent, 14);
  c2_gam = 1.1064058800893963;
  _SFD_EML_CALL(0U, chartInstance->c2_sfEvent, 16);
  c2_vpmb = 1.76625E-5;
  _SFD_EML_CALL(0U, chartInstance->c2_sfEvent, 17);
  c2_vpmh = 2.1195E-6;
  _SFD_EML_CALL(0U, chartInstance->c2_sfEvent, 19);
  c2_a = c2_HP;
  c2_HP = c2_a * 100000.0;
  _SFD_EML_CALL(0U, chartInstance->c2_sfEvent, 20);
  c2_b_a = c2_BP;
  c2_BP = c2_b_a * 100000.0;
  _SFD_EML_CALL(0U, chartInstance->c2_sfEvent, 22);
  c2_A = c2_HP;
  c2_B = c2_BP;
  c2_x = c2_A;
  c2_y = c2_B;
  c2_b_x = c2_x;
  c2_b_y = c2_y;
  c2_c_y = c2_b_x / c2_b_y;
  c2_c_a = c2_c_y;
  c2_d_a = c2_c_a;
  c2_e_a = c2_d_a;
  c2_eml_scalar_eg(chartInstance);
  c2_ak = c2_e_a;
  if (c2_ak < 0.0) {
    c2_eml_error(chartInstance);
  }

  c2_c = muDoubleScalarPower(c2_ak, -0.90382744524025949);
  c2_f_a = c2_HP;
  c2_b = c2_c;
  c2_d_y = c2_f_a * c2_b;
  c2_b_b = c2_d_y - c2_BP;
  c2_e_y = 0.000183654266480959 * c2_b_b;
  c2_c_b = c2_HP - c2_BP;
  c2_f_y = 2.1195E-6 * c2_c_b;
  c2_Wtot = c2_e_y - c2_f_y;
  _SFD_EML_CALL(0U, chartInstance->c2_sfEvent, 24);
  c2_g_a = c2_Wtot;
  c2_d_b = c2_N;
  c2_g_y = c2_g_a * c2_d_b;
  c2_b_A = c2_g_y;
  c2_c_x = c2_b_A;
  c2_d_x = c2_c_x;
  c2_h_y = c2_d_x / 60.0;
  c2_c_A = c2_h_y;
  c2_e_x = c2_c_A;
  c2_f_x = c2_e_x;
  c2_P = c2_f_x / 1000.0;
  _SFD_EML_CALL(0U, chartInstance->c2_sfEvent, 26);
  c2_d_A = c2_HP;
  c2_b_B = c2_BP;
  c2_g_x = c2_d_A;
  c2_i_y = c2_b_B;
  c2_h_x = c2_g_x;
  c2_j_y = c2_i_y;
  c2_k_y = c2_h_x / c2_j_y;
  c2_h_a = c2_k_y - 5.0;
  c2_i_a = c2_h_a;
  c2_j_a = c2_i_a;
  c2_eml_scalar_eg(chartInstance);
  c2_b_ak = c2_j_a;
  c2_b_c = muDoubleScalarPower(c2_b_ak, 2.0);
  c2_e_b = c2_b_c;
  c2_l_y = 0.004 * c2_e_b;
  c2_e_A = c2_HP;
  c2_c_B = c2_BP;
  c2_i_x = c2_e_A;
  c2_m_y = c2_c_B;
  c2_j_x = c2_i_x;
  c2_n_y = c2_m_y;
  c2_o_y = c2_j_x / c2_n_y;
  c2_d_B = c2_o_y - 0.3;
  c2_p_y = c2_d_B;
  c2_q_y = c2_p_y;
  c2_r_y = 0.5 / c2_q_y;
  c2_neff = (0.8 - c2_l_y) - c2_r_y;
  _SFD_EML_CALL(0U, chartInstance->c2_sfEvent, 27);
  c2_f_A = c2_HP;
  c2_e_B = c2_BP;
  c2_k_x = c2_f_A;
  c2_s_y = c2_e_B;
  c2_l_x = c2_k_x;
  c2_t_y = c2_s_y;
  c2_u_y = c2_l_x / c2_t_y;
  c2_k_a = c2_u_y;
  c2_l_a = c2_k_a;
  c2_m_a = c2_l_a;
  c2_eml_scalar_eg(chartInstance);
  c2_c_ak = c2_m_a;
  if (c2_c_ak < 0.0) {
    c2_eml_error(chartInstance);
  }

  c2_c_c = muDoubleScalarPower(c2_c_ak, 0.72);
  c2_f_b = 1.0 - c2_c_c;
  c2_v_y = 0.13636363636363638 * c2_f_b;
  c2_g_b = 1.0 + c2_v_y;
  c2_nv = 0.9 * c2_g_b;
  _SFD_EML_CALL(0U, chartInstance->c2_sfEvent, 29);
  c2_n_a = c2_nv;
  c2_w_y = c2_n_a * 1.5543E-5;
  c2_g_A = c2_w_y;
  c2_f_B = c2_v1;
  c2_m_x = c2_g_A;
  c2_x_y = c2_f_B;
  c2_n_x = c2_m_x;
  c2_y_y = c2_x_y;
  c2_ab_y = c2_n_x / c2_y_y;
  c2_o_a = c2_ab_y;
  c2_h_b = c2_N;
  c2_bb_y = c2_o_a * c2_h_b;
  c2_h_A = c2_bb_y;
  c2_o_x = c2_h_A;
  c2_p_x = c2_o_x;
  c2_qmff = c2_p_x / 60.0;
  _SFD_EML_CALL(0U, chartInstance->c2_sfEvent, 31);
  c2_i_A = c2_Wtot;
  c2_q_x = c2_i_A;
  c2_r_x = c2_q_x;
  c2_cb_y = c2_r_x / 1000.0;
  c2_j_A = c2_cb_y;
  c2_g_B = c2_nv;
  c2_s_x = c2_j_A;
  c2_db_y = c2_g_B;
  c2_t_x = c2_s_x;
  c2_eb_y = c2_db_y;
  c2_fb_y = c2_t_x / c2_eb_y;
  c2_k_A = c2_fb_y;
  c2_u_x = c2_k_A;
  c2_v_x = c2_u_x;
  c2_gb_y = c2_v_x / 1.5543E-5;
  c2_p_a = c2_gb_y;
  c2_i_b = c2_v1;
  c2_hb_y = c2_p_a * c2_i_b;
  c2_h2 = c2_h1 + c2_hb_y;
  _SFD_EML_CALL(0U, chartInstance->c2_sfEvent, 34);
  c2_l_A = c2_Wtot;
  c2_h_B = c2_neff;
  c2_w_x = c2_l_A;
  c2_ib_y = c2_h_B;
  c2_x_x = c2_w_x;
  c2_jb_y = c2_ib_y;
  c2_kb_y = c2_x_x / c2_jb_y;
  c2_m_A = c2_kb_y;
  c2_y_x = c2_m_A;
  c2_ab_x = c2_y_x;
  c2_lb_y = c2_ab_x / 2.0;
  c2_n_A = c2_lb_y;
  c2_bb_x = c2_n_A;
  c2_cb_x = c2_bb_x;
  c2_Tm = c2_cb_x / 3.14;
  _SFD_EML_CALL(0U, chartInstance->c2_sfEvent, -34);
  sf_debug_symbol_scope_pop();
  *c2_b_P = c2_P;
  *c2_b_Tm = c2_Tm;
  *c2_b_h2 = c2_h2;
  *c2_b_qmff = c2_qmff;
  _SFD_CC_CALL(EXIT_OUT_OF_FUNCTION_TAG, 0U, chartInstance->c2_sfEvent);
}

static void initSimStructsc2_Compresseur(SFc2_CompresseurInstanceStruct
  *chartInstance)
{
}

static void init_script_number_translation(uint32_T c2_machineNumber, uint32_T
  c2_chartNumber)
{
}

static const mxArray *c2_sf_marshallOut(void *chartInstanceVoid, void *c2_inData)
{
  const mxArray *c2_mxArrayOutData = NULL;
  real_T c2_u;
  const mxArray *c2_y = NULL;
  SFc2_CompresseurInstanceStruct *chartInstance;
  chartInstance = (SFc2_CompresseurInstanceStruct *)chartInstanceVoid;
  c2_mxArrayOutData = NULL;
  c2_u = *(real_T *)c2_inData;
  c2_y = NULL;
  sf_mex_assign(&c2_y, sf_mex_create("y", &c2_u, 0, 0U, 0U, 0U, 0), FALSE);
  sf_mex_assign(&c2_mxArrayOutData, c2_y, FALSE);
  return c2_mxArrayOutData;
}

static real_T c2_emlrt_marshallIn(SFc2_CompresseurInstanceStruct *chartInstance,
  const mxArray *c2_qmff, const char_T *c2_identifier)
{
  real_T c2_y;
  emlrtMsgIdentifier c2_thisId;
  c2_thisId.fIdentifier = c2_identifier;
  c2_thisId.fParent = NULL;
  c2_y = c2_b_emlrt_marshallIn(chartInstance, sf_mex_dup(c2_qmff), &c2_thisId);
  sf_mex_destroy(&c2_qmff);
  return c2_y;
}

static real_T c2_b_emlrt_marshallIn(SFc2_CompresseurInstanceStruct
  *chartInstance, const mxArray *c2_u, const emlrtMsgIdentifier *c2_parentId)
{
  real_T c2_y;
  real_T c2_d0;
  sf_mex_import(c2_parentId, sf_mex_dup(c2_u), &c2_d0, 1, 0, 0U, 0, 0U, 0);
  c2_y = c2_d0;
  sf_mex_destroy(&c2_u);
  return c2_y;
}

static void c2_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c2_mxArrayInData, const char_T *c2_varName, void *c2_outData)
{
  const mxArray *c2_qmff;
  const char_T *c2_identifier;
  emlrtMsgIdentifier c2_thisId;
  real_T c2_y;
  SFc2_CompresseurInstanceStruct *chartInstance;
  chartInstance = (SFc2_CompresseurInstanceStruct *)chartInstanceVoid;
  c2_qmff = sf_mex_dup(c2_mxArrayInData);
  c2_identifier = c2_varName;
  c2_thisId.fIdentifier = c2_identifier;
  c2_thisId.fParent = NULL;
  c2_y = c2_b_emlrt_marshallIn(chartInstance, sf_mex_dup(c2_qmff), &c2_thisId);
  sf_mex_destroy(&c2_qmff);
  *(real_T *)c2_outData = c2_y;
  sf_mex_destroy(&c2_mxArrayInData);
}

const mxArray *sf_c2_Compresseur_get_eml_resolved_functions_info(void)
{
  const mxArray *c2_nameCaptureInfo;
  c2_ResolvedFunctionInfo c2_info[11];
  c2_ResolvedFunctionInfo (*c2_b_info)[11];
  const mxArray *c2_m0 = NULL;
  int32_T c2_i0;
  c2_ResolvedFunctionInfo *c2_r0;
  c2_nameCaptureInfo = NULL;
  c2_nameCaptureInfo = NULL;
  c2_b_info = (c2_ResolvedFunctionInfo (*)[11])c2_info;
  (*c2_b_info)[0].context = "";
  (*c2_b_info)[0].name = "mrdivide";
  (*c2_b_info)[0].dominantType = "double";
  (*c2_b_info)[0].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mrdivide.p";
  (*c2_b_info)[0].fileTimeLo = 1342810944U;
  (*c2_b_info)[0].fileTimeHi = 0U;
  (*c2_b_info)[0].mFileTimeLo = 1319729966U;
  (*c2_b_info)[0].mFileTimeHi = 0U;
  (*c2_b_info)[1].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mrdivide.p";
  (*c2_b_info)[1].name = "rdivide";
  (*c2_b_info)[1].dominantType = "double";
  (*c2_b_info)[1].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/rdivide.m";
  (*c2_b_info)[1].fileTimeLo = 1286818844U;
  (*c2_b_info)[1].fileTimeHi = 0U;
  (*c2_b_info)[1].mFileTimeLo = 0U;
  (*c2_b_info)[1].mFileTimeHi = 0U;
  (*c2_b_info)[2].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/rdivide.m";
  (*c2_b_info)[2].name = "eml_div";
  (*c2_b_info)[2].dominantType = "double";
  (*c2_b_info)[2].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_div.m";
  (*c2_b_info)[2].fileTimeLo = 1313347810U;
  (*c2_b_info)[2].fileTimeHi = 0U;
  (*c2_b_info)[2].mFileTimeLo = 0U;
  (*c2_b_info)[2].mFileTimeHi = 0U;
  (*c2_b_info)[3].context = "";
  (*c2_b_info)[3].name = "mtimes";
  (*c2_b_info)[3].dominantType = "double";
  (*c2_b_info)[3].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mtimes.m";
  (*c2_b_info)[3].fileTimeLo = 1289519692U;
  (*c2_b_info)[3].fileTimeHi = 0U;
  (*c2_b_info)[3].mFileTimeLo = 0U;
  (*c2_b_info)[3].mFileTimeHi = 0U;
  (*c2_b_info)[4].context = "";
  (*c2_b_info)[4].name = "mpower";
  (*c2_b_info)[4].dominantType = "double";
  (*c2_b_info)[4].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mpower.m";
  (*c2_b_info)[4].fileTimeLo = 1286818842U;
  (*c2_b_info)[4].fileTimeHi = 0U;
  (*c2_b_info)[4].mFileTimeLo = 0U;
  (*c2_b_info)[4].mFileTimeHi = 0U;
  (*c2_b_info)[5].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mpower.m";
  (*c2_b_info)[5].name = "power";
  (*c2_b_info)[5].dominantType = "double";
  (*c2_b_info)[5].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/power.m";
  (*c2_b_info)[5].fileTimeLo = 1336522096U;
  (*c2_b_info)[5].fileTimeHi = 0U;
  (*c2_b_info)[5].mFileTimeLo = 0U;
  (*c2_b_info)[5].mFileTimeHi = 0U;
  (*c2_b_info)[6].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/power.m!fltpower";
  (*c2_b_info)[6].name = "eml_scalar_eg";
  (*c2_b_info)[6].dominantType = "double";
  (*c2_b_info)[6].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_scalar_eg.m";
  (*c2_b_info)[6].fileTimeLo = 1286818796U;
  (*c2_b_info)[6].fileTimeHi = 0U;
  (*c2_b_info)[6].mFileTimeLo = 0U;
  (*c2_b_info)[6].mFileTimeHi = 0U;
  (*c2_b_info)[7].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/power.m!fltpower";
  (*c2_b_info)[7].name = "eml_scalexp_alloc";
  (*c2_b_info)[7].dominantType = "double";
  (*c2_b_info)[7].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_scalexp_alloc.m";
  (*c2_b_info)[7].fileTimeLo = 1330608434U;
  (*c2_b_info)[7].fileTimeHi = 0U;
  (*c2_b_info)[7].mFileTimeLo = 0U;
  (*c2_b_info)[7].mFileTimeHi = 0U;
  (*c2_b_info)[8].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/power.m!fltpower";
  (*c2_b_info)[8].name = "floor";
  (*c2_b_info)[8].dominantType = "double";
  (*c2_b_info)[8].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/floor.m";
  (*c2_b_info)[8].fileTimeLo = 1286818742U;
  (*c2_b_info)[8].fileTimeHi = 0U;
  (*c2_b_info)[8].mFileTimeLo = 0U;
  (*c2_b_info)[8].mFileTimeHi = 0U;
  (*c2_b_info)[9].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/floor.m";
  (*c2_b_info)[9].name = "eml_scalar_floor";
  (*c2_b_info)[9].dominantType = "double";
  (*c2_b_info)[9].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/eml_scalar_floor.m";
  (*c2_b_info)[9].fileTimeLo = 1286818726U;
  (*c2_b_info)[9].fileTimeHi = 0U;
  (*c2_b_info)[9].mFileTimeLo = 0U;
  (*c2_b_info)[9].mFileTimeHi = 0U;
  (*c2_b_info)[10].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/power.m!fltpower";
  (*c2_b_info)[10].name = "eml_error";
  (*c2_b_info)[10].dominantType = "char";
  (*c2_b_info)[10].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_error.m";
  (*c2_b_info)[10].fileTimeLo = 1305318000U;
  (*c2_b_info)[10].fileTimeHi = 0U;
  (*c2_b_info)[10].mFileTimeLo = 0U;
  (*c2_b_info)[10].mFileTimeHi = 0U;
  sf_mex_assign(&c2_m0, sf_mex_createstruct("nameCaptureInfo", 1, 11), FALSE);
  for (c2_i0 = 0; c2_i0 < 11; c2_i0++) {
    c2_r0 = &c2_info[c2_i0];
    sf_mex_addfield(c2_m0, sf_mex_create("nameCaptureInfo", c2_r0->context, 15,
      0U, 0U, 0U, 2, 1, strlen(c2_r0->context)), "context", "nameCaptureInfo",
                    c2_i0);
    sf_mex_addfield(c2_m0, sf_mex_create("nameCaptureInfo", c2_r0->name, 15, 0U,
      0U, 0U, 2, 1, strlen(c2_r0->name)), "name", "nameCaptureInfo", c2_i0);
    sf_mex_addfield(c2_m0, sf_mex_create("nameCaptureInfo", c2_r0->dominantType,
      15, 0U, 0U, 0U, 2, 1, strlen(c2_r0->dominantType)), "dominantType",
                    "nameCaptureInfo", c2_i0);
    sf_mex_addfield(c2_m0, sf_mex_create("nameCaptureInfo", c2_r0->resolved, 15,
      0U, 0U, 0U, 2, 1, strlen(c2_r0->resolved)), "resolved", "nameCaptureInfo",
                    c2_i0);
    sf_mex_addfield(c2_m0, sf_mex_create("nameCaptureInfo", &c2_r0->fileTimeLo,
      7, 0U, 0U, 0U, 0), "fileTimeLo", "nameCaptureInfo", c2_i0);
    sf_mex_addfield(c2_m0, sf_mex_create("nameCaptureInfo", &c2_r0->fileTimeHi,
      7, 0U, 0U, 0U, 0), "fileTimeHi", "nameCaptureInfo", c2_i0);
    sf_mex_addfield(c2_m0, sf_mex_create("nameCaptureInfo", &c2_r0->mFileTimeLo,
      7, 0U, 0U, 0U, 0), "mFileTimeLo", "nameCaptureInfo", c2_i0);
    sf_mex_addfield(c2_m0, sf_mex_create("nameCaptureInfo", &c2_r0->mFileTimeHi,
      7, 0U, 0U, 0U, 0), "mFileTimeHi", "nameCaptureInfo", c2_i0);
  }

  sf_mex_assign(&c2_nameCaptureInfo, c2_m0, FALSE);
  sf_mex_emlrtNameCapturePostProcessR2012a(&c2_nameCaptureInfo);
  return c2_nameCaptureInfo;
}

static void c2_eml_scalar_eg(SFc2_CompresseurInstanceStruct *chartInstance)
{
}

static void c2_eml_error(SFc2_CompresseurInstanceStruct *chartInstance)
{
  int32_T c2_i1;
  static char_T c2_varargin_1[31] = { 'C', 'o', 'd', 'e', 'r', ':', 't', 'o',
    'o', 'l', 'b', 'o', 'x', ':', 'p', 'o', 'w', 'e', 'r', '_', 'd', 'o', 'm',
    'a', 'i', 'n', 'E', 'r', 'r', 'o', 'r' };

  char_T c2_u[31];
  const mxArray *c2_y = NULL;
  for (c2_i1 = 0; c2_i1 < 31; c2_i1++) {
    c2_u[c2_i1] = c2_varargin_1[c2_i1];
  }

  c2_y = NULL;
  sf_mex_assign(&c2_y, sf_mex_create("y", c2_u, 10, 0U, 1U, 0U, 2, 1, 31), FALSE);
  sf_mex_call_debug("error", 0U, 1U, 14, sf_mex_call_debug("message", 1U, 1U, 14,
    c2_y));
}

static const mxArray *c2_b_sf_marshallOut(void *chartInstanceVoid, void
  *c2_inData)
{
  const mxArray *c2_mxArrayOutData = NULL;
  int32_T c2_u;
  const mxArray *c2_y = NULL;
  SFc2_CompresseurInstanceStruct *chartInstance;
  chartInstance = (SFc2_CompresseurInstanceStruct *)chartInstanceVoid;
  c2_mxArrayOutData = NULL;
  c2_u = *(int32_T *)c2_inData;
  c2_y = NULL;
  sf_mex_assign(&c2_y, sf_mex_create("y", &c2_u, 6, 0U, 0U, 0U, 0), FALSE);
  sf_mex_assign(&c2_mxArrayOutData, c2_y, FALSE);
  return c2_mxArrayOutData;
}

static int32_T c2_c_emlrt_marshallIn(SFc2_CompresseurInstanceStruct
  *chartInstance, const mxArray *c2_u, const emlrtMsgIdentifier *c2_parentId)
{
  int32_T c2_y;
  int32_T c2_i2;
  sf_mex_import(c2_parentId, sf_mex_dup(c2_u), &c2_i2, 1, 6, 0U, 0, 0U, 0);
  c2_y = c2_i2;
  sf_mex_destroy(&c2_u);
  return c2_y;
}

static void c2_b_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c2_mxArrayInData, const char_T *c2_varName, void *c2_outData)
{
  const mxArray *c2_b_sfEvent;
  const char_T *c2_identifier;
  emlrtMsgIdentifier c2_thisId;
  int32_T c2_y;
  SFc2_CompresseurInstanceStruct *chartInstance;
  chartInstance = (SFc2_CompresseurInstanceStruct *)chartInstanceVoid;
  c2_b_sfEvent = sf_mex_dup(c2_mxArrayInData);
  c2_identifier = c2_varName;
  c2_thisId.fIdentifier = c2_identifier;
  c2_thisId.fParent = NULL;
  c2_y = c2_c_emlrt_marshallIn(chartInstance, sf_mex_dup(c2_b_sfEvent),
    &c2_thisId);
  sf_mex_destroy(&c2_b_sfEvent);
  *(int32_T *)c2_outData = c2_y;
  sf_mex_destroy(&c2_mxArrayInData);
}

static uint8_T c2_d_emlrt_marshallIn(SFc2_CompresseurInstanceStruct
  *chartInstance, const mxArray *c2_b_is_active_c2_Compresseur, const char_T
  *c2_identifier)
{
  uint8_T c2_y;
  emlrtMsgIdentifier c2_thisId;
  c2_thisId.fIdentifier = c2_identifier;
  c2_thisId.fParent = NULL;
  c2_y = c2_e_emlrt_marshallIn(chartInstance, sf_mex_dup
    (c2_b_is_active_c2_Compresseur), &c2_thisId);
  sf_mex_destroy(&c2_b_is_active_c2_Compresseur);
  return c2_y;
}

static uint8_T c2_e_emlrt_marshallIn(SFc2_CompresseurInstanceStruct
  *chartInstance, const mxArray *c2_u, const emlrtMsgIdentifier *c2_parentId)
{
  uint8_T c2_y;
  uint8_T c2_u0;
  sf_mex_import(c2_parentId, sf_mex_dup(c2_u), &c2_u0, 1, 3, 0U, 0, 0U, 0);
  c2_y = c2_u0;
  sf_mex_destroy(&c2_u);
  return c2_y;
}

static void init_dsm_address_info(SFc2_CompresseurInstanceStruct *chartInstance)
{
}

/* SFunction Glue Code */
void sf_c2_Compresseur_get_check_sum(mxArray *plhs[])
{
  ((real_T *)mxGetPr((plhs[0])))[0] = (real_T)(1111138847U);
  ((real_T *)mxGetPr((plhs[0])))[1] = (real_T)(1465013446U);
  ((real_T *)mxGetPr((plhs[0])))[2] = (real_T)(2238471936U);
  ((real_T *)mxGetPr((plhs[0])))[3] = (real_T)(1319926120U);
}

mxArray *sf_c2_Compresseur_get_autoinheritance_info(void)
{
  const char *autoinheritanceFields[] = { "checksum", "inputs", "parameters",
    "outputs", "locals" };

  mxArray *mxAutoinheritanceInfo = mxCreateStructMatrix(1,1,5,
    autoinheritanceFields);

  {
    mxArray *mxChecksum = mxCreateString("ldZMW6oDcNd2nXBDjiTyAF");
    mxSetField(mxAutoinheritanceInfo,0,"checksum",mxChecksum);
  }

  {
    const char *dataFields[] = { "size", "type", "complexity" };

    mxArray *mxData = mxCreateStructMatrix(1,5,3,dataFields);

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,0,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }

    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,1,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,1,"type",mxType);
    }

    mxSetField(mxData,1,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,2,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,2,"type",mxType);
    }

    mxSetField(mxData,2,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,3,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,3,"type",mxType);
    }

    mxSetField(mxData,3,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,4,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,4,"type",mxType);
    }

    mxSetField(mxData,4,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"inputs",mxData);
  }

  {
    mxSetField(mxAutoinheritanceInfo,0,"parameters",mxCreateDoubleMatrix(0,0,
                mxREAL));
  }

  {
    const char *dataFields[] = { "size", "type", "complexity" };

    mxArray *mxData = mxCreateStructMatrix(1,4,3,dataFields);

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,0,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }

    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,1,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,1,"type",mxType);
    }

    mxSetField(mxData,1,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,2,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,2,"type",mxType);
    }

    mxSetField(mxData,2,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,3,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,3,"type",mxType);
    }

    mxSetField(mxData,3,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"outputs",mxData);
  }

  {
    mxSetField(mxAutoinheritanceInfo,0,"locals",mxCreateDoubleMatrix(0,0,mxREAL));
  }

  return(mxAutoinheritanceInfo);
}

static const mxArray *sf_get_sim_state_info_c2_Compresseur(void)
{
  const char *infoFields[] = { "chartChecksum", "varInfo" };

  mxArray *mxInfo = mxCreateStructMatrix(1, 1, 2, infoFields);
  const char *infoEncStr[] = {
    "100 S1x5'type','srcId','name','auxInfo'{{M[1],M[5],T\"P\",},{M[1],M[11],T\"Tm\",},{M[1],M[12],T\"h2\",},{M[1],M[13],T\"qmff\",},{M[8],M[0],T\"is_active_c2_Compresseur\",}}"
  };

  mxArray *mxVarInfo = sf_mex_decode_encoded_mx_struct_array(infoEncStr, 5, 10);
  mxArray *mxChecksum = mxCreateDoubleMatrix(1, 4, mxREAL);
  sf_c2_Compresseur_get_check_sum(&mxChecksum);
  mxSetField(mxInfo, 0, infoFields[0], mxChecksum);
  mxSetField(mxInfo, 0, infoFields[1], mxVarInfo);
  return mxInfo;
}

static void chart_debug_initialization(SimStruct *S, unsigned int
  fullDebuggerInitialization)
{
  if (!sim_mode_is_rtw_gen(S)) {
    SFc2_CompresseurInstanceStruct *chartInstance;
    chartInstance = (SFc2_CompresseurInstanceStruct *) ((ChartInfoStruct *)
      (ssGetUserData(S)))->chartInstance;
    if (ssIsFirstInitCond(S) && fullDebuggerInitialization==1) {
      /* do this only if simulation is starting */
      {
        unsigned int chartAlreadyPresent;
        chartAlreadyPresent = sf_debug_initialize_chart
          (_CompresseurMachineNumber_,
           2,
           1,
           1,
           9,
           0,
           0,
           0,
           0,
           0,
           &(chartInstance->chartNumber),
           &(chartInstance->instanceNumber),
           ssGetPath(S),
           (void *)S);
        if (chartAlreadyPresent==0) {
          /* this is the first instance */
          init_script_number_translation(_CompresseurMachineNumber_,
            chartInstance->chartNumber);
          sf_debug_set_chart_disable_implicit_casting(_CompresseurMachineNumber_,
            chartInstance->chartNumber,1);
          sf_debug_set_chart_event_thresholds(_CompresseurMachineNumber_,
            chartInstance->chartNumber,
            0,
            0,
            0);
          _SFD_SET_DATA_PROPS(0,1,1,0,"N");
          _SFD_SET_DATA_PROPS(1,2,0,1,"P");
          _SFD_SET_DATA_PROPS(2,1,1,0,"HP");
          _SFD_SET_DATA_PROPS(3,1,1,0,"BP");
          _SFD_SET_DATA_PROPS(4,1,1,0,"h1");
          _SFD_SET_DATA_PROPS(5,1,1,0,"v1");
          _SFD_SET_DATA_PROPS(6,2,0,1,"Tm");
          _SFD_SET_DATA_PROPS(7,2,0,1,"h2");
          _SFD_SET_DATA_PROPS(8,2,0,1,"qmff");
          _SFD_STATE_INFO(0,0,2);
          _SFD_CH_SUBSTATE_COUNT(0);
          _SFD_CH_SUBSTATE_DECOMP(0);
        }

        _SFD_CV_INIT_CHART(0,0,0,0);

        {
          _SFD_CV_INIT_STATE(0,0,0,0,0,0,NULL,NULL);
        }

        _SFD_CV_INIT_TRANS(0,0,NULL,NULL,0,NULL);

        /* Initialization of MATLAB Function Model Coverage */
        _SFD_CV_INIT_EML(0,1,1,0,0,0,0,0,0,0,0);
        _SFD_CV_INIT_EML_FCN(0,0,"eML_blk_kernel",0,-1,794);
        _SFD_TRANS_COV_WTS(0,0,0,1,0);
        if (chartAlreadyPresent==0) {
          _SFD_TRANS_COV_MAPS(0,
                              0,NULL,NULL,
                              0,NULL,NULL,
                              1,NULL,NULL,
                              0,NULL,NULL);
        }

        _SFD_SET_DATA_COMPILED_PROPS(0,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c2_sf_marshallOut,(MexInFcnForType)NULL);
        _SFD_SET_DATA_COMPILED_PROPS(1,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c2_sf_marshallOut,(MexInFcnForType)c2_sf_marshallIn);
        _SFD_SET_DATA_COMPILED_PROPS(2,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c2_sf_marshallOut,(MexInFcnForType)NULL);
        _SFD_SET_DATA_COMPILED_PROPS(3,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c2_sf_marshallOut,(MexInFcnForType)NULL);
        _SFD_SET_DATA_COMPILED_PROPS(4,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c2_sf_marshallOut,(MexInFcnForType)NULL);
        _SFD_SET_DATA_COMPILED_PROPS(5,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c2_sf_marshallOut,(MexInFcnForType)NULL);
        _SFD_SET_DATA_COMPILED_PROPS(6,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c2_sf_marshallOut,(MexInFcnForType)c2_sf_marshallIn);
        _SFD_SET_DATA_COMPILED_PROPS(7,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c2_sf_marshallOut,(MexInFcnForType)c2_sf_marshallIn);
        _SFD_SET_DATA_COMPILED_PROPS(8,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c2_sf_marshallOut,(MexInFcnForType)c2_sf_marshallIn);

        {
          real_T *c2_N;
          real_T *c2_P;
          real_T *c2_HP;
          real_T *c2_BP;
          real_T *c2_h1;
          real_T *c2_v1;
          real_T *c2_Tm;
          real_T *c2_h2;
          real_T *c2_qmff;
          c2_qmff = (real_T *)ssGetOutputPortSignal(chartInstance->S, 4);
          c2_h2 = (real_T *)ssGetOutputPortSignal(chartInstance->S, 3);
          c2_Tm = (real_T *)ssGetOutputPortSignal(chartInstance->S, 2);
          c2_v1 = (real_T *)ssGetInputPortSignal(chartInstance->S, 4);
          c2_h1 = (real_T *)ssGetInputPortSignal(chartInstance->S, 3);
          c2_BP = (real_T *)ssGetInputPortSignal(chartInstance->S, 2);
          c2_HP = (real_T *)ssGetInputPortSignal(chartInstance->S, 1);
          c2_P = (real_T *)ssGetOutputPortSignal(chartInstance->S, 1);
          c2_N = (real_T *)ssGetInputPortSignal(chartInstance->S, 0);
          _SFD_SET_DATA_VALUE_PTR(0U, c2_N);
          _SFD_SET_DATA_VALUE_PTR(1U, c2_P);
          _SFD_SET_DATA_VALUE_PTR(2U, c2_HP);
          _SFD_SET_DATA_VALUE_PTR(3U, c2_BP);
          _SFD_SET_DATA_VALUE_PTR(4U, c2_h1);
          _SFD_SET_DATA_VALUE_PTR(5U, c2_v1);
          _SFD_SET_DATA_VALUE_PTR(6U, c2_Tm);
          _SFD_SET_DATA_VALUE_PTR(7U, c2_h2);
          _SFD_SET_DATA_VALUE_PTR(8U, c2_qmff);
        }
      }
    } else {
      sf_debug_reset_current_state_configuration(_CompresseurMachineNumber_,
        chartInstance->chartNumber,chartInstance->instanceNumber);
    }
  }
}

static const char* sf_get_instance_specialization()
{
  return "svxj0UETqvZHyBDm4Ykl5D";
}

static void sf_opaque_initialize_c2_Compresseur(void *chartInstanceVar)
{
  chart_debug_initialization(((SFc2_CompresseurInstanceStruct*) chartInstanceVar)
    ->S,0);
  initialize_params_c2_Compresseur((SFc2_CompresseurInstanceStruct*)
    chartInstanceVar);
  initialize_c2_Compresseur((SFc2_CompresseurInstanceStruct*) chartInstanceVar);
}

static void sf_opaque_enable_c2_Compresseur(void *chartInstanceVar)
{
  enable_c2_Compresseur((SFc2_CompresseurInstanceStruct*) chartInstanceVar);
}

static void sf_opaque_disable_c2_Compresseur(void *chartInstanceVar)
{
  disable_c2_Compresseur((SFc2_CompresseurInstanceStruct*) chartInstanceVar);
}

static void sf_opaque_gateway_c2_Compresseur(void *chartInstanceVar)
{
  sf_c2_Compresseur((SFc2_CompresseurInstanceStruct*) chartInstanceVar);
}

extern const mxArray* sf_internal_get_sim_state_c2_Compresseur(SimStruct* S)
{
  ChartInfoStruct *chartInfo = (ChartInfoStruct*) ssGetUserData(S);
  mxArray *plhs[1] = { NULL };

  mxArray *prhs[4];
  int mxError = 0;
  prhs[0] = mxCreateString("chart_simctx_raw2high");
  prhs[1] = mxCreateDoubleScalar(ssGetSFuncBlockHandle(S));
  prhs[2] = (mxArray*) get_sim_state_c2_Compresseur
    ((SFc2_CompresseurInstanceStruct*)chartInfo->chartInstance);/* raw sim ctx */
  prhs[3] = (mxArray*) sf_get_sim_state_info_c2_Compresseur();/* state var info */
  mxError = sf_mex_call_matlab(1, plhs, 4, prhs, "sfprivate");
  mxDestroyArray(prhs[0]);
  mxDestroyArray(prhs[1]);
  mxDestroyArray(prhs[2]);
  mxDestroyArray(prhs[3]);
  if (mxError || plhs[0] == NULL) {
    sf_mex_error_message("Stateflow Internal Error: \nError calling 'chart_simctx_raw2high'.\n");
  }

  return plhs[0];
}

extern void sf_internal_set_sim_state_c2_Compresseur(SimStruct* S, const mxArray
  *st)
{
  ChartInfoStruct *chartInfo = (ChartInfoStruct*) ssGetUserData(S);
  mxArray *plhs[1] = { NULL };

  mxArray *prhs[4];
  int mxError = 0;
  prhs[0] = mxCreateString("chart_simctx_high2raw");
  prhs[1] = mxCreateDoubleScalar(ssGetSFuncBlockHandle(S));
  prhs[2] = mxDuplicateArray(st);      /* high level simctx */
  prhs[3] = (mxArray*) sf_get_sim_state_info_c2_Compresseur();/* state var info */
  mxError = sf_mex_call_matlab(1, plhs, 4, prhs, "sfprivate");
  mxDestroyArray(prhs[0]);
  mxDestroyArray(prhs[1]);
  mxDestroyArray(prhs[2]);
  mxDestroyArray(prhs[3]);
  if (mxError || plhs[0] == NULL) {
    sf_mex_error_message("Stateflow Internal Error: \nError calling 'chart_simctx_high2raw'.\n");
  }

  set_sim_state_c2_Compresseur((SFc2_CompresseurInstanceStruct*)
    chartInfo->chartInstance, mxDuplicateArray(plhs[0]));
  mxDestroyArray(plhs[0]);
}

static const mxArray* sf_opaque_get_sim_state_c2_Compresseur(SimStruct* S)
{
  return sf_internal_get_sim_state_c2_Compresseur(S);
}

static void sf_opaque_set_sim_state_c2_Compresseur(SimStruct* S, const mxArray
  *st)
{
  sf_internal_set_sim_state_c2_Compresseur(S, st);
}

static void sf_opaque_terminate_c2_Compresseur(void *chartInstanceVar)
{
  if (chartInstanceVar!=NULL) {
    SimStruct *S = ((SFc2_CompresseurInstanceStruct*) chartInstanceVar)->S;
    if (sim_mode_is_rtw_gen(S) || sim_mode_is_external(S)) {
      sf_clear_rtw_identifier(S);
    }

    finalize_c2_Compresseur((SFc2_CompresseurInstanceStruct*) chartInstanceVar);
    free((void *)chartInstanceVar);
    ssSetUserData(S,NULL);
  }

  unload_Compresseur_optimization_info();
}

static void sf_opaque_init_subchart_simstructs(void *chartInstanceVar)
{
  initSimStructsc2_Compresseur((SFc2_CompresseurInstanceStruct*)
    chartInstanceVar);
}

extern unsigned int sf_machine_global_initializer_called(void);
static void mdlProcessParameters_c2_Compresseur(SimStruct *S)
{
  int i;
  for (i=0;i<ssGetNumRunTimeParams(S);i++) {
    if (ssGetSFcnParamTunable(S,i)) {
      ssUpdateDlgParamAsRunTimeParam(S,i);
    }
  }

  if (sf_machine_global_initializer_called()) {
    initialize_params_c2_Compresseur((SFc2_CompresseurInstanceStruct*)
      (((ChartInfoStruct *)ssGetUserData(S))->chartInstance));
  }
}

static void mdlSetWorkWidths_c2_Compresseur(SimStruct *S)
{
  if (sim_mode_is_rtw_gen(S) || sim_mode_is_external(S)) {
    mxArray *infoStruct = load_Compresseur_optimization_info();
    int_T chartIsInlinable =
      (int_T)sf_is_chart_inlinable(S,sf_get_instance_specialization(),infoStruct,
      2);
    ssSetStateflowIsInlinable(S,chartIsInlinable);
    ssSetRTWCG(S,sf_rtw_info_uint_prop(S,sf_get_instance_specialization(),
                infoStruct,2,"RTWCG"));
    ssSetEnableFcnIsTrivial(S,1);
    ssSetDisableFcnIsTrivial(S,1);
    ssSetNotMultipleInlinable(S,sf_rtw_info_uint_prop(S,
      sf_get_instance_specialization(),infoStruct,2,
      "gatewayCannotBeInlinedMultipleTimes"));
    if (chartIsInlinable) {
      ssSetInputPortOptimOpts(S, 0, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 1, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 2, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 3, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 4, SS_REUSABLE_AND_LOCAL);
      sf_mark_chart_expressionable_inputs(S,sf_get_instance_specialization(),
        infoStruct,2,5);
      sf_mark_chart_reusable_outputs(S,sf_get_instance_specialization(),
        infoStruct,2,4);
    }

    sf_set_rtw_dwork_info(S,sf_get_instance_specialization(),infoStruct,2);
    ssSetHasSubFunctions(S,!(chartIsInlinable));
  } else {
  }

  ssSetOptions(S,ssGetOptions(S)|SS_OPTION_WORKS_WITH_CODE_REUSE);
  ssSetChecksum0(S,(3681408329U));
  ssSetChecksum1(S,(3929197841U));
  ssSetChecksum2(S,(2260127306U));
  ssSetChecksum3(S,(2447015384U));
  ssSetmdlDerivatives(S, NULL);
  ssSetExplicitFCSSCtrl(S,1);
  ssSupportsMultipleExecInstances(S,1);
}

static void mdlRTW_c2_Compresseur(SimStruct *S)
{
  if (sim_mode_is_rtw_gen(S)) {
    ssWriteRTWStrParam(S, "StateflowChartType", "Embedded MATLAB");
  }
}

static void mdlStart_c2_Compresseur(SimStruct *S)
{
  SFc2_CompresseurInstanceStruct *chartInstance;
  chartInstance = (SFc2_CompresseurInstanceStruct *)malloc(sizeof
    (SFc2_CompresseurInstanceStruct));
  memset(chartInstance, 0, sizeof(SFc2_CompresseurInstanceStruct));
  if (chartInstance==NULL) {
    sf_mex_error_message("Could not allocate memory for chart instance.");
  }

  chartInstance->chartInfo.chartInstance = chartInstance;
  chartInstance->chartInfo.isEMLChart = 1;
  chartInstance->chartInfo.chartInitialized = 0;
  chartInstance->chartInfo.sFunctionGateway = sf_opaque_gateway_c2_Compresseur;
  chartInstance->chartInfo.initializeChart = sf_opaque_initialize_c2_Compresseur;
  chartInstance->chartInfo.terminateChart = sf_opaque_terminate_c2_Compresseur;
  chartInstance->chartInfo.enableChart = sf_opaque_enable_c2_Compresseur;
  chartInstance->chartInfo.disableChart = sf_opaque_disable_c2_Compresseur;
  chartInstance->chartInfo.getSimState = sf_opaque_get_sim_state_c2_Compresseur;
  chartInstance->chartInfo.setSimState = sf_opaque_set_sim_state_c2_Compresseur;
  chartInstance->chartInfo.getSimStateInfo =
    sf_get_sim_state_info_c2_Compresseur;
  chartInstance->chartInfo.zeroCrossings = NULL;
  chartInstance->chartInfo.outputs = NULL;
  chartInstance->chartInfo.derivatives = NULL;
  chartInstance->chartInfo.mdlRTW = mdlRTW_c2_Compresseur;
  chartInstance->chartInfo.mdlStart = mdlStart_c2_Compresseur;
  chartInstance->chartInfo.mdlSetWorkWidths = mdlSetWorkWidths_c2_Compresseur;
  chartInstance->chartInfo.extModeExec = NULL;
  chartInstance->chartInfo.restoreLastMajorStepConfiguration = NULL;
  chartInstance->chartInfo.restoreBeforeLastMajorStepConfiguration = NULL;
  chartInstance->chartInfo.storeCurrentConfiguration = NULL;
  chartInstance->S = S;
  ssSetUserData(S,(void *)(&(chartInstance->chartInfo)));/* register the chart instance with simstruct */
  init_dsm_address_info(chartInstance);
  if (!sim_mode_is_rtw_gen(S)) {
  }

  sf_opaque_init_subchart_simstructs(chartInstance->chartInfo.chartInstance);
  chart_debug_initialization(S,1);
}

void c2_Compresseur_method_dispatcher(SimStruct *S, int_T method, void *data)
{
  switch (method) {
   case SS_CALL_MDL_START:
    mdlStart_c2_Compresseur(S);
    break;

   case SS_CALL_MDL_SET_WORK_WIDTHS:
    mdlSetWorkWidths_c2_Compresseur(S);
    break;

   case SS_CALL_MDL_PROCESS_PARAMETERS:
    mdlProcessParameters_c2_Compresseur(S);
    break;

   default:
    /* Unhandled method */
    sf_mex_error_message("Stateflow Internal Error:\n"
                         "Error calling c2_Compresseur_method_dispatcher.\n"
                         "Can't handle method %d.\n", method);
    break;
  }
}
