/* Include files */

#include "blascompat32.h"
#include "PAC_sfun.h"
#include "c3_PAC.h"
#include "mwmathutil.h"
#define CHARTINSTANCE_CHARTNUMBER      (chartInstance->chartNumber)
#define CHARTINSTANCE_INSTANCENUMBER   (chartInstance->instanceNumber)
#include "PAC_sfun_debug_macros.h"

/* Type Definitions */

/* Named Constants */
#define CALL_EVENT                     (-1)

/* Variable Declarations */

/* Variable Definitions */
static const char * c3_debug_family_names[25] = { "d1", "d2", "d3", "d4", "d5",
  "T", "cp", "R", "gam", "vpmb", "vpmh", "Wtot", "neff", "nv", "nargin",
  "nargout", "N", "HP", "BP", "h1", "v1", "P", "Tm", "h2", "qmff" };

/* Function Declarations */
static void initialize_c3_PAC(SFc3_PACInstanceStruct *chartInstance);
static void initialize_params_c3_PAC(SFc3_PACInstanceStruct *chartInstance);
static void enable_c3_PAC(SFc3_PACInstanceStruct *chartInstance);
static void disable_c3_PAC(SFc3_PACInstanceStruct *chartInstance);
static void c3_update_debugger_state_c3_PAC(SFc3_PACInstanceStruct
  *chartInstance);
static const mxArray *get_sim_state_c3_PAC(SFc3_PACInstanceStruct *chartInstance);
static void set_sim_state_c3_PAC(SFc3_PACInstanceStruct *chartInstance, const
  mxArray *c3_st);
static void finalize_c3_PAC(SFc3_PACInstanceStruct *chartInstance);
static void sf_c3_PAC(SFc3_PACInstanceStruct *chartInstance);
static void c3_chartstep_c3_PAC(SFc3_PACInstanceStruct *chartInstance);
static void initSimStructsc3_PAC(SFc3_PACInstanceStruct *chartInstance);
static void init_script_number_translation(uint32_T c3_machineNumber, uint32_T
  c3_chartNumber);
static const mxArray *c3_sf_marshallOut(void *chartInstanceVoid, void *c3_inData);
static real_T c3_emlrt_marshallIn(SFc3_PACInstanceStruct *chartInstance, const
  mxArray *c3_qmff, const char_T *c3_identifier);
static real_T c3_b_emlrt_marshallIn(SFc3_PACInstanceStruct *chartInstance, const
  mxArray *c3_u, const emlrtMsgIdentifier *c3_parentId);
static void c3_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c3_mxArrayInData, const char_T *c3_varName, void *c3_outData);
static void c3_eml_scalar_eg(SFc3_PACInstanceStruct *chartInstance);
static void c3_eml_error(SFc3_PACInstanceStruct *chartInstance);
static const mxArray *c3_b_sf_marshallOut(void *chartInstanceVoid, void
  *c3_inData);
static int32_T c3_c_emlrt_marshallIn(SFc3_PACInstanceStruct *chartInstance,
  const mxArray *c3_u, const emlrtMsgIdentifier *c3_parentId);
static void c3_b_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c3_mxArrayInData, const char_T *c3_varName, void *c3_outData);
static uint8_T c3_d_emlrt_marshallIn(SFc3_PACInstanceStruct *chartInstance,
  const mxArray *c3_b_is_active_c3_PAC, const char_T *c3_identifier);
static uint8_T c3_e_emlrt_marshallIn(SFc3_PACInstanceStruct *chartInstance,
  const mxArray *c3_u, const emlrtMsgIdentifier *c3_parentId);
static void init_dsm_address_info(SFc3_PACInstanceStruct *chartInstance);

/* Function Definitions */
static void initialize_c3_PAC(SFc3_PACInstanceStruct *chartInstance)
{
  chartInstance->c3_sfEvent = CALL_EVENT;
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
  chartInstance->c3_is_active_c3_PAC = 0U;
}

static void initialize_params_c3_PAC(SFc3_PACInstanceStruct *chartInstance)
{
}

static void enable_c3_PAC(SFc3_PACInstanceStruct *chartInstance)
{
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
}

static void disable_c3_PAC(SFc3_PACInstanceStruct *chartInstance)
{
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
}

static void c3_update_debugger_state_c3_PAC(SFc3_PACInstanceStruct
  *chartInstance)
{
}

static const mxArray *get_sim_state_c3_PAC(SFc3_PACInstanceStruct *chartInstance)
{
  const mxArray *c3_st;
  const mxArray *c3_y = NULL;
  real_T c3_hoistedGlobal;
  real_T c3_u;
  const mxArray *c3_b_y = NULL;
  real_T c3_b_hoistedGlobal;
  real_T c3_b_u;
  const mxArray *c3_c_y = NULL;
  real_T c3_c_hoistedGlobal;
  real_T c3_c_u;
  const mxArray *c3_d_y = NULL;
  real_T c3_d_hoistedGlobal;
  real_T c3_d_u;
  const mxArray *c3_e_y = NULL;
  uint8_T c3_e_hoistedGlobal;
  uint8_T c3_e_u;
  const mxArray *c3_f_y = NULL;
  real_T *c3_P;
  real_T *c3_Tm;
  real_T *c3_h2;
  real_T *c3_qmff;
  c3_qmff = (real_T *)ssGetOutputPortSignal(chartInstance->S, 4);
  c3_h2 = (real_T *)ssGetOutputPortSignal(chartInstance->S, 3);
  c3_Tm = (real_T *)ssGetOutputPortSignal(chartInstance->S, 2);
  c3_P = (real_T *)ssGetOutputPortSignal(chartInstance->S, 1);
  c3_st = NULL;
  c3_st = NULL;
  c3_y = NULL;
  sf_mex_assign(&c3_y, sf_mex_createcellarray(5), FALSE);
  c3_hoistedGlobal = *c3_P;
  c3_u = c3_hoistedGlobal;
  c3_b_y = NULL;
  sf_mex_assign(&c3_b_y, sf_mex_create("y", &c3_u, 0, 0U, 0U, 0U, 0), FALSE);
  sf_mex_setcell(c3_y, 0, c3_b_y);
  c3_b_hoistedGlobal = *c3_Tm;
  c3_b_u = c3_b_hoistedGlobal;
  c3_c_y = NULL;
  sf_mex_assign(&c3_c_y, sf_mex_create("y", &c3_b_u, 0, 0U, 0U, 0U, 0), FALSE);
  sf_mex_setcell(c3_y, 1, c3_c_y);
  c3_c_hoistedGlobal = *c3_h2;
  c3_c_u = c3_c_hoistedGlobal;
  c3_d_y = NULL;
  sf_mex_assign(&c3_d_y, sf_mex_create("y", &c3_c_u, 0, 0U, 0U, 0U, 0), FALSE);
  sf_mex_setcell(c3_y, 2, c3_d_y);
  c3_d_hoistedGlobal = *c3_qmff;
  c3_d_u = c3_d_hoistedGlobal;
  c3_e_y = NULL;
  sf_mex_assign(&c3_e_y, sf_mex_create("y", &c3_d_u, 0, 0U, 0U, 0U, 0), FALSE);
  sf_mex_setcell(c3_y, 3, c3_e_y);
  c3_e_hoistedGlobal = chartInstance->c3_is_active_c3_PAC;
  c3_e_u = c3_e_hoistedGlobal;
  c3_f_y = NULL;
  sf_mex_assign(&c3_f_y, sf_mex_create("y", &c3_e_u, 3, 0U, 0U, 0U, 0), FALSE);
  sf_mex_setcell(c3_y, 4, c3_f_y);
  sf_mex_assign(&c3_st, c3_y, FALSE);
  return c3_st;
}

static void set_sim_state_c3_PAC(SFc3_PACInstanceStruct *chartInstance, const
  mxArray *c3_st)
{
  const mxArray *c3_u;
  real_T *c3_P;
  real_T *c3_Tm;
  real_T *c3_h2;
  real_T *c3_qmff;
  c3_qmff = (real_T *)ssGetOutputPortSignal(chartInstance->S, 4);
  c3_h2 = (real_T *)ssGetOutputPortSignal(chartInstance->S, 3);
  c3_Tm = (real_T *)ssGetOutputPortSignal(chartInstance->S, 2);
  c3_P = (real_T *)ssGetOutputPortSignal(chartInstance->S, 1);
  chartInstance->c3_doneDoubleBufferReInit = TRUE;
  c3_u = sf_mex_dup(c3_st);
  *c3_P = c3_emlrt_marshallIn(chartInstance, sf_mex_dup(sf_mex_getcell(c3_u, 0)),
    "P");
  *c3_Tm = c3_emlrt_marshallIn(chartInstance, sf_mex_dup(sf_mex_getcell(c3_u, 1)),
    "Tm");
  *c3_h2 = c3_emlrt_marshallIn(chartInstance, sf_mex_dup(sf_mex_getcell(c3_u, 2)),
    "h2");
  *c3_qmff = c3_emlrt_marshallIn(chartInstance, sf_mex_dup(sf_mex_getcell(c3_u,
    3)), "qmff");
  chartInstance->c3_is_active_c3_PAC = c3_d_emlrt_marshallIn(chartInstance,
    sf_mex_dup(sf_mex_getcell(c3_u, 4)), "is_active_c3_PAC");
  sf_mex_destroy(&c3_u);
  c3_update_debugger_state_c3_PAC(chartInstance);
  sf_mex_destroy(&c3_st);
}

static void finalize_c3_PAC(SFc3_PACInstanceStruct *chartInstance)
{
}

static void sf_c3_PAC(SFc3_PACInstanceStruct *chartInstance)
{
  real_T *c3_N;
  real_T *c3_P;
  real_T *c3_HP;
  real_T *c3_BP;
  real_T *c3_h1;
  real_T *c3_v1;
  real_T *c3_Tm;
  real_T *c3_h2;
  real_T *c3_qmff;
  c3_qmff = (real_T *)ssGetOutputPortSignal(chartInstance->S, 4);
  c3_h2 = (real_T *)ssGetOutputPortSignal(chartInstance->S, 3);
  c3_Tm = (real_T *)ssGetOutputPortSignal(chartInstance->S, 2);
  c3_v1 = (real_T *)ssGetInputPortSignal(chartInstance->S, 4);
  c3_h1 = (real_T *)ssGetInputPortSignal(chartInstance->S, 3);
  c3_BP = (real_T *)ssGetInputPortSignal(chartInstance->S, 2);
  c3_HP = (real_T *)ssGetInputPortSignal(chartInstance->S, 1);
  c3_P = (real_T *)ssGetOutputPortSignal(chartInstance->S, 1);
  c3_N = (real_T *)ssGetInputPortSignal(chartInstance->S, 0);
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
  _SFD_CC_CALL(CHART_ENTER_SFUNCTION_TAG, 2U, chartInstance->c3_sfEvent);
  _SFD_DATA_RANGE_CHECK(*c3_N, 0U);
  _SFD_DATA_RANGE_CHECK(*c3_P, 1U);
  _SFD_DATA_RANGE_CHECK(*c3_HP, 2U);
  _SFD_DATA_RANGE_CHECK(*c3_BP, 3U);
  _SFD_DATA_RANGE_CHECK(*c3_h1, 4U);
  _SFD_DATA_RANGE_CHECK(*c3_v1, 5U);
  _SFD_DATA_RANGE_CHECK(*c3_Tm, 6U);
  _SFD_DATA_RANGE_CHECK(*c3_h2, 7U);
  _SFD_DATA_RANGE_CHECK(*c3_qmff, 8U);
  chartInstance->c3_sfEvent = CALL_EVENT;
  c3_chartstep_c3_PAC(chartInstance);
  sf_debug_check_for_state_inconsistency(_PACMachineNumber_,
    chartInstance->chartNumber, chartInstance->instanceNumber);
}

static void c3_chartstep_c3_PAC(SFc3_PACInstanceStruct *chartInstance)
{
  real_T c3_hoistedGlobal;
  real_T c3_b_hoistedGlobal;
  real_T c3_c_hoistedGlobal;
  real_T c3_d_hoistedGlobal;
  real_T c3_e_hoistedGlobal;
  real_T c3_N;
  real_T c3_HP;
  real_T c3_BP;
  real_T c3_h1;
  real_T c3_v1;
  uint32_T c3_debug_family_var_map[25];
  real_T c3_d1;
  real_T c3_d2;
  real_T c3_d3;
  real_T c3_d4;
  real_T c3_d5;
  real_T c3_T;
  real_T c3_cp;
  real_T c3_R;
  real_T c3_gam;
  real_T c3_vpmb;
  real_T c3_vpmh;
  real_T c3_Wtot;
  real_T c3_neff;
  real_T c3_nv;
  real_T c3_nargin = 5.0;
  real_T c3_nargout = 4.0;
  real_T c3_P;
  real_T c3_Tm;
  real_T c3_h2;
  real_T c3_qmff;
  real_T c3_a;
  real_T c3_b_a;
  real_T c3_A;
  real_T c3_B;
  real_T c3_x;
  real_T c3_y;
  real_T c3_b_x;
  real_T c3_b_y;
  real_T c3_c_y;
  real_T c3_c_a;
  real_T c3_d_a;
  real_T c3_e_a;
  real_T c3_ak;
  real_T c3_c;
  real_T c3_f_a;
  real_T c3_b;
  real_T c3_d_y;
  real_T c3_b_b;
  real_T c3_e_y;
  real_T c3_c_b;
  real_T c3_f_y;
  real_T c3_g_a;
  real_T c3_d_b;
  real_T c3_g_y;
  real_T c3_b_A;
  real_T c3_c_x;
  real_T c3_d_x;
  real_T c3_h_y;
  real_T c3_c_A;
  real_T c3_e_x;
  real_T c3_f_x;
  real_T c3_d_A;
  real_T c3_b_B;
  real_T c3_g_x;
  real_T c3_i_y;
  real_T c3_h_x;
  real_T c3_j_y;
  real_T c3_k_y;
  real_T c3_h_a;
  real_T c3_i_a;
  real_T c3_j_a;
  real_T c3_b_ak;
  real_T c3_b_c;
  real_T c3_e_b;
  real_T c3_l_y;
  real_T c3_e_A;
  real_T c3_c_B;
  real_T c3_i_x;
  real_T c3_m_y;
  real_T c3_j_x;
  real_T c3_n_y;
  real_T c3_o_y;
  real_T c3_d_B;
  real_T c3_p_y;
  real_T c3_q_y;
  real_T c3_r_y;
  real_T c3_f_A;
  real_T c3_e_B;
  real_T c3_k_x;
  real_T c3_s_y;
  real_T c3_l_x;
  real_T c3_t_y;
  real_T c3_u_y;
  real_T c3_k_a;
  real_T c3_l_a;
  real_T c3_m_a;
  real_T c3_c_ak;
  real_T c3_c_c;
  real_T c3_f_b;
  real_T c3_v_y;
  real_T c3_g_b;
  real_T c3_n_a;
  real_T c3_w_y;
  real_T c3_g_A;
  real_T c3_f_B;
  real_T c3_m_x;
  real_T c3_x_y;
  real_T c3_n_x;
  real_T c3_y_y;
  real_T c3_ab_y;
  real_T c3_o_a;
  real_T c3_h_b;
  real_T c3_bb_y;
  real_T c3_h_A;
  real_T c3_o_x;
  real_T c3_p_x;
  real_T c3_i_A;
  real_T c3_q_x;
  real_T c3_r_x;
  real_T c3_cb_y;
  real_T c3_j_A;
  real_T c3_g_B;
  real_T c3_s_x;
  real_T c3_db_y;
  real_T c3_t_x;
  real_T c3_eb_y;
  real_T c3_fb_y;
  real_T c3_k_A;
  real_T c3_u_x;
  real_T c3_v_x;
  real_T c3_gb_y;
  real_T c3_p_a;
  real_T c3_i_b;
  real_T c3_hb_y;
  real_T c3_l_A;
  real_T c3_h_B;
  real_T c3_w_x;
  real_T c3_ib_y;
  real_T c3_x_x;
  real_T c3_jb_y;
  real_T c3_kb_y;
  real_T c3_m_A;
  real_T c3_y_x;
  real_T c3_ab_x;
  real_T c3_lb_y;
  real_T c3_n_A;
  real_T c3_bb_x;
  real_T c3_cb_x;
  real_T *c3_b_qmff;
  real_T *c3_b_h2;
  real_T *c3_b_Tm;
  real_T *c3_b_P;
  real_T *c3_b_v1;
  real_T *c3_b_h1;
  real_T *c3_b_BP;
  real_T *c3_b_HP;
  real_T *c3_b_N;
  c3_b_qmff = (real_T *)ssGetOutputPortSignal(chartInstance->S, 4);
  c3_b_h2 = (real_T *)ssGetOutputPortSignal(chartInstance->S, 3);
  c3_b_Tm = (real_T *)ssGetOutputPortSignal(chartInstance->S, 2);
  c3_b_v1 = (real_T *)ssGetInputPortSignal(chartInstance->S, 4);
  c3_b_h1 = (real_T *)ssGetInputPortSignal(chartInstance->S, 3);
  c3_b_BP = (real_T *)ssGetInputPortSignal(chartInstance->S, 2);
  c3_b_HP = (real_T *)ssGetInputPortSignal(chartInstance->S, 1);
  c3_b_P = (real_T *)ssGetOutputPortSignal(chartInstance->S, 1);
  c3_b_N = (real_T *)ssGetInputPortSignal(chartInstance->S, 0);
  _SFD_CC_CALL(CHART_ENTER_DURING_FUNCTION_TAG, 2U, chartInstance->c3_sfEvent);
  c3_hoistedGlobal = *c3_b_N;
  c3_b_hoistedGlobal = *c3_b_HP;
  c3_c_hoistedGlobal = *c3_b_BP;
  c3_d_hoistedGlobal = *c3_b_h1;
  c3_e_hoistedGlobal = *c3_b_v1;
  c3_N = c3_hoistedGlobal;
  c3_HP = c3_b_hoistedGlobal;
  c3_BP = c3_c_hoistedGlobal;
  c3_h1 = c3_d_hoistedGlobal;
  c3_v1 = c3_e_hoistedGlobal;
  sf_debug_symbol_scope_push_eml(0U, 25U, 25U, c3_debug_family_names,
    c3_debug_family_var_map);
  sf_debug_symbol_scope_add_eml(&c3_d1, 0U, c3_sf_marshallOut);
  sf_debug_symbol_scope_add_eml(&c3_d2, 1U, c3_sf_marshallOut);
  sf_debug_symbol_scope_add_eml(&c3_d3, 2U, c3_sf_marshallOut);
  sf_debug_symbol_scope_add_eml(&c3_d4, 3U, c3_sf_marshallOut);
  sf_debug_symbol_scope_add_eml(&c3_d5, 4U, c3_sf_marshallOut);
  sf_debug_symbol_scope_add_eml(&c3_T, 5U, c3_sf_marshallOut);
  sf_debug_symbol_scope_add_eml(&c3_cp, 6U, c3_sf_marshallOut);
  sf_debug_symbol_scope_add_eml(&c3_R, 7U, c3_sf_marshallOut);
  sf_debug_symbol_scope_add_eml(&c3_gam, 8U, c3_sf_marshallOut);
  sf_debug_symbol_scope_add_eml(&c3_vpmb, 9U, c3_sf_marshallOut);
  sf_debug_symbol_scope_add_eml(&c3_vpmh, 10U, c3_sf_marshallOut);
  sf_debug_symbol_scope_add_eml_importable(&c3_Wtot, 11U, c3_sf_marshallOut,
    c3_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c3_neff, 12U, c3_sf_marshallOut,
    c3_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c3_nv, 13U, c3_sf_marshallOut,
    c3_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c3_nargin, 14U, c3_sf_marshallOut,
    c3_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c3_nargout, 15U, c3_sf_marshallOut,
    c3_sf_marshallIn);
  sf_debug_symbol_scope_add_eml(&c3_N, 16U, c3_sf_marshallOut);
  sf_debug_symbol_scope_add_eml(&c3_HP, 17U, c3_sf_marshallOut);
  sf_debug_symbol_scope_add_eml(&c3_BP, 18U, c3_sf_marshallOut);
  sf_debug_symbol_scope_add_eml(&c3_h1, 19U, c3_sf_marshallOut);
  sf_debug_symbol_scope_add_eml(&c3_v1, 20U, c3_sf_marshallOut);
  sf_debug_symbol_scope_add_eml_importable(&c3_P, 21U, c3_sf_marshallOut,
    c3_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c3_Tm, 22U, c3_sf_marshallOut,
    c3_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c3_h2, 23U, c3_sf_marshallOut,
    c3_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c3_qmff, 24U, c3_sf_marshallOut,
    c3_sf_marshallIn);
  CV_EML_FCN(0, 0);
  _SFD_EML_CALL(0U, chartInstance->c3_sfEvent, 4);
  c3_d1 = 0.249202;
  _SFD_EML_CALL(0U, chartInstance->c3_sfEvent, 5);
  c3_d2 = 0.00245251;
  _SFD_EML_CALL(0U, chartInstance->c3_sfEvent, 6);
  c3_d3 = -1.6565E-6;
  _SFD_EML_CALL(0U, chartInstance->c3_sfEvent, 7);
  c3_d4 = 8.91048E-10;
  _SFD_EML_CALL(0U, chartInstance->c3_sfEvent, 8);
  c3_d5 = -6.96764;
  _SFD_EML_CALL(0U, chartInstance->c3_sfEvent, 10);
  c3_T = 306.0;
  _SFD_EML_CALL(0U, chartInstance->c3_sfEvent, 11);
  c3_cp = 0.8473228168220911;
  _SFD_EML_CALL(0U, chartInstance->c3_sfEvent, 13);
  c3_R = 0.0814892;
  _SFD_EML_CALL(0U, chartInstance->c3_sfEvent, 14);
  c3_gam = 1.1064058800893963;
  _SFD_EML_CALL(0U, chartInstance->c3_sfEvent, 16);
  c3_vpmb = 1.76625E-5;
  _SFD_EML_CALL(0U, chartInstance->c3_sfEvent, 17);
  c3_vpmh = 2.1195E-6;
  _SFD_EML_CALL(0U, chartInstance->c3_sfEvent, 19);
  c3_a = c3_HP;
  c3_HP = c3_a * 100000.0;
  _SFD_EML_CALL(0U, chartInstance->c3_sfEvent, 20);
  c3_b_a = c3_BP;
  c3_BP = c3_b_a * 100000.0;
  _SFD_EML_CALL(0U, chartInstance->c3_sfEvent, 22);
  c3_A = c3_HP;
  c3_B = c3_BP;
  c3_x = c3_A;
  c3_y = c3_B;
  c3_b_x = c3_x;
  c3_b_y = c3_y;
  c3_c_y = c3_b_x / c3_b_y;
  c3_c_a = c3_c_y;
  c3_d_a = c3_c_a;
  c3_e_a = c3_d_a;
  c3_eml_scalar_eg(chartInstance);
  c3_ak = c3_e_a;
  if (c3_ak < 0.0) {
    c3_eml_error(chartInstance);
  }

  c3_c = muDoubleScalarPower(c3_ak, -0.90382744524025949);
  c3_f_a = c3_HP;
  c3_b = c3_c;
  c3_d_y = c3_f_a * c3_b;
  c3_b_b = c3_d_y - c3_BP;
  c3_e_y = 0.000183654266480959 * c3_b_b;
  c3_c_b = c3_HP - c3_BP;
  c3_f_y = 2.1195E-6 * c3_c_b;
  c3_Wtot = c3_e_y - c3_f_y;
  _SFD_EML_CALL(0U, chartInstance->c3_sfEvent, 24);
  c3_g_a = c3_Wtot;
  c3_d_b = c3_N;
  c3_g_y = c3_g_a * c3_d_b;
  c3_b_A = c3_g_y;
  c3_c_x = c3_b_A;
  c3_d_x = c3_c_x;
  c3_h_y = c3_d_x / 60.0;
  c3_c_A = c3_h_y;
  c3_e_x = c3_c_A;
  c3_f_x = c3_e_x;
  c3_P = c3_f_x / 1000.0;
  _SFD_EML_CALL(0U, chartInstance->c3_sfEvent, 26);
  c3_d_A = c3_HP;
  c3_b_B = c3_BP;
  c3_g_x = c3_d_A;
  c3_i_y = c3_b_B;
  c3_h_x = c3_g_x;
  c3_j_y = c3_i_y;
  c3_k_y = c3_h_x / c3_j_y;
  c3_h_a = c3_k_y - 5.0;
  c3_i_a = c3_h_a;
  c3_j_a = c3_i_a;
  c3_eml_scalar_eg(chartInstance);
  c3_b_ak = c3_j_a;
  c3_b_c = muDoubleScalarPower(c3_b_ak, 2.0);
  c3_e_b = c3_b_c;
  c3_l_y = 0.004 * c3_e_b;
  c3_e_A = c3_HP;
  c3_c_B = c3_BP;
  c3_i_x = c3_e_A;
  c3_m_y = c3_c_B;
  c3_j_x = c3_i_x;
  c3_n_y = c3_m_y;
  c3_o_y = c3_j_x / c3_n_y;
  c3_d_B = c3_o_y - 0.3;
  c3_p_y = c3_d_B;
  c3_q_y = c3_p_y;
  c3_r_y = 0.5 / c3_q_y;
  c3_neff = (0.8 - c3_l_y) - c3_r_y;
  _SFD_EML_CALL(0U, chartInstance->c3_sfEvent, 27);
  c3_f_A = c3_HP;
  c3_e_B = c3_BP;
  c3_k_x = c3_f_A;
  c3_s_y = c3_e_B;
  c3_l_x = c3_k_x;
  c3_t_y = c3_s_y;
  c3_u_y = c3_l_x / c3_t_y;
  c3_k_a = c3_u_y;
  c3_l_a = c3_k_a;
  c3_m_a = c3_l_a;
  c3_eml_scalar_eg(chartInstance);
  c3_c_ak = c3_m_a;
  if (c3_c_ak < 0.0) {
    c3_eml_error(chartInstance);
  }

  c3_c_c = muDoubleScalarPower(c3_c_ak, 0.72);
  c3_f_b = 1.0 - c3_c_c;
  c3_v_y = 0.13636363636363638 * c3_f_b;
  c3_g_b = 1.0 + c3_v_y;
  c3_nv = 0.9 * c3_g_b;
  _SFD_EML_CALL(0U, chartInstance->c3_sfEvent, 29);
  c3_n_a = c3_nv;
  c3_w_y = c3_n_a * 1.5543E-5;
  c3_g_A = c3_w_y;
  c3_f_B = c3_v1;
  c3_m_x = c3_g_A;
  c3_x_y = c3_f_B;
  c3_n_x = c3_m_x;
  c3_y_y = c3_x_y;
  c3_ab_y = c3_n_x / c3_y_y;
  c3_o_a = c3_ab_y;
  c3_h_b = c3_N;
  c3_bb_y = c3_o_a * c3_h_b;
  c3_h_A = c3_bb_y;
  c3_o_x = c3_h_A;
  c3_p_x = c3_o_x;
  c3_qmff = c3_p_x / 60.0;
  _SFD_EML_CALL(0U, chartInstance->c3_sfEvent, 31);
  c3_i_A = c3_Wtot;
  c3_q_x = c3_i_A;
  c3_r_x = c3_q_x;
  c3_cb_y = c3_r_x / 1000.0;
  c3_j_A = c3_cb_y;
  c3_g_B = c3_nv;
  c3_s_x = c3_j_A;
  c3_db_y = c3_g_B;
  c3_t_x = c3_s_x;
  c3_eb_y = c3_db_y;
  c3_fb_y = c3_t_x / c3_eb_y;
  c3_k_A = c3_fb_y;
  c3_u_x = c3_k_A;
  c3_v_x = c3_u_x;
  c3_gb_y = c3_v_x / 1.5543E-5;
  c3_p_a = c3_gb_y;
  c3_i_b = c3_v1;
  c3_hb_y = c3_p_a * c3_i_b;
  c3_h2 = c3_h1 + c3_hb_y;
  _SFD_EML_CALL(0U, chartInstance->c3_sfEvent, 34);
  c3_l_A = c3_Wtot;
  c3_h_B = c3_neff;
  c3_w_x = c3_l_A;
  c3_ib_y = c3_h_B;
  c3_x_x = c3_w_x;
  c3_jb_y = c3_ib_y;
  c3_kb_y = c3_x_x / c3_jb_y;
  c3_m_A = c3_kb_y;
  c3_y_x = c3_m_A;
  c3_ab_x = c3_y_x;
  c3_lb_y = c3_ab_x / 2.0;
  c3_n_A = c3_lb_y;
  c3_bb_x = c3_n_A;
  c3_cb_x = c3_bb_x;
  c3_Tm = c3_cb_x / 3.14;
  _SFD_EML_CALL(0U, chartInstance->c3_sfEvent, -34);
  sf_debug_symbol_scope_pop();
  *c3_b_P = c3_P;
  *c3_b_Tm = c3_Tm;
  *c3_b_h2 = c3_h2;
  *c3_b_qmff = c3_qmff;
  _SFD_CC_CALL(EXIT_OUT_OF_FUNCTION_TAG, 2U, chartInstance->c3_sfEvent);
}

static void initSimStructsc3_PAC(SFc3_PACInstanceStruct *chartInstance)
{
}

static void init_script_number_translation(uint32_T c3_machineNumber, uint32_T
  c3_chartNumber)
{
}

static const mxArray *c3_sf_marshallOut(void *chartInstanceVoid, void *c3_inData)
{
  const mxArray *c3_mxArrayOutData = NULL;
  real_T c3_u;
  const mxArray *c3_y = NULL;
  SFc3_PACInstanceStruct *chartInstance;
  chartInstance = (SFc3_PACInstanceStruct *)chartInstanceVoid;
  c3_mxArrayOutData = NULL;
  c3_u = *(real_T *)c3_inData;
  c3_y = NULL;
  sf_mex_assign(&c3_y, sf_mex_create("y", &c3_u, 0, 0U, 0U, 0U, 0), FALSE);
  sf_mex_assign(&c3_mxArrayOutData, c3_y, FALSE);
  return c3_mxArrayOutData;
}

static real_T c3_emlrt_marshallIn(SFc3_PACInstanceStruct *chartInstance, const
  mxArray *c3_qmff, const char_T *c3_identifier)
{
  real_T c3_y;
  emlrtMsgIdentifier c3_thisId;
  c3_thisId.fIdentifier = c3_identifier;
  c3_thisId.fParent = NULL;
  c3_y = c3_b_emlrt_marshallIn(chartInstance, sf_mex_dup(c3_qmff), &c3_thisId);
  sf_mex_destroy(&c3_qmff);
  return c3_y;
}

static real_T c3_b_emlrt_marshallIn(SFc3_PACInstanceStruct *chartInstance, const
  mxArray *c3_u, const emlrtMsgIdentifier *c3_parentId)
{
  real_T c3_y;
  real_T c3_d0;
  sf_mex_import(c3_parentId, sf_mex_dup(c3_u), &c3_d0, 1, 0, 0U, 0, 0U, 0);
  c3_y = c3_d0;
  sf_mex_destroy(&c3_u);
  return c3_y;
}

static void c3_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c3_mxArrayInData, const char_T *c3_varName, void *c3_outData)
{
  const mxArray *c3_qmff;
  const char_T *c3_identifier;
  emlrtMsgIdentifier c3_thisId;
  real_T c3_y;
  SFc3_PACInstanceStruct *chartInstance;
  chartInstance = (SFc3_PACInstanceStruct *)chartInstanceVoid;
  c3_qmff = sf_mex_dup(c3_mxArrayInData);
  c3_identifier = c3_varName;
  c3_thisId.fIdentifier = c3_identifier;
  c3_thisId.fParent = NULL;
  c3_y = c3_b_emlrt_marshallIn(chartInstance, sf_mex_dup(c3_qmff), &c3_thisId);
  sf_mex_destroy(&c3_qmff);
  *(real_T *)c3_outData = c3_y;
  sf_mex_destroy(&c3_mxArrayInData);
}

const mxArray *sf_c3_PAC_get_eml_resolved_functions_info(void)
{
  const mxArray *c3_nameCaptureInfo;
  c3_ResolvedFunctionInfo c3_info[11];
  c3_ResolvedFunctionInfo (*c3_b_info)[11];
  const mxArray *c3_m0 = NULL;
  int32_T c3_i0;
  c3_ResolvedFunctionInfo *c3_r0;
  c3_nameCaptureInfo = NULL;
  c3_nameCaptureInfo = NULL;
  c3_b_info = (c3_ResolvedFunctionInfo (*)[11])c3_info;
  (*c3_b_info)[0].context = "";
  (*c3_b_info)[0].name = "mrdivide";
  (*c3_b_info)[0].dominantType = "double";
  (*c3_b_info)[0].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mrdivide.p";
  (*c3_b_info)[0].fileTimeLo = 1342810944U;
  (*c3_b_info)[0].fileTimeHi = 0U;
  (*c3_b_info)[0].mFileTimeLo = 1319729966U;
  (*c3_b_info)[0].mFileTimeHi = 0U;
  (*c3_b_info)[1].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mrdivide.p";
  (*c3_b_info)[1].name = "rdivide";
  (*c3_b_info)[1].dominantType = "double";
  (*c3_b_info)[1].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/rdivide.m";
  (*c3_b_info)[1].fileTimeLo = 1286818844U;
  (*c3_b_info)[1].fileTimeHi = 0U;
  (*c3_b_info)[1].mFileTimeLo = 0U;
  (*c3_b_info)[1].mFileTimeHi = 0U;
  (*c3_b_info)[2].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/rdivide.m";
  (*c3_b_info)[2].name = "eml_div";
  (*c3_b_info)[2].dominantType = "double";
  (*c3_b_info)[2].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_div.m";
  (*c3_b_info)[2].fileTimeLo = 1313347810U;
  (*c3_b_info)[2].fileTimeHi = 0U;
  (*c3_b_info)[2].mFileTimeLo = 0U;
  (*c3_b_info)[2].mFileTimeHi = 0U;
  (*c3_b_info)[3].context = "";
  (*c3_b_info)[3].name = "mtimes";
  (*c3_b_info)[3].dominantType = "double";
  (*c3_b_info)[3].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mtimes.m";
  (*c3_b_info)[3].fileTimeLo = 1289519692U;
  (*c3_b_info)[3].fileTimeHi = 0U;
  (*c3_b_info)[3].mFileTimeLo = 0U;
  (*c3_b_info)[3].mFileTimeHi = 0U;
  (*c3_b_info)[4].context = "";
  (*c3_b_info)[4].name = "mpower";
  (*c3_b_info)[4].dominantType = "double";
  (*c3_b_info)[4].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mpower.m";
  (*c3_b_info)[4].fileTimeLo = 1286818842U;
  (*c3_b_info)[4].fileTimeHi = 0U;
  (*c3_b_info)[4].mFileTimeLo = 0U;
  (*c3_b_info)[4].mFileTimeHi = 0U;
  (*c3_b_info)[5].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mpower.m";
  (*c3_b_info)[5].name = "power";
  (*c3_b_info)[5].dominantType = "double";
  (*c3_b_info)[5].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/power.m";
  (*c3_b_info)[5].fileTimeLo = 1336522096U;
  (*c3_b_info)[5].fileTimeHi = 0U;
  (*c3_b_info)[5].mFileTimeLo = 0U;
  (*c3_b_info)[5].mFileTimeHi = 0U;
  (*c3_b_info)[6].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/power.m!fltpower";
  (*c3_b_info)[6].name = "eml_scalar_eg";
  (*c3_b_info)[6].dominantType = "double";
  (*c3_b_info)[6].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_scalar_eg.m";
  (*c3_b_info)[6].fileTimeLo = 1286818796U;
  (*c3_b_info)[6].fileTimeHi = 0U;
  (*c3_b_info)[6].mFileTimeLo = 0U;
  (*c3_b_info)[6].mFileTimeHi = 0U;
  (*c3_b_info)[7].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/power.m!fltpower";
  (*c3_b_info)[7].name = "eml_scalexp_alloc";
  (*c3_b_info)[7].dominantType = "double";
  (*c3_b_info)[7].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_scalexp_alloc.m";
  (*c3_b_info)[7].fileTimeLo = 1330608434U;
  (*c3_b_info)[7].fileTimeHi = 0U;
  (*c3_b_info)[7].mFileTimeLo = 0U;
  (*c3_b_info)[7].mFileTimeHi = 0U;
  (*c3_b_info)[8].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/power.m!fltpower";
  (*c3_b_info)[8].name = "floor";
  (*c3_b_info)[8].dominantType = "double";
  (*c3_b_info)[8].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/floor.m";
  (*c3_b_info)[8].fileTimeLo = 1286818742U;
  (*c3_b_info)[8].fileTimeHi = 0U;
  (*c3_b_info)[8].mFileTimeLo = 0U;
  (*c3_b_info)[8].mFileTimeHi = 0U;
  (*c3_b_info)[9].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/floor.m";
  (*c3_b_info)[9].name = "eml_scalar_floor";
  (*c3_b_info)[9].dominantType = "double";
  (*c3_b_info)[9].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/eml_scalar_floor.m";
  (*c3_b_info)[9].fileTimeLo = 1286818726U;
  (*c3_b_info)[9].fileTimeHi = 0U;
  (*c3_b_info)[9].mFileTimeLo = 0U;
  (*c3_b_info)[9].mFileTimeHi = 0U;
  (*c3_b_info)[10].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/power.m!fltpower";
  (*c3_b_info)[10].name = "eml_error";
  (*c3_b_info)[10].dominantType = "char";
  (*c3_b_info)[10].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_error.m";
  (*c3_b_info)[10].fileTimeLo = 1305318000U;
  (*c3_b_info)[10].fileTimeHi = 0U;
  (*c3_b_info)[10].mFileTimeLo = 0U;
  (*c3_b_info)[10].mFileTimeHi = 0U;
  sf_mex_assign(&c3_m0, sf_mex_createstruct("nameCaptureInfo", 1, 11), FALSE);
  for (c3_i0 = 0; c3_i0 < 11; c3_i0++) {
    c3_r0 = &c3_info[c3_i0];
    sf_mex_addfield(c3_m0, sf_mex_create("nameCaptureInfo", c3_r0->context, 15,
      0U, 0U, 0U, 2, 1, strlen(c3_r0->context)), "context", "nameCaptureInfo",
                    c3_i0);
    sf_mex_addfield(c3_m0, sf_mex_create("nameCaptureInfo", c3_r0->name, 15, 0U,
      0U, 0U, 2, 1, strlen(c3_r0->name)), "name", "nameCaptureInfo", c3_i0);
    sf_mex_addfield(c3_m0, sf_mex_create("nameCaptureInfo", c3_r0->dominantType,
      15, 0U, 0U, 0U, 2, 1, strlen(c3_r0->dominantType)), "dominantType",
                    "nameCaptureInfo", c3_i0);
    sf_mex_addfield(c3_m0, sf_mex_create("nameCaptureInfo", c3_r0->resolved, 15,
      0U, 0U, 0U, 2, 1, strlen(c3_r0->resolved)), "resolved", "nameCaptureInfo",
                    c3_i0);
    sf_mex_addfield(c3_m0, sf_mex_create("nameCaptureInfo", &c3_r0->fileTimeLo,
      7, 0U, 0U, 0U, 0), "fileTimeLo", "nameCaptureInfo", c3_i0);
    sf_mex_addfield(c3_m0, sf_mex_create("nameCaptureInfo", &c3_r0->fileTimeHi,
      7, 0U, 0U, 0U, 0), "fileTimeHi", "nameCaptureInfo", c3_i0);
    sf_mex_addfield(c3_m0, sf_mex_create("nameCaptureInfo", &c3_r0->mFileTimeLo,
      7, 0U, 0U, 0U, 0), "mFileTimeLo", "nameCaptureInfo", c3_i0);
    sf_mex_addfield(c3_m0, sf_mex_create("nameCaptureInfo", &c3_r0->mFileTimeHi,
      7, 0U, 0U, 0U, 0), "mFileTimeHi", "nameCaptureInfo", c3_i0);
  }

  sf_mex_assign(&c3_nameCaptureInfo, c3_m0, FALSE);
  sf_mex_emlrtNameCapturePostProcessR2012a(&c3_nameCaptureInfo);
  return c3_nameCaptureInfo;
}

static void c3_eml_scalar_eg(SFc3_PACInstanceStruct *chartInstance)
{
}

static void c3_eml_error(SFc3_PACInstanceStruct *chartInstance)
{
  int32_T c3_i1;
  static char_T c3_varargin_1[31] = { 'C', 'o', 'd', 'e', 'r', ':', 't', 'o',
    'o', 'l', 'b', 'o', 'x', ':', 'p', 'o', 'w', 'e', 'r', '_', 'd', 'o', 'm',
    'a', 'i', 'n', 'E', 'r', 'r', 'o', 'r' };

  char_T c3_u[31];
  const mxArray *c3_y = NULL;
  for (c3_i1 = 0; c3_i1 < 31; c3_i1++) {
    c3_u[c3_i1] = c3_varargin_1[c3_i1];
  }

  c3_y = NULL;
  sf_mex_assign(&c3_y, sf_mex_create("y", c3_u, 10, 0U, 1U, 0U, 2, 1, 31), FALSE);
  sf_mex_call_debug("error", 0U, 1U, 14, sf_mex_call_debug("message", 1U, 1U, 14,
    c3_y));
}

static const mxArray *c3_b_sf_marshallOut(void *chartInstanceVoid, void
  *c3_inData)
{
  const mxArray *c3_mxArrayOutData = NULL;
  int32_T c3_u;
  const mxArray *c3_y = NULL;
  SFc3_PACInstanceStruct *chartInstance;
  chartInstance = (SFc3_PACInstanceStruct *)chartInstanceVoid;
  c3_mxArrayOutData = NULL;
  c3_u = *(int32_T *)c3_inData;
  c3_y = NULL;
  sf_mex_assign(&c3_y, sf_mex_create("y", &c3_u, 6, 0U, 0U, 0U, 0), FALSE);
  sf_mex_assign(&c3_mxArrayOutData, c3_y, FALSE);
  return c3_mxArrayOutData;
}

static int32_T c3_c_emlrt_marshallIn(SFc3_PACInstanceStruct *chartInstance,
  const mxArray *c3_u, const emlrtMsgIdentifier *c3_parentId)
{
  int32_T c3_y;
  int32_T c3_i2;
  sf_mex_import(c3_parentId, sf_mex_dup(c3_u), &c3_i2, 1, 6, 0U, 0, 0U, 0);
  c3_y = c3_i2;
  sf_mex_destroy(&c3_u);
  return c3_y;
}

static void c3_b_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c3_mxArrayInData, const char_T *c3_varName, void *c3_outData)
{
  const mxArray *c3_b_sfEvent;
  const char_T *c3_identifier;
  emlrtMsgIdentifier c3_thisId;
  int32_T c3_y;
  SFc3_PACInstanceStruct *chartInstance;
  chartInstance = (SFc3_PACInstanceStruct *)chartInstanceVoid;
  c3_b_sfEvent = sf_mex_dup(c3_mxArrayInData);
  c3_identifier = c3_varName;
  c3_thisId.fIdentifier = c3_identifier;
  c3_thisId.fParent = NULL;
  c3_y = c3_c_emlrt_marshallIn(chartInstance, sf_mex_dup(c3_b_sfEvent),
    &c3_thisId);
  sf_mex_destroy(&c3_b_sfEvent);
  *(int32_T *)c3_outData = c3_y;
  sf_mex_destroy(&c3_mxArrayInData);
}

static uint8_T c3_d_emlrt_marshallIn(SFc3_PACInstanceStruct *chartInstance,
  const mxArray *c3_b_is_active_c3_PAC, const char_T *c3_identifier)
{
  uint8_T c3_y;
  emlrtMsgIdentifier c3_thisId;
  c3_thisId.fIdentifier = c3_identifier;
  c3_thisId.fParent = NULL;
  c3_y = c3_e_emlrt_marshallIn(chartInstance, sf_mex_dup(c3_b_is_active_c3_PAC),
    &c3_thisId);
  sf_mex_destroy(&c3_b_is_active_c3_PAC);
  return c3_y;
}

static uint8_T c3_e_emlrt_marshallIn(SFc3_PACInstanceStruct *chartInstance,
  const mxArray *c3_u, const emlrtMsgIdentifier *c3_parentId)
{
  uint8_T c3_y;
  uint8_T c3_u0;
  sf_mex_import(c3_parentId, sf_mex_dup(c3_u), &c3_u0, 1, 3, 0U, 0, 0U, 0);
  c3_y = c3_u0;
  sf_mex_destroy(&c3_u);
  return c3_y;
}

static void init_dsm_address_info(SFc3_PACInstanceStruct *chartInstance)
{
}

/* SFunction Glue Code */
void sf_c3_PAC_get_check_sum(mxArray *plhs[])
{
  ((real_T *)mxGetPr((plhs[0])))[0] = (real_T)(1111138847U);
  ((real_T *)mxGetPr((plhs[0])))[1] = (real_T)(1465013446U);
  ((real_T *)mxGetPr((plhs[0])))[2] = (real_T)(2238471936U);
  ((real_T *)mxGetPr((plhs[0])))[3] = (real_T)(1319926120U);
}

mxArray *sf_c3_PAC_get_autoinheritance_info(void)
{
  const char *autoinheritanceFields[] = { "checksum", "inputs", "parameters",
    "outputs", "locals" };

  mxArray *mxAutoinheritanceInfo = mxCreateStructMatrix(1,1,5,
    autoinheritanceFields);

  {
    mxArray *mxChecksum = mxCreateString("ldZMW6oDcNd2nXBDjiTyAF");
    mxSetField(mxAutoinheritanceInfo,0,"checksum",mxChecksum);
  }

  {
    const char *dataFields[] = { "size", "type", "complexity" };

    mxArray *mxData = mxCreateStructMatrix(1,5,3,dataFields);

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,0,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }

    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,1,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,1,"type",mxType);
    }

    mxSetField(mxData,1,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,2,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,2,"type",mxType);
    }

    mxSetField(mxData,2,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,3,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,3,"type",mxType);
    }

    mxSetField(mxData,3,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,4,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,4,"type",mxType);
    }

    mxSetField(mxData,4,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"inputs",mxData);
  }

  {
    mxSetField(mxAutoinheritanceInfo,0,"parameters",mxCreateDoubleMatrix(0,0,
                mxREAL));
  }

  {
    const char *dataFields[] = { "size", "type", "complexity" };

    mxArray *mxData = mxCreateStructMatrix(1,4,3,dataFields);

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,0,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }

    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,1,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,1,"type",mxType);
    }

    mxSetField(mxData,1,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,2,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,2,"type",mxType);
    }

    mxSetField(mxData,2,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,3,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,3,"type",mxType);
    }

    mxSetField(mxData,3,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"outputs",mxData);
  }

  {
    mxSetField(mxAutoinheritanceInfo,0,"locals",mxCreateDoubleMatrix(0,0,mxREAL));
  }

  return(mxAutoinheritanceInfo);
}

static const mxArray *sf_get_sim_state_info_c3_PAC(void)
{
  const char *infoFields[] = { "chartChecksum", "varInfo" };

  mxArray *mxInfo = mxCreateStructMatrix(1, 1, 2, infoFields);
  const char *infoEncStr[] = {
    "100 S1x5'type','srcId','name','auxInfo'{{M[1],M[5],T\"P\",},{M[1],M[11],T\"Tm\",},{M[1],M[12],T\"h2\",},{M[1],M[13],T\"qmff\",},{M[8],M[0],T\"is_active_c3_PAC\",}}"
  };

  mxArray *mxVarInfo = sf_mex_decode_encoded_mx_struct_array(infoEncStr, 5, 10);
  mxArray *mxChecksum = mxCreateDoubleMatrix(1, 4, mxREAL);
  sf_c3_PAC_get_check_sum(&mxChecksum);
  mxSetField(mxInfo, 0, infoFields[0], mxChecksum);
  mxSetField(mxInfo, 0, infoFields[1], mxVarInfo);
  return mxInfo;
}

static void chart_debug_initialization(SimStruct *S, unsigned int
  fullDebuggerInitialization)
{
  if (!sim_mode_is_rtw_gen(S)) {
    SFc3_PACInstanceStruct *chartInstance;
    chartInstance = (SFc3_PACInstanceStruct *) ((ChartInfoStruct *)
      (ssGetUserData(S)))->chartInstance;
    if (ssIsFirstInitCond(S) && fullDebuggerInitialization==1) {
      /* do this only if simulation is starting */
      {
        unsigned int chartAlreadyPresent;
        chartAlreadyPresent = sf_debug_initialize_chart(_PACMachineNumber_,
          3,
          1,
          1,
          9,
          0,
          0,
          0,
          0,
          0,
          &(chartInstance->chartNumber),
          &(chartInstance->instanceNumber),
          ssGetPath(S),
          (void *)S);
        if (chartAlreadyPresent==0) {
          /* this is the first instance */
          init_script_number_translation(_PACMachineNumber_,
            chartInstance->chartNumber);
          sf_debug_set_chart_disable_implicit_casting(_PACMachineNumber_,
            chartInstance->chartNumber,1);
          sf_debug_set_chart_event_thresholds(_PACMachineNumber_,
            chartInstance->chartNumber,
            0,
            0,
            0);
          _SFD_SET_DATA_PROPS(0,1,1,0,"N");
          _SFD_SET_DATA_PROPS(1,2,0,1,"P");
          _SFD_SET_DATA_PROPS(2,1,1,0,"HP");
          _SFD_SET_DATA_PROPS(3,1,1,0,"BP");
          _SFD_SET_DATA_PROPS(4,1,1,0,"h1");
          _SFD_SET_DATA_PROPS(5,1,1,0,"v1");
          _SFD_SET_DATA_PROPS(6,2,0,1,"Tm");
          _SFD_SET_DATA_PROPS(7,2,0,1,"h2");
          _SFD_SET_DATA_PROPS(8,2,0,1,"qmff");
          _SFD_STATE_INFO(0,0,2);
          _SFD_CH_SUBSTATE_COUNT(0);
          _SFD_CH_SUBSTATE_DECOMP(0);
        }

        _SFD_CV_INIT_CHART(0,0,0,0);

        {
          _SFD_CV_INIT_STATE(0,0,0,0,0,0,NULL,NULL);
        }

        _SFD_CV_INIT_TRANS(0,0,NULL,NULL,0,NULL);

        /* Initialization of MATLAB Function Model Coverage */
        _SFD_CV_INIT_EML(0,1,1,0,0,0,0,0,0,0,0);
        _SFD_CV_INIT_EML_FCN(0,0,"eML_blk_kernel",0,-1,794);
        _SFD_TRANS_COV_WTS(0,0,0,1,0);
        if (chartAlreadyPresent==0) {
          _SFD_TRANS_COV_MAPS(0,
                              0,NULL,NULL,
                              0,NULL,NULL,
                              1,NULL,NULL,
                              0,NULL,NULL);
        }

        _SFD_SET_DATA_COMPILED_PROPS(0,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c3_sf_marshallOut,(MexInFcnForType)NULL);
        _SFD_SET_DATA_COMPILED_PROPS(1,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c3_sf_marshallOut,(MexInFcnForType)c3_sf_marshallIn);
        _SFD_SET_DATA_COMPILED_PROPS(2,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c3_sf_marshallOut,(MexInFcnForType)NULL);
        _SFD_SET_DATA_COMPILED_PROPS(3,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c3_sf_marshallOut,(MexInFcnForType)NULL);
        _SFD_SET_DATA_COMPILED_PROPS(4,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c3_sf_marshallOut,(MexInFcnForType)NULL);
        _SFD_SET_DATA_COMPILED_PROPS(5,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c3_sf_marshallOut,(MexInFcnForType)NULL);
        _SFD_SET_DATA_COMPILED_PROPS(6,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c3_sf_marshallOut,(MexInFcnForType)c3_sf_marshallIn);
        _SFD_SET_DATA_COMPILED_PROPS(7,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c3_sf_marshallOut,(MexInFcnForType)c3_sf_marshallIn);
        _SFD_SET_DATA_COMPILED_PROPS(8,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c3_sf_marshallOut,(MexInFcnForType)c3_sf_marshallIn);

        {
          real_T *c3_N;
          real_T *c3_P;
          real_T *c3_HP;
          real_T *c3_BP;
          real_T *c3_h1;
          real_T *c3_v1;
          real_T *c3_Tm;
          real_T *c3_h2;
          real_T *c3_qmff;
          c3_qmff = (real_T *)ssGetOutputPortSignal(chartInstance->S, 4);
          c3_h2 = (real_T *)ssGetOutputPortSignal(chartInstance->S, 3);
          c3_Tm = (real_T *)ssGetOutputPortSignal(chartInstance->S, 2);
          c3_v1 = (real_T *)ssGetInputPortSignal(chartInstance->S, 4);
          c3_h1 = (real_T *)ssGetInputPortSignal(chartInstance->S, 3);
          c3_BP = (real_T *)ssGetInputPortSignal(chartInstance->S, 2);
          c3_HP = (real_T *)ssGetInputPortSignal(chartInstance->S, 1);
          c3_P = (real_T *)ssGetOutputPortSignal(chartInstance->S, 1);
          c3_N = (real_T *)ssGetInputPortSignal(chartInstance->S, 0);
          _SFD_SET_DATA_VALUE_PTR(0U, c3_N);
          _SFD_SET_DATA_VALUE_PTR(1U, c3_P);
          _SFD_SET_DATA_VALUE_PTR(2U, c3_HP);
          _SFD_SET_DATA_VALUE_PTR(3U, c3_BP);
          _SFD_SET_DATA_VALUE_PTR(4U, c3_h1);
          _SFD_SET_DATA_VALUE_PTR(5U, c3_v1);
          _SFD_SET_DATA_VALUE_PTR(6U, c3_Tm);
          _SFD_SET_DATA_VALUE_PTR(7U, c3_h2);
          _SFD_SET_DATA_VALUE_PTR(8U, c3_qmff);
        }
      }
    } else {
      sf_debug_reset_current_state_configuration(_PACMachineNumber_,
        chartInstance->chartNumber,chartInstance->instanceNumber);
    }
  }
}

static const char* sf_get_instance_specialization()
{
  return "svxj0UETqvZHyBDm4Ykl5D";
}

static void sf_opaque_initialize_c3_PAC(void *chartInstanceVar)
{
  chart_debug_initialization(((SFc3_PACInstanceStruct*) chartInstanceVar)->S,0);
  initialize_params_c3_PAC((SFc3_PACInstanceStruct*) chartInstanceVar);
  initialize_c3_PAC((SFc3_PACInstanceStruct*) chartInstanceVar);
}

static void sf_opaque_enable_c3_PAC(void *chartInstanceVar)
{
  enable_c3_PAC((SFc3_PACInstanceStruct*) chartInstanceVar);
}

static void sf_opaque_disable_c3_PAC(void *chartInstanceVar)
{
  disable_c3_PAC((SFc3_PACInstanceStruct*) chartInstanceVar);
}

static void sf_opaque_gateway_c3_PAC(void *chartInstanceVar)
{
  sf_c3_PAC((SFc3_PACInstanceStruct*) chartInstanceVar);
}

extern const mxArray* sf_internal_get_sim_state_c3_PAC(SimStruct* S)
{
  ChartInfoStruct *chartInfo = (ChartInfoStruct*) ssGetUserData(S);
  mxArray *plhs[1] = { NULL };

  mxArray *prhs[4];
  int mxError = 0;
  prhs[0] = mxCreateString("chart_simctx_raw2high");
  prhs[1] = mxCreateDoubleScalar(ssGetSFuncBlockHandle(S));
  prhs[2] = (mxArray*) get_sim_state_c3_PAC((SFc3_PACInstanceStruct*)
    chartInfo->chartInstance);         /* raw sim ctx */
  prhs[3] = (mxArray*) sf_get_sim_state_info_c3_PAC();/* state var info */
  mxError = sf_mex_call_matlab(1, plhs, 4, prhs, "sfprivate");
  mxDestroyArray(prhs[0]);
  mxDestroyArray(prhs[1]);
  mxDestroyArray(prhs[2]);
  mxDestroyArray(prhs[3]);
  if (mxError || plhs[0] == NULL) {
    sf_mex_error_message("Stateflow Internal Error: \nError calling 'chart_simctx_raw2high'.\n");
  }

  return plhs[0];
}

extern void sf_internal_set_sim_state_c3_PAC(SimStruct* S, const mxArray *st)
{
  ChartInfoStruct *chartInfo = (ChartInfoStruct*) ssGetUserData(S);
  mxArray *plhs[1] = { NULL };

  mxArray *prhs[4];
  int mxError = 0;
  prhs[0] = mxCreateString("chart_simctx_high2raw");
  prhs[1] = mxCreateDoubleScalar(ssGetSFuncBlockHandle(S));
  prhs[2] = mxDuplicateArray(st);      /* high level simctx */
  prhs[3] = (mxArray*) sf_get_sim_state_info_c3_PAC();/* state var info */
  mxError = sf_mex_call_matlab(1, plhs, 4, prhs, "sfprivate");
  mxDestroyArray(prhs[0]);
  mxDestroyArray(prhs[1]);
  mxDestroyArray(prhs[2]);
  mxDestroyArray(prhs[3]);
  if (mxError || plhs[0] == NULL) {
    sf_mex_error_message("Stateflow Internal Error: \nError calling 'chart_simctx_high2raw'.\n");
  }

  set_sim_state_c3_PAC((SFc3_PACInstanceStruct*)chartInfo->chartInstance,
                       mxDuplicateArray(plhs[0]));
  mxDestroyArray(plhs[0]);
}

static const mxArray* sf_opaque_get_sim_state_c3_PAC(SimStruct* S)
{
  return sf_internal_get_sim_state_c3_PAC(S);
}

static void sf_opaque_set_sim_state_c3_PAC(SimStruct* S, const mxArray *st)
{
  sf_internal_set_sim_state_c3_PAC(S, st);
}

static void sf_opaque_terminate_c3_PAC(void *chartInstanceVar)
{
  if (chartInstanceVar!=NULL) {
    SimStruct *S = ((SFc3_PACInstanceStruct*) chartInstanceVar)->S;
    if (sim_mode_is_rtw_gen(S) || sim_mode_is_external(S)) {
      sf_clear_rtw_identifier(S);
    }

    finalize_c3_PAC((SFc3_PACInstanceStruct*) chartInstanceVar);
    free((void *)chartInstanceVar);
    ssSetUserData(S,NULL);
  }

  unload_PAC_optimization_info();
}

static void sf_opaque_init_subchart_simstructs(void *chartInstanceVar)
{
  initSimStructsc3_PAC((SFc3_PACInstanceStruct*) chartInstanceVar);
}

extern unsigned int sf_machine_global_initializer_called(void);
static void mdlProcessParameters_c3_PAC(SimStruct *S)
{
  int i;
  for (i=0;i<ssGetNumRunTimeParams(S);i++) {
    if (ssGetSFcnParamTunable(S,i)) {
      ssUpdateDlgParamAsRunTimeParam(S,i);
    }
  }

  if (sf_machine_global_initializer_called()) {
    initialize_params_c3_PAC((SFc3_PACInstanceStruct*)(((ChartInfoStruct *)
      ssGetUserData(S))->chartInstance));
  }
}

static void mdlSetWorkWidths_c3_PAC(SimStruct *S)
{
  if (sim_mode_is_rtw_gen(S) || sim_mode_is_external(S)) {
    mxArray *infoStruct = load_PAC_optimization_info();
    int_T chartIsInlinable =
      (int_T)sf_is_chart_inlinable(S,sf_get_instance_specialization(),infoStruct,
      3);
    ssSetStateflowIsInlinable(S,chartIsInlinable);
    ssSetRTWCG(S,sf_rtw_info_uint_prop(S,sf_get_instance_specialization(),
                infoStruct,3,"RTWCG"));
    ssSetEnableFcnIsTrivial(S,1);
    ssSetDisableFcnIsTrivial(S,1);
    ssSetNotMultipleInlinable(S,sf_rtw_info_uint_prop(S,
      sf_get_instance_specialization(),infoStruct,3,
      "gatewayCannotBeInlinedMultipleTimes"));
    if (chartIsInlinable) {
      ssSetInputPortOptimOpts(S, 0, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 1, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 2, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 3, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 4, SS_REUSABLE_AND_LOCAL);
      sf_mark_chart_expressionable_inputs(S,sf_get_instance_specialization(),
        infoStruct,3,5);
      sf_mark_chart_reusable_outputs(S,sf_get_instance_specialization(),
        infoStruct,3,4);
    }

    sf_set_rtw_dwork_info(S,sf_get_instance_specialization(),infoStruct,3);
    ssSetHasSubFunctions(S,!(chartIsInlinable));
  } else {
  }

  ssSetOptions(S,ssGetOptions(S)|SS_OPTION_WORKS_WITH_CODE_REUSE);
  ssSetChecksum0(S,(3681408329U));
  ssSetChecksum1(S,(3929197841U));
  ssSetChecksum2(S,(2260127306U));
  ssSetChecksum3(S,(2447015384U));
  ssSetmdlDerivatives(S, NULL);
  ssSetExplicitFCSSCtrl(S,1);
  ssSupportsMultipleExecInstances(S,1);
}

static void mdlRTW_c3_PAC(SimStruct *S)
{
  if (sim_mode_is_rtw_gen(S)) {
    ssWriteRTWStrParam(S, "StateflowChartType", "Embedded MATLAB");
  }
}

static void mdlStart_c3_PAC(SimStruct *S)
{
  SFc3_PACInstanceStruct *chartInstance;
  chartInstance = (SFc3_PACInstanceStruct *)malloc(sizeof(SFc3_PACInstanceStruct));
  memset(chartInstance, 0, sizeof(SFc3_PACInstanceStruct));
  if (chartInstance==NULL) {
    sf_mex_error_message("Could not allocate memory for chart instance.");
  }

  chartInstance->chartInfo.chartInstance = chartInstance;
  chartInstance->chartInfo.isEMLChart = 1;
  chartInstance->chartInfo.chartInitialized = 0;
  chartInstance->chartInfo.sFunctionGateway = sf_opaque_gateway_c3_PAC;
  chartInstance->chartInfo.initializeChart = sf_opaque_initialize_c3_PAC;
  chartInstance->chartInfo.terminateChart = sf_opaque_terminate_c3_PAC;
  chartInstance->chartInfo.enableChart = sf_opaque_enable_c3_PAC;
  chartInstance->chartInfo.disableChart = sf_opaque_disable_c3_PAC;
  chartInstance->chartInfo.getSimState = sf_opaque_get_sim_state_c3_PAC;
  chartInstance->chartInfo.setSimState = sf_opaque_set_sim_state_c3_PAC;
  chartInstance->chartInfo.getSimStateInfo = sf_get_sim_state_info_c3_PAC;
  chartInstance->chartInfo.zeroCrossings = NULL;
  chartInstance->chartInfo.outputs = NULL;
  chartInstance->chartInfo.derivatives = NULL;
  chartInstance->chartInfo.mdlRTW = mdlRTW_c3_PAC;
  chartInstance->chartInfo.mdlStart = mdlStart_c3_PAC;
  chartInstance->chartInfo.mdlSetWorkWidths = mdlSetWorkWidths_c3_PAC;
  chartInstance->chartInfo.extModeExec = NULL;
  chartInstance->chartInfo.restoreLastMajorStepConfiguration = NULL;
  chartInstance->chartInfo.restoreBeforeLastMajorStepConfiguration = NULL;
  chartInstance->chartInfo.storeCurrentConfiguration = NULL;
  chartInstance->S = S;
  ssSetUserData(S,(void *)(&(chartInstance->chartInfo)));/* register the chart instance with simstruct */
  init_dsm_address_info(chartInstance);
  if (!sim_mode_is_rtw_gen(S)) {
  }

  sf_opaque_init_subchart_simstructs(chartInstance->chartInfo.chartInstance);
  chart_debug_initialization(S,1);
}

void c3_PAC_method_dispatcher(SimStruct *S, int_T method, void *data)
{
  switch (method) {
   case SS_CALL_MDL_START:
    mdlStart_c3_PAC(S);
    break;

   case SS_CALL_MDL_SET_WORK_WIDTHS:
    mdlSetWorkWidths_c3_PAC(S);
    break;

   case SS_CALL_MDL_PROCESS_PARAMETERS:
    mdlProcessParameters_c3_PAC(S);
    break;

   default:
    /* Unhandled method */
    sf_mex_error_message("Stateflow Internal Error:\n"
                         "Error calling c3_PAC_method_dispatcher.\n"
                         "Can't handle method %d.\n", method);
    break;
  }
}
