/* Include files */

#include "blascompat32.h"
#include "evaporateur_sfun.h"
#include "c5_evaporateur.h"
#include "mwmathutil.h"
#define CHARTINSTANCE_CHARTNUMBER      (chartInstance->chartNumber)
#define CHARTINSTANCE_INSTANCENUMBER   (chartInstance->instanceNumber)
#include "evaporateur_sfun_debug_macros.h"

/* Type Definitions */

/* Named Constants */
#define CALL_EVENT                     (-1)

/* Variable Declarations */

/* Variable Definitions */
static const char * c5_debug_family_names[25] = { "Tc", "Pc", "R", "d1", "d2",
  "d3", "d5", "e1", "e2", "e3", "e4", "g1", "g2", "g4", "b", "k", "Ho", "z",
  "Tr", "nargin", "nargout", "T", "P", "v", "H" };

/* Function Declarations */
static void initialize_c5_evaporateur(SFc5_evaporateurInstanceStruct
  *chartInstance);
static void initialize_params_c5_evaporateur(SFc5_evaporateurInstanceStruct
  *chartInstance);
static void enable_c5_evaporateur(SFc5_evaporateurInstanceStruct *chartInstance);
static void disable_c5_evaporateur(SFc5_evaporateurInstanceStruct *chartInstance);
static void c5_update_debugger_state_c5_evaporateur
  (SFc5_evaporateurInstanceStruct *chartInstance);
static const mxArray *get_sim_state_c5_evaporateur
  (SFc5_evaporateurInstanceStruct *chartInstance);
static void set_sim_state_c5_evaporateur(SFc5_evaporateurInstanceStruct
  *chartInstance, const mxArray *c5_st);
static void finalize_c5_evaporateur(SFc5_evaporateurInstanceStruct
  *chartInstance);
static void sf_c5_evaporateur(SFc5_evaporateurInstanceStruct *chartInstance);
static void c5_chartstep_c5_evaporateur(SFc5_evaporateurInstanceStruct
  *chartInstance);
static void initSimStructsc5_evaporateur(SFc5_evaporateurInstanceStruct
  *chartInstance);
static void init_script_number_translation(uint32_T c5_machineNumber, uint32_T
  c5_chartNumber);
static const mxArray *c5_sf_marshallOut(void *chartInstanceVoid, void *c5_inData);
static real_T c5_emlrt_marshallIn(SFc5_evaporateurInstanceStruct *chartInstance,
  const mxArray *c5_H, const char_T *c5_identifier);
static real_T c5_b_emlrt_marshallIn(SFc5_evaporateurInstanceStruct
  *chartInstance, const mxArray *c5_u, const emlrtMsgIdentifier *c5_parentId);
static void c5_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c5_mxArrayInData, const char_T *c5_varName, void *c5_outData);
static void c5_info_helper(c5_ResolvedFunctionInfo c5_info[14]);
static void c5_eml_error(SFc5_evaporateurInstanceStruct *chartInstance);
static const mxArray *c5_b_sf_marshallOut(void *chartInstanceVoid, void
  *c5_inData);
static int32_T c5_c_emlrt_marshallIn(SFc5_evaporateurInstanceStruct
  *chartInstance, const mxArray *c5_u, const emlrtMsgIdentifier *c5_parentId);
static void c5_b_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c5_mxArrayInData, const char_T *c5_varName, void *c5_outData);
static uint8_T c5_d_emlrt_marshallIn(SFc5_evaporateurInstanceStruct
  *chartInstance, const mxArray *c5_b_is_active_c5_evaporateur, const char_T
  *c5_identifier);
static uint8_T c5_e_emlrt_marshallIn(SFc5_evaporateurInstanceStruct
  *chartInstance, const mxArray *c5_u, const emlrtMsgIdentifier *c5_parentId);
static void init_dsm_address_info(SFc5_evaporateurInstanceStruct *chartInstance);

/* Function Definitions */
static void initialize_c5_evaporateur(SFc5_evaporateurInstanceStruct
  *chartInstance)
{
  chartInstance->c5_sfEvent = CALL_EVENT;
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
  chartInstance->c5_is_active_c5_evaporateur = 0U;
}

static void initialize_params_c5_evaporateur(SFc5_evaporateurInstanceStruct
  *chartInstance)
{
}

static void enable_c5_evaporateur(SFc5_evaporateurInstanceStruct *chartInstance)
{
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
}

static void disable_c5_evaporateur(SFc5_evaporateurInstanceStruct *chartInstance)
{
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
}

static void c5_update_debugger_state_c5_evaporateur
  (SFc5_evaporateurInstanceStruct *chartInstance)
{
}

static const mxArray *get_sim_state_c5_evaporateur
  (SFc5_evaporateurInstanceStruct *chartInstance)
{
  const mxArray *c5_st;
  const mxArray *c5_y = NULL;
  real_T c5_hoistedGlobal;
  real_T c5_u;
  const mxArray *c5_b_y = NULL;
  uint8_T c5_b_hoistedGlobal;
  uint8_T c5_b_u;
  const mxArray *c5_c_y = NULL;
  real_T *c5_H;
  c5_H = (real_T *)ssGetOutputPortSignal(chartInstance->S, 1);
  c5_st = NULL;
  c5_st = NULL;
  c5_y = NULL;
  sf_mex_assign(&c5_y, sf_mex_createcellarray(2), FALSE);
  c5_hoistedGlobal = *c5_H;
  c5_u = c5_hoistedGlobal;
  c5_b_y = NULL;
  sf_mex_assign(&c5_b_y, sf_mex_create("y", &c5_u, 0, 0U, 0U, 0U, 0), FALSE);
  sf_mex_setcell(c5_y, 0, c5_b_y);
  c5_b_hoistedGlobal = chartInstance->c5_is_active_c5_evaporateur;
  c5_b_u = c5_b_hoistedGlobal;
  c5_c_y = NULL;
  sf_mex_assign(&c5_c_y, sf_mex_create("y", &c5_b_u, 3, 0U, 0U, 0U, 0), FALSE);
  sf_mex_setcell(c5_y, 1, c5_c_y);
  sf_mex_assign(&c5_st, c5_y, FALSE);
  return c5_st;
}

static void set_sim_state_c5_evaporateur(SFc5_evaporateurInstanceStruct
  *chartInstance, const mxArray *c5_st)
{
  const mxArray *c5_u;
  real_T *c5_H;
  c5_H = (real_T *)ssGetOutputPortSignal(chartInstance->S, 1);
  chartInstance->c5_doneDoubleBufferReInit = TRUE;
  c5_u = sf_mex_dup(c5_st);
  *c5_H = c5_emlrt_marshallIn(chartInstance, sf_mex_dup(sf_mex_getcell(c5_u, 0)),
    "H");
  chartInstance->c5_is_active_c5_evaporateur = c5_d_emlrt_marshallIn
    (chartInstance, sf_mex_dup(sf_mex_getcell(c5_u, 1)),
     "is_active_c5_evaporateur");
  sf_mex_destroy(&c5_u);
  c5_update_debugger_state_c5_evaporateur(chartInstance);
  sf_mex_destroy(&c5_st);
}

static void finalize_c5_evaporateur(SFc5_evaporateurInstanceStruct
  *chartInstance)
{
}

static void sf_c5_evaporateur(SFc5_evaporateurInstanceStruct *chartInstance)
{
  real_T *c5_T;
  real_T *c5_P;
  real_T *c5_v;
  real_T *c5_H;
  c5_H = (real_T *)ssGetOutputPortSignal(chartInstance->S, 1);
  c5_v = (real_T *)ssGetInputPortSignal(chartInstance->S, 2);
  c5_P = (real_T *)ssGetInputPortSignal(chartInstance->S, 1);
  c5_T = (real_T *)ssGetInputPortSignal(chartInstance->S, 0);
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
  _SFD_CC_CALL(CHART_ENTER_SFUNCTION_TAG, 2U, chartInstance->c5_sfEvent);
  _SFD_DATA_RANGE_CHECK(*c5_T, 0U);
  _SFD_DATA_RANGE_CHECK(*c5_P, 1U);
  _SFD_DATA_RANGE_CHECK(*c5_v, 2U);
  _SFD_DATA_RANGE_CHECK(*c5_H, 3U);
  chartInstance->c5_sfEvent = CALL_EVENT;
  c5_chartstep_c5_evaporateur(chartInstance);
  sf_debug_check_for_state_inconsistency(_evaporateurMachineNumber_,
    chartInstance->chartNumber, chartInstance->instanceNumber);
}

static void c5_chartstep_c5_evaporateur(SFc5_evaporateurInstanceStruct
  *chartInstance)
{
  real_T c5_hoistedGlobal;
  real_T c5_b_hoistedGlobal;
  real_T c5_c_hoistedGlobal;
  real_T c5_T;
  real_T c5_P;
  real_T c5_v;
  uint32_T c5_debug_family_var_map[25];
  real_T c5_Tc;
  real_T c5_Pc;
  real_T c5_R;
  real_T c5_d1;
  real_T c5_d2;
  real_T c5_d3;
  real_T c5_d5;
  real_T c5_e1;
  real_T c5_e2;
  real_T c5_e3;
  real_T c5_e4;
  real_T c5_g1;
  real_T c5_g2;
  real_T c5_g4;
  real_T c5_b;
  real_T c5_k;
  real_T c5_Ho;
  real_T c5_z;
  real_T c5_Tr;
  real_T c5_nargin = 3.0;
  real_T c5_nargout = 1.0;
  real_T c5_H;
  real_T c5_A;
  real_T c5_x;
  real_T c5_b_x;
  real_T c5_a;
  real_T c5_b_b;
  real_T c5_y;
  real_T c5_c_b;
  real_T c5_b_y;
  real_T c5_d_b;
  real_T c5_c_y;
  real_T c5_e_b;
  real_T c5_d_y;
  real_T c5_f_b;
  real_T c5_e_y;
  real_T c5_b_a;
  real_T c5_g_b;
  real_T c5_f_y;
  real_T c5_b_A;
  real_T c5_c_x;
  real_T c5_d_x;
  real_T c5_g_y;
  real_T c5_h_b;
  real_T c5_h_y;
  real_T c5_c_a;
  real_T c5_i_b;
  real_T c5_i_y;
  real_T c5_d_a;
  real_T c5_j_b;
  real_T c5_j_y;
  real_T c5_c_A;
  real_T c5_e_x;
  real_T c5_f_x;
  real_T c5_k_y;
  real_T c5_g_x;
  real_T c5_h_x;
  real_T c5_k_b;
  real_T c5_l_y;
  real_T c5_B;
  real_T c5_m_y;
  real_T c5_n_y;
  real_T c5_o_y;
  real_T c5_b_B;
  real_T c5_p_y;
  real_T c5_q_y;
  real_T c5_r_y;
  real_T c5_d_A;
  real_T c5_c_B;
  real_T c5_i_x;
  real_T c5_s_y;
  real_T c5_j_x;
  real_T c5_t_y;
  real_T c5_u_y;
  real_T c5_d_B;
  real_T c5_v_y;
  real_T c5_w_y;
  real_T c5_x_y;
  real_T c5_e_A;
  real_T c5_e_B;
  real_T c5_k_x;
  real_T c5_y_y;
  real_T c5_l_x;
  real_T c5_ab_y;
  real_T c5_bb_y;
  real_T c5_f_A;
  real_T c5_f_B;
  real_T c5_m_x;
  real_T c5_cb_y;
  real_T c5_n_x;
  real_T c5_db_y;
  real_T c5_eb_y;
  real_T c5_g_B;
  real_T c5_fb_y;
  real_T c5_gb_y;
  real_T c5_hb_y;
  real_T c5_g_A;
  real_T c5_h_B;
  real_T c5_o_x;
  real_T c5_ib_y;
  real_T c5_p_x;
  real_T c5_jb_y;
  real_T c5_kb_y;
  real_T c5_h_A;
  real_T c5_i_B;
  real_T c5_q_x;
  real_T c5_lb_y;
  real_T c5_r_x;
  real_T c5_mb_y;
  real_T c5_nb_y;
  real_T c5_i_A;
  real_T c5_j_B;
  real_T c5_s_x;
  real_T c5_ob_y;
  real_T c5_t_x;
  real_T c5_pb_y;
  real_T c5_qb_y;
  real_T c5_l_b;
  real_T c5_rb_y;
  real_T c5_u_x;
  real_T c5_v_x;
  real_T c5_m_b;
  real_T c5_sb_y;
  real_T c5_e_a;
  real_T c5_n_b;
  real_T c5_tb_y;
  real_T c5_k_B;
  real_T c5_ub_y;
  real_T c5_vb_y;
  real_T c5_wb_y;
  real_T c5_l_B;
  real_T c5_xb_y;
  real_T c5_yb_y;
  real_T c5_ac_y;
  real_T c5_j_A;
  real_T c5_m_B;
  real_T c5_w_x;
  real_T c5_bc_y;
  real_T c5_x_x;
  real_T c5_cc_y;
  real_T c5_dc_y;
  real_T c5_n_B;
  real_T c5_ec_y;
  real_T c5_fc_y;
  real_T c5_gc_y;
  real_T c5_k_A;
  real_T c5_o_B;
  real_T c5_y_x;
  real_T c5_hc_y;
  real_T c5_ab_x;
  real_T c5_ic_y;
  real_T c5_jc_y;
  real_T c5_l_A;
  real_T c5_p_B;
  real_T c5_bb_x;
  real_T c5_kc_y;
  real_T c5_cb_x;
  real_T c5_lc_y;
  real_T c5_mc_y;
  real_T c5_m_A;
  real_T c5_q_B;
  real_T c5_db_x;
  real_T c5_nc_y;
  real_T c5_eb_x;
  real_T c5_oc_y;
  real_T c5_pc_y;
  real_T c5_f_a;
  real_T c5_o_b;
  real_T c5_qc_y;
  real_T c5_p_b;
  real_T c5_rc_y;
  real_T *c5_b_v;
  real_T *c5_b_P;
  real_T *c5_b_T;
  real_T *c5_b_H;
  c5_b_H = (real_T *)ssGetOutputPortSignal(chartInstance->S, 1);
  c5_b_v = (real_T *)ssGetInputPortSignal(chartInstance->S, 2);
  c5_b_P = (real_T *)ssGetInputPortSignal(chartInstance->S, 1);
  c5_b_T = (real_T *)ssGetInputPortSignal(chartInstance->S, 0);
  _SFD_CC_CALL(CHART_ENTER_DURING_FUNCTION_TAG, 2U, chartInstance->c5_sfEvent);
  c5_hoistedGlobal = *c5_b_T;
  c5_b_hoistedGlobal = *c5_b_P;
  c5_c_hoistedGlobal = *c5_b_v;
  c5_T = c5_hoistedGlobal;
  c5_P = c5_b_hoistedGlobal;
  c5_v = c5_c_hoistedGlobal;
  sf_debug_symbol_scope_push_eml(0U, 25U, 25U, c5_debug_family_names,
    c5_debug_family_var_map);
  sf_debug_symbol_scope_add_eml(&c5_Tc, 0U, c5_sf_marshallOut);
  sf_debug_symbol_scope_add_eml_importable(&c5_Pc, 1U, c5_sf_marshallOut,
    c5_sf_marshallIn);
  sf_debug_symbol_scope_add_eml(&c5_R, 2U, c5_sf_marshallOut);
  sf_debug_symbol_scope_add_eml(&c5_d1, 3U, c5_sf_marshallOut);
  sf_debug_symbol_scope_add_eml(&c5_d2, 4U, c5_sf_marshallOut);
  sf_debug_symbol_scope_add_eml(&c5_d3, 5U, c5_sf_marshallOut);
  sf_debug_symbol_scope_add_eml(&c5_d5, 6U, c5_sf_marshallOut);
  sf_debug_symbol_scope_add_eml(&c5_e1, 7U, c5_sf_marshallOut);
  sf_debug_symbol_scope_add_eml(&c5_e2, 8U, c5_sf_marshallOut);
  sf_debug_symbol_scope_add_eml(&c5_e3, 9U, c5_sf_marshallOut);
  sf_debug_symbol_scope_add_eml(&c5_e4, 10U, c5_sf_marshallOut);
  sf_debug_symbol_scope_add_eml(&c5_g1, 11U, c5_sf_marshallOut);
  sf_debug_symbol_scope_add_eml(&c5_g2, 12U, c5_sf_marshallOut);
  sf_debug_symbol_scope_add_eml(&c5_g4, 13U, c5_sf_marshallOut);
  sf_debug_symbol_scope_add_eml_importable(&c5_b, 14U, c5_sf_marshallOut,
    c5_sf_marshallIn);
  sf_debug_symbol_scope_add_eml(&c5_k, 15U, c5_sf_marshallOut);
  sf_debug_symbol_scope_add_eml_importable(&c5_Ho, 16U, c5_sf_marshallOut,
    c5_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c5_z, 17U, c5_sf_marshallOut,
    c5_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c5_Tr, 18U, c5_sf_marshallOut,
    c5_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c5_nargin, 19U, c5_sf_marshallOut,
    c5_sf_marshallIn);
  sf_debug_symbol_scope_add_eml_importable(&c5_nargout, 20U, c5_sf_marshallOut,
    c5_sf_marshallIn);
  sf_debug_symbol_scope_add_eml(&c5_T, 21U, c5_sf_marshallOut);
  sf_debug_symbol_scope_add_eml(&c5_P, 22U, c5_sf_marshallOut);
  sf_debug_symbol_scope_add_eml(&c5_v, 23U, c5_sf_marshallOut);
  sf_debug_symbol_scope_add_eml_importable(&c5_H, 24U, c5_sf_marshallOut,
    c5_sf_marshallIn);
  CV_EML_FCN(0, 0);
  _SFD_EML_CALL(0U, chartInstance->c5_sfEvent, 4);
  c5_T += 273.15;
  _SFD_EML_CALL(0U, chartInstance->c5_sfEvent, 5);
  if (CV_EML_IF(0, 1, 0, c5_P < 1.0)) {
    _SFD_EML_CALL(0U, chartInstance->c5_sfEvent, 6);
    c5_P = 1.0;
  }

  _SFD_EML_CALL(0U, chartInstance->c5_sfEvent, 8);
  c5_Tc = 374.21;
  _SFD_EML_CALL(0U, chartInstance->c5_sfEvent, 9);
  c5_Pc = 40.59;
  _SFD_EML_CALL(0U, chartInstance->c5_sfEvent, 11);
  c5_R = 0.000814892;
  _SFD_EML_CALL(0U, chartInstance->c5_sfEvent, 13);
  c5_d1 = 0.249202;
  _SFD_EML_CALL(0U, chartInstance->c5_sfEvent, 14);
  c5_d2 = 0.00245251;
  _SFD_EML_CALL(0U, chartInstance->c5_sfEvent, 15);
  c5_d3 = -1.6565E-6;
  _SFD_EML_CALL(0U, chartInstance->c5_sfEvent, 17);
  c5_d5 = -6.96764;
  _SFD_EML_CALL(0U, chartInstance->c5_sfEvent, 19);
  c5_e1 = -0.00140114;
  _SFD_EML_CALL(0U, chartInstance->c5_sfEvent, 20);
  c5_e2 = 2.19433E-6;
  _SFD_EML_CALL(0U, chartInstance->c5_sfEvent, 21);
  c5_e3 = -6.7358E-10;
  _SFD_EML_CALL(0U, chartInstance->c5_sfEvent, 22);
  c5_e4 = -4.668E-12;
  _SFD_EML_CALL(0U, chartInstance->c5_sfEvent, 28);
  c5_g1 = -0.0269555;
  _SFD_EML_CALL(0U, chartInstance->c5_sfEvent, 29);
  c5_g2 = 2.67772E-5;
  _SFD_EML_CALL(0U, chartInstance->c5_sfEvent, 30);
  c5_g4 = 1.69513E-10;
  _SFD_EML_CALL(0U, chartInstance->c5_sfEvent, 32);
  c5_b = 0.000299628;
  _SFD_EML_CALL(0U, chartInstance->c5_sfEvent, 33);
  c5_k = 5.475;
  _SFD_EML_CALL(0U, chartInstance->c5_sfEvent, 35);
  c5_Ho = 295.57;
  _SFD_EML_CALL(0U, chartInstance->c5_sfEvent, 37);
  c5_z = c5_v - c5_b;
  _SFD_EML_CALL(0U, chartInstance->c5_sfEvent, 39);
  c5_A = c5_T;
  c5_x = c5_A;
  c5_b_x = c5_x;
  c5_Tr = c5_b_x / 374.21;
  _SFD_EML_CALL(0U, chartInstance->c5_sfEvent, 41);
  c5_a = c5_P;
  c5_b_b = c5_v;
  c5_y = c5_a * c5_b_b;
  c5_c_b = c5_T;
  c5_b_y = 0.000814892 * c5_c_b;
  c5_d_b = c5_y - c5_b_y;
  c5_c_y = 100.0 * c5_d_b;
  c5_e_b = c5_T;
  c5_d_y = 0.249202 * c5_e_b;
  c5_f_b = c5_T;
  c5_e_y = 0.00245251 * c5_f_b;
  c5_b_a = c5_e_y;
  c5_g_b = c5_T;
  c5_f_y = c5_b_a * c5_g_b;
  c5_b_A = c5_f_y;
  c5_c_x = c5_b_A;
  c5_d_x = c5_c_x;
  c5_g_y = c5_d_x / 2.0;
  c5_h_b = c5_T;
  c5_h_y = -1.6565E-6 * c5_h_b;
  c5_c_a = c5_h_y;
  c5_i_b = c5_T;
  c5_i_y = c5_c_a * c5_i_b;
  c5_d_a = c5_i_y;
  c5_j_b = c5_T;
  c5_j_y = c5_d_a * c5_j_b;
  c5_c_A = c5_j_y;
  c5_e_x = c5_c_A;
  c5_f_x = c5_e_x;
  c5_k_y = c5_f_x / 3.0;
  c5_g_x = c5_T;
  c5_h_x = c5_g_x;
  if (c5_h_x < 0.0) {
    c5_eml_error(chartInstance);
  }

  c5_h_x = muDoubleScalarLog(c5_h_x);
  c5_k_b = c5_h_x;
  c5_l_y = -6.96764 * c5_k_b;
  c5_B = c5_z;
  c5_m_y = c5_B;
  c5_n_y = c5_m_y;
  c5_o_y = -0.00140114 / c5_n_y;
  c5_b_B = c5_z;
  c5_p_y = c5_b_B;
  c5_q_y = c5_p_y;
  c5_r_y = 1.097165E-6 / c5_q_y;
  c5_d_A = c5_r_y;
  c5_c_B = c5_z;
  c5_i_x = c5_d_A;
  c5_s_y = c5_c_B;
  c5_j_x = c5_i_x;
  c5_t_y = c5_s_y;
  c5_u_y = c5_j_x / c5_t_y;
  c5_d_B = c5_z;
  c5_v_y = c5_d_B;
  c5_w_y = c5_v_y;
  c5_x_y = -2.2452666666666665E-10 / c5_w_y;
  c5_e_A = c5_x_y;
  c5_e_B = c5_z;
  c5_k_x = c5_e_A;
  c5_y_y = c5_e_B;
  c5_l_x = c5_k_x;
  c5_ab_y = c5_y_y;
  c5_bb_y = c5_l_x / c5_ab_y;
  c5_f_A = c5_bb_y;
  c5_f_B = c5_z;
  c5_m_x = c5_f_A;
  c5_cb_y = c5_f_B;
  c5_n_x = c5_m_x;
  c5_db_y = c5_cb_y;
  c5_eb_y = c5_n_x / c5_db_y;
  c5_g_B = c5_z;
  c5_fb_y = c5_g_B;
  c5_gb_y = c5_fb_y;
  c5_hb_y = -1.167E-12 / c5_gb_y;
  c5_g_A = c5_hb_y;
  c5_h_B = c5_z;
  c5_o_x = c5_g_A;
  c5_ib_y = c5_h_B;
  c5_p_x = c5_o_x;
  c5_jb_y = c5_ib_y;
  c5_kb_y = c5_p_x / c5_jb_y;
  c5_h_A = c5_kb_y;
  c5_i_B = c5_z;
  c5_q_x = c5_h_A;
  c5_lb_y = c5_i_B;
  c5_r_x = c5_q_x;
  c5_mb_y = c5_lb_y;
  c5_nb_y = c5_r_x / c5_mb_y;
  c5_i_A = c5_nb_y;
  c5_j_B = c5_z;
  c5_s_x = c5_i_A;
  c5_ob_y = c5_j_B;
  c5_t_x = c5_s_x;
  c5_pb_y = c5_ob_y;
  c5_qb_y = c5_t_x / c5_pb_y;
  c5_l_b = c5_Tr;
  c5_rb_y = -5.475 * c5_l_b;
  c5_u_x = c5_rb_y;
  c5_v_x = c5_u_x;
  c5_v_x = muDoubleScalarExp(c5_v_x);
  c5_m_b = c5_Tr;
  c5_sb_y = 5.475 * c5_m_b;
  c5_e_a = c5_v_x;
  c5_n_b = 1.0 + c5_sb_y;
  c5_tb_y = c5_e_a * c5_n_b;
  c5_k_B = c5_z;
  c5_ub_y = c5_k_B;
  c5_vb_y = c5_ub_y;
  c5_wb_y = -0.0269555 / c5_vb_y;
  c5_l_B = c5_z;
  c5_xb_y = c5_l_B;
  c5_yb_y = c5_xb_y;
  c5_ac_y = 1.33886E-5 / c5_yb_y;
  c5_j_A = c5_ac_y;
  c5_m_B = c5_z;
  c5_w_x = c5_j_A;
  c5_bc_y = c5_m_B;
  c5_x_x = c5_w_x;
  c5_cc_y = c5_bc_y;
  c5_dc_y = c5_x_x / c5_cc_y;
  c5_n_B = c5_z;
  c5_ec_y = c5_n_B;
  c5_fc_y = c5_ec_y;
  c5_gc_y = 4.237825E-11 / c5_fc_y;
  c5_k_A = c5_gc_y;
  c5_o_B = c5_z;
  c5_y_x = c5_k_A;
  c5_hc_y = c5_o_B;
  c5_ab_x = c5_y_x;
  c5_ic_y = c5_hc_y;
  c5_jc_y = c5_ab_x / c5_ic_y;
  c5_l_A = c5_jc_y;
  c5_p_B = c5_z;
  c5_bb_x = c5_l_A;
  c5_kc_y = c5_p_B;
  c5_cb_x = c5_bb_x;
  c5_lc_y = c5_kc_y;
  c5_mc_y = c5_cb_x / c5_lc_y;
  c5_m_A = c5_mc_y;
  c5_q_B = c5_z;
  c5_db_x = c5_m_A;
  c5_nc_y = c5_q_B;
  c5_eb_x = c5_db_x;
  c5_oc_y = c5_nc_y;
  c5_pc_y = c5_eb_x / c5_oc_y;
  c5_f_a = c5_tb_y;
  c5_o_b = (c5_wb_y + c5_dc_y) + c5_pc_y;
  c5_qc_y = c5_f_a * c5_o_b;
  c5_p_b = (((c5_o_y + c5_u_y) + c5_eb_y) + c5_qb_y) + c5_qc_y;
  c5_rc_y = 100.0 * c5_p_b;
  c5_H = (((((c5_Ho + c5_c_y) + c5_d_y) + c5_g_y) + c5_k_y) + c5_l_y) + c5_rc_y;
  _SFD_EML_CALL(0U, chartInstance->c5_sfEvent, -41);
  sf_debug_symbol_scope_pop();
  *c5_b_H = c5_H;
  _SFD_CC_CALL(EXIT_OUT_OF_FUNCTION_TAG, 2U, chartInstance->c5_sfEvent);
}

static void initSimStructsc5_evaporateur(SFc5_evaporateurInstanceStruct
  *chartInstance)
{
}

static void init_script_number_translation(uint32_T c5_machineNumber, uint32_T
  c5_chartNumber)
{
}

static const mxArray *c5_sf_marshallOut(void *chartInstanceVoid, void *c5_inData)
{
  const mxArray *c5_mxArrayOutData = NULL;
  real_T c5_u;
  const mxArray *c5_y = NULL;
  SFc5_evaporateurInstanceStruct *chartInstance;
  chartInstance = (SFc5_evaporateurInstanceStruct *)chartInstanceVoid;
  c5_mxArrayOutData = NULL;
  c5_u = *(real_T *)c5_inData;
  c5_y = NULL;
  sf_mex_assign(&c5_y, sf_mex_create("y", &c5_u, 0, 0U, 0U, 0U, 0), FALSE);
  sf_mex_assign(&c5_mxArrayOutData, c5_y, FALSE);
  return c5_mxArrayOutData;
}

static real_T c5_emlrt_marshallIn(SFc5_evaporateurInstanceStruct *chartInstance,
  const mxArray *c5_H, const char_T *c5_identifier)
{
  real_T c5_y;
  emlrtMsgIdentifier c5_thisId;
  c5_thisId.fIdentifier = c5_identifier;
  c5_thisId.fParent = NULL;
  c5_y = c5_b_emlrt_marshallIn(chartInstance, sf_mex_dup(c5_H), &c5_thisId);
  sf_mex_destroy(&c5_H);
  return c5_y;
}

static real_T c5_b_emlrt_marshallIn(SFc5_evaporateurInstanceStruct
  *chartInstance, const mxArray *c5_u, const emlrtMsgIdentifier *c5_parentId)
{
  real_T c5_y;
  real_T c5_d0;
  sf_mex_import(c5_parentId, sf_mex_dup(c5_u), &c5_d0, 1, 0, 0U, 0, 0U, 0);
  c5_y = c5_d0;
  sf_mex_destroy(&c5_u);
  return c5_y;
}

static void c5_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c5_mxArrayInData, const char_T *c5_varName, void *c5_outData)
{
  const mxArray *c5_H;
  const char_T *c5_identifier;
  emlrtMsgIdentifier c5_thisId;
  real_T c5_y;
  SFc5_evaporateurInstanceStruct *chartInstance;
  chartInstance = (SFc5_evaporateurInstanceStruct *)chartInstanceVoid;
  c5_H = sf_mex_dup(c5_mxArrayInData);
  c5_identifier = c5_varName;
  c5_thisId.fIdentifier = c5_identifier;
  c5_thisId.fParent = NULL;
  c5_y = c5_b_emlrt_marshallIn(chartInstance, sf_mex_dup(c5_H), &c5_thisId);
  sf_mex_destroy(&c5_H);
  *(real_T *)c5_outData = c5_y;
  sf_mex_destroy(&c5_mxArrayInData);
}

const mxArray *sf_c5_evaporateur_get_eml_resolved_functions_info(void)
{
  const mxArray *c5_nameCaptureInfo;
  c5_ResolvedFunctionInfo c5_info[14];
  const mxArray *c5_m0 = NULL;
  int32_T c5_i0;
  c5_ResolvedFunctionInfo *c5_r0;
  c5_nameCaptureInfo = NULL;
  c5_nameCaptureInfo = NULL;
  c5_info_helper(c5_info);
  sf_mex_assign(&c5_m0, sf_mex_createstruct("nameCaptureInfo", 1, 14), FALSE);
  for (c5_i0 = 0; c5_i0 < 14; c5_i0++) {
    c5_r0 = &c5_info[c5_i0];
    sf_mex_addfield(c5_m0, sf_mex_create("nameCaptureInfo", c5_r0->context, 15,
      0U, 0U, 0U, 2, 1, strlen(c5_r0->context)), "context", "nameCaptureInfo",
                    c5_i0);
    sf_mex_addfield(c5_m0, sf_mex_create("nameCaptureInfo", c5_r0->name, 15, 0U,
      0U, 0U, 2, 1, strlen(c5_r0->name)), "name", "nameCaptureInfo", c5_i0);
    sf_mex_addfield(c5_m0, sf_mex_create("nameCaptureInfo", c5_r0->dominantType,
      15, 0U, 0U, 0U, 2, 1, strlen(c5_r0->dominantType)), "dominantType",
                    "nameCaptureInfo", c5_i0);
    sf_mex_addfield(c5_m0, sf_mex_create("nameCaptureInfo", c5_r0->resolved, 15,
      0U, 0U, 0U, 2, 1, strlen(c5_r0->resolved)), "resolved", "nameCaptureInfo",
                    c5_i0);
    sf_mex_addfield(c5_m0, sf_mex_create("nameCaptureInfo", &c5_r0->fileTimeLo,
      7, 0U, 0U, 0U, 0), "fileTimeLo", "nameCaptureInfo", c5_i0);
    sf_mex_addfield(c5_m0, sf_mex_create("nameCaptureInfo", &c5_r0->fileTimeHi,
      7, 0U, 0U, 0U, 0), "fileTimeHi", "nameCaptureInfo", c5_i0);
    sf_mex_addfield(c5_m0, sf_mex_create("nameCaptureInfo", &c5_r0->mFileTimeLo,
      7, 0U, 0U, 0U, 0), "mFileTimeLo", "nameCaptureInfo", c5_i0);
    sf_mex_addfield(c5_m0, sf_mex_create("nameCaptureInfo", &c5_r0->mFileTimeHi,
      7, 0U, 0U, 0U, 0), "mFileTimeHi", "nameCaptureInfo", c5_i0);
  }

  sf_mex_assign(&c5_nameCaptureInfo, c5_m0, FALSE);
  sf_mex_emlrtNameCapturePostProcessR2012a(&c5_nameCaptureInfo);
  return c5_nameCaptureInfo;
}

static void c5_info_helper(c5_ResolvedFunctionInfo c5_info[14])
{
  c5_info[0].context = "";
  c5_info[0].name = "mrdivide";
  c5_info[0].dominantType = "double";
  c5_info[0].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mrdivide.p";
  c5_info[0].fileTimeLo = 1342810944U;
  c5_info[0].fileTimeHi = 0U;
  c5_info[0].mFileTimeLo = 1319729966U;
  c5_info[0].mFileTimeHi = 0U;
  c5_info[1].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mrdivide.p";
  c5_info[1].name = "rdivide";
  c5_info[1].dominantType = "double";
  c5_info[1].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/rdivide.m";
  c5_info[1].fileTimeLo = 1286818844U;
  c5_info[1].fileTimeHi = 0U;
  c5_info[1].mFileTimeLo = 0U;
  c5_info[1].mFileTimeHi = 0U;
  c5_info[2].context = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/rdivide.m";
  c5_info[2].name = "eml_div";
  c5_info[2].dominantType = "double";
  c5_info[2].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_div.m";
  c5_info[2].fileTimeLo = 1313347810U;
  c5_info[2].fileTimeHi = 0U;
  c5_info[2].mFileTimeLo = 0U;
  c5_info[2].mFileTimeHi = 0U;
  c5_info[3].context = "";
  c5_info[3].name = "mtimes";
  c5_info[3].dominantType = "double";
  c5_info[3].resolved = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mtimes.m";
  c5_info[3].fileTimeLo = 1289519692U;
  c5_info[3].fileTimeHi = 0U;
  c5_info[3].mFileTimeLo = 0U;
  c5_info[3].mFileTimeHi = 0U;
  c5_info[4].context = "";
  c5_info[4].name = "log";
  c5_info[4].dominantType = "double";
  c5_info[4].resolved = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/log.m";
  c5_info[4].fileTimeLo = 1286818742U;
  c5_info[4].fileTimeHi = 0U;
  c5_info[4].mFileTimeLo = 0U;
  c5_info[4].mFileTimeHi = 0U;
  c5_info[5].context = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/log.m";
  c5_info[5].name = "eml_error";
  c5_info[5].dominantType = "char";
  c5_info[5].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_error.m";
  c5_info[5].fileTimeLo = 1305318000U;
  c5_info[5].fileTimeHi = 0U;
  c5_info[5].mFileTimeLo = 0U;
  c5_info[5].mFileTimeHi = 0U;
  c5_info[6].context = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/log.m";
  c5_info[6].name = "eml_scalar_log";
  c5_info[6].dominantType = "double";
  c5_info[6].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/eml_scalar_log.m";
  c5_info[6].fileTimeLo = 1286818728U;
  c5_info[6].fileTimeHi = 0U;
  c5_info[6].mFileTimeLo = 0U;
  c5_info[6].mFileTimeHi = 0U;
  c5_info[7].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/eml_scalar_log.m";
  c5_info[7].name = "realmax";
  c5_info[7].dominantType = "char";
  c5_info[7].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elmat/realmax.m";
  c5_info[7].fileTimeLo = 1307651242U;
  c5_info[7].fileTimeHi = 0U;
  c5_info[7].mFileTimeLo = 0U;
  c5_info[7].mFileTimeHi = 0U;
  c5_info[8].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elmat/realmax.m";
  c5_info[8].name = "eml_realmax";
  c5_info[8].dominantType = "char";
  c5_info[8].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_realmax.m";
  c5_info[8].fileTimeLo = 1326727996U;
  c5_info[8].fileTimeHi = 0U;
  c5_info[8].mFileTimeLo = 0U;
  c5_info[8].mFileTimeHi = 0U;
  c5_info[9].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_realmax.m";
  c5_info[9].name = "eml_float_model";
  c5_info[9].dominantType = "char";
  c5_info[9].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_float_model.m";
  c5_info[9].fileTimeLo = 1326727996U;
  c5_info[9].fileTimeHi = 0U;
  c5_info[9].mFileTimeLo = 0U;
  c5_info[9].mFileTimeHi = 0U;
  c5_info[10].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_realmax.m";
  c5_info[10].name = "mtimes";
  c5_info[10].dominantType = "double";
  c5_info[10].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mtimes.m";
  c5_info[10].fileTimeLo = 1289519692U;
  c5_info[10].fileTimeHi = 0U;
  c5_info[10].mFileTimeLo = 0U;
  c5_info[10].mFileTimeHi = 0U;
  c5_info[11].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/eml_scalar_log.m";
  c5_info[11].name = "mrdivide";
  c5_info[11].dominantType = "double";
  c5_info[11].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mrdivide.p";
  c5_info[11].fileTimeLo = 1342810944U;
  c5_info[11].fileTimeHi = 0U;
  c5_info[11].mFileTimeLo = 1319729966U;
  c5_info[11].mFileTimeHi = 0U;
  c5_info[12].context = "";
  c5_info[12].name = "exp";
  c5_info[12].dominantType = "double";
  c5_info[12].resolved = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/exp.m";
  c5_info[12].fileTimeLo = 1286818740U;
  c5_info[12].fileTimeHi = 0U;
  c5_info[12].mFileTimeLo = 0U;
  c5_info[12].mFileTimeHi = 0U;
  c5_info[13].context = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/exp.m";
  c5_info[13].name = "eml_scalar_exp";
  c5_info[13].dominantType = "double";
  c5_info[13].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/eml_scalar_exp.m";
  c5_info[13].fileTimeLo = 1301328464U;
  c5_info[13].fileTimeHi = 0U;
  c5_info[13].mFileTimeLo = 0U;
  c5_info[13].mFileTimeHi = 0U;
}

static void c5_eml_error(SFc5_evaporateurInstanceStruct *chartInstance)
{
  int32_T c5_i1;
  static char_T c5_varargin_1[29] = { 'C', 'o', 'd', 'e', 'r', ':', 't', 'o',
    'o', 'l', 'b', 'o', 'x', ':', 'l', 'o', 'g', '_', 'd', 'o', 'm', 'a', 'i',
    'n', 'E', 'r', 'r', 'o', 'r' };

  char_T c5_u[29];
  const mxArray *c5_y = NULL;
  for (c5_i1 = 0; c5_i1 < 29; c5_i1++) {
    c5_u[c5_i1] = c5_varargin_1[c5_i1];
  }

  c5_y = NULL;
  sf_mex_assign(&c5_y, sf_mex_create("y", c5_u, 10, 0U, 1U, 0U, 2, 1, 29), FALSE);
  sf_mex_call_debug("error", 0U, 1U, 14, sf_mex_call_debug("message", 1U, 1U, 14,
    c5_y));
}

static const mxArray *c5_b_sf_marshallOut(void *chartInstanceVoid, void
  *c5_inData)
{
  const mxArray *c5_mxArrayOutData = NULL;
  int32_T c5_u;
  const mxArray *c5_y = NULL;
  SFc5_evaporateurInstanceStruct *chartInstance;
  chartInstance = (SFc5_evaporateurInstanceStruct *)chartInstanceVoid;
  c5_mxArrayOutData = NULL;
  c5_u = *(int32_T *)c5_inData;
  c5_y = NULL;
  sf_mex_assign(&c5_y, sf_mex_create("y", &c5_u, 6, 0U, 0U, 0U, 0), FALSE);
  sf_mex_assign(&c5_mxArrayOutData, c5_y, FALSE);
  return c5_mxArrayOutData;
}

static int32_T c5_c_emlrt_marshallIn(SFc5_evaporateurInstanceStruct
  *chartInstance, const mxArray *c5_u, const emlrtMsgIdentifier *c5_parentId)
{
  int32_T c5_y;
  int32_T c5_i2;
  sf_mex_import(c5_parentId, sf_mex_dup(c5_u), &c5_i2, 1, 6, 0U, 0, 0U, 0);
  c5_y = c5_i2;
  sf_mex_destroy(&c5_u);
  return c5_y;
}

static void c5_b_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c5_mxArrayInData, const char_T *c5_varName, void *c5_outData)
{
  const mxArray *c5_b_sfEvent;
  const char_T *c5_identifier;
  emlrtMsgIdentifier c5_thisId;
  int32_T c5_y;
  SFc5_evaporateurInstanceStruct *chartInstance;
  chartInstance = (SFc5_evaporateurInstanceStruct *)chartInstanceVoid;
  c5_b_sfEvent = sf_mex_dup(c5_mxArrayInData);
  c5_identifier = c5_varName;
  c5_thisId.fIdentifier = c5_identifier;
  c5_thisId.fParent = NULL;
  c5_y = c5_c_emlrt_marshallIn(chartInstance, sf_mex_dup(c5_b_sfEvent),
    &c5_thisId);
  sf_mex_destroy(&c5_b_sfEvent);
  *(int32_T *)c5_outData = c5_y;
  sf_mex_destroy(&c5_mxArrayInData);
}

static uint8_T c5_d_emlrt_marshallIn(SFc5_evaporateurInstanceStruct
  *chartInstance, const mxArray *c5_b_is_active_c5_evaporateur, const char_T
  *c5_identifier)
{
  uint8_T c5_y;
  emlrtMsgIdentifier c5_thisId;
  c5_thisId.fIdentifier = c5_identifier;
  c5_thisId.fParent = NULL;
  c5_y = c5_e_emlrt_marshallIn(chartInstance, sf_mex_dup
    (c5_b_is_active_c5_evaporateur), &c5_thisId);
  sf_mex_destroy(&c5_b_is_active_c5_evaporateur);
  return c5_y;
}

static uint8_T c5_e_emlrt_marshallIn(SFc5_evaporateurInstanceStruct
  *chartInstance, const mxArray *c5_u, const emlrtMsgIdentifier *c5_parentId)
{
  uint8_T c5_y;
  uint8_T c5_u0;
  sf_mex_import(c5_parentId, sf_mex_dup(c5_u), &c5_u0, 1, 3, 0U, 0, 0U, 0);
  c5_y = c5_u0;
  sf_mex_destroy(&c5_u);
  return c5_y;
}

static void init_dsm_address_info(SFc5_evaporateurInstanceStruct *chartInstance)
{
}

/* SFunction Glue Code */
void sf_c5_evaporateur_get_check_sum(mxArray *plhs[])
{
  ((real_T *)mxGetPr((plhs[0])))[0] = (real_T)(3542298508U);
  ((real_T *)mxGetPr((plhs[0])))[1] = (real_T)(2074890056U);
  ((real_T *)mxGetPr((plhs[0])))[2] = (real_T)(811363648U);
  ((real_T *)mxGetPr((plhs[0])))[3] = (real_T)(268708102U);
}

mxArray *sf_c5_evaporateur_get_autoinheritance_info(void)
{
  const char *autoinheritanceFields[] = { "checksum", "inputs", "parameters",
    "outputs", "locals" };

  mxArray *mxAutoinheritanceInfo = mxCreateStructMatrix(1,1,5,
    autoinheritanceFields);

  {
    mxArray *mxChecksum = mxCreateString("mFSucZ0DBYaqZhdaVbpdGG");
    mxSetField(mxAutoinheritanceInfo,0,"checksum",mxChecksum);
  }

  {
    const char *dataFields[] = { "size", "type", "complexity" };

    mxArray *mxData = mxCreateStructMatrix(1,3,3,dataFields);

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,0,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }

    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,1,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,1,"type",mxType);
    }

    mxSetField(mxData,1,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,2,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,2,"type",mxType);
    }

    mxSetField(mxData,2,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"inputs",mxData);
  }

  {
    mxSetField(mxAutoinheritanceInfo,0,"parameters",mxCreateDoubleMatrix(0,0,
                mxREAL));
  }

  {
    const char *dataFields[] = { "size", "type", "complexity" };

    mxArray *mxData = mxCreateStructMatrix(1,1,3,dataFields);

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,0,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }

    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"outputs",mxData);
  }

  {
    mxSetField(mxAutoinheritanceInfo,0,"locals",mxCreateDoubleMatrix(0,0,mxREAL));
  }

  return(mxAutoinheritanceInfo);
}

static const mxArray *sf_get_sim_state_info_c5_evaporateur(void)
{
  const char *infoFields[] = { "chartChecksum", "varInfo" };

  mxArray *mxInfo = mxCreateStructMatrix(1, 1, 2, infoFields);
  const char *infoEncStr[] = {
    "100 S1x2'type','srcId','name','auxInfo'{{M[1],M[7],T\"H\",},{M[8],M[0],T\"is_active_c5_evaporateur\",}}"
  };

  mxArray *mxVarInfo = sf_mex_decode_encoded_mx_struct_array(infoEncStr, 2, 10);
  mxArray *mxChecksum = mxCreateDoubleMatrix(1, 4, mxREAL);
  sf_c5_evaporateur_get_check_sum(&mxChecksum);
  mxSetField(mxInfo, 0, infoFields[0], mxChecksum);
  mxSetField(mxInfo, 0, infoFields[1], mxVarInfo);
  return mxInfo;
}

static void chart_debug_initialization(SimStruct *S, unsigned int
  fullDebuggerInitialization)
{
  if (!sim_mode_is_rtw_gen(S)) {
    SFc5_evaporateurInstanceStruct *chartInstance;
    chartInstance = (SFc5_evaporateurInstanceStruct *) ((ChartInfoStruct *)
      (ssGetUserData(S)))->chartInstance;
    if (ssIsFirstInitCond(S) && fullDebuggerInitialization==1) {
      /* do this only if simulation is starting */
      {
        unsigned int chartAlreadyPresent;
        chartAlreadyPresent = sf_debug_initialize_chart
          (_evaporateurMachineNumber_,
           5,
           1,
           1,
           4,
           0,
           0,
           0,
           0,
           0,
           &(chartInstance->chartNumber),
           &(chartInstance->instanceNumber),
           ssGetPath(S),
           (void *)S);
        if (chartAlreadyPresent==0) {
          /* this is the first instance */
          init_script_number_translation(_evaporateurMachineNumber_,
            chartInstance->chartNumber);
          sf_debug_set_chart_disable_implicit_casting(_evaporateurMachineNumber_,
            chartInstance->chartNumber,1);
          sf_debug_set_chart_event_thresholds(_evaporateurMachineNumber_,
            chartInstance->chartNumber,
            0,
            0,
            0);
          _SFD_SET_DATA_PROPS(0,1,1,0,"T");
          _SFD_SET_DATA_PROPS(1,1,1,0,"P");
          _SFD_SET_DATA_PROPS(2,1,1,0,"v");
          _SFD_SET_DATA_PROPS(3,2,0,1,"H");
          _SFD_STATE_INFO(0,0,2);
          _SFD_CH_SUBSTATE_COUNT(0);
          _SFD_CH_SUBSTATE_DECOMP(0);
        }

        _SFD_CV_INIT_CHART(0,0,0,0);

        {
          _SFD_CV_INIT_STATE(0,0,0,0,0,0,NULL,NULL);
        }

        _SFD_CV_INIT_TRANS(0,0,NULL,NULL,0,NULL);

        /* Initialization of MATLAB Function Model Coverage */
        _SFD_CV_INIT_EML(0,1,1,1,0,0,0,0,0,0,0);
        _SFD_CV_INIT_EML_FCN(0,0,"eML_blk_kernel",0,-1,847);
        _SFD_CV_INIT_EML_IF(0,1,0,102,110,-1,125);
        _SFD_TRANS_COV_WTS(0,0,0,1,0);
        if (chartAlreadyPresent==0) {
          _SFD_TRANS_COV_MAPS(0,
                              0,NULL,NULL,
                              0,NULL,NULL,
                              1,NULL,NULL,
                              0,NULL,NULL);
        }

        _SFD_SET_DATA_COMPILED_PROPS(0,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c5_sf_marshallOut,(MexInFcnForType)NULL);
        _SFD_SET_DATA_COMPILED_PROPS(1,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c5_sf_marshallOut,(MexInFcnForType)NULL);
        _SFD_SET_DATA_COMPILED_PROPS(2,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c5_sf_marshallOut,(MexInFcnForType)NULL);
        _SFD_SET_DATA_COMPILED_PROPS(3,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c5_sf_marshallOut,(MexInFcnForType)c5_sf_marshallIn);

        {
          real_T *c5_T;
          real_T *c5_P;
          real_T *c5_v;
          real_T *c5_H;
          c5_H = (real_T *)ssGetOutputPortSignal(chartInstance->S, 1);
          c5_v = (real_T *)ssGetInputPortSignal(chartInstance->S, 2);
          c5_P = (real_T *)ssGetInputPortSignal(chartInstance->S, 1);
          c5_T = (real_T *)ssGetInputPortSignal(chartInstance->S, 0);
          _SFD_SET_DATA_VALUE_PTR(0U, c5_T);
          _SFD_SET_DATA_VALUE_PTR(1U, c5_P);
          _SFD_SET_DATA_VALUE_PTR(2U, c5_v);
          _SFD_SET_DATA_VALUE_PTR(3U, c5_H);
        }
      }
    } else {
      sf_debug_reset_current_state_configuration(_evaporateurMachineNumber_,
        chartInstance->chartNumber,chartInstance->instanceNumber);
    }
  }
}

static const char* sf_get_instance_specialization()
{
  return "RrWt2PV7q6h0vBxOyEfEYE";
}

static void sf_opaque_initialize_c5_evaporateur(void *chartInstanceVar)
{
  chart_debug_initialization(((SFc5_evaporateurInstanceStruct*) chartInstanceVar)
    ->S,0);
  initialize_params_c5_evaporateur((SFc5_evaporateurInstanceStruct*)
    chartInstanceVar);
  initialize_c5_evaporateur((SFc5_evaporateurInstanceStruct*) chartInstanceVar);
}

static void sf_opaque_enable_c5_evaporateur(void *chartInstanceVar)
{
  enable_c5_evaporateur((SFc5_evaporateurInstanceStruct*) chartInstanceVar);
}

static void sf_opaque_disable_c5_evaporateur(void *chartInstanceVar)
{
  disable_c5_evaporateur((SFc5_evaporateurInstanceStruct*) chartInstanceVar);
}

static void sf_opaque_gateway_c5_evaporateur(void *chartInstanceVar)
{
  sf_c5_evaporateur((SFc5_evaporateurInstanceStruct*) chartInstanceVar);
}

extern const mxArray* sf_internal_get_sim_state_c5_evaporateur(SimStruct* S)
{
  ChartInfoStruct *chartInfo = (ChartInfoStruct*) ssGetUserData(S);
  mxArray *plhs[1] = { NULL };

  mxArray *prhs[4];
  int mxError = 0;
  prhs[0] = mxCreateString("chart_simctx_raw2high");
  prhs[1] = mxCreateDoubleScalar(ssGetSFuncBlockHandle(S));
  prhs[2] = (mxArray*) get_sim_state_c5_evaporateur
    ((SFc5_evaporateurInstanceStruct*)chartInfo->chartInstance);/* raw sim ctx */
  prhs[3] = (mxArray*) sf_get_sim_state_info_c5_evaporateur();/* state var info */
  mxError = sf_mex_call_matlab(1, plhs, 4, prhs, "sfprivate");
  mxDestroyArray(prhs[0]);
  mxDestroyArray(prhs[1]);
  mxDestroyArray(prhs[2]);
  mxDestroyArray(prhs[3]);
  if (mxError || plhs[0] == NULL) {
    sf_mex_error_message("Stateflow Internal Error: \nError calling 'chart_simctx_raw2high'.\n");
  }

  return plhs[0];
}

extern void sf_internal_set_sim_state_c5_evaporateur(SimStruct* S, const mxArray
  *st)
{
  ChartInfoStruct *chartInfo = (ChartInfoStruct*) ssGetUserData(S);
  mxArray *plhs[1] = { NULL };

  mxArray *prhs[4];
  int mxError = 0;
  prhs[0] = mxCreateString("chart_simctx_high2raw");
  prhs[1] = mxCreateDoubleScalar(ssGetSFuncBlockHandle(S));
  prhs[2] = mxDuplicateArray(st);      /* high level simctx */
  prhs[3] = (mxArray*) sf_get_sim_state_info_c5_evaporateur();/* state var info */
  mxError = sf_mex_call_matlab(1, plhs, 4, prhs, "sfprivate");
  mxDestroyArray(prhs[0]);
  mxDestroyArray(prhs[1]);
  mxDestroyArray(prhs[2]);
  mxDestroyArray(prhs[3]);
  if (mxError || plhs[0] == NULL) {
    sf_mex_error_message("Stateflow Internal Error: \nError calling 'chart_simctx_high2raw'.\n");
  }

  set_sim_state_c5_evaporateur((SFc5_evaporateurInstanceStruct*)
    chartInfo->chartInstance, mxDuplicateArray(plhs[0]));
  mxDestroyArray(plhs[0]);
}

static const mxArray* sf_opaque_get_sim_state_c5_evaporateur(SimStruct* S)
{
  return sf_internal_get_sim_state_c5_evaporateur(S);
}

static void sf_opaque_set_sim_state_c5_evaporateur(SimStruct* S, const mxArray
  *st)
{
  sf_internal_set_sim_state_c5_evaporateur(S, st);
}

static void sf_opaque_terminate_c5_evaporateur(void *chartInstanceVar)
{
  if (chartInstanceVar!=NULL) {
    SimStruct *S = ((SFc5_evaporateurInstanceStruct*) chartInstanceVar)->S;
    if (sim_mode_is_rtw_gen(S) || sim_mode_is_external(S)) {
      sf_clear_rtw_identifier(S);
    }

    finalize_c5_evaporateur((SFc5_evaporateurInstanceStruct*) chartInstanceVar);
    free((void *)chartInstanceVar);
    ssSetUserData(S,NULL);
  }

  unload_evaporateur_optimization_info();
}

static void sf_opaque_init_subchart_simstructs(void *chartInstanceVar)
{
  initSimStructsc5_evaporateur((SFc5_evaporateurInstanceStruct*)
    chartInstanceVar);
}

extern unsigned int sf_machine_global_initializer_called(void);
static void mdlProcessParameters_c5_evaporateur(SimStruct *S)
{
  int i;
  for (i=0;i<ssGetNumRunTimeParams(S);i++) {
    if (ssGetSFcnParamTunable(S,i)) {
      ssUpdateDlgParamAsRunTimeParam(S,i);
    }
  }

  if (sf_machine_global_initializer_called()) {
    initialize_params_c5_evaporateur((SFc5_evaporateurInstanceStruct*)
      (((ChartInfoStruct *)ssGetUserData(S))->chartInstance));
  }
}

static void mdlSetWorkWidths_c5_evaporateur(SimStruct *S)
{
  if (sim_mode_is_rtw_gen(S) || sim_mode_is_external(S)) {
    mxArray *infoStruct = load_evaporateur_optimization_info();
    int_T chartIsInlinable =
      (int_T)sf_is_chart_inlinable(S,sf_get_instance_specialization(),infoStruct,
      5);
    ssSetStateflowIsInlinable(S,chartIsInlinable);
    ssSetRTWCG(S,sf_rtw_info_uint_prop(S,sf_get_instance_specialization(),
                infoStruct,5,"RTWCG"));
    ssSetEnableFcnIsTrivial(S,1);
    ssSetDisableFcnIsTrivial(S,1);
    ssSetNotMultipleInlinable(S,sf_rtw_info_uint_prop(S,
      sf_get_instance_specialization(),infoStruct,5,
      "gatewayCannotBeInlinedMultipleTimes"));
    if (chartIsInlinable) {
      ssSetInputPortOptimOpts(S, 0, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 1, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 2, SS_REUSABLE_AND_LOCAL);
      sf_mark_chart_expressionable_inputs(S,sf_get_instance_specialization(),
        infoStruct,5,3);
      sf_mark_chart_reusable_outputs(S,sf_get_instance_specialization(),
        infoStruct,5,1);
    }

    sf_set_rtw_dwork_info(S,sf_get_instance_specialization(),infoStruct,5);
    ssSetHasSubFunctions(S,!(chartIsInlinable));
  } else {
  }

  ssSetOptions(S,ssGetOptions(S)|SS_OPTION_WORKS_WITH_CODE_REUSE);
  ssSetChecksum0(S,(2857384794U));
  ssSetChecksum1(S,(1358693156U));
  ssSetChecksum2(S,(3860450684U));
  ssSetChecksum3(S,(560448563U));
  ssSetmdlDerivatives(S, NULL);
  ssSetExplicitFCSSCtrl(S,1);
  ssSupportsMultipleExecInstances(S,1);
}

static void mdlRTW_c5_evaporateur(SimStruct *S)
{
  if (sim_mode_is_rtw_gen(S)) {
    ssWriteRTWStrParam(S, "StateflowChartType", "Embedded MATLAB");
  }
}

static void mdlStart_c5_evaporateur(SimStruct *S)
{
  SFc5_evaporateurInstanceStruct *chartInstance;
  chartInstance = (SFc5_evaporateurInstanceStruct *)malloc(sizeof
    (SFc5_evaporateurInstanceStruct));
  memset(chartInstance, 0, sizeof(SFc5_evaporateurInstanceStruct));
  if (chartInstance==NULL) {
    sf_mex_error_message("Could not allocate memory for chart instance.");
  }

  chartInstance->chartInfo.chartInstance = chartInstance;
  chartInstance->chartInfo.isEMLChart = 1;
  chartInstance->chartInfo.chartInitialized = 0;
  chartInstance->chartInfo.sFunctionGateway = sf_opaque_gateway_c5_evaporateur;
  chartInstance->chartInfo.initializeChart = sf_opaque_initialize_c5_evaporateur;
  chartInstance->chartInfo.terminateChart = sf_opaque_terminate_c5_evaporateur;
  chartInstance->chartInfo.enableChart = sf_opaque_enable_c5_evaporateur;
  chartInstance->chartInfo.disableChart = sf_opaque_disable_c5_evaporateur;
  chartInstance->chartInfo.getSimState = sf_opaque_get_sim_state_c5_evaporateur;
  chartInstance->chartInfo.setSimState = sf_opaque_set_sim_state_c5_evaporateur;
  chartInstance->chartInfo.getSimStateInfo =
    sf_get_sim_state_info_c5_evaporateur;
  chartInstance->chartInfo.zeroCrossings = NULL;
  chartInstance->chartInfo.outputs = NULL;
  chartInstance->chartInfo.derivatives = NULL;
  chartInstance->chartInfo.mdlRTW = mdlRTW_c5_evaporateur;
  chartInstance->chartInfo.mdlStart = mdlStart_c5_evaporateur;
  chartInstance->chartInfo.mdlSetWorkWidths = mdlSetWorkWidths_c5_evaporateur;
  chartInstance->chartInfo.extModeExec = NULL;
  chartInstance->chartInfo.restoreLastMajorStepConfiguration = NULL;
  chartInstance->chartInfo.restoreBeforeLastMajorStepConfiguration = NULL;
  chartInstance->chartInfo.storeCurrentConfiguration = NULL;
  chartInstance->S = S;
  ssSetUserData(S,(void *)(&(chartInstance->chartInfo)));/* register the chart instance with simstruct */
  init_dsm_address_info(chartInstance);
  if (!sim_mode_is_rtw_gen(S)) {
  }

  sf_opaque_init_subchart_simstructs(chartInstance->chartInfo.chartInstance);
  chart_debug_initialization(S,1);
}

void c5_evaporateur_method_dispatcher(SimStruct *S, int_T method, void *data)
{
  switch (method) {
   case SS_CALL_MDL_START:
    mdlStart_c5_evaporateur(S);
    break;

   case SS_CALL_MDL_SET_WORK_WIDTHS:
    mdlSetWorkWidths_c5_evaporateur(S);
    break;

   case SS_CALL_MDL_PROCESS_PARAMETERS:
    mdlProcessParameters_c5_evaporateur(S);
    break;

   default:
    /* Unhandled method */
    sf_mex_error_message("Stateflow Internal Error:\n"
                         "Error calling c5_evaporateur_method_dispatcher.\n"
                         "Can't handle method %d.\n", method);
    break;
  }
}
